;==========
;Chomp
;==========

PROPERTIES: db $6D,$2D

TILEMAP: 
	db $00,$02,$20,$22
	db $04,$06,$24,$26
	db $00,$02,$20,$22
	db $04,$06,$24,$26

Y_Speeds:
	db $DA,$DC
	db $D7,$D5
	db $DB,$D9
	db $D8,$DB
	db $D7,$D5
	db $DB,$D9
	db $DA,$DC
	db $D7,$D5
	db $D6,$D4
	db $DA,$D9
X_Speeds: 
	db $1A,-$1A
	db $16,-$16
	db $18,-$18
	db $12,-$12
	db $1A,-$1A
	db $16,-$16
	db $18,-$18
	db $12,-$12
	
!SpeedValueCounter = $C2

print "INIT ", pc
	JSR SUB_HORZ_POS		;Face Mario, uncomment this line and the next two if you don't want that.
	TYA
	STA $157C,x
	RTL

Return:
	RTS

print "MAIN ", pc
	PHB
	PHK
	PLB
	JSR Run
	PLB
	RTL

SP: db $30,$D0
	
Run:
	JSR GFX
	JSR SUB_OFF_SCREEN_X0
	LDA $14C8,x		;If the sprite is dead..
	CMP #$08
	BNE Return		;..return
	LDA $9D
	BNE Return		;Also return if sprites are locked.

	JSL $01802A
	JSL $018032
	JSL $01A7DC	
	
	LDA $1588,x
	AND #$04
	BEQ NOT_ON_GND         

	JSR SUB_HORZ_POS
	TYA
	STA $157C,x
	
	LDA #$06
	STA $1887
	
	LDY !SpeedValueCounter,x
	LDA Y_Speeds,y
	STA $AA,x
	LDA #$01
	STA $1DF9
	INC !SpeedValueCounter,x
	INC !SpeedValueCounter,x
	LDA !SpeedValueCounter,x
	CMP #$10
	BCC NoIncOrReset
	STZ !SpeedValueCounter,x
	JMP Mode
NoIncOrReset:
	LDA $157C,x
	CLC
	ADC !SpeedValueCounter,x
	TAY
	LDA X_Speeds,y
	STA $B6,x
NOT_ON_GND:	
	LDA $1588,x
	AND #$03
	BEQ +
	LDA $157C,x
	EOR #$01
	STA $157C,x
+
	RTS

Mode:
	LDA #$01
	STA $1504,x
	LDA $1686,x
	ORA #$80
	STA $1686,x
	JSR SUB_HORZ_POS
	TYA
	STA $157C,x
	;LDA #$C5
	;STA $AA,x
	;LDY $157C,x
	;LDA SP,y
	;STA $B6,x
	;JSL $01802A
	
	REP #$20
	LDA $14E0,x
	XBA
	LDA $E4,x
	SEC
	SBC $94
	SEP #$20
	PHA
	JSR SUB_HORZ_POS
	PLA
	EOR DirFix,y
	LSR #4
	PHY
	TAY
	LDA XSPEEDS,y
	PHA
	LDA $157C,x
	BEQ .R
	PLA
	EOR #$FF
	INC A
	BRA ++
.R
	PLA
++
	STA $B6,x
	PLY
	
;===============;
;Y SPEED AIMING ;
;===============;
	
	REP #$20
	LDA $14D4,x
	XBA
	LDA $D8,x
	SEC
	SBC $96
	SEP #$20
	PHA
	JSR SUB_VERT_POS
	PLA
	EOR DirFix,y
	LSR #4
	PHY
	TAY
	LDA YSPEEDS,y
	STA $AA,x
	PLY
EndAim:
	JSL $01802A
	RTS
	
XSPEEDS: 
	db $15,$20,$25,$30
	db $35,$45,$55,$60
	db $65,$70,$70,$75
	db $7F,$70,$7F,$7F
YSPEEDS:
	db $D0,$CD,$C5,$C0
	db $BD,$B0,$AD,$A8
	db $A0,$9A,$95,$8F
	db $88,$84,$80,$D0

DirFix: db $FF,$00	
	
;Sprite Routines

YDISP:  
	db $F0,$F0,$00,$00 
	db $F0,$F0,$00,$00 
	db $F0,$F0,$00,$00 
	db $F0,$F0,$00,$00 
 
XDISP:  
	db $00,$10,$00,$10 
	db $00,$10,$00,$10 
	db $10,$00,$10,$00 
	db $10,$00,$10,$00 

GFX:
	JSR GET_DRAW_INFO

	LDA $14			
	LSR #3
	AND #$01		
	ASL A 			
	ASL A			
	STA $03			

	LDA $157C,x
	STA $02			
	BNE NoAdd
	LDA $03			
	CLC			
	ADC #$08		
	STA $03			
NoAdd:
	PHX			
	LDX #$03		
Loop:
	PHX			
	TXA			
	ORA $03			
	TAX			

	LDA $00			
	CLC			
	ADC XDISP,x		
	STA $0300,y		

	LDA $01			
	CLC			
	ADC YDISP,x		
	STA $0301,y		
				

	LDA TILEMAP,x
	STA $0302,y

	PHX			
	LDX $02			
	LDA PROPERTIES,x	
	STA $0303,y		
	PLX			

	INY			
	INY			
	INY			
	INY			
		
	PLX			
	DEX							
	BPL Loop			
	PLX			

	LDY #$02		
	LDA #$03		
	JSL $01B7B3		
	RTS			


;=================;
;SUB_HORZ_POS
;=================;

SUB_HORZ_POS:
	LDY #$00
	LDA $D1
	SEC
	SBC $E4,x
	STA $0F
	LDA $D2
	SBC $14E0,x
	BPL SPR_L16
	INY
SPR_L16:
	RTS

;=================;
;SUB_VERT_POS
;=================;

SUB_VERT_POS:
	LDY #$00
	LDA $D3
	SEC
	SBC $D8,x
	STA $0F
	LDA $D4
	SBC $14D4,x
	BPL SPR_L11
	INY
SPR_L11:
	RTS

;=================;
;SUB_OFF_SCREEN
;=================;

SPR_T12:
	db $40,$B0
SPR_T13:
	db $01,$FF
SPR_T14:
	db $30,$C0,$A0,$C0,$A0,$F0,$60,$90
	db $30,$C0,$A0,$80,$A0,$40,$60,$B0
SPR_T15:
	db $01,$FF,$01,$FF,$01,$FF,$01,$FF
	db $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X1:
	LDA #$02
	BRA STORE_03
SUB_OFF_SCREEN_X2:
	LDA #$04
	BRA STORE_03
SUB_OFF_SCREEN_X3:
	LDA #$06
	BRA STORE_03
SUB_OFF_SCREEN_X4:
	LDA #$08
	BRA STORE_03
SUB_OFF_SCREEN_X5:
	LDA #$0A
	BRA STORE_03
SUB_OFF_SCREEN_X6:
	LDA #$0C
	BRA STORE_03
SUB_OFF_SCREEN_X7:
	LDA #$0E
STORE_03:
	STA $03
	BRA START_SUB
SUB_OFF_SCREEN_X0:
	STZ $03

START_SUB:
	JSR SUB_IS_OFF_SCREEN
	BEQ RETURN_35
	LDA $5B
	AND #$01
	BNE VERTICAL_LEVEL
	LDA $D8,x
	CLC
	ADC #$50
	LDA $14D4,x
	ADC #$00
	CMP #$02
	BPL ERASE_SPRITE
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	AND #$01
	ORA $03
	STA $01
	TAY
	LDA $1A
	CLC
	ADC SPR_T14,y
	ROL $00
	CMP $E4,x
	PHP
	LDA $1B
	LSR $00
	ADC SPR_T15,y
	PLP
	SBC $14E0,x
	STA $00
	LSR $01
	BCC SPR_L31
	EOR #$80
	STA $00
SPR_L31:
	LDA $00
	BPL RETURN_35
	ERASE_SPRITE:
	LDA $14C8,x
	CMP #$08
	BCC KILL_SPRITE
	LDY $161A,x
	CPY #$FF
	BEQ KILL_SPRITE
	LDA #$00
	STA $1938,y
KILL_SPRITE:
	STZ $14C8,x
RETURN_35:
	RTS

VERTICAL_LEVEL:
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	LSR A
	BCS RETURN_35
	LDA $E4,x
	CMP #$00
	LDA $14E0,x
	SBC #$00
	CMP #$02
	BCS ERASE_SPRITE
	LDA $13
	LSR A
	AND #$01
	STA $01
	TAY
	LDA $1C
	CLC
	ADC SPR_T12,y
	ROL $00
	CMP $D8,x
	PHP
	LDA $001D
	LSR $00
	ADC SPR_T13,y
	PLP
	SBC $14D4,x
	STA $00
	LDY $01
	BEQ SPR_L38
	EOR #$80
	STA $00
SPR_L38:
	LDA $00
	BPL RETURN_35
	BMI ERASE_SPRITE

SUB_IS_OFF_SCREEN:
	LDA $15A0,x
	ORA $186C,x
	RTS

;================;
;GET_DRAW_INFO
;================;

SPR_T1:
	db $0C,$1C
SPR_T2:
	db $01,$02

GET_DRAW_INFO:
	STZ $186C,x
	STZ $15A0,x
	LDA $E4,x
	CMP $1A
	LDA $14E0,x
	SBC $1B
	BEQ ON_SCREEN_X
	INC $15A0,x

ON_SCREEN_X:
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
	SEC
	SBC $1A
	CLC
	ADC.w #$0040
	CMP.w #$0180
	SEP #$20
	ROL A
	AND #$01
	STA $15C4,x
	BNE INVALID

	LDY #$00
	LDA $1662,x
	AND #$20
	BEQ ON_SCREEN_LOOP
	INY
ON_SCREEN_LOOP:
	LDA $D8,x
	CLC
	ADC SPR_T1,y
	PHP
	CMP $1C
	ROL $00
	PLP
	LDA $14D4,x
	ADC #$00
	LSR $00
	SBC $1D
	BEQ ON_SCREEN_Y
	LDA $186C,x
	ORA SPR_T2,y
	STA $186C,x
ON_SCREEN_Y:
	DEY
	BPL ON_SCREEN_LOOP
	LDY $15EA,x
	LDA $E4,x
	SEC
	SBC $1A
	STA $00
	LDA $D8,x
	SEC
	SBC $1C
	STA $01
	RTS

INVALID:
	PLA
	PLA
	RTS