;=======================================
;Divine Koopa
; By Atma
;  Extra Bit: If set, will not change
;   into a normal Koopa after being hit
;    and will take an extra hit
;=======================================

print "INIT ",pc
PHB		;\
PHK		; | Change the data bank to the one our code is running from.
PLB		;/ This is a good practice.
	LDA #$01
	STA $1528,x
	JSR SubHorzPos	;\
	TYA		; | Use if enemy doesn't change direction in main code.
	EOR #$01
	STA $157C,x	;/
PLB		;\ Restore old data bank.
RTL		;/ And return.

print "MAIN ",pc

PHB		;\
PHK		; | Change the data bank to the one our code is running from.
PLB		; | This is a good practice.
JSR SpriteCode	; | Jump to the sprite's function.
PLB		; | Restore old data bank.
RTL		;/ And return.

;===================================
;Defines
;===================================
Xspeed: db $EE,$12
DirFix: db $FF,$00
!Spawn = $09
;===================================
;Routines
;===================================
RandomRoutine:
PHX
PHP
SEP #$30
PHA
JSL $01ACF9         ; Random number generation routine
PLX
CPX #$FF            ;\ Handle glitch if max is FF
BNE normalrt        ;|
LDA $148B           ;|
BRA EndRandRoutine  ;/
normalrt:
INX                 ; Amount in plus 1
LDA $148B           ;\
STA $4202           ;| Multiply with hardware regsisters
STX $4203           ;|
NOP                 ;|
NOP                 ;|
NOP                 ;|
NOP                 ;/
LDA $4217
EndRandRoutine:
PLP
PLX
RTL
Proximity:
	LDA $E4,x		;\
	SEC			; |
	SBC $94			; |
	PHA			; |
	JSR SubHorzPos	; | Check sprite range ..
	PLA			; |
	EOR DirFix,y		; |
	CMP $00		; | ; If Range > !Temp return. 
	BCS +			; |
	LDA #$01		; | A = #$01.
	RTS			; |
+	LDA #$00		; | A = #$00 if not in range.
	RTS			;/
VProximity:
	LDA $D8,x		;\
	SEC			; |
	SBC $96			; |
	PHA			; |
	JSR SubVertPos	; | Check sprite range ..
	PLA			; |
	EOR DirFix,y		; |
	CMP $00		; | ; If Range > !Temp return. 
	BCS +			; |
	LDA #$01		; | A = #$01.
	RTS			; |
+	LDA #$00		; | A = #$00 if not in range.
	RTS			;/
;===================================
;Sprite Function
;===================================
RETURN: RTS
SpriteCode:
	JSR Graphics
	LDA $14C8,x			;\
	CMP #$08			; | If sprite dead,
	BNE RETURN			;/ Return.
	LDA $9D				;\
	BNE RETURN			;/ If locked, return.
	JSR SubOffscreenX0		; Handle offscreen
	LDA $151C,x
	BEQ JSLS
	DEc $151C,x
JSLS:
	JSL $018032
	JSL $01A7DC	;\
	BCC NoContact	; |
	LDA $0E		; |Use if default Contact routine isn't used.
	CMP #$E6	; |
	BPL SpriteWins	;/
	LDA $C2,x
	BNE SpriteWins
	LDA #$B0
	STA $7D
	LDA #$13
	STA $1DF9
	LDA $7FAB10,x
	AND #$04
	BNE ReduceHealth
	LDA #!Spawn ; Sprite # of sprite you wish to load
	STA $9E,x
	LDA #$01 ; Sprite Status of sprite you wish to load
	STA $14C8,x
	JSL $07F7D2 ; Reset sprite tables.
	BRA NoContact
ReduceHealth:
	DEC $1528,x
	BPL NoContact
	LDA #$02
	STA $14C8,x
	STZ $B6,x
	JSL $018022
	LDA #$03
	STA $1602,x
	RTS
SpriteWins:
	JSL $00F5B7	; Code for when sprite hits mario goes here.
NoContact:
	LDA $C2,x	;\ Pointer JSL,
	JSL $0086DF	;/ determines what Action the sprite should take.

	dw Walking
	dw ShellRise
	dw ShellWhirl
	dw TornadoSmash



Walking:
	LDA $14
	LSR
	LSR
	LSR
	AND #$01
	STA $1602,x
	LDA $1588,x
	AND #$03
	BEQ NoSwitchDir
	LDA $157C,x
	EOR #$01
	STA $157C,x
NoSwitchDir:
	JSL $019138
	LDA $151C,x
	BNE NoSwitchDir2
	LDA $1588,x
	AND #$04
	BNE NoSwitchDir2
	LDA $B6,x
	EOR #$FF
	STA $B6,x
	JSL $018022
	LDA $157C,x
	EOR #$01
	STA $157C,x
	LDA #$08
	STA $151C,x
NoSwitchDir2:
	LDY $157C,x
	LDA Xspeed,y
	STA $B6,x
	JSL $018022
	LDA $1510,x
	INC A
	STA $1510,x
	CMP #$40
	BNE State1RET
	INC $C2,x
	STZ $1510,x
	STZ $1504,x
	STZ $AA,x
	STZ $B6,x
State1RET:
	RTS

ShellRise:
	LDA $14
	LSR
	AND #$01
	CLC
	ADC #$02
	STA $1602,x
	DEC $AA,x
	JSL $01801A
	LDA $AA,x
	CMP #$D8
	BNE State2RET
	INC $C2,x
	STZ $AA,x
	LDA #$0F
	STA $1DF9
State2RET:
	RTS
ShellWhirl:
	LDA $14
	LSR
	AND #$01
	CLC
	ADC #$02
	STA $1602,x
	INC $1504,x
	LDA $1504,x
	CMP #$08
	BNE TimeStuff
	STZ $1504,x
LDY #$07
ExtraLoop:
LDA $170B,y
BEQ Extra1
DEY
BPL ExtraLoop
RTS

Extra1:
LDA #$0B
STA $170B,y
LDA $E4,x
STA $171F,y ; X position low byte
LDA $14E0,x
STA $1733,y ; X position high byte
LDA $D8,x
STA $1715,y ; Y position low byte
LDA $14D4,x
STA $1729,y ; Y position high byte
LDA #$EC
STA $173D,y
LDA #$60
JSL RandomRoutine
SEC
SBC #$30
STA $1747,y
LDA #$FF
STA $176F,y
TimeStuff:
	LDA $1510,x
	INC A
	STA $1510,x
	CMP #$F0
	BNE State3RET
	INC $C2,x
	STZ $1510,x
State3RET:
	RTS
TornadoSmash:
	LDA $14
	LSR
	AND #$01
	CLC
	ADC #$02
	STA $1602,x
	LDA #$28
	STA $AA,x
	JSL $01802A
	LDA $1588,x
	AND #$04
	BEQ State4RET
	STZ $C2,x
	LDA #$09
	STA $1DFC
	LDA #$30
	STA $1887
	LDA $77
	AND #$04
	BEQ State4RET
	LDA #$50
	STA $00
	JSR VProximity
	BEQ State4RET
	LDA #$50
	STA $00
	JSR Proximity
	BEQ State4RET
	LDA #$30
	STA $18BD
	JSR SubHorzPos	;\
	TYA		; | Use if enemy doesn't change direction in main code.
	STA $157C,x	;/
State4RET:
	RTS
	
;===================================
;Graphics Code
;===================================
TileMap:	db $82,$A2,$82,$A0
		db $80,$8E,$80,$8C
Yoffset:	db $F0,$00
Graphics:
        JSR GetDrawInfo         ; sets y = OAM offset   

	LDA $1602,x
	ASL A
	STA $03             

	LDA $157C,x
	ASL A
	STA $02

	PHX
	LDX #$01
Loop:
	LDA $00                 ; \ tile x position = sprite y location ($01)
	STA $0300,y             ; /

	LDA Yoffset,x
	CLC
	ADC $01                 ; \ tile y position = sprite x location ($00)
	STA $0301,y             ; /

	PHX
	TXA
	CLC
	ADC $03
	TAX
	LDA TileMap,x
	STA $0302,y 
	PLX

	PHX
	LDX $15E9
	LDA $15F6,x             ; tile properties xyppccct, format
	LDX $02                 ; \ if direction == 0...
	BEQ NoFlip              ;  |
	ORA #$40                ; /    ...flip tile
NoFlip:
	ORA $64                 ; add in tile priority of level
	STA $0303,y             ; store tile properties
	PLX
	INY	 		; \ increase index to sprite tile map ($300)...
	INY			;  |    ...we wrote 1 16x16 tile...
	INY	 		;  |    ...sprite OAM is 8x8...
	INY	 		; /    ...so increment 4 times
	DEX
	BPL Loop

	PLX

	LDY #$02                ; \ 460 = 2 (all 16x16 tiles)
	LDA #$01                ;  | A = (number of tiles drawn - 1)
	JSL $01B7B3             ; / don't draw if offscreen
	RTS	 		; return
;===================================
;Library Routines
;===================================

Table1:              db $0C,$1C
Table2:              db $01,$02

GetDrawInfo:

STZ $186C,x
STZ $15A0,x
LDA $E4,x
CMP $1A
LDA $14E0,x
SBC $1B
BEQ OnscreenX
INC $15A0,x
OnscreenX:
LDA $14E0,x
XBA
LDA $E4,x
REP #$20
SEC
SBC $1A
CLC
ADC.w #$0040
CMP #$0180
SEP #$20
ROL A
AND #$01
STA $15C4,x
BNE Invalid

LDY #$00
LDA $1662,x
AND #$20
BEQ OnscreenLoop
INY
OnscreenLoop:
LDA $D8,x
CLC
ADC Table1,y
PHP
CMP $1C
ROL $00
PLP
LDA $14D4,x
ADC #$00
LSR $00
SBC $1D
BEQ OnscreenY
LDA $186C,x
ORA Table2,y
STA $186C,x
OnscreenY:
DEY
BPL OnscreenLoop
LDY $15EA,x
LDA $E4,x
SEC
SBC $1A
STA $00
LDA $D8,x
SEC
SBC $1C
STA $01
RTS

Invalid:
PLA
PLA
RTS
      
Table3:              db $40,$B0
Table6:              db $01,$FF
Table4:              db $30,$C0,$A0,$C0,$A0,$F0,$60,$90,$30,$C0,$A0,$80,$A0,$40,$60,$B0
Table5:              db $01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$FF,$01,$00,$01,$FF

SubOffscreenX0:
LDA #$00
STA $03

JSR SubIsOffscreen
BEQ Return2

LDA $5B
LSR
BCS VerticalLevel
LDA $D8,x
CLC
ADC #$50
LDA $14D4,x
ADC #$00
CMP #$02
BPL EraseSprite
LDA $167A,x
AND #$04
BNE Return2
LDA $13
AND #$01
ORA $03
STA $01
TAY
LDA $1A
CLC
ADC Table4,y
ROL $00
CMP $E4,x
PHP
LDA $1B
LSR $00
ADC Table5,y
PLP
SBC $14E0,x
STA $00
LSR $01
BCC Label20
EOR #$80
STA $00
Label20:
LDA $00
BPL Return2

EraseSprite:
LDA $14C8,x
CMP #$08
BCC KillSprite
LDY $161A,x
CPY #$FF
BEQ KillSprite
LDA #$00
STA $1938,y
KillSprite:
STZ $14C8,x
Return2:
RTS

VerticalLevel:

LDA $167A,x
AND #$04
BNE Return2
LDA $13
LSR
BCS Return2
AND #$01
STA $01
TAY
LDA $1C
CLC
ADC Table3,y
ROL $00
CMP $D8,x
PHP
LDA $1D
LSR $00
ADC Table6,y
PLP
SBC $14D4,x
STA $00
LDY $02
BEQ Label22
EOR #$80
STA $00
Label22:
LDA $00
BPL Return2
BMI EraseSprite

SubIsOffscreen:
LDA $15A0,x
ORA $186C,x
RTS

SubHorzPos:
LDY #$00
LDA $94
SEC
SBC $E4,x
STA $0F
LDA $95
SBC $14E0,x
BPL $01
INY
RTS

SubVertPos:
LDY #$00
LDA $96
SEC
SBC $D8,x
STA $0F
LDA $97
SBC $14D4,x
BPL $01
INY
RTS