;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Layer 3 Air Meter - By Sonikku. 
; To customize;
; Change RAM_AirMeter to an empty RAM address. 
; Change MeterPos to change the position of the meter.
; Change DSpeed to change the speed at which it counts down. ($00 = Fast, $FF = Slow)
; Change USpeed to change the speed at which it counts up.
; Change Sound to change what sound is played every time it decreases.
; If you want to reverse the Air Meter, change "BEQ NOSWIM" to "BNE NOSWIM".
; 
; Other stuff;
; Oddly, the Kill Mario JSL glitches with this meter, so I STZ'd his powerup and hurts 
; him as an alternative. Hope that isn't much of a problem.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Sprite Code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	dcb "INIT"
	LDA #$09
	STA RAM_AirMeter
	RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RAM_AirMeter = $6734
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MeterPos = $0F1D
DSpeed = $7F
USpeed = $0F
Sound = $0E
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Main Sprite Code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		dcb "MAIN"
		LDA RAM_AirMeter	;Store Air Meter onto the..
		STA MeterPos		;position of the Air Meter.
		LDA $75			;If Mario isn't in water..
		BEQ NOSWIM		;Go to NOSWIM.
		LDA $14			;
		AND #DSpeed		;If the frame isn't $7F
		BNE RETURN		;RETURN
		DEC RAM_AirMeter	;If it is, decrease air by 1. 
		LDA #Sound		;Play Sound effect
		STA $1DF9		;
		LDA RAM_AirMeter	;
		CMP #$FF		;If Mario's Air Meter isn't $FF
		BNE RETURN		;RETURN
		STZ RAM_AirMeter	;If it is, make it zero (To prevent scrolling through all tiles.)
		LDA RAM_AirMeter	;If his air isn't zero
		BNE RETURN		;RETURN
		STZ $19			;Make Mario Small..
		JSL $00F5B7		;And Hurt him. (To kill him)
RETURN:				;
		RTL			;Return
NOSWIM:				;
		LDA $14
		AND #USpeed
		BNE RETURN
		INC RAM_AirMeter
		LDA #$0A
		CMP RAM_AirMeter
		BNE RETURN
		LDA #09
		STA RAM_AirMeter
		RTL			;Return