;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Yellow Blurp Fish - by Le Comte Niark
; Based on nekoh's disassembled SMW Blurp
;
; Uses first extra bit: NO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
                    LDY #$00                
                    LDA $D1                   
                    SEC                       
                    SBC $E4,X       
                    STA $0F                   
                    LDA $D2                   
                    SBC.W $14E0,X     
                    BPL Return01AD41          
                    INY                             
                    TYA                       
                    STA $157C,X     
Return01AD41:       RTL                       


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite main code 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                           
                    dcb "MAIN"
                    PHB                       
                    PHK                       
                    PLB                             
                    JSR Blurp         
                    PLB                       
                    RTL                       ; Return 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BlurpMaxSpeedY:     db $04,$FC

BlurpSpeedX:        db $10,$F0

BlurpAccelY:        db $01,$FF

Blurp:              JSL $0190B2   
                    LDY $15EA,X   ; Y = Index into sprite OAM 
                    LDA $14   
                    LSR                       
                    LSR                       
                    LSR                       
                    CLC                       
                    ADC $15E9               
                    LSR                       
                    LDA #$A2                
                    BCC CODE_0384E2           
                    LDA #$EC                
CODE_0384E2:        STA $0302,Y          
                    LDA $14C8,X             
                    CMP #$08                
                    BEQ CODE_0384F5           
                    LDA $0303,Y          
                    ORA #$80                
                    STA $0303,Y          
                    RTS                       ; Return 

CODE_0384F5:        LDA $9D     
                    BNE Return03852A          
                    JSR SubOffscreen0Bnk3   
                    LDA $14     
                    AND #$03                
                    BNE CODE_038516           
                    LDA $C2,X     
                    AND #$01                
                    TAY                       
                    LDA $AA,X    
                    CLC                       
                    ADC BlurpAccelY,Y       
                    STA $AA,X    
                    CMP BlurpMaxSpeedY,Y    
                    BNE CODE_038516           
                    INC $C2,X     
CODE_038516:        LDY $157C,X     
                    LDA BlurpSpeedX,Y       
                    STA $B6,X    
                    JSL $018022   
                    JSL $01801A  
                    JSL $01803A
Return03852A:       RTS                       ; Return 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Sprite Graphics Routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DATA_03B83B:                      db $40,$B0
DATA_03B83D:                      db $01,$FF
DATA_03B83F:                      db $30,$C0,$A0,$80,$A0,$40,$60,$B0
DATA_03B847:                      db $01,$FF,$01,$FF,$01,$00,$01,$FF

SubOffscreen0Bnk3:  STZ $03                     ; / 
                    JSR IsSprOffScreenBnk3      ; \ if sprite is not off screen, return 
                    BEQ RETURNONE               ; / 
                    LDA $5B                     ; \  vertical level 
                    AND #$01                    ;  | 
                    BNE VerticalLevelBnk3       ; / 
                    LDA $D8,X                   ; \ 
                    CLC                         ;  | 
                    ADC #$50                    ;  | if the sprite has gone off the bottom of the level... 
                    LDA $14D4,X                 ;  | 
                    ADC #$00                    ;  | 
                    CMP #$02                    ;  | 
                    BPL OffScrEraseSprBnk3      ; /    ...erase the sprite 
                    LDA $167A,X                 ; \ if "process offscreen" flag is set, return 
                    AND #$04                    ;  | 
                    BNE RETURNONE               ; / 
                    LDA $13      
                    AND #$01                
                    ORA $03                   
                    STA $01                   
                    TAY                       
                    LDA $1A    
                    CLC                       
                    ADC DATA_03B83F,Y       
                    ROL $00                   
                    CMP $E4,X       
                    PHP                       
                    LDA $1B    
                    LSR $00                   
                    ADC DATA_03B847,Y       
                    PLP                       
                    SBC $14E0,X     
                    STA $00                   
                    LSR $01                   
                    BCC CODE_03B8A8           
                    EOR #$80                
                    STA $00        
           
CODE_03B8A8:        LDA $00                   
                    BPL RETURNONE   
       
OffScrEraseSprBnk3: LDA $14C8,X                 ; \ If sprite status < 8, permanently erase sprite 
                    CMP #$08                    ;  | 
                    BCC OffScrKillSprBnk3       ; / 
                    LDY $161A,X                 ; \ Branch if should permanently erase sprite 
                    CPY #$FF                    ;  | 
                    BEQ OffScrKillSprBnk3       ; / 
                    LDA #$00                    ; \ Allow sprite to be reloaded by level loading routine 
                    STA $1938,Y                 ; / 
OffScrKillSprBnk3:  STZ $14C8,X 
            
RETURNONE:          RTS                         ; Return 

VerticalLevelBnk3:  LDA $167A,X                 ; \ If "process offscreen" flag is set, return 
                    AND #$04                    ;  | 
                    BNE RETURNONE               ; / 
                    LDA $13                     ; \ Return every other frame 
                    LSR                         ;  | 
                    BCS RETURNONE               ; / 
                    AND #$01                
                    STA $01                   
                    TAY                       
                    LDA $1C    
                    CLC                       
                    ADC DATA_03B83B,Y       
                    ROL $00                   
                    CMP $D8,X       
                    PHP                       
                    LDA $1D  
                    LSR $00                   
                    ADC DATA_03B83D,Y       
                    PLP                       
                    SBC $14D4,X     
                    STA $00                   
                    LDY $01                   
                    BEQ CODE_03B8F5           
                    EOR #$80                
                    STA $00  
                 
CODE_03B8F5:        LDA $00                   
                    BPL RETURNONE          
                    BMI OffScrEraseSprBnk3 
   
IsSprOffScreenBnk3: LDA $15A0,X                 ; \ If sprite is on screen, A = 0  
                    ORA $186C,X                 ;  | 
                    RTS                         ; / Return 

