;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Boo ring	by 33953YoShI
;
; This sprite is depend on same position tile number.
;
; IMPORTANT NOTE:
; - This sprite is require No More Sprite Tile Limit for use.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Uses first extra bit: YES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Extra Bit	Rotation direction
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Num, Space, Radius, Speed
Settings:	db $0A,$28,$50,$10	; Tile xxx0
		db $04,$66,$38,$18	; Tile xxx1
		db $05,$55,$40,$14	; Tile xxx2
		db $0A,$28,$50,$10	; Tile xxx3
		
		db $0A,$28,$50,$10	; Tile xxx4
		db $0A,$28,$50,$10	; Tile xxx5
		db $0A,$28,$50,$10	; Tile xxx6
		db $0A,$28,$50,$10	; Tile xxx7
		
		db $0A,$28,$50,$10	; Tile xxx8
		db $0A,$28,$50,$10	; Tile xxx9
		db $0A,$28,$50,$10	; Tile xxxA
		db $0A,$28,$50,$10	; Tile xxxB
		
		db $0A,$28,$50,$10	; Tile xxxC
		db $0A,$28,$50,$10	; Tile xxxD
		db $0A,$28,$50,$10	; Tile xxxE
		db $13,$16,$50,$7F	; Tile xxxF


		!DispX =	$03
		!DispY =	$03
		!Width =	$0A
		!Height =	$0A

		!ExtraBits =	$7FAB10
		!ExtraProp1 =	$7FAB28
		!ExtraProp2 =	$7FAB34
		!NewSpriteNum =	$7FAB9E
		
		!GetSin =	$87F7DB
		!GetCos =	$87F7DB
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
		print "INIT ",pc
		PHB
		PHK
		PLB
		JSR InitCode
		PLB
		RTL

		print "MAIN ",pc
		PHB
		PHK
		PLB
		JSR MainCode
		PLB
		RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

InitCode:	LDA $E4,x
		STA $9A
		LDA $14E0,x
		STA $9B
		LDA $D8,x
		STA $98
		LDA $14D4,x
		STA $99
		CLC
		JSR GetBlock
		AND #$0F
		ASL #2
		TAY
		LDA.w Settings+$02,y
		STA $187B,x
		LDA.w Settings,y
		AND #$3F
		STA !ExtraProp1,x
		LDA.w Settings+$01,y
		STA $1602,x
		LDA !ExtraBits,x
		AND #$04
		CMP #$04
		LDA.w Settings+$03,y
		BCC +
		EOR #$FF
		INC A
+		STA $1504,x
		STZ $1510,x
		STZ $151C,x
		STZ $1528,x
		LDA #$00
		STA !ExtraProp2,x
		RTS
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MainCode:	JSR GetDrawInfo
		LDA $9D
		BNE .Start
		LDY #$06
		JSR SubOffScreen
		LDA $1504,x
		TAY
		ASL #4
		CLC
		ADC $1510,x
		STA $1510,x
		TYA
		PHP
		LSR #4
		LDY #$00
		PLP
		BPL .IfPlus
		ORA #$F0
		DEY
.IfPlus		ADC $151C,x
		STA $151C,x
		TYA
		ADC $1528,x
		AND #$01
		STA $1528,x
		
.Start		LDA $151C,x
		STA $04
		LDA $1528,x
		STA $05
		LDA $187B,x
		STA $0C
		STA $4202
		LDA !ExtraProp1,x
		AND #$3F
		STA $0D
		STA $0F
		TAY
		LDA $E4,x
		STA $08
		LDA $14E0,x
		STA $09
		LDA $D8,x
		STA $0A
		LDA $14D4,x
		STA $0B
		LDA $1602,x
		STA $06
		STZ $07

		REP #$30
.PositionLoop	LDA $04
		STA $00
		CLC
		ADC.w #$0080
		AND.w #$01FF
		STA $02
		AND.w #$00FF
		ASL A
		TAX
		LDA.l !GetCos,x
		CMP.w #$0100
		AND.w #$00FF
		SEP #$30
		STA $4203
		LDX $00		; pre-load angle
		LDA $0C
		BCS .SkipCos
		ASL $4216
		LDA $4217
		ADC #$00
.SkipCos	LSR $03
		REP #$30
		BCC .NotNegCos
		EOR.w #$FFFF
.NotNegCos	ADC $08
		PHA
		
		TXA
		ASL A
		TAX
		LDA.l !GetSin,x
		CMP.w #$0100
		AND.w #$00FF
		SEP #$30
		STA $4203
		LDA $0C
		BCS .SkipSin
		LDA $0C		; wait 3 cycles...
		ASL $4216
		LDA $4217
		ADC #$00
.SkipSin	LSR $01
		REP #$30
		BCC .NotNegSin
		EOR.w #$FFFF
.NotNegSin	ADC $0A
		PHA
		
		LDA $04
		CLC
		ADC $06
		AND.w #$01FF
		STA $04
		DEY
		BPL .PositionLoop
		
.LoopEnd	SEP #$30
		LDX $15E9
		LDA $15C4,x
		BNE +
		JSR SubGFX
+		LDA $71
		BNE .PullLoop
		LDA $13F9
		EOR $1632,x
		BEQ .GetCollision
.PullLoop	REP #$20
		LDA $0D
		INC A
		AND.w #$00FF
		ASL #2
		STA $0D
		TSC
		ADC $0D
		TCS
		SEP #$20
		RTS

.GetCollision	LDA #!Width
		STA $06
		LDA #!Height
		STA $07
		JSL $83B664

.CollisionLoop	LDA $0D
		EOR $14
		LSR A
		BCC .PullNext
		LDA $94
		SBC $03,s
		CLC
		ADC #$20
		CMP #$40
		BCS .PullNext
		LDA $96
		ADC #$18
		SEC
		SBC $01,s
		CMP #$60
		BCS .PullNext
		PLA
		PLY
		ADC #!DispY
		STA $05
		BCC +
		INY
		CLC
+		STY $0B
		PLA
		PLY
		ADC #!DispX
		STA $04
		BCC +
		INY
+		STY $0A
		JSL $83B72B
		BCC .Next
		LDA $1497
		ORA $1490
		BNE .Next
		LDA $187A
		BEQ +
		JSR LoseYoshi
		BRA .Next
+		JSL $80F5B7
		BRA .Next
.PullNext	PLA
		PLA
		PLA
		PLA
.Next		DEC $0D
		BPL .CollisionLoop
		RTS

LoseYoshi:	LDX $18E2
		DEX
		BMI +
		LDA #$10
		STA $163E,x
		LDA #$03
		STA $1DFA
		LDA #$13
		STA $1DFC
		LDA #$02
		STA $C2,x
		STZ $187A
		STZ $0DC1
		LDA #$C0
		STA $7D
		STZ $7B
		LDY $157C,x
		LDA .SetXspeed,y
		STA $B6,x
		STZ $1594,x
		STZ $151C,x
		STZ $18AE
		LDA #$30
		STA $1497
+		LDX $15E9
		RTS

.SetXspeed	db $20,$E0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

TileMap:	db $AE,$AA
		db $8C,$88
		db $8C,$88
		db $8E,$A8

SubGFX:		LDA $14
		LSR #3
		AND #$01
		TAY
		LDA $15F6,x
		EOR $64
		EOR #$40
		STA $04
		STZ $2183
		LDA #$03
		STA $2182
		LDA $15EA,x
		STA $2181
		LSR #2
		ADC #$60
		STA $02
		LDA #$04
		STA $03
		TSX

.Loop		REP #$21
		LDA $0103,x
		ADC.w #$000F
		SEC
		SBC $1C
		CMP.w #$00EF
		BCS .Next
		STA $00
		LDA $0105,x
		ADC.w #$000F
		SEC
		SBC $1A
		CMP.w #$011F
		BCS .Next
		SBC.w #$000E
		SEP #$21
		STA $2180
		XBA
		AND #$01
		ORA #$02
		STA ($02)
		INC $02
		LDA $00
		SBC #$0F
		STA $2180
		LDA.w TileMap,y
		STA $2180
		LDA $04
		STA $2180
.Next		SEP #$21
		TXA			;\
		ADC #$03		; | X += 4
		TAX			;/
		TYA
		ADC #$02
		AND #$07
		TAY
		DEC $0F
		BPL .Loop
		LDX $15E9
		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GetDrawInfo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; DON'T REPLACE TO SHARED ROUTINE.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetDrawInfo:	LDA $E4,x
		CMP $1A
		LDA $14E0,x
		SBC $1B
		BEQ .OnScreenX
		LDA #$01
.OnScreenX	STA $15A0,x

		LDA $14E0,x
		PHA
		LDA $E4,x
		PHA
		LDY $187B,x
		REP #$20
		TYA
		STA $00
		ASL A
		ADC.w #$0110
		STA $02
		PLA
		ADC $00
		CLC
		ADC.w #$0010
		SEC
		SBC $1A
		CMP $02
		SEP #$20
		TDC
		ROL A
		STA $15C4,x
		BNE .Invalid

		LDA $14D4,x
		XBA
		LDA $D8,x
		REP #$21
		ADC.w #$000C
		SEC
		SBC $1C
		SEP #$20
		XBA
		BEQ .OnScreenY
		LDA #$01
.OnScreenY	STA $186C,x
.Invalid	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubOffScreen:	LDA $15A0,x
		ORA $186C,x
		BEQ .Return2
		LDA $167A,x
		AND #$04
		BNE .Return2
		LDA $5B
		LSR A
		BCS .VerticalLevel
		LDA $D8,x
		ADC #$50
		LDA $14D4,x
		ADC #$00
		CMP #$02
		BCS .EraseSprite
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$21
		ADC .AddTable,y
		SEC
		SBC $1A
		CMP .CmpTable,y
.Common		SEP #$20
		BCC .Return2
.EraseSprite	LDA $14C8,x
		CMP #$08
		BCC .KillSprite
		LDY $161A,x
		CPY #$FF
		BEQ .KillSprite
		LDA $1938,y
		AND #$FE
		STA $1938,y
.KillSprite	STZ $14C8,x
.Return2	RTS

.VerticalLevel	LDA $13
		LSR A
		BCS .CheckY
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$21
		ADC.w #$0040
		CMP.w #$0280
		BRA .Common
.CheckY		LDA $14D4,x
		XBA
		LDA $D8,x
		REP #$20
		SBC $1C
		CLC
		ADC.w #$0070
		CMP.w #$01D0
		BRA .Common

.AddTable	dw $0040,$0040,$0010,$0070
		dw $0090,$0050,$0080,$FFC0
.CmpTable	dw $0170,$01E0,$01B0,$01D0
		dw $0230,$01B0,$0220,$0160

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetBlock:	BCC .Layer1
		LDA $5B
		BPL .Layer1
		LSR A
		BCC .Horz0
		LDA $99
		ADC #$0D
		STA $99
		BRA .Common0
.Horz0		LDA $9B
		ADC #$10
		STA $9B
.Common0	REP #$21
		LDA $9A
		ADC $26
		STA $9A
		LDA $98
		CLC
		ADC $28
		STA $98
		SEP #$20
.Layer1		JSR .GetBlockAddr
		LDA [$00]
		TAY
		DEC $02
		LDA [$00]
		STA $1693
		RTS

.GetBlockAddr	LDA $9A
		LSR #4
		STA $00
		LDA $98
		AND #$F0
		ORA $00
		STA $00
		STZ $02
		LDA $5B
		LSR A
		LDA $99
		BCC .HorzLevel
		ASL A
		STA $03
		LDA $9B
		STA $01
		REP #$21
		TDC
		BRA .Common
.HorzLevel	STA $03
		STZ $01
		LDA $9B
		ASL A
		STA $4202
		LDA #$D8
		STA $4203
		REP #$21
		NOP #3
		LDA $4216
.Common		ADC $02
		ADC $00
		ADC.w #$C800
		STA $00
		SEP #$20
		LDA #$7F
		STA $02
		RTS
