;@sa1 <-- DO NOT REMOVE THIS LINE!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Classic Firebar - SA-1 Compatible version    by 33953YoShI
;
; IMPORTANT NOTE:
; - This sprite is require No More Sprite Tile Limit for use.
; - This sprite is for the exclusive use of Vitor Vilela's SA-1 pack!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Uses first extra bit: YES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Extra Bit			Rotation direction
; Extra Property Byte 1		bit0-6	: Number of fire -2
;				bit7	: Default angle, highbyte
; Extra Property Byte 2		Default angle, lowbyte
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		!ClockSpeed =	$02
		!CounterClock =	$FE

		!DispX =	$01
		!DispY =	$01
		!Width =	$06
		!Height =	$06

; SA-1 pack - Memory remap
		!BW =		$6000
		
		!9E =		$3200
		!AA =		$9E
		!B6 =		$B6
		!C2 =		$D8
		!D8 =		$3216
		!E4 =		$322C

		!00AA =		$309E
		!00B6 =		$30B6
		!00C2 =		$30D8
		!009E =		$3200
		!00D8 =		$3216
		!00E4 =		$322C
		!14C8 =		$3242
		!14D4 =		$3258
		!14E0 =		$326E
		!151C =		$3284
		!1528 =		$329A
		!1534 =		$32B0
		!1540 =		$32C6
		!154C =		$32DC
		!1558 =		$32F2
		!1564 =		$3308
		!1570 =		$331E
		!157C =		$3334
		!1588 =		$334A
		!1594 =		$3360
		!15A0 =		$3376
		!15AC =		$338C
		!15EA =		$33A2
		!15F6 =		$33B8
		!1602 =		$33CE
		!160E =		$33E4
		!163E =		$33FA
		!187B =		$3410
		
		!14EC =		$74C8
		!14F8 =		$74DE
		!1504 =		$74F4
		!1510 =		$750A
		!15B8 =		$7520
		!15C4 =		$7536
		!15D0 =		$754C
		!15DC =		$7562
		!161A =		$7578
		!1626 =		$758E
		!1632 =		$75A4
		!190F =		$7658
		!1FD6 =		$766E
		!1FE2 =		$7FD6
		!164A =		$75BA
		!1656 =		$75D0
		!1662 =		$75EA
		!166E =		$7600
		!167A =		$7616
		!1686 =		$762C
		!186C =		$7642
		
		!ExtraBits =	$6040
		!ExtraProp1 =	$6057
		!ExtraProp2 =	$606D
		!NewSpriteNum =	$6083
		
		!GetSin =	$07F7DB
		!GetCos =	$07F7DB
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		print "INIT ",pc
		LDA !D8,x
		AND #$F0
		ORA #$04
		STA !D8,x
		LDA !E4,x
		AND #$F0
		ORA #$04
		STA !E4,x
		
		LDA !ExtraProp1,x
		ASL A
		ROL !151C,x
		LSR A
		STA !187B,x
		LDA !ExtraProp2,x
		STA !1602,x
		LDY #!ClockSpeed
		LDA !ExtraBits,x
		AND #$04
		BEQ +
		LDY #!CounterClock
+		TYA
		STA !1528,x
		STZ !ExtraProp1,x
		STZ !ExtraProp2,x
		RTL
		
		print "MAIN ",pc
		PHB
		PHK
		PLB
		JSR MainCode
		PLB
		RTL
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MainCode:	JSR GetDrawInfo
		LDA $9D
		BNE .Lock
		LDY #$08
		JSR SubOffScreenSA1
		LDY #$00
		LDA !1528,x
		BPL +
		DEY
+		CLC
		ADC !1602,x
		STA !1602,x
		TYA
		ADC !151C,x
		AND #$01
		STA !151C,x
		
.Lock		LDA !14E0,x
		STA $01
		PHA
		LDA !E4,x
		STA $00
		PHA
		LDA !14D4,x
		STA $03
		PHA
		LDA !D8,x
		STA $02
		PHA
		LDY !187B,x
		LDA !151C,x
		XBA
		LDA !1602,x
		REP #$30
		PHY
		STA $0E
		
		TAY
		AND.w #$00FF
		ASL A
		TAX
		LDA !GetSin,x
		LDX.w #$0000
		ASL A
		BEQ +
		ASL #2
		CPY.w #$0100
		BCC +
		EOR.w #$FFFF
		INC A
		DEX
		CLC
+		STA $04
		STA $0C
		STX $06
		LDA $0E
		ADC.w #$0080
		AND.w #$01FF
		TAY
		AND.w #$00FF
		ASL A
		TAX
		LDA !GetCos,x
		LDX.w #$0000
		ASL A
		BEQ +
		ASL #2
		CPY.w #$0100
		BCC +
		EOR.w #$FFFF
		INC A
		DEX
+		STA $08
		STA $0E
		STX $0A
		PLY
		BRA .Init
		
.PositionLoop	LDA $04
		CLC
		ADC $0C
		STA $04
		LDA $08
		CLC
		ADC $0E
		STA $08
		
.Init		LDA $00
		CLC
		ADC $09
		PHA
		LDA $02
		CLC
		ADC $05
		PHA
		
		DEY
		BPL .PositionLoop
		SEP #$30
		
		LDX $15E9|!BW
		LDA !187B,x
		INC A
		STA $0D
		LDY !15C4,x
		BNE +
		STA $0F
		JSR SubGFX
		
+		LDA $71
		BNE .PullAll
		LDA $13F9|!BW
		EOR !1632,x
		BEQ .GetCollision
.PullAll	REP #$20
		LDA $0D
		INC A
		AND.w #$00FF
		ASL #2
		STA $0D
		TSC
		ADC $0D
		TCS
		SEP #$20
		RTS
		
.GetCollision	LDA #!Width
		STA $06
		LDA #!Height
		STA $07
		JSL $03B664
		
.CollisionLoop	LDA $0D
		EOR $14
		LSR A
		BCC .PullNext
		LDA $94
		SBC $03,s
		CLC
		ADC #$20
		CMP #$40
		BCS .PullNext
		LDA $96
		ADC #$18
		SEC
		SBC $01,s
		CMP #$60
		BCS .PullNext
		
		PLA
		PLY
		ADC #!DispY
		STA $05
		BCC +
		INY
		CLC
+		STY $0B
		PLA
		PLY
		ADC #!DispX
		STA $04
		BCC +
		INY
+		STY $0A
		JSL $03B72B
		BCC .Next
		LDA $1497|!BW
		ORA $1490|!BW
		BNE .Next
		LDA $187A|!BW
		BEQ +
		JSR LoseYoshi
		BRA .Next
+		JSL $00F5B7
		BRA .Next
		
.PullNext	PLA
		PLA
		PLA
		PLA
.Next		DEC $0D
		BPL .CollisionLoop
		RTS
		
LoseYoshi:	LDX $18E2|!BW
		DEX
		BMI +
		LDA #$10
		STA !163E,x
		LDA #$03
		STA $1DFA|!BW
		LDA #$13
		STA $1DFC|!BW
		LDA #$02
		STA !C2,x
		STZ $187A|!BW
		STZ $0DC1|!BW
		LDA #$C0
		STA $7D
		STZ $7B
		LDY !157C,x
		LDA .SetXspeed,y
		STA !B6,x
		STZ !1594,x
		STZ !151C,x
		STZ $18AE|!BW
		LDA #$30
		STA $1497|!BW
+		LDX $15E9|!BW
		RTS

.SetXspeed	db $20,$E0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubGFX:		TXA
		EOR $14
		LSR #2
		AND #$03
		TAY
		LDA .TileMap,y
		STA $02
		LDA !15F6,x
		EOR .TileProp,y
		ORA $64
		STA $03
		LDA !15EA,x
		TAY
		LSR #2
		ADC #$60
		STA $04
		LDA #$64
		STA $05
		TSX
		
.Loop		REP #$21
		LDA $3703,x
		ADC.w #$0007
		SEC
		SBC $1C
		CMP.w #$00E7
		BCS .Next
		SBC.w #$0006
		STA $00
		LDA $3705,x
		ADC.w #$0007
		SEC
		SBC $1A
		CMP.w #$0107
		BCS .Next
		SBC.w #$0006
		CMP.w #$0100
		STA $0300|!BW,y
		LDA $02
		STA $0302|!BW,y
		SEP #$20
		LDA $00
		STA $0301|!BW,y
		TDC
		ROL A
		STA ($04)
		INC $04
		TYA
		ADC #$04
		TAY
.Next		SEP #$21
		TXA
		ADC #$03
		TAX
		DEC $0F
		BPL .Loop
		LDX $15E9|!BW
		RTS
		
.TileMap	db $2C,$2D,$2C,$2D
.TileProp	db $00,$00,$C0,$C0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GetDrawInfo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; DON'T REPLACE TO SHARED ROUTINE.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetDrawInfo:	LDA !E4,x
		CMP $1A
		LDA !14E0,x
		SBC $1B
		BEQ .OnScreenX
		LDA #$01
.OnScreenX	STA !15A0,x

		LDA !14E0,x
		PHA
		LDA !E4,x
		PHA
		LDY !187B,x
		INY #2
		REP #$20
		TYA
		ASL #3
		DEC A
		STA $00
		ASL A
		ADC.w #$0108
		STA $02
		PLA
		ADC $00
		CLC
		ADC.w #$0008
		SEC
		SBC $1A
		CMP $02
		SEP #$20
		TDC
		ROL A
		STA !15C4,x
		BNE .Invalid
		
		LDA !14D4,x
		XBA
		LDA !D8,x
		REP #$21
		ADC.w #$000C
		SEC
		SBC $1C
		SEP #$20
		XBA
		BEQ .OnScreenY
		LDA #$01
.OnScreenY	STA !186C,x
.Invalid	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubOffScreenSA1:
		LDA !15A0,x
		ORA !186C,x
		BEQ .Return2
		LDA !167A,x
		AND #$04
		BNE .Return2
		LDA $5B
		LSR A
		BCS .VerticalLevel
		LDA !D8,x
		ADC #$50
		LDA !14D4,x
		ADC #$00
		CMP #$02
		BCS .EraseSprite
		LDA !14E0,x
		XBA
		LDA !E4,x
		REP #$21
		ADC .AddTable,y
		SEC
		SBC $1A
		CMP .CmpTable,y
.Common		SEP #$20
		BCC .Return2
.EraseSprite	LDA !14C8,x
		CMP #$08
		BCC .KillSprite
		LDY !161A,x
		CPY #$FF
		BEQ .KillSprite
		TYX
		LDA.l $418A00,x
		AND #$FE
		STA.l $418A00,x
		LDX $15E9|!BW
.KillSprite	STZ !14C8,x
.Return2	RTS

.VerticalLevel	LDA $13
		LSR A
		BCS .CheckY
		LDA !14E0,x
		XBA
		LDA !E4,x
		REP #$21
		ADC.w #$0040
		CMP.w #$0280
		BRA .Common
.CheckY		LDA !14D4,x
		XBA
		LDA !D8,x
		REP #$20
		SBC $1C
		CLC
		ADC.w #$0070
		CMP.w #$01D0
		BRA .Common

.AddTable	dw $0040,$0040,$0010,$0070
		dw $0090,$0050,$0080,$FFC0
.CmpTable	dw $0170,$01E0,$01B0,$01D0
		dw $0230,$01B0,$0220,$0160
