;==============================================
; Flyin' Football
; By Erik557
;
; Description: A footbal that flies similar to
; a green parakoopa (sprite 08) and that when
; stomped acts like a normal football.
;
; Uses first extra bit: NO
;===============================================

!FootballTile = $8A

WingsTiles:
       db $5D,$C6,$5D,$C6
WingProps:
       db $76,$76,$36,$36
XSpeeds:
       db $08,$F8

;=================================
; INIT and MAIN Wrappers
;=================================

print "INIT ",pc
       JSR SubHorizPos
       TYA
       STA $157C,x
       JSL $01ACF9
       STA $1570,x
       RTL

print "MAIN ",pc
       PHB
       PHK
       PLB
       JSR flyinFootball
       PLB
       RTL

Return:
       RTS
flyinFootball:
       JSR Graphics
       LDA $14C8,x
       EOR #$08
       ORA $9D
       BNE Return
       TAY
       JSR SubOffScreen
       LDY $157C,x
       LDA XSpeeds,y
       STA $B6,x
       JSL $018022
       LDY #$FC
       INC $1570,x
       LDA $1570,x
       AND #$20
       BEQ +
       LDY #$04
+      STY $AA,x
       LDA $1570,x
       LSR #3
       AND #$01
       STA $1602,x
       JSL $01801A
       JSL $018032
       JSL $01A7DC
       BCC Return
       LDA $1490
       BNE .star
       LDA $0E
       CMP #$E6
       BMI .cont
       LDA $7D
       BPL .cont
       LDA $1497
       BNE +
       JSL $00F5B7
       LDX $15E9
       JSR SubHorizPos
       TYA
       STA $157C,x
+      RTS
.cont
       JSL $01AB99

       LDA $140D
       ORA $187A
       BNE .spinJump

       JSL $01AA33

       LDA #$1B
       STA $9E,x

       LDA $1626,x
       PHA
       JSL $07F7D2
       PLA
       STA $1626,x

GivePoints:
       PHY
       LDA $1697
       CLC
       ADC $1626,x
       INC $1697
       TAY
       INY
       CPY #$08
       BCS +
       LDA KillSFX,y
       STA $1DF9
+      TYA
       CMP #$08
       BCC +
       LDA #$08
+      JSL $02ACE5
       PLY
.return
       RTS

flyinFootball_star:
       JSL $01AB6F
       INC $18D2
       LDA $18D2
       CMP #$08
       BCC +
       LDA #$08
       STA $18D2
+      JSL $02ACE5
       LDY $18D2
       CPY #$08
       BCS +
       LDA KillSFX,y
       STA $1DF9
+      LDA #$02
       STA $14C8,x
       LDA #$D0
       STA $AA,x
       JSR SubHorizPos
       LDA KillSpeeds,y
       STA $B6,x
       RTS

flyinFootball_spinJump:
       JSR GivePoints
       LDA #$04
       STA $14C8,x
       LDA #$1F
       STA $1540,x
       LDA #$08
       STA $1DF9
       JSL $07FC3B
       LDA #$F8
       STA $7D
       RTS

KillSFX:
       db $00,$13,$14,$15,$16,$17,$18,$19
KillSpeeds:
       db $F0,$10

;========================
; Graphics routine
;========================

; jesus this is horrible. so i commented it.
Graphics:
       JSR GetDrawInfo
       LDA $1602,x          ;\  tile index for future uses
       STA $02              ;/
       LDA $157C,x          ;\
       ASL                  ; | multiply the direction
       CLC                  ; | add our frame index to index the tables
       ADC $02              ; |
       TAX                  ;/
       LDA $00              ;\
       CLC                  ; | wings x pos
       ADC WingsXDisp,x     ; |
       STA $0300,y          ;/
       LDA $01              ;\
       CLC                  ; | wings y pos
       ADC WingsYDisp,x     ; |
       STA $0301,y          ;/
       LDA WingsTiles,x     ;\  wings tilemap
       STA $0302,y          ;/
       LDA $64              ;\
       ORA WingProps,x      ; | wings properties
       STA $0303,y          ;/
       TYA                  ;\
       LSR #2               ; | index into tilesize
       TAY                  ;/
       LDA WingsSize,x      ;\  variable size, depending on the wing frame
       STA $0460,y          ;/

       LDX $15E9            ;   retrieve index
       LDA $15EA,x          ;\
       CLC                  ; | get new set of oam slots
       ADC #$04             ; |
       TAY                  ;/
       REP #$20
       LDA $00              ;\  x and y pos
       STA $0300,y          ;/
       SEP #$20
       LDA #$61             ;\  properties
       STA $0303,y          ;/
       LDA #!FootballTile   ;\  tilemap
       STA $0302,y          ;/
       TYA                  ;\
       LSR #2               ; | index into tilesize
       TAY                  ;/
       LDA #$02             ;\  spiny is 16x16
       STA $0460,y          ;/
       LDA #$01             ;   2 tiles
       LDY #$FF             ;   variable size
       JSL $01B7B3          ;   finish write
       RTS                  ;   CURSE THIS ROUTINE

WingsSize:
       db $00,$02,$00,$02
WingsXDisp:
       db $FF,$F8,$08,$0A
WingsYDisp:
       db $02,$FA,$02,$FA

;========================
; Misc. subroutines
;========================

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  GetDrawInfo:            ;; - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$20
       SEC
       SBC $1A
       STA $00
       CLC
       ADC #$0040
       CMP #$0180
       SEP #$20
       LDA $01
       BEQ +
       LDA #$01
+      STA $15A0,x
       TDC
       ROL A
       STA $15C4,x
       BNE .Invalid
       LDA $14D4,x
       XBA
       LDA $1662,x
       AND #$20
       BEQ .CheckOnce
.CheckTwice
       LDA $D8,x
       REP #$21
       ADC #$001C
       SEC
       SBC $1C
       SEP #$20
       LDA $14D4,x
       XBA
       BEQ .CheckOnce
       LDA #$02
.CheckOnce
       STA $186C,x
       LDA $D8,x
       REP #$21
       ADC #$000C
       SEC
       SBC $1C
       SEP #$21
       SBC #$0C
       STA $01
       XBA
       BEQ .OnScreenY
       INC $186C,x
.OnScreenY
       LDY $15EA,x
       RTS

.Invalid
       PLA
       PLA
       RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  SubOffScreen:           ;; - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
       
       LDA $15A0,x
       ORA $186C,x
       BEQ .Return2
       LDA $167A,x
       AND #$04
       BNE .Return2
       LDA $5B
       LSR A
       BCS .VerticalLevel
       LDA $D8,x
       ADC #$50
       LDA $14D4,x
       ADC #$00
       CMP #$02
       BCS .EraseSprite
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC .AddTable,y
       SEC
       SBC $1A
       CMP .CmpTable,y
.Common
       SEP #$20
       BCC .Return2
.EraseSprite
       LDA $14C8,x
       CMP #$08
       BCC .KillSprite
       LDY $161A,x
       CPY #$FF
       BEQ .KillSprite
       LDA $1938,y
       AND #$FE
       STA $1938,y
.KillSprite
       STZ $14C8,x
.Return2
       RTS

.VerticalLevel
       LDA $13
       LSR A
       BCS .CheckY
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC.w #$0040
       CMP.w #$0280
       BRA .Common
.CheckY
       LDA $14D4,x
       XBA
       LDA $D8,x
       REP #$20
       SBC $1C
       CLC
       ADC.w #$0070
       CMP.w #$01D0
       BRA .Common

.AddTable
       dw $0040,$0040,$0010,$0070
       dw $0090,$0050,$0080,$FFC0
.CmpTable
       dw $0170,$01E0,$01B0,$01D0
       dw $0230,$01B0,$0220,$0160

;==================
  SubHorizPos:
;==================

       LDY #$00
       LDA $94
       SEC
       SBC $E4,x
       STA $0F
       LDA $95
       SBC $14E0,x
       BPL $01
       INY
       RTS

