; Hovering muncher
; for my fam Noivern aka not trs
; By Erik557

;=================================
; INIT and MAIN Wrappers
;=================================

print "MAIN ",pc
       PHB
       PHK
       PLB
       JSR HoverMunch
       PLB
print "INIT ",pc
       RTL

MaxYSpeed:
       db $E8,$18
AccumSpeed:
       db $FF,$01
Tilemap:
       db $AA,$AC

;========================
; Main routine
;========================

HoverMunch:
       JSR Graphics
       LDA $14C8,x
       CMP #$08
       BNE .Return
       LDA $9D
       BNE .Return
       LDA $14
       AND #$01
       BNE .Update
       LDA $C2,x
       AND #$01
       TAY
       LDA $AA,x
       CLC
       ADC AccumSpeed,y
       STA $AA,x
       CMP MaxYSpeed,y
       BNE .Update
       INC $C2,x
.Update
       JSL $01801A
       STZ $1528,x
       JSL $01B44F
       JSL $01A7DC
       BCC +
       JSL $00F5B7
+      LDY #$06
       JSR SubOffScreen
.Return
       RTS

;========================
; Graphics routine
;========================

Graphics:
       JSR GetDrawInfo
       REP #$20
       LDA $00
       STA $0300,y
       SEP #$20
       LDA $15F6,x
       ORA $64
       STA $0303,y
       LDA $14
       LSR #4
       AND #$01
       TAX
       LDA Tilemap,x
       STA $0302,y
       LDX $15E9
       LDY #$02
       TDC
       JSL $01B7B3
       RTS

;========================
; Misc. subroutines
;========================

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  SubOffScreen:           ;; - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
       
       LDA $15A0,x
       ORA $186C,x
       BEQ .Return2
       LDA $167A,x
       AND #$04
       BNE .Return2
       LDA $5B
       LSR A
       BCS .VerticalLevel
       LDA $D8,x
       ADC #$50
       LDA $14D4,x
       ADC #$00
       CMP #$02
       BCS .EraseSprite
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC .AddTable,y
       SEC
       SBC $1A
       CMP .CmpTable,y
.Common
       SEP #$20
       BCC .Return2
.EraseSprite
       LDA $14C8,x
       CMP #$08
       BCC .KillSprite
       LDY $161A,x
       CPY #$FF
       BEQ .KillSprite
       LDA $1938,y
       AND #$FE
       STA $1938,y
.KillSprite
       STZ $14C8,x
.Return2
       RTS

.VerticalLevel
       LDA $13
       LSR A
       BCS .CheckY
       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$21
       ADC.w #$0040
       CMP.w #$0280
       BRA .Common
.CheckY
       LDA $14D4,x
       XBA
       LDA $D8,x
       REP #$20
       SBC $1C
       CLC
       ADC.w #$0070
       CMP.w #$01D0
       BRA .Common

.AddTable
       dw $0040,$0040,$0010,$0070
       dw $0090,$0050,$0080,$FFC0
.CmpTable
       dw $0170,$01E0,$01B0,$01D0
       dw $0230,$01B0,$0220,$0160

;================================================
  GetDrawInfo:            ; - Optimized version
;================================================

       LDA $14E0,x
       XBA
       LDA $E4,x
       REP #$20
       SEC
       SBC $1A
       STA $00
       CLC
       ADC #$0040
       CMP #$0180
       SEP #$20
       LDA $01
       BEQ +
       LDA #$01
+      STA $15A0,x
       TDC
       ROL A
       STA $15C4,x
       BNE .Invalid
       LDA $14D4,x
       XBA
       LDA $1662,x
       AND #$20
       BEQ .CheckOnce
.CheckTwice
       LDA $D8,x
       REP #$21
       ADC #$001C
       SEC
       SBC $1C
       SEP #$20
       LDA $14D4,x
       XBA
       BEQ .CheckOnce
       LDA #$02
.CheckOnce
       STA $186C,x
       LDA $D8,x
       REP #$21
       ADC #$000C
       SEC
       SBC $1C
       SEP #$21
       SBC #$0C
       STA $01
       XBA
       BEQ .OnScreenY
       INC $186C,x
.OnScreenY
       LDY $15EA,x
       RTS

.Invalid
       PLA
       PLA
       RTS

