;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; "Customizable BG scrolling rate" generator
; Coded by Jimmy52905
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	dcb "INIT"
	dcb "MAIN" 
	PHB
	PHK
	PLB
	JSR MAIN
	PLB
	RTL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SETUP
; Read the Readme for more info.
; It's set to H-Scroll: "Variable", V-Scroll: "Slow" by default!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	HorizLayer2_SpeedSlow = $02		;Change this to a higher value to make Layer 2 scroll slower horizontally. Set to a value from $01 to $07.
	HorizLayer2_SpeedFast = $01		;Change this to a higher value to make Layer 2 scroll faster horizontally. Set to a value from $01 to $07.

	VertLayer2_SpeedSlow = $06		;Change this to a higher value to make Layer 2 scroll slower vertically. Set to a value from $01 to $07.
	VertLayer2_SpeedFast = $01		;Change this to a higher value to make Layer 2 scroll faster vertically. Set to a value from $01 to $07.

	BG_INITPostionHi = $00			;\
	BG_INITPostionLo = $BA			;/ Set this to the BG initial position you want. Setting it in LM won't work!

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; MAIN CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
MAIN:
	STZ $1413			;Set horizontal BG scrolling rate to "none" so that this code will work properly.
	STZ $1414			;Set vertical BG scrolling rate to "none" so that this code will work properly.

	REP #$20

	LDA $1462
	LDX #HorizLayer2_SpeedFast
Loop1:
	ASL A
	STA $1466
	DEX
	CPX #$00
	BNE Loop1

	LDX #HorizLayer2_SpeedSlow
Loop2:
	LSR A
	STA $1466
	DEX
	CPX #$00
	BNE Loop2

	LDA $1464
	LDX #VertLayer2_SpeedFast
Loop3:
	ASL A
	STA $1468
	DEX
	CPX #$00
	BNE Loop3

	LDX #VertLayer2_SpeedSlow
Loop4:
	LSR A
	STA $1468
	DEX
	CPX #$00
	BNE Loop4

	LDX #BG_INITPostionLo
INITLoopLo:
	INC $1468
	DEX
	CPX #$00
	BNE INITLoopLo

	LDX #BG_INITPostionHi
INITLoopHi:
	INC $1469
	DEX
	CPX #$00
	BNE INITLoopHi

	SEP #$20
	RTS