;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite 1F - Magikoopa
; adapted for Romi's Spritetool and commented by yoshicookiezeus
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


			!RAM_FrameCounter	= $13
			!RAM_FrameCounterB	= $14
			!RAM_ScreenBndryXLo	= $1A
			!RAM_ScreenBndryXHi	= $1B
			!RAM_ScreenBndryYLo	= $1C
			!RAM_ScreenBndryYHi	= $1D
			!RAM_MarioSpeedX	= $7B
			!RAM_MarioXPos		= $94
			!RAM_MarioXPosHi	= $95
			!RAM_SpritesLocked	= $9D
			!RAM_SpriteNum		= $9E
			!RAM_SpriteSpeedY	= $AA
			!RAM_SpriteSpeedX	= $B6
			!RAM_SpriteState	= $C2
			!RAM_SpriteYLo		= $D8
			!RAM_SpriteXLo		= $E4
			!OAM_DispX		= $0300
			!OAM_DispY		= $0301
			!OAM_Tile		= $0302
			!OAM_Prop		= $0303
			!OAM_Tile2DispX		= $0304
			!OAM_Tile2DispY		= $0305
			!OAM_Tile2		= $0306
			!OAM_Tile2Prop		= $0307
			!OAM_Tile3DispX		= $0308
			!OAM_Tile3DispY		= $0309
			!OAM_Tile3		= $030A
			!OAM_Tile3Prop		= $030B
			!OAM_TileSize		= $0460
			!RAM_SpriteYHi		= $14D4
			!RAM_SpriteXHi		= $14E0
			!RAM_SpriteDir		= $157C
			!RAM_SprObjStatus	= $1588
			!RAM_OffscreenHorz	= $15A0
			!RAM_SprOAMIndex	= $15EA
			!RAM_SpritePal		= $15F6
			!RAM_OffscreenVert	= $186C


!Sprite_To_Gen		= $20					; Magikoopa magic
!Wand_Tile		= $99

SprTilemap:		db $A0,$C0,$A0,$C0,$A4,$C4,$A4,$C4,$A0,$C0,$A0,$C0
Y_Offset:		db $10,$00


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			print "INIT ",pc
			PHB
			PHK
			PLB
			LDY #$09				; setup loop
CODE_01BDBA:		CPY $15E9				;\ if sprite being checked is this one,
			BEQ CODE_01BDCF				;/ branch
			LDA $14C8,y				;\ if sprite being checked is non-existant,
			BEQ CODE_01BDCF				;/ branch
			PHX
			TYX
			LDA $7FAB9E,x				;\ if sprite being checked isn't Magikoopa,
			PLX					; |	
			CMP $7FAB9E,x				; |
			BNE CODE_01BDCF				;/ branch
			STZ $14C8,x				; if code gets here, there is another Magikoopa active, so this one is destroyed
			PLB
			RTL

CODE_01BDCF:		DEY					; decrease loop counter
			BPL CODE_01BDBA				; if sprites left to check, branch
			STZ $18BF				; activate sprite
			PLB
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			print "MAIN ",pc
			PHB
			PHK
			PLB
			JSR Magikoopa
			PLB
			RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Magikoopa:		LDA #$01
			STA $15D0,x
			LDA !RAM_OffscreenHorz,x		;\ if sprite not offscreen,
			BEQ CODE_01BDE2				;/ branch
			STZ !RAM_SpriteState,x			; else, reset sprite state
CODE_01BDE2:		LDA !RAM_SpriteState,x
			AND #$03
			JSL $0086DF

MagiKoopaPtrs:		dw CODE_01BDF2				; searching for a spot
			dw CODE_01BE5F				; appearing
			dw CODE_01BE6E				; attacking
			dw CODE_01BF16				; disappearing

CODE_01BDF2:		LDA $18BF				;\ if sprite not deactivated,
			BEQ CODE_01BDFB				;/ branch
			STZ $14C8,x				; else, destroy sprite
			RTS					; return

CODE_01BDFB:		LDA !RAM_SpritesLocked			;\ if sprites locked,
			BNE Return01BE5E			;/ return
			LDY #$24				;\ something to do with colour addition?
			STY $40					;/
			LDA $1540,x				;\ if still waiting after disappearing,
			BNE Return01BE5E			;/ return
			JSL $01ACF9				; get random number
			CMP #$D1				;\ if random number more than D1,
			BCS Return01BE5E			;/ return
			CLC					;\ else, use it to determine sprite y position
			ADC !RAM_ScreenBndryYLo			; |
			AND #$F0				; |
			STA !RAM_SpriteYLo,x			; |
			LDA !RAM_ScreenBndryYHi			; |
			ADC #$00				; |
			STA !RAM_SpriteYHi,x			;/
			JSL $01ACF9				;\ get another random number
			CLC					; | and use it to determine sprite x position
			ADC !RAM_ScreenBndryXLo			; |
			AND #$F0				; |
			STA !RAM_SpriteXLo,x			; |
			LDA !RAM_ScreenBndryXHi			; |
			ADC #$00				; |
			STA !RAM_SpriteXHi,x			;/
			JSR SUB_HORZ_POS			;\ if sprite closer to Mario than 0x20 pixels,
			LDA $0F					; |
			CLC					; |
			ADC #$20				; |
			CMP #$40				; |
			BCC Return01BE5E			;/ return
			STZ !RAM_SpriteSpeedY,x			; clear sprite y speed
			LDA #$01				;\ set sprite x speed
			STA !RAM_SpriteSpeedX,x			;/
			JSL $019138				; interact with objects
			LDA !RAM_SprObjStatus,x			;\ if sprite not on ground,
			AND #$04				; |
			BEQ Return01BE5E			;/ return
			LDA $1862				;\ if high byte of "acts like" setting of the block that sprite is touching isn't 0 (if block solid),
			BNE Return01BE5E			;/ return
			INC !RAM_SpriteState,x			; go to next sprite state
			STZ $1570,x
			JSR CODE_01BE82
			JSR SUB_HORZ_POS			;\ make sprite face Mario
			TYA					; |
			STA !RAM_SpriteDir,x			;/
Return01BE5E:		RTS					; return

CODE_01BE5F:		JSR CODE_01C004
			STZ $1602,X				; set graphics frame to use
			JSR SubSprGfx1
			RTS					; return


DATA_01BE69:		db $04,$02,$00

DATA_01BE6C:		db $10,$F8

CODE_01BE6E:		STZ $15D0,X
			JSL $01803A				; interact with Mario and with other sprites
			JSR SUB_HORZ_POS			;\ make sprite face Mario
			TYA					; |
			STA !RAM_SpriteDir,x			;/
			LDA $1540,x				;\ if not time to change sprite state,
			BNE CODE_01BE86				;/ branch
			INC !RAM_SpriteState,x			; go to next sprite state
CODE_01BE82:		LDY #$34				;\ more colour addition stuff
			STY $40					;/
CODE_01BE86:		CMP #$40				;\ if not time to generate magic,
			BNE CODE_01BE96				;/ branch
			PHA					; preserve sprite state timer
			LDA !RAM_SpritesLocked			;\ if sprites locked
			ORA !RAM_OffscreenHorz,x		; | or sprite is offscreen,
			BNE CODE_01BE95				;/ branch
			JSR CODE_01BF1D				; generate magic
CODE_01BE95:		PLA					; retrieve sprite state timer
CODE_01BE96:		LSR					;\ use sprite state timer to determine graphics frame to use
			LSR					; | in some very complicated manner
			LSR					; |
			LSR					; |
			LSR					; |
			LSR					; |
			TAY					; | get seventh bit of sprite state timer into y register
			PHY					; | and preserve it
			LDA $1540,x				; |
			LSR					; |
			LSR					; |
			LSR					; |
			AND #$01				; | get fourth bit of sprite state timer
			ORA DATA_01BE69,y			; | add in seventh bit
			STA $1602,x				;/ and use it to determine sprite graphics frame to use
			JSR SubSprGfx1
			LDA $1602,x				;\ if sprite graphics frame less than 0x4,
			SEC					; |
			SBC #$02				; |
			CMP #$02				; |
			BCC CODE_01BEC6				;/ branch
			LSR					;\ if it's less than 
			BCC CODE_01BEC6				;/ branch
			LDA !RAM_SprOAMIndex,x			;\ place head tile one pixel lower
			TAX					; |
			INC !OAM_DispY,x			;/
			LDX $15E9				; load sprite index
CODE_01BEC6:		PLY					;\ retrieve seventh bit of sprite state timer
			CPY #$01				; | if it's clear,
			BNE CODE_01BECE				;/ branch
			JSR CODE_01B14E				; sparkle effect
CODE_01BECE:		LDA $1602,x				;\ if sprite graphics frame less than 0x4,
			CMP #$04				; |
			BCC Return01BF15			;/ return
			LDY !RAM_SpriteDir,x			;\ use sprite direction to determine x position of wand tile
			LDA !RAM_SpriteXLo,x			; |
			CLC					; |
			ADC DATA_01BE6C,y			; |
			SEC					; |
			SBC !RAM_ScreenBndryXLo			; |
			LDY !RAM_SprOAMIndex,x			; |
			STA !OAM_Tile3DispX,y			;/
			LDA !RAM_SpriteYLo,x			;\ set y position of wand tile
			SEC					; |
			SBC !RAM_ScreenBndryYLo			; |
			CLC					; |
			ADC #$10				; |
			STA !OAM_Tile3DispY,y			;/
			LDA !RAM_SpriteDir,x			;\ set properties of wand tile
			LSR					; |
			LDA #$00				; |
			BCS CODE_01BEFC				; |
			ORA #$40				; |
CODE_01BEFC:		ORA $64					; |
			ORA !RAM_SpritePal,x			; |
			STA !OAM_Tile3Prop,y			;/
			LDA #!Wand_Tile				;\ set wand tile number
			STA !OAM_Tile3,y			;/
			TYA					;\ ...divide OAM index by four?
			LSR					; |
			LSR					; |
			TAY					;/
			LDA #$00				;\ set wand tile size
			ORA !RAM_OffscreenHorz,x		; |
			STA $0462,y				;/
Return01BF15:		RTS					; return

CODE_01BF16:		JSR CODE_01BFE3
			JSR SubSprGfx1
			RTS					; return

CODE_01BF1D:		LDY #$09				; setup loop
CODE_01BF1F:		LDA $14C8,y				;\ check if sprite slot is free
			BEQ CODE_01BF28				;/ if so, branch
			DEY					;\ if not, check next slot
			BPL CODE_01BF1F				;/
			RTS					; if no slots left, return

CODE_01BF28:		LDA #$10				;\ sound effect
			STA $1DF9				;/ 
			LDA #$08				;\ set sprite status
			STA $14C8,y				;/ 
			LDA #!Sprite_To_Gen			;\ set sprite number       
			STA $009E,y				;/
			LDA !RAM_SpriteXLo,x			;\ set sprite x position
			STA $00E4,y				; |
			LDA !RAM_SpriteXHi,x			; |
			STA !RAM_SpriteXHi,y			;/
			LDA !RAM_SpriteYLo,x			;\ set sprite y position
			CLC					; |
			ADC #$0A				; |
			STA $00D8,y				; |
			LDA !RAM_SpriteYHi,x			; |
			ADC #$00				; |
			STA !RAM_SpriteYHi,y			;/
			TYX                       
			JSL $07F7D2				; clear out old sprite values
			LDA #$20
			JSR CODE_01BF6A				; aiming routine
			LDX $15E9				; load sprite index
			LDA $00					;\ set sprite speeds
			STA $00AA,y				; |
			LDA $01					; |
			STA $00B6,y				;/
			RTS					; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; aiming routine
; input: accumulator should be set to total speed (x+y)
; output: $00 = y speed, $01 = x speed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CODE_01BF6A:		STA $01
			PHX					;\ preserve sprite indexes of Magikoopa and magic
			PHY					;/
			JSR CODE_01AD42				; $0E = vertical distance to Mario
			STY $02					; $02 = vertical direction to Mario
			LDA $0E					;\ $0C = vertical distance to Mario, positive
			BPL CODE_01BF7C				; |
			EOR #$FF				; |
			CLC					; |
			ADC #$01				; |
CODE_01BF7C:		STA $0C					;/
			JSR SUB_HORZ_POS			; $0F = horizontal distance to Mario
			STY $03					; $03 = horizontal direction to Mario
			LDA $0F					;\ $0D = horizontal distance to Mario, positive
			BPL CODE_01BF8C				; |
			EOR #$FF				; |
			CLC					; |
			ADC #$01				; |
CODE_01BF8C:		STA $0D					;/
			LDY #$00
			LDA $0D					;\ if vertical distance less than horizontal distance,
			CMP $0C					; |
			BCS CODE_01BF9F				;/ branch
			INY					; set y register
			PHA					;\ switch $0C and $0D
			LDA $0C					; |
			STA $0D					; |
			PLA					; |
			STA $0C					;/
CODE_01BF9F:		LDA #$00				;\ zero out $00 and $0B
			STA $0B					; | ...what's wrong with STZ?
			STA $00					;/
			LDX $01					;\ divide $0C by $0D?
CODE_01BFA7:		LDA $0B					; |\ if $0C + loop counter is less than $0D,
			CLC					; | |
			ADC $0C					; | |
			CMP $0D					; | |
			BCC CODE_01BFB4				; |/ branch
			SBC $0D					; | else, subtract $0D
			INC $00					; | and increase $00
CODE_01BFB4:		STA $0B					; |
			DEX					; |\ if still cycles left to run,
			BNE CODE_01BFA7				;/ / go to start of loop
			TYA					;\ if $0C and $0D was not switched,
			BEQ CODE_01BFC6				;/ branch
			LDA $00					;\ else, switch $00 and $01
			PHA					; |
			LDA $01					; |
			STA $00					; |
			PLA					; |
			STA $01					;/
CODE_01BFC6:		LDA $00					;\ if horizontal distance was inverted,
			LDY $02					; | invert $00
			BEQ CODE_01BFD3				; |
			EOR #$FF				; |
			CLC					; |
			ADC #$01				; |
			STA $00					;/
CODE_01BFD3:		LDA $01					;\ if vertical distance was inverted,
			LDY $03					; | invert $01
			BEQ CODE_01BFE0				; |
			EOR #$FF				; |
			CLC					; |
			ADC #$01				; |
			STA $01					;/
CODE_01BFE0:		PLY					;\ retrieve Magikoopa and magic sprite indexes
			PLX					;/
			RTS					; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


CODE_01BFE3:		LDA $1540,x				;\ only run code every third frame
			BNE Return01C000			; |
			LDA #$02				; |
			STA $1540,x				;/
			DEC $1570,x
			LDA $1570,x				;\ if palette changing done,
			CMP #$00				; | (since when is CMP #$00 necessary?)
			BNE CODE_01C001				;/ branch
			INC !RAM_SpriteState,x			; go to next sprite state
			LDA #$10				;\ set time until next appeareance
			STA $1540,x				;/
			PLA					;\ return directly from main routine, skipping graphics routine
			PLA					;/
Return01C000:		RTS					; return

CODE_01C001:		JMP CODE_01C028

CODE_01C004:		LDA $1540,x				;\ only run code every fifth frame
			BNE CODE_01C05E				; |
			LDA #$04				; |
			STA $1540,x				;/
			INC $1570,x				
			LDA $1570,x				;\ if palette changing done,
			CMP #$09				; |
			BNE CODE_01C01C				;/ branch
			LDY #$24				;\ again, colour addition stuff
			STY $40					;/
CODE_01C01C:		CMP #$09				;\ if palette changing done, (...again?)
			BNE CODE_01C028				;/ branch
			INC !RAM_SpriteState,x			; go to next sprite state
			LDA #$70				;\ set time before appearing again
			STA $1540,x				;/
			RTS					; return

CODE_01C028:		LDA $1570,x				;\ get colour table offset
			DEC A					; |
			ASL					; |
			ASL					; |
			ASL					; |
			ASL					; |
			TAX					;/
			STZ $00					; setup loop
			LDY $0681				; get initial palette offset
CODE_01C036:		LDA MagiKoopaPals,x			;\ set new colour
			STA $0684,y				;/
			INY					; increase palette offset
			INX					; increase colour table offset
			INC $00					; increase loop counter
			LDA $00					;\ if still colours left to change,
			CMP #$10				; |
			BNE CODE_01C036				;/ go to start of loop
			LDX $0681				;\ yay for doing stuff to unknown RAM addresses!
			LDA #$10				; |
			STA $0682,x				; |
			LDA #$F0				; |
			STA $0683,x				; |
			STZ $0694,x				; |
			TXA					; |
			CLC					; |
			ADC #$12				; |
			STA $0681				;/
CODE_01C05E:		LDX $15E9				; retrieve sprite index
			RTS					; return


MagiKoopaPals:		db $FF,$7F,$4A,$29,$00,$00,$00,$14
			db $00,$20,$92,$7E,$0A,$00,$2A,$00
			db $FF,$7F,$AD,$35,$00,$00,$00,$24
			db $00,$2C,$2F,$72,$0D,$00,$AD,$00
			db $FF,$7F,$10,$42,$00,$00,$00,$30
			db $00,$38,$CC,$65,$50,$00,$10,$01
			db $FF,$7F,$73,$4E,$00,$00,$00,$3C
			db $41,$44,$69,$59,$B3,$00,$73,$01
			db $FF,$7F,$D6,$5A,$00,$00,$00,$48
			db $A4,$50,$06,$4D,$16,$01,$D6,$01
			db $FF,$7F,$39,$67,$00,$00,$42,$54
			db $07,$5D,$A3,$40,$79,$01,$39,$02
			db $FF,$7F,$9C,$73,$00,$00,$A5,$60
			db $6A,$69,$40,$34,$DC,$01,$9C,$02
			db $FF,$7F,$FF,$7F,$00,$00,$08,$6D
			db $CD,$75,$00,$28,$3F,$02,$FF,$02


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


SubSprGfx1:		JSR GET_DRAW_INFO
			LDA $1602,x				;\ use graphics frame to determine initial tile table offset
			ASL					; |
			STA $03					;/
			LDA !RAM_SpriteDir,x
			STA $02
			PHX					; preserve sprite index
			LDX #$01				; setup loop counter
Loop_Start:		LDA $01					;\ set y position of tile
			CLC					; |
			ADC Y_Offset,x				; |
			STA !OAM_DispY,y			;/
			LDA $00					;\ set x position of tile
			STA !OAM_DispX,y			;/
			PHX					; preserve loop counter
			LDX $03					; get tilemap index
			LDA SprTilemap,x			;\ set tile number
			STA !OAM_Tile,y				;/
			LDX $15E9				; load sprite index
			LDA $15F6,x				; load sprite graphics properties
			PLX					; retrieve loop counter
			PHY					; preserve OAM index
			LDY $02					;\ if sprite facing right,
			BNE No_X_Flip				; |
			EOR #$40				;/ flip tile
No_X_Flip:		PLY					; retrieve OAM index
			ORA $64					; add in level properties
			STA !OAM_Prop,Y				; set tile properties
			INY					;\ as we wrote a 16x16 tile to OAM, we need to increase the pointer by 4
			INY					; |
			INY					; |
			INY					;/
			INC $03
			DEX					; decrease loop counter
			BPL Loop_Start				; if still tiles left to draw, go to start of loop
			PLX					; retrieve sprite index
			LDY #$02				; the tiles written were 16x16
			LDA #$01				; we wrote two tiles
			JSL $01B7B3
			RTS					; return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


CODE_01B14E:		LDA !RAM_FrameCounter			;\ only run code every fourth frame
			AND #$03				; |
			ORA !RAM_OffscreenVert,x		; | if sprite offscreen vertically
			ORA !RAM_SpritesLocked			; | or sprites locked,
			BNE Return01B191			;/ return
			JSL $01ACF9				;\ #$02 = sprite xpos low byte + random number between 0x-5 and 0xB
			AND #$0F				; |
			CLC					; |
			LDY #$00				; |
			ADC #$FC				; |
			BPL CODE_01B167				; |
			DEY					; |
CODE_01B167:		CLC					; |
			ADC !RAM_SpriteXLo,x			; |
			STA $02					;/
			TYA					;\ if $02 means an offscreen location?
			ADC !RAM_SpriteXHi,x			; |
			PHA					; |
			LDA $02					; |
			CMP !RAM_ScreenBndryXLo			; |
			PLA					; |
			SBC !RAM_ScreenBndryXHi			; |
			BNE Return01B191			;/ return
			LDA $148E				;\ #$00 = sprite ypos low byte + random number between 0x-2 and 0xD
			AND #$0F				; |
			CLC					; |
			ADC #$FE				; |
			ADC !RAM_SpriteYLo,x			; |
			STA $00					;/
			LDA !RAM_SpriteYHi,x			;\ #$01 = sprite ypos high byte with changes for earlier random number
			ADC #$00				; |
			STA $01					;/
			JSL $0285BA				; sparkle effect
Return01B191:		RTS					; return



CODE_01AD42:		LDY #$00
			LDA $D3
			SEC
			SBC !RAM_SpriteYLo,x
			STA $0E
			LDA $D4
			SBC !RAM_SpriteYHi,x
			BPL Return01AD53
			INY
Return01AD53:		RTS					; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;org $03B75C

TABLE1:			db $0C,$1C
TABLE2:			db $01,$02

GET_DRAW_INFO:		STZ $186C,x             ; reset sprite offscreen flag, vertical
			STZ $15A0,x             ; reset sprite offscreen flag, horizontal
			LDA $E4,x               ; \
			CMP $1A                 ;  | set horizontal offscreen if necessary
			LDA $14E0,x             ;  |
			SBC $1B                 ;  |
			BEQ ON_SCREEN_X         ;  |
			INC $15A0,x             ; /

ON_SCREEN_X:		LDA $14E0,x             ; \
			XBA			;  |
			LDA $E4,x               ;  |
			REP #$20                ;  |
			SEC			;  |
			SBC $1A                 ;  | mark sprite invalid if far enough off screen
			CLC			;  |
			ADC #$0040            ;  |
			CMP #$0180            ;  |
			SEP #$20                ;  |
			ROL A                   ;  |
			AND #$01                ;  |
			STA $15C4,x             ; / 
			BNE INVALID             ; 
			
			LDY #$00                ; \ set up loop:
			LDA $1662,x             ;  | 
			AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
			BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
			INY			; / 
ON_SCREEN_LOOP:		LDA $D8,x               ; \ 
			CLC			;  | set vertical offscreen if necessary
			ADC TABLE1,y            ;  |
			PHP			;  |
			CMP $1C                 ;  | (vert screen boundry)
			ROL $00                 ;  |
			PLP			;  |
			LDA $14D4,x             ;  | 
			ADC #$00                ;  |
			LSR $00                 ;  |
			SBC $1D                 ;  |
			BEQ ON_SCREEN_Y         ;  |
			LDA $186C,x             ;  | (vert offscreen)
			ORA TABLE2,y            ;  |
			STA $186C,x             ;  |
ON_SCREEN_Y:		DEY			;  |
			BPL ON_SCREEN_LOOP      ; /

			LDY $15EA,x             ; get offset to sprite OAM
			LDA $E4,x               ; \ 
			SEC			;  | 
			SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
			STA $00                 ; / 
			LDA $D8,x               ; \ 
			SEC			;  | 
			SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
			STA $01                 ; / 
			RTS			; return

INVALID:		PLA			; \ return from *main gfx routine* subroutine...
			PLA			;  |    ...(not just this subroutine)
			RTS			; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_OFF_SCREEN
; This subroutine deals with sprites that have moved off screen
; It is adapted from the subroutine at $01AC0D
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			
SPR_T12:		db $40,$B0
SPR_T13:		db $01,$FF
SPR_T14:		db $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
			db $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15:		db $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
			db $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1:	LDA #$02                ; \ entry point of routine determines value of $03
			BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2:	LDA #$04                ;  | 
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3:	LDA #$06                ;  |
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4:	LDA #$08                ;  |
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5:	LDA #$0A                ;  |
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6:	LDA #$0C                ;  |
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X7:	LDA #$0E                ;  |
STORE_03:		STA $03			;  |            
			BRA START_SUB		;  |
SUB_OFF_SCREEN_X0:	STZ $03			; /

START_SUB:		JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
			BEQ RETURN_35           ; /
			LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
			AND #$01                ; |
			BNE VERTICAL_LEVEL      ; /     
			LDA $D8,x               ; \
			CLC			; | 
			ADC #$50                ; | if the sprite has gone off the bottom of the level...
			LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
			ADC #$00                ; | 
			CMP #$02                ; | 
			BPL ERASE_SPRITE        ; /    ...erase the sprite
			LDA $167A,x             ; \ if "process offscreen" flag is set, return
			AND #$04                ; |
			BNE RETURN_35           ; /
			LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
			AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
			ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
			STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
			TAY			;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
			LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
			CLC			;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
			ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
			ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
			CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
			PHP			;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
			LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
			LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
			ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
			PLP			;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
			SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
			STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
			LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
			BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
			EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
			STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31:		LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
			BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE:		LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
			CMP #$08                ; |
			BCC KILL_SPRITE         ; /    
			LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
			CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
			BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
			LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
			STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE:		STZ $14C8,x             ; erase sprite
RETURN_35:		RTS			 ; return

VERTICAL_LEVEL:		LDA $167A,x             ; \ if "process offscreen" flag is set, return
			AND #$04                ; |
			BNE RETURN_35           ; /
			LDA $13                 ; \
			LSR A                   ; | 
			BCS RETURN_35           ; /
			LDA $E4,x               ; \ 
			CMP #$00                ;  | if the sprite has gone off the side of the level...
			LDA $14E0,x             ;  |
			SBC #$00                ;  |
			CMP #$02                ;  |
			BCS ERASE_SPRITE        ; /  ...erase the sprite
			LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
			LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
			AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
			STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
			TAY			;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
			LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
			CLC			;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
			ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
			ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
			CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
			PHP			;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
			LDA $001D               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
			LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
			ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
			PLP			;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
			SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
			STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
			LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
			BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
			EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
			STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38:		LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
			BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
			BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN:	LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
			ORA $186C,x             ; |  
			RTS			; / return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS:       LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16:            RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642