PRINT "INIT ",pc

;###############################
!HP = #$02 ;here put the HP of the sprite, use a value between 1-7F
;###############################

STZ $1510,x ;frame helice
STZ $1504,x ;frame cara
STZ $163E,x ;timer de frame

STZ $1534,x ;timer de risa o de subida cuando daa a mario
STZ $1594,x ;timer de paleta

STZ $C2,x ;Estado. 0= moverse, 1= subir cuando golpea a mario, 2 = reir

LDA !HP
STA $1528,x ;HP del sprite

RTL
PRINT "MAIN ",pc

PHB		;\
PHK		; | Change the data bank to the one our code is running from.
PLB		; | This is a good practice.
JSR SpriteCode	; | Jump to the sprite's function.
PLB		; | Restore old data bank.
RTL		;/ And return.

;===================================
;Sprite Function
;===================================

RETURN: RTS

SpriteCode:

	JSR Graphics

	LDA $14C8,x			;\
	CMP #$08			; | If sprite dead,
	BNE RETURN			;/ Return.
	LDA $9D				;\
	BNE RETURN			;/ If locked, return.
	
	JSR direccionGraficaHelice
	JSR direccionGraficaCara
	JSR colisionMario
	JSR detectarBala
	JSR timerPal
	JSR decisionMovimiento
	JSR timer1534
	JSR direccionMovimiento
	JSL $01801A
	JSL $018022
    RTS
;====================================================
;================direccion Grafica===================
;====================================================
;dirige los frames de la helice
retDGH:
	RTS
direccionGraficaHelice:
	LDA $163E,x
	BNE retDGH
	
	LDA $1510,x
	CMP #$05
	BCS ExplotaDG
	JSR DGHeliceNormal
	RTS
ExplotaDG:
	JSR DGExplosion
	RTS
;dirige los frames de la cara
retDGC:
	RTS
direccionGraficaCara:
	LDA $13
	AND #$03
	BNE retDGC
	
	LDA $C2,x
	CMP #$02
	BNE normalCaraDG
	JSR DGCaraReir
	RTS
normalCaraDG:
	JSR DGCaraNormal
	RTS

;dirige la helice cuando el sprite esta vivo
nextCara1510: db $01,$02,$03,$04,$00
DGHeliceNormal:
	LDA #$02
	STA $163E,x
	
	LDA $1510,x
	TAY 
	
	LDA nextCara1510,y
	STA $1510,x
RTS
;dirige los frames de la explosion cuando muere

timeExp: db $00,$00,$00,$00,$00,$01,$02,$03,$03,$03,$03,$03,$03,$03
nextExp1510: db $05,$05,$05,$05,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E
DGExplosion:
	LDA $1510,x
	TAY
	
	LDA nextExp1510,y
	STA $1510,x
	CMP #$0E
	BEQ .kill
	
	LDA timeExp,y
	STA $163E,x

	RTS
	
.kill
	STZ $14C8,x
	RTS
;dirige los frames de la cara cuando no rie
CarF1:
	LDA #$01
	STA $1504,x
	RTS
DGCaraNormal:
	LDA $1504,x
	CMP #$03
	BEQ CarF1
	STZ $1504,x
RTS
;dirige los frames de la cara cuando rie
DGCaraReir:
	INC $1504,x
	LDA $1504,x
	CMP #$04
	BNE retDGCR
	STZ $1504,x
retDGCR:
RTS
;====================================================
;================direccion Movimiento================
;====================================================
;decide que movimiento hacer
decisionMovimiento:
	LDA $C2,x
	BNE .mov1
	JSR decEstado0
	RTS
.mov1
	LDA $C2,x
	CMP #$01
	BNE .mov2
	JSR decEstado1
	RTS
.mov2
	JSR decEstado2
	RTS
;dirige el movimiento del sprite dependiendo de C2
direccionMovimiento:
	LDA $1510,x
	CMP #$05
	BCC .mov
	STZ $B6,x
	STZ $AA,x
	RTS
.mov
	LDA $C2,x
	BNE .mov1
	JSR movEstado0
	RTS
.mov1
	LDA $C2,x
	CMP #$01
	BNE .mov2
	JSR movEstado1
	RTS
.mov2
	JSR movEstado2
	RTS
	
;decide el movimiento cuando esta en estado 0
decEstado0:
	STZ $C2,x
	RTS
;actualiza el timer
retT1534:
	RTS
timer1534:
	LDA $1534,x
	BEQ retT1534
	DEC $1534,x
	RTS
;decide el movimiento cuando esta en estado 1
decEstado1:
	LDA #$01
	STA $C2,x
	
	LDA $1534,x
	BNE .ret
	LDA #$02
	STA $C2,x
	LDA #$60
	STA $1534,x
.ret
	RTS
;decide el movimiento cuando esta en estado 2
decEstado2:
	LDA #$02
	STA $C2,x
	
	LDA $1534,x
	BNE .ret
	STZ $C2,x
.ret
	RTS
	
;mueve al sprite cuando esta en estado 0
;moverse normal
movEstado0:
	JSR ME0X
	JSR ME0Y
	RTS

Xvel: 	db $00,$06,$0C,$0C,$12,$18,$1E,$24,$2A,$30,$38,$40,$48,$50,$50,$50
		db $B0,$B0,$B0,$B0,$B0,$B8,$C0,$C8,$D0,$D6,$DC,$E2,$E8,$EE,$F4,$FA
;ve el movimiento horizontal en el estado 0
ME0X:
	LDA $E4,x
	STA $00
	LDA $14E0,x
	STA $01
	
	REP #$20
	LDA $94
	CLC
	ADC #$0008
	SEC
	SBC $00	
	BPL .Xcont0
	CMP #$FF00 
	BEQ .MaxIzqVel
	BCC .MaxIzqVel
.Xcont0
	CMP #$000E
	BCS .cont1
	SEP #$20
	LDA #$FC
	STA $B6,x
	RTS
.cont1
	CMP #$0100
	BMI .Xcont2
	BCS .MaxDerVel
.Xcont2
	LSR
	LSR
	LSR
	LSR ;obtain te high byte of the xSpeed
	AND #$001F
	SEP #$20
	TAY
	
	LDA Xvel,y
	STA $B6,x
	
	RTS

.MaxDerVel
	SEP #$20
	LDA #$50
	STA $B6,x
	RTS
.MaxIzqVel
	SEP #$20
	LDA #$B0
	STA $B6,x
	RTS
Yvel: 	db $00,$08,$10,$18,$20,$28,$30,$38,$40,$48,$50,$58,$60,$68,$70,$70
		db $90,$90,$90,$98,$A0,$A8,$B0,$B8,$C0,$C8,$D0,$D8,$E0,$E8,$F0,$F8
;ve el movimiento horizontal en el estado 0
ME0Y:
	LDA $D8,x
	STA $00
	LDA $14D4,x
	STA $01
	
	REP #$20
	LDA $96
	CLC
	ADC #$0020
	SEC
	SBC $00	
	BPL .Ycont0
	CMP #$FF00 
	BEQ .MaxArVel
	BCC .MaxArVel
.Ycont0
	CMP #$000D
	BCS .cont1
	SEP #$20
	LDA #$F8
	STA $AA,x
	RTS
.cont1
	CMP #$0100
	BMI .Ycont2
	BCS .MaxAbVel
.Ycont2
	LSR
	LSR
	LSR
	LSR ;obtain te high byte of the xSpeed
	AND #$001F
	SEP #$20
	TAY
	
	LDA Yvel,y
	STA $AA,x
	
	RTS

.MaxAbVel
	SEP #$20
	LDA #$70
	STA $AA,x
	RTS
.MaxArVel
	SEP #$20
	LDA #$90
	STA $AA,x
	RTS
	
;mueve al sprite cuando esta en estado 1
;subir cuando golpea a mario
movEstado1:
	LDA #$04
	STA $B6,x
	LDA #$D8
	STA $AA,x
	RTS
;mueve al sprite cuando esta en estado 2
;reirse
movEstado2:
	STZ $B6,x
	STZ $AA,x
	RTS

;====================================================
;================colision============================
;====================================================
;detecta la colision con mario	
colisionMario:
	
	LDA $1510,x
	CMP #$05
	BCS .ret

	JSR spriteFirst

	JSR MarioSecond
	
	LDA #$0018
	STA $08
	LDY $19
	BNE .big
	LDA #$0002
	BRA .small
.big
	LDA #$0008
.small
	STA $0A
	LDA #$000A
	STA $0C
	LDY $187A
	BNE .yosho1
	LDA #$0022
	STA $0E
	BRA .startFirstHitbox
.yosho1
	LDA #$0030
	STA $0E	
.startFirstHitbox
	JSR colision
	BCC .secondHitBox
.dan
	LDA $1497
	BNE .ret
	JSR daniarMario
	RTS
.secondHitBox
	REP #$20
	LDY $187A
	BNE .yosho2
	LDA #$0028
	STA $0E
	BRA .startSecontHitbox
.yosho2
	LDA #$0036
	STA $0E
.startSecontHitbox
	JSR colision
	BCC .ret
	LDA $7FAB10,x
	AND #$04
	BNE .dan
	LDY $187A
	BNE .spin 
	LDA $140D
	BEQ .dan
.spin 
	JSR spinJump	
.ret
	RTS
	
spinJump:
	JSL $01AB99
	JSL $01AA33
	LDA #$02
	STA $1DF9
	RTS
	
daniarMario:
	LDA #$01
	STA $C2,x
	LDA #$20
	STA $1534,x
	STZ $B6,x
	LDA #$D0
	STA $AA,x
	JSL $01801A
	JSL $018022	
	
	LDY $187A
	BNE .loseYoshi
	JSL $00F5B7
	RTS
.loseYoshi
	JSR LOSEYOSHI
	RTS
	
vel: db $20,$E0
LOSEYOSHI:	
	LDA $187A
	BEQ NOYOSHI
	PHX
	LDX $18E2
	LDA #$10
	STA $163D,x
	LDA #$03
	STA $1DFA
	LDA #$13
	STA $1DFC
	LDA #$02
	STA $C1,x
	STZ $187A
	STZ $0DC1
	LDA #$C0
	STA $7D
	STZ $7B
	LDY $157B,x
	PHX
	TYX
	LDA vel,x
	PLX
	STA $B5,x
	STZ $1593,x
	STZ $151B,x
	STZ $18AE
	LDA #$30
	STA $1497
	PLX
NOYOSHI:
	RTS
;busca la bala que esta colisionando con el sprite
detectarBala:

	LDY #$09

.loop
	JSR colisionBala
	DEY
	CPY #$08
	BCS .loop
.ret
	RTS
;rutina de colision con extended sprites
colisionBala:
	LDA $1510,x
	CMP #$05
	BCS .ret

	LDA $170B,y
	CMP #$05
	BNE .ret

	JSR spriteFirst

	JSR extendedSecondY
	
	REP #$20
	LDA #$0018
	STA $08
	LDA #$000C
	STA $0A
	LDA #$000A
	STA $0C
	LDA #$0018
	STA $0E
	
	JSR colision
	BCC .ret
	JSR daniar
.ret
	RTS
;actualiza el timer de la paleta qu pone blanco al sprite
retTPal:
	RTS
timerPal:
	LDA $1594,x 
	BEQ retTPal
	DEC $1594,x 
	RTS
;dania al sprite
daniar:
	LDA #$00
	STA $170B,y
	LDA $1594,x 
	BNE .ret
	LDA #$04
	STA $1594,x 
	DEC $1528,x
	LDA $1528,x
	BEQ .startDeath
	RTS	
.startDeath
	LDA #$05
	STA $1510,x
	LDA #$01
	STA $163E,x
	LDA #$09
	STA $1DFC
.ret
	RTS
	
spriteFirst:

	LDA $E4,x
	STA $00 ;set the positions of the sprite indexed by x
	LDA $14E0,x
	STA $01
	LDA $D8,x
	STA $02
	LDA $14D4,x
	STA $03
	RTS
	
MarioSecond:
	REP #$20
	LDA $94 ;set the mario positions
	STA $04
	LDA $96
	STA $06
	RTS

extendedSecondY:
	LDA $171F,y ;set the extended sprite indexed by y
	STA $04
	LDA $1733,y
	STA $05
	LDA $1715,y
	STA $06
	LDA $1729,y
	STA $07
	RTS
	
colision:
	
	LDA $00
	CLC
	ADC $08
	CMP $04
	BCC .ret 
	
	LDA $02
	CLC
	ADC $0A
	CMP $06
	BCC .ret
	
	LDA $04
	CLC
	ADC $0C
	CMP $00
	BCC .ret
	
	LDA $06
	CLC
	ADC $0E
	CMP $02
	BCC .ret
	
	SEP #$20	
	SEC
	RTS
	
.ret
	SEP #$20
	CLC
	RTS
;====================================================
;================Graphics Routine====================
;====================================================
Graphics:
	JSR GET_DRAW_INFO
	LDA $06
	BEQ .cont1
	RTS
.cont1
	LDA $1510,x
	CMP #$05
	BCS .exp
	
	LDA #$29
	STA $0D
	LDA $1594,x
	BEQ .cont
	LDA #$2F
	STA $0D
.cont
	JSR GRHelice
	JSR GRCara

	LDY #$02
	LDA #$03
	JSL $01B7B3
	RTS
.exp
	JSR GRExplosion
	RTS

;Tables for Frames:
;###############  Tables for HeliceFrame1   #############
PROPERTIES_HeliceFrame1: 	db $2D,$6D ;f1
							db $2D,$6D ;f2
							db $2D,$6D ;f3
							db $2D,$6D ;f4
							db $2D,$6D ;f5
							
TILEMAP_HeliceFrame1: 		db $2A,$2A ;f1
							db $0C,$0E ;f2
							db $2C,$2E ;f3
							db $0E,$0C ;f4
							db $2E,$2C ;f5
							
XDISP_HeliceFrame1: 		db $00,$0F ;f1
							db $00,$0F ;f2
							db $00,$0F ;f3
							db $00,$0F ;f4
							db $00,$0F ;f5
							
;y =F0
iniPosH: db $01,$03,$05,$07,$09 
finPosH: db $00,$02,$04,$06,$08
;########################################################################
GRHelice:

	PHX
	LDA $1510,x
	TAX

	LDA finPosH,x
	STA $0A

	LDA iniPosH,x
	TAX

.loop
	LDA $00
	CLC
	ADC XDISP_HeliceFrame1,x
	STA $0300,y

	LDA $01
	CLC
	ADC #$F0
	STA $0301,y

	LDA TILEMAP_HeliceFrame1,x
	STA $0302,y

	LDA PROPERTIES_HeliceFrame1,x
	ORA $0D
	ORA $64
	STA $0303,y

	INY
	INY
	INY
	INY

	DEX
	BMI .quit
	CPX $0A
	BCS .loop
.quit
	PLX
	RTS

;###############  Tables for CaraFrame1   #############
PROPERTIES_CaraFrame1: 	db $2D,$6D ;f1
						db $2D,$6D ;f2
						db $2D,$6D ;f3
						db $2D,$6D ;f2
						
TILEMAP_CaraFrame1: 	db $06,$06 ;f1
						db $08,$08 ;f2
						db $0A,$0A ;f3
						db $08,$08 ;f2
						
XDISP_CaraFrame1: 		db $00,$0F ;f1
						db $00,$0F ;f2
						db $00,$0F ;f3
						db $00,$0F ;f2
	
;Y = 00	
iniPosC: db $01,$03,$05,$07 
finPosC: db $00,$02,$04,$06
;########################################################################
GRCara:
	PHX
	LDA $1504,x
	TAX

	LDA finPosC,x
	STA $0A

	LDA iniPosC,x
	TAX

.loop
	LDA $00
	CLC
	ADC XDISP_CaraFrame1,x
	STA $0300,y

	LDA $01
	STA $0301,y

	LDA TILEMAP_CaraFrame1,x
	STA $0302,y

	LDA PROPERTIES_CaraFrame1,x
	ORA $0D
	ORA $64
	STA $0303,y

	INY
	INY
	INY
	INY

	DEX
	BMI .quit
	CPX $0A
	BCS .loop
.quit
	PLX
	RTS

;###############  Tables for FrameEx1   #############
PROPERTIES_FrameEx1: db $29,$69,$A9,$E9 ;ex1
					db $29,$69,$A9,$E9 ;ex2
					db $29,$69,$A9,$E9 ;ex1
					db $29,$69,$29,$69 ;ex3
					db $29,$69,$29,$69 ;ex4
					db $29,$69,$29,$69 ;ex5
					db $29,$69,$29,$69 ;ex6
					db $29,$69,$29,$69 ;ex7
					db $29,$69 ;ex8

TILEMAP_FrameEx1:	db $B8,$B8,$B8,$B8 ;ex1
					db $C2,$C2,$C2,$C2 ;ex2
					db $B8,$B8,$B8,$B8 ;ex1
					db $C4,$C4,$E0,$E0 ;ex3
					db $C6,$C6,$E2,$E2 ;ex4
					db $C8,$C8,$E4,$E4 ;ex5
					db $CA,$CA,$E6,$E6 ;ex6
					db $CC,$CC,$E8,$E8 ;ex7
					db $CE,$CE ;ex8
						
XDISP_FrameEx1: 		db $08,$10,$08,$10 ;f1
						db $00,$10,$00,$10 ;f2
						db $08,$10,$08,$10 ;f1
						db $00,$10,$00,$10 ;f3
						db $00,$10,$00,$10 ;f4
						db $00,$10,$00,$10 ;f5
						db $00,$10,$00,$10 ;f6
						db $00,$10,$00,$10 ;f7
						db $00,$10 ;f8
						
YDISP_FrameEx1: 		db $F8,$F8,$00,$00 ;f1
						db $F0,$F0,$00,$00 ;f2
						db $F8,$F8,$00,$00 ;f1
						db $F0,$F0,$00,$00 ;f3
						db $F0,$F0,$00,$00 ;f4
						db $F0,$F0,$00,$00 ;f5
						db $F0,$F0,$00,$00 ;f6
						db $F0,$F0,$00,$00 ;f7
						db $F0,$F0 ;f8
tilesExp: db $03,$03,$03,$03,$03,$03,$03,$03,$01	
TamanExp: db $00,$02,$00,$02,$02,$02,$02,$02,$02		
iniPosExp: db $03,$07,$0B,$0F,$13,$17,$1B,$1F,$21	
finPosExp: db $00,$03,$07,$0B,$0F,$13,$17,$1B,$1F		
;########################################################################
GRExplosion:
	PHX
	LDA $1510,x
	SEC
	SBC #$05
	TAX

	LDA finPosExp,x
	STA $0A
	
	LDA tilesExp,x
	STA $0B
	
	LDA TamanExp,x
	STA $0C

	LDA iniPosExp,x
	TAX

.loop
	LDA $00
	CLC
	ADC XDISP_FrameEx1,x
	STA $0300,y

	LDA $01
	CLC
	ADC YDISP_FrameEx1,x
	STA $0301,y

	LDA TILEMAP_FrameEx1,x
	STA $0302,y

	LDA PROPERTIES_FrameEx1,x
	ORA $64
	STA $0303,y

	INY
	INY
	INY
	INY

	DEX
	BMI .quit
	CPX $0A
	BCS .loop
.quit
	PLX
	LDY $0C
	LDA $0B
	JSL $01B7B3
	RTS
	
	
;###################Subroutines#####################

SPR_T1:              db $0C,$1C
SPR_T2:             db $01,$02

GET_DRAW_INFO:  
    
	STZ $06
	STZ $186C,x             ; reset sprite offscreen flag, vertical
	STZ $15A0,x             ; reset sprite offscreen flag, horizontal
	LDA $E4,x               ; \
	CMP $1A                 ;  | set horizontal offscreen if necessary
	LDA $14E0,x             ;  |
	SBC $1B                 ;  |
	BEQ ON_SCREEN_X         ;  |
	INC $15A0,x             ; /

ON_SCREEN_X:  
       
	LDA $14E0,x             ; \
	XBA                     ;  |
	LDA $E4,x               ;  |
	REP #$20                ;  |
	SEC                     ;  |
	SBC $1A                 ;  | mark sprite invalid if far enough off screen
	CLC                     ;  |
	ADC #$0040            ;  |
	CMP #$0180            ;  |
	SEP #$20                ;  |
	ROL A                   ;  |
	AND #$01                ;  |
	STA $15C4,x             ; / 
	BNE INVALID             ; 
                    
	LDY #$00                ; \ set up loop:
	LDA $1662,x             ;  | 
	AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
	BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
	INY                     ; / 

ON_SCREEN_LOOP:

	LDA $D8,x               ; \ 
	CLC                     ;  | set vertical offscreen if necessary
	ADC SPR_T1,y            ;  |
	PHP                     ;  |
	CMP $1C                 ;  | (vert screen boundry)
	ROL $00                 ;  |
	PLP                     ;  |
	LDA $14D4,x             ;  | 
	ADC #$00                ;  |
	LSR $00                 ;  |
	SBC $1D                 ;  |
	BEQ ON_SCREEN_Y         ;  |
	LDA $186C,x             ;  | (vert offscreen)
	ORA SPR_T2,y            ;  |
	STA $186C,x             ;  |

ON_SCREEN_Y:

	DEY                     ;  |
	BPL ON_SCREEN_LOOP      ; /

	LDY $15EA,x             ; get offset to sprite OAM
	LDA $E4,x               ; \ 
	SEC                     ;  | 
	SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
	STA $00                 ; / 
	LDA $D8,x               ; \ 
	SEC                     ;  | 
	SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
	STA $01                 ; / 
	RTS                     ; return

INVALID:

	LDA #$01
	STA $06                    ;  |    ...(not just this subroutine)
	RTS                     ; /	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B85D - off screen processing code - shared
; sprites enter at different points
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T12:             db $40,$B0
SPR_T13:             db $01,$FF
SPR_T14:             db $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
		            db $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15:             db $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
					db $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1:   LDA #$02                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2:   LDA #$04                ;  | 
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3:   LDA #$06                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4:   LDA #$08                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5:   LDA #$0A                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6:   LDA #$0C                ;  |
                    BRA STORE_03            ;  | OMG YOU FOUND THIS HIDDEN z0mg place!111 you win a cookie!
SUB_OFF_SCREEN_X7:   LDA #$0E                ;  |
STORE_03:			STA $03					;  |            
					BRA START_SUB			;  |
SUB_OFF_SCREEN_X0:   STZ $03					; /

START_SUB:           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_35           ; /
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
                    AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
                    ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
                    STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
                    TAY                     ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
                    LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
                    CLC                     ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
                    ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
                    ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
                    CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
                    PHP                     ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
                    LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
                    LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
                    ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
                    PLP                     ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
                    SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
                    STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
                    LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
                    BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
                    EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
                    STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31:             LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
                    BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE:        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /    
                    LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
                    CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
                    BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
                    LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
                    STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE:         STZ $14C8,x             ; erase sprite
RETURN_35:           RTS                     ; return

VERTICAL_LEVEL:      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ; \
                    LSR A                   ; | 
                    BCS RETURN_35           ; /
                    LDA $E4,x               ; \ 
                    CMP #$00                ;  | if the sprite has gone off the side of the level...
                    LDA $14E0,x             ;  |
                    SBC #$00                ;  |
                    CMP #$02                ;  |
                    BCS ERASE_SPRITE        ; /  ...erase the sprite
                    LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
                    LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
                    AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
                    STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
                    TAY                     ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
                    LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
                    CLC                     ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
                    ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
                    ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
                    CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
                    PHP                     ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
                    LDA $001D             ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
                    LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
                    ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
                    PLP                     ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
                    SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
                    STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
                    LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
                    BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
                    EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
                    STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38:             LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
                    BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
                    BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN:   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / 
