PRINT "INIT ",pc

;###############################
!HP = #$02 ;here put the HP of the sprite, use a value between 1-7F
;###############################

;###############################
!Bullet = #$0C 
;###############################

STZ $1510,x ;frame

STZ $C2,x ;estado, 0 = oculto, 1 = esconderse, 2 = levantarse, 3 = caminar

STZ $163E,x ;timer de frames

STZ $1594,x ;timer de paleta

LDA #$40
STA $1534,x ;timer escondido

LDA #$01
STA $157C,x

LDA !HP
STA $1528,x ;HP del sprite

STZ $151C,x ;puede levantarse

STZ $1FD6,x ;1 = dispara, 0 = camina

STZ $1602,x

RTL

PRINT "MAIN ",pc

PHB		;\
PHK		; | Change the data bank to the one our code is running from.
PLB		; | This is a good practice.
JSR SpriteCode	; | Jump to the sprite's function.
PLB		; | Restore old data bank.
RTL		;/ And return.

;===================================
;Sprite Function
;===================================

RETURN: RTS

SpriteCode:
	JSR Graphics

	LDA $14C8,x			;\
	CMP #$08			; | If sprite dead,
	BNE RETURN			;/ Return.
	LDA $9D				;\
	BNE RETURN			;/ If locked, return.

	JSR SUB_OFF_SCREEN_X0		; Handle offscreen.
	JSR timerPal
	JSR colisionMario
	JSR detectarBala
	JSR colisionPared
	JSR timer1534
	JSR cambiosDeEstado
	JSR direccionGrafica
	JSL $01802A
    RTS
	
;===================================
;graphic manager
;===================================

direccionGrafica:

	LDA $163E,x
	BNE .ret
	
	LDA $1510,x
	CMP #$0C
	BCS .exp
	
	LDA #$04
	STA $163E,x
	
	LDA $C2,x
	CMP #$02
	BCS +
	JSR grEst0 ;estar oculto
	RTS
+
	BNE +
	JSR grEst2 ;levantarse
	RTS
+
	JSR grEst3 ;caminar
	RTS
	
.exp
	JSR explosion
.ret
	RTS
	
next0: db $00,$00,$01,$02,$03,$04,$05,$03,$04,$05,$05,$05
grEst0:

	LDA $1510,x
	TAY
	
	LDA next0,y
	STA $1510,x

	RTS

next2: db $03,$04,$03,$04,$05,$06,$07,$07,$07,$07,$07,$07
grEst2:
	LDA $1510,x
	TAY
	
	LDA next2,y
	STA $1510,x

	RTS

next3: db $03,$04,$03,$04,$05,$06,$07,$08,$09,$0A,$07,$07
grEst3:
	LDA $1510,x
	TAY
	
	LDA next3,y
	STA $1510,x

	RTS
	
nextE: db $0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0C,$0D,$0E,$0F,$10,$11,$12,$13,$14,$15
timeE: db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$02,$03,$03,$03,$03,$03,$03	
explosion: 

	STZ $B6,x
	STZ $AA,x
	LDA $1510,x
	TAY
	
	LDA nextE,y
	STA $1510,x
	
	LDA $1510,x
	CMP #$15
	BCS .kill
	
	LDA timeE,y
	STA $163E,x
	
	RTS
.kill
	STZ $14C8,x	
	RTS
;===================================
;movement
;===================================
direccionar:
	
	LDA $E4,x
	STA $00 ;carga el low byte en 00
	
	LDA $14E0,x
	STA $01 ;carga el high byte en 01
	
	REP #$20
	
	LDA $00
	CLC
	ADC #$000C ;le suma una cantidad para referenciar el centro del sprite
	CMP $94 ;compara la posicion del centro del sprite con la posicion de mario
	SEP #$20
	BCC + ;si mario esta a la derecha pone la direccion en derecha sino izquierda
	
	LDA #$01
	STA $157C,x ;direccion izquierda
	RTS
+
	STZ $157C,x ;direccion derecha
	RTS
	
timer1534:

	LDA $1534,x
	BEQ .ret
	
	DEC $1534,x
.ret
	RTS

cambiosDeEstado:
	LDA $1510,x
	CMP #$0C
	BCS .ret

	JSR direccionar ;setea la direccion del sprite
	STZ $B6,x ;velocidad 0	
	
	LDA $C2,x
	BNE +
	JSR est0 ;estar oculto
	RTS
+
	CMP #$01
	BNE +
	JSR est1 ;esconderse
	RTS
+
	CMP #$02
	BNE +
	JSR est2 ;levantarse
	RTS
+
	JSR est3 ;caminar
.ret
	RTS
	
;estar oculto
est0:

	LDA $1534,x ;checkea si esta el timer de esconderse puesto
	BNE +
	
	LDA $1602,x
	BNE .par
	
	LDA $76
	CMP $157C,x ;checkea la direccion de mario
	BNE .cambio
.par
	STZ $151C,x
	
	LDA $1534,x
	BNE +
	
	LDA $7FAB28,x
	BEQ +
	
	LDA #$01
	STA $1FD6,x
	LDA #$02
	STA $C2,x
+	
	RTS
	
.cambio
	LDA $151C,x
	BEQ .ret
	LDA #$02
	STA $C2,x ;si mario no esta mirando hacia met y el timer no esta puesto, se pasa al estado 2 levantarse
	RTS
.ret
	LDA #$30
	STA $1534,x
	LDA #$01
	STA $151C,x
	RTS
	
;esconderse
est1:

	LDA $1510,x ;si el frame es 0, pasa al estado 0 y pone el timer para estar escondido
	BNE .ret
	
	STZ $C2,x
	JSL $01ACF9
	LDA $148D
	ORA #$4F
	STA $1534,x
.ret
	RTS
;levantarse
est2:

	LDA $1602,x
	BNE .par
	
	LDA $76
	CMP $157C,x ;checkea la direccion de mario
	BNE ++
	
.par
	LDA $7FAB28,x
	BEQ +
	
	LDA $1FD6,x
	BNE .cont
	
+
	LDA #$01
	STA $C2,x ;si mario esta viendo hacia met entonces se vuelve a esconder
	RTS
.cont

	LDA $1510,x
	CMP #$07
	BCC .ret
	
	JSR invocar
	
	LDA #$01 ;si el frame es 5 o mas met se pone a caminar
	STA $C2,x		
	RTS
	
++
	LDA $1510,x
	CMP #$07
	BCC .ret
	LDA #$03 ;si el frame es 5 o mas met se pone a caminar
	STA $C2,x	
.ret
	RTS
	
;caminar
est3:
	LDA $1602,x
	BNE .par
	
	LDA $76
	CMP $157C,x ;checkea la direccion de mario
	BNE +
.par
	LDA #$01
	STA $C2,x ;si mario esta viendo hacia met entonces se vuelve a esconder
	RTS
	
+	
	LDA $1510,x ;si el frame es menor que 6 retorna
	CMP #$08
	BCC .ret
	
	LDA $157C,x
	BEQ + ;si la direccion es derecha camina hacia la derecha, sino hacia la izquierda
	
	LDA #$E8
	STA $B6,x	
	RTS
+
	LDA #$18
	STA $B6,x
.ret
	RTS
	

;===================================
;interaction
;===================================

colisionPared:

	LDA $E4,x
	STA $00
	
	LDA $14E0,x
	STA $01
	
	LDA $D8,x
	STA $02
	
	LDA $14D4,x
	STA $03
	
	LDA $157C,x ;checkea la direccion de mario
	BEQ +

	REP #$20
	LDA $00
	CLC
	ADC #$0004
	AND #$FFF0
	STA $9A
	
	LDA $02
	CLC
	ADC #$0008
	AND #$FFF0
	STA $98
	
	SEP #$20
	
	JSR detectarSolido
	
	RTS
+

	REP #$20
	LDA $00
	CLC
	ADC #$0014
	AND #$FFF0
	STA $9A
	
	LDA $02
	CLC
	ADC #$0008
	AND #$FFF0
	STA $98
	
	SEP #$20
	
	JSR detectarSolido
	
	RTS
	
solido:	db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
		db $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
		db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
detectarSolido:
	PHX
	PHY
	JSR CheckMap16    ;check the map16 tile at that position
	LDA [$05]         ;\
	XBA               ; |
	INC $07           ; | get the 16bit tile number into A
	LDA [$05]         ; |
	XBA               ;/
 
	REP #$20
	STA $00           ;store it in $00 for the acts like check
	SEP #$20
 
	JSR GetActLike    ;get the big ole acts like setting of the block the sprite is checking
	
	REP #$10
	LDX $00
	LDA solido,x
	SEP #$10
	
	PLY
	PLX
	
	STA $1602,x
	RTS
	
CheckMap16:
	LDA $98                  
	AND #$F0                
	STA $06                  
	LDA $9A                  
	LSR                      
	LSR                      
	LSR                      
	LSR                                              
	ORA $06                  
	PHA                      
	LDA $5B    
	AND #$01                
	BEQ .CODE_01D977          
	PLA                      
	LDX $99                  
	CLC                      
	ADC $00BA80,X      
	STA $05                  
	LDA $00BABC,X      
	ADC $9B                  
	STA $06                  
	BRA .CODE_01D989          
 
.CODE_01D977
	PLA                      
	LDX $9B                  
	CLC                      
	ADC.l $00BA60,X      
	STA $05                  
	LDA.l $00BA9C,x      
	ADC $99                  
	STA $06                  
 
.CODE_01D989
	LDA.b #$7E                
	STA $07                  
	LDX $15E9
RTS

; $00 = map16 tile
GetActLike:
        LDA $06F624
        STA $02
        REP #$30
        LDA $06F625
        STA $03
       
        LDA $00
        AND #$3FFF
        ASL
        TAY
        LDA [$02],y
        STA $00
        SEP #$30
        RTS
;detecta la colision con mario	
colisionMario:
	
	LDA $1510,x
	CMP #$0C
	BCS .ret

	JSR spriteFirst

	JSR MarioSecond
	
	LDA #$0012
	STA $08
	LDY $19
	BNE .big
	LDA #$0002
	BRA .small
.big
	LDA #$0008
.small
	STA $0A
	LDA #$0008
	STA $0C
	LDY $187A
	BNE .yosho1
	LDA #$0014
	STA $0E
	BRA .startFirstHitbox
.yosho1
	LDA #$0022
	STA $0E	
.startFirstHitbox
	JSR colision
	BCC .secondHitBox
.dan
	JSR daniarMario
	RTS
.secondHitBox
	REP #$20
	LDY $187A
	BNE .yosho2
	LDA #$001A
	STA $0E
	BRA .startSecontHitbox
.yosho2
	LDA #$0028
	STA $0E
.startSecontHitbox
	JSR colision
	BCC .ret
	LDA $7FAB10,x
	AND #$04
	BNE .dan
	LDY $187A
	BNE .spin 
	LDA $140D
	BEQ .dan
.spin 
	JSR spinJump	
.ret
	RTS
	
spinJump:
	JSL $01AB99
	JSL $01AA33
	LDA #$02
	STA $1DF9
	RTS
	
daniarMario:
	LDA $1497
	BNE .ret	
	LDY $187A
	BNE .loseYoshi
	JSL $00F5B7
.ret
	RTS
.loseYoshi
	JSR LOSEYOSHI
	RTS
	
vel: db $20,$E0
LOSEYOSHI:	
	LDA $187A
	BEQ NOYOSHI
	PHX
	LDX $18E2
	LDA #$10
	STA $163D,x
	LDA #$03
	STA $1DFA
	LDA #$13
	STA $1DFC
	LDA #$02
	STA $C1,x
	STZ $187A
	STZ $0DC1
	LDA #$C0
	STA $7D
	STZ $7B
	LDY $157B,x
	PHX
	TYX
	LDA vel,x
	PLX
	STA $B5,x
	STZ $1593,x
	STZ $151B,x
	STZ $18AE
	LDA #$30
	STA $1497
	PLX
NOYOSHI:
	RTS
	
	
;busca la bala que esta colisionando con el sprite
detectarBala:

	LDY #$09

.loop
	JSR colisionBala
	DEY
	CPY #$08
	BCS .loop
.ret
	RTS
;rutina de colision con extended sprites
colisionBala:
	LDA $1510,x
	CMP #$0C
	BCS .ret

	LDA $170B,y
	CMP #$05
	BNE .ret

	JSR spriteFirst

	JSR extendedSecondY
	
	REP #$20
	LDA #$0012
	STA $08
	LDA #$000E
	STA $0A
	LDA #$0002
	STA $0C
	LDA #$0000
	STA $0E
	
	JSR colision
	BCC .ret
	JSR daniar
.ret
	RTS
;actualiza el timer de la paleta qu pone blanco al sprite
retTPal:
	RTS
timerPal:
	LDA $1594,x 
	BEQ retTPal
	DEC $1594,x 
	RTS
;dania al sprite
daniar:
	JSR DrawSmoke
	LDA #$00
	STA $170B,y
	LDA $1510,x
	CMP #$02
	BCC .ret
	LDA $1594,x 
	BNE .ret
	LDA #$04
	STA $1594,x 
	DEC $1528,x
	LDA $1528,x
	BEQ .startDeath
	RTS	
.startDeath
	LDA #$0C
	STA $1510,x
	LDA #$01
	STA $163E,x
	LDA #$09
	STA $1DFC
.ret
	RTS
	
DrawSmoke:
	PHX
	TYX
	LDY #$03
-
	LDA $17C0,y
	BEQ +
	DEY
	BPL -
	TXY
	PLX
	RTS
+
	LDA #$01
	STA $17C0,y
	LDA #$1B
	STA $17CC,y
	LDA $1715,x
	STA $17C4,y
	LDA $171F,x
	STA $17C8,y
	TXY
	PLX
	RTS
	
spriteFirst:

	LDA $E4,x
	STA $00 ;set the positions of the sprite indexed by x
	LDA $14E0,x
	STA $01
	LDA $D8,x
	STA $02
	LDA $14D4,x
	STA $03
	RTS
	
MarioSecond:
	REP #$20
	LDA $94 ;set the mario positions
	STA $04
	LDA $96
	STA $06
	RTS

extendedSecondY:
	LDA $171F,y ;set the extended sprite indexed by y
	STA $04
	LDA $1733,y
	STA $05
	LDA $1715,y
	STA $06
	LDA $1729,y
	STA $07
	RTS
	
colision:
	
	LDA $00
	CLC
	ADC $08
	CMP $04
	BCC .ret 
	
	LDA $02
	CLC
	ADC $0A
	CMP $06
	BCC .ret
	
	LDA $04
	CLC
	ADC $0C
	CMP $00
	BCC .ret
	
	LDA $06
	CLC
	ADC $0E
	CMP $02
	BCC .ret
	
	SEP #$20	
	SEC
	RTS
	
.ret
	SEP #$20
	CLC
	RTS
;===================================
;spawn
;===================================

invocar:

	LDY #$13
.loop
	LDA $1892,y
	BNE .next
	
	LDA !Bullet
	STA $1892,y
	
	LDA $E4,x
	STA $08
	
	LDA $14E0,x
	STA $09
	
	LDA $D8,x
	STA $0A
	
	LDA $14D4,x
	STA $0B
	
	LDA $157C,x
	REP #$20
	BEQ +
	
	LDA $08
	CLC
	ADC #$0004
	BRA .cont
+
	LDA $08
	CLC
	ADC #$000C
.cont	
	STA $08
	SEC
	SBC $94
	SEC
	SBC #$0008
	STA $00
	
	LDA $0A
	CLC
	ADC #$0009
	STA $0A
	SEC
	SBC $96
	SEC
	SBC #$0010
	STA $02
	
	SEP #$20
	
	LDA #$20
	JSR apuntar

	JSR setearCosas
	
	LDA #$01 ; \ Run cluster sprite routine.
	STA $18B8
	RTS
.next
	DEY
	BPL .loop
	RTS

setearCosas:
	LDA $00
	STA $0F72,y
	
	LDA $02
	STA $0F5E,y
	
	LDA $08
	STA $1E16,y
	
	LDA $09
	STA $1E3E,y
	
	LDA $0A
	STA $1E02,y
	
	LDA $0B
	STA $1E2A,y
	
	LDA #$00
	STA $0F86,y
	STA $1E52,y
	STA $1E66,y
	RTS
			
apuntar:
	PHX
	PHY
	PHP
	SEP #$30
	STA $0F
	LDX #$00
	REP #$20
	LDA $00
	BPL .pos_dx
	EOR #$FFFF
	INC
	INX
	INX
	STA $00
	
.pos_dx	

	SEP #$20
	STA $4202
	STA $4203
	NOP
	NOP
	NOP
	REP #$20
	LDA $4216
	STA $04
	LDA $02
	BPL .pos_dy
	EOR #$FFFF
	INC
	INX
	STA $02
	
.pos_dy	

	SEP #$20
	STA $4202
	STA $4203
	STX $0E
	REP #$30
	LDA $04
	CLC
	ADC $4216
	LDY #$0000
	BCC .loop
	INY
	ROR
	LSR
	
.loop	

	CMP #$0100
	BCC +
	INY
	LSR
	LSR
	BRA .loop
	
+	

	CLC
	ASL
	TAX
	LDA recip_sqrt_lookup,x
	
-	

	DEY
	BMI +
	LSR
	BRA -
	
+	

	SEP #$30
	STA $4202
	LDA $0F
	STA $4203
	NOP
	STZ $05
	STZ $07
	LDA $4217
	STA $04
	XBA
	STA $4202
	LDA $0F
	STA $4203
	REP #$20
	LDA $04
	CLC
	ADC $4216
	STA $04
	SEP #$20
	LDX #$02
-	

	LDA $04
	STA $4202
	LDA $00,x
	STA $4203
	NOP
	NOP
	NOP
	NOP
	LDA $4217
	STA $06
	LDA $05
	STA $4202
	LDA $00,x
	STA $4203
	REP #$20
	LDA $06
	CLC
	ADC $4216
	SEP #$20
	LSR $0E
	BCS +
	EOR #$FF
	INC
	
+	
	STA $00,x
	DEX
	DEX
	BPL -
	PLP
	PLY
	PLX
	RTS	

recip_sqrt_lookup:
		dw $0000,$FFFF,$B505,$93CD,$8000,$727D,$6883,$60C2
		dw $5A82,$5555,$50F4,$4D30,$49E7,$4700,$446B,$4219
		dw $4000,$3E17,$3C57,$3ABB,$393E,$37DD,$3694,$3561
		dw $3441,$3333,$3235,$3144,$3061,$2F8A,$2EBD,$2DFB
		dw $2D41,$2C90,$2BE7,$2B46,$2AAB,$2A16,$2987,$28FE
		dw $287A,$27FB,$2780,$270A,$2698,$262A,$25BF,$2557
		dw $24F3,$2492,$2434,$23D9,$2380,$232A,$22D6,$2285
		dw $2236,$21E8,$219D,$2154,$210D,$20C7,$2083,$2041
		dw $2000,$1FC1,$1F83,$1F46,$1F0B,$1ED2,$1E99,$1E62
		dw $1E2B,$1DF6,$1DC2,$1D8F,$1D5D,$1D2D,$1CFC,$1CCD
		dw $1C9F,$1C72,$1C45,$1C1A,$1BEF,$1BC4,$1B9B,$1B72
		dw $1B4A,$1B23,$1AFC,$1AD6,$1AB1,$1A8C,$1A68,$1A44
		dw $1A21,$19FE,$19DC,$19BB,$199A,$1979,$1959,$1939
		dw $191A,$18FC,$18DD,$18C0,$18A2,$1885,$1869,$184C
		dw $1831,$1815,$17FA,$17DF,$17C5,$17AB,$1791,$1778
		dw $175F,$1746,$172D,$1715,$16FD,$16E6,$16CE,$16B7
		dw $16A1,$168A,$1674,$165E,$1648,$1633,$161D,$1608
		dw $15F4,$15DF,$15CB,$15B7,$15A3,$158F,$157C,$1568
		dw $1555,$1542,$1530,$151D,$150B,$14F9,$14E7,$14D5
		dw $14C4,$14B2,$14A1,$1490,$147F,$146E,$145E,$144D
		dw $143D,$142D,$141D,$140D,$13FE,$13EE,$13DF,$13CF
		dw $13C0,$13B1,$13A2,$1394,$1385,$1377,$1368,$135A
		dw $134C,$133E,$1330,$1322,$1315,$1307,$12FA,$12ED
		dw $12DF,$12D2,$12C5,$12B8,$12AC,$129F,$1292,$1286
		dw $127A,$126D,$1261,$1255,$1249,$123D,$1231,$1226
		dw $121A,$120F,$1203,$11F8,$11EC,$11E1,$11D6,$11CB
		dw $11C0,$11B5,$11AA,$11A0,$1195,$118A,$1180,$1176
		dw $116B,$1161,$1157,$114D,$1142,$1138,$112E,$1125
		dw $111B,$1111,$1107,$10FE,$10F4,$10EB,$10E1,$10D8
		dw $10CF,$10C5,$10BC,$10B3,$10AA,$10A1,$1098,$108F
		dw $1086,$107E,$1075,$106C,$1064,$105B,$1052,$104A
		dw $1042,$1039,$1031,$1029,$1020,$1018,$1010,$1008

;====================================================
;================Graphics Routine====================
;====================================================

props:	db $25,$25 ;f1
		db $25,$25 ;f2
		db $25,$25 ;f1
		db $25,$25 ;f2
		db $25,$65,$25,$25 ;f3
		db $25,$65,$25,$25 ;f4
		db $25,$65,$25,$25 ;f3
		db $25,$65,$25,$25 ;f4
		db $25,$25,$65,$65 ;f5
		db $25,$25,$25,$25 ;f6
		db $25,$25,$25,$25 ;f7
		db $25,$25,$25,$25 ;f6
		db $29,$69,$A9,$E9 ;ex1
		db $29,$69,$A9,$E9 ;ex2
		db $29,$69,$A9,$E9 ;ex1
		db $29,$69,$29,$69 ;ex3
		db $29,$69,$29,$69 ;ex4
		db $29,$69,$29,$69 ;ex5
		db $29,$69,$29,$69 ;ex6
		db $29,$69,$29,$69 ;ex7
		db $29,$69 ;ex8

tiles: 	db $00,$40 ;f1
		db $02,$60 ;f2
		db $00,$40 ;f1
		db $02,$60 ;f2
		db $04,$41,$67,$69 ;f3
		db $20,$61,$47,$49 ;f4
		db $04,$41,$67,$69 ;f3
		db $20,$61,$47,$49 ;f4
		db $22,$43,$6A,$6C ;f5
		db $24,$63,$4B,$4D ;f6
		db $26,$28,$45,$6E ;f7
		db $24,$63,$4B,$4D ;f6
		db $B8,$B8,$B8,$B8 ;ex1
		db $C2,$C2,$C2,$C2 ;ex2
		db $B8,$B8,$B8,$B8 ;ex1
		db $C4,$C4,$E0,$E0 ;ex3
		db $C6,$C6,$E2,$E2 ;ex4
		db $C8,$C8,$E4,$E4 ;ex5
		db $CA,$CA,$E6,$E6 ;ex6
		db $CC,$CC,$E8,$E8 ;ex7
		db $CE,$CE ;ex8
		
xDisp: 	db $08,$F8 ;f1
		db $08,$F8 ;f2
		db $08,$F8 ;f1
		db $08,$F8 ;f2
		db $08,$F8,$08,$F8 ;f3
		db $08,$F8,$08,$F8 ;f4
		db $08,$F8,$08,$F8 ;f3
		db $08,$F8,$08,$F8 ;f4
		db $08,$F8,$F8,$08 ;f5
		db $08,$F8,$08,$F8 ;f6
		db $08,$F8,$08,$F8 ;f7
		db $08,$F8,$08,$F8 ;f6
		db $00,$08,$00,$08 ;ex1
		db $F8,$08,$F8,$08 ;ex2
		db $00,$08,$00,$08 ;ex1
		db $F8,$08,$F8,$08 ;ex3
		db $F8,$08,$F8,$08 ;ex4
		db $F8,$08,$F8,$08 ;ex5
		db $F8,$08,$F8,$08 ;ex6
		db $F8,$08,$F8,$08 ;ex7
		db $F8,$08 ;ex8
		db $00,$10 ;f1
		db $00,$10 ;f2
		db $00,$10 ;f1
		db $00,$10 ;f2
		db $00,$10,$00,$10 ;f3
		db $00,$10,$00,$10 ;f4
		db $00,$10,$00,$10 ;f3
		db $00,$10,$00,$10 ;f4
		db $00,$10,$10,$00 ;f5
		db $00,$10,$00,$10 ;f6
		db $00,$10,$00,$10 ;f7
		db $00,$10,$00,$10 ;f6
		db $00,$08,$00,$08 ;ex1
		db $F8,$08,$F8,$08 ;ex2
		db $00,$08,$00,$08 ;ex1
		db $F8,$08,$F8,$08 ;ex3
		db $F8,$08,$F8,$08 ;ex4
		db $F8,$08,$F8,$08 ;ex5
		db $F8,$08,$F8,$08 ;ex6
		db $F8,$08,$F8,$08 ;ex7
		db $F8,$08 ;ex8
		
yDisp:	db $00,$00 ;f1
		db $00,$00 ;f2
		db $00,$00 ;f1
		db $00,$00 ;f2
		db $00,$00,$F0,$F0 ;f3
		db $00,$00,$F0,$F0 ;f4
		db $00,$00,$F0,$F0 ;f3
		db $00,$00,$F0,$F0 ;f4
		db $00,$00,$F0,$F0 ;f5
		db $00,$00,$F0,$F0 ;f6
		db $00,$00,$F0,$F0 ;f7
		db $00,$00,$F0,$F0 ;f6
		db $F8,$F8,$00,$00 ;ex1
		db $F0,$F0,$00,$00 ;ex2
		db $F8,$F8,$00,$00 ;ex1
		db $F0,$F0,$00,$00 ;ex3
		db $F0,$F0,$00,$00 ;ex4
		db $F0,$F0,$00,$00 ;ex5
		db $F0,$F0,$00,$00 ;ex6
		db $F0,$F0,$00,$00 ;ex7
		db $F0,$F0 ;ex8
		
tilesT: db $01,$01,$01,$01,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$03,$01
TamanT: db $02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$02,$00,$02,$00,$02,$02,$02,$02,$02,$02		
iniPosT: db $01,$03,$05,$07,$0B,$0F,$13,$17,$1B,$1F,$23,$27,$2B,$2F,$33,$37,$3B,$3F,$43,$47,$49
finPosT: db $00,$02,$04,$06,$08,$0C,$10,$14,$18,$1C,$20,$24,$28,$2C,$30,$34,$38,$3C,$40,$44,$48
;########################################################################
Graphics:
	JSR GET_DRAW_INFO

	LDA $06 ;si la posicion no es valida retorna
	BEQ +
	RTS
+
	PHX
	
	STZ $02	
	
	LDA $1510,x
	CMP #$0C
	BCS .cont0
	
	LDA $1594,x ;si el timer de paleta es distinto de 0 usa la paleta F, sino la paleta A
	BEQ +
	LDA #$0E
	STA $02
+	
	
	LDA $157C,x
	BEQ .cont ;si esta mirando hacia la derecha no voltea nada, sino voltea hacia la izquierda
.cont0	
	LDA #$01
	STA $04 
	STZ $03
	BRA +
.cont
	LDA #$40
	STA $03
	STZ $04
+	
	LDA $1510,x
	TAX ;pone el puntero en x

	LDA finPosT,x
	STA $0A ;pone la posicion final a la que debe llegar
	
	LDA tilesT,x
	STA $0B ;pone la cantidad de tiles que debe usar
	
	LDA TamanT,x
	STA $0C ;pone el tamanio de los tiles

	LDA iniPosT,x
	TAX ;pone la posicion inicial que debe usar
	
.loop

	LDA $04
	BNE +
	LDA xDisp,x
	BRA .setX
+	
	PHX
	TXA
	CLC
	ADC #$4A
	TAX
	LDA xDisp,x
	PLX
.setX
	CLC
	ADC $00
	STA $0300,y
	
	LDA $01
	CLC
	ADC yDisp,x
	STA $0301,y

	LDA tiles,x
	STA $0302,y

	LDA props,x
	AND #$BF
	STA $05
	
	LDA props,x
	EOR $03
	AND #$40
	ORA $05
	ORA $02
	ORA $64
	STA $0303,y

	INY
	INY
	INY
	INY

	DEX
	BMI .quit
	CPX $0A
	BCS .loop
.quit
	PLX
	LDY $0C
	LDA $0B
	JSL $01B7B3
	RTS

;###################Subroutines#####################3

SPR_T1:              db $0C,$1C
SPR_T2:             db $01,$02

GET_DRAW_INFO:  
    
	STZ $06
	STZ $186C,x             ; reset sprite offscreen flag, vertical
	STZ $15A0,x             ; reset sprite offscreen flag, horizontal
	LDA $E4,x               ; \
	CMP $1A                 ;  | set horizontal offscreen if necessary
	LDA $14E0,x             ;  |
	SBC $1B                 ;  |
	BEQ ON_SCREEN_X         ;  |
	INC $15A0,x             ; /

ON_SCREEN_X:  
       
	LDA $14E0,x             ; \
	XBA                     ;  |
	LDA $E4,x               ;  |
	REP #$20                ;  |
	SEC                     ;  |
	SBC $1A                 ;  | mark sprite invalid if far enough off screen
	CLC                     ;  |
	ADC #$0040            ;  |
	CMP #$0180            ;  |
	SEP #$20                ;  |
	ROL A                   ;  |
	AND #$01                ;  |
	STA $15C4,x             ; / 
	BNE INVALID             ; 
                    
	LDY #$00                ; \ set up loop:
	LDA $1662,x             ;  | 
	AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
	BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
	INY                     ; / 

ON_SCREEN_LOOP:

	LDA $D8,x               ; \ 
	CLC                     ;  | set vertical offscreen if necessary
	ADC SPR_T1,y            ;  |
	PHP                     ;  |
	CMP $1C                 ;  | (vert screen boundry)
	ROL $00                 ;  |
	PLP                     ;  |
	LDA $14D4,x             ;  | 
	ADC #$00                ;  |
	LSR $00                 ;  |
	SBC $1D                 ;  |
	BEQ ON_SCREEN_Y         ;  |
	LDA $186C,x             ;  | (vert offscreen)
	ORA SPR_T2,y            ;  |
	STA $186C,x             ;  |

ON_SCREEN_Y:

	DEY                     ;  |
	BPL ON_SCREEN_LOOP      ; /

	LDY $15EA,x             ; get offset to sprite OAM
	LDA $E4,x               ; \ 
	SEC                     ;  | 
	SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
	STA $00                 ; / 
	LDA $D8,x               ; \ 
	SEC                     ;  | 
	SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
	STA $01                 ; / 
	RTS                     ; return

INVALID:

	LDA #$01
	STA $06                    ;  |    ...(not just this subroutine)
	RTS                     ; /	
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B85D - off screen processing code - shared
; sprites enter at different points
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T12:             db $40,$B0
SPR_T13:             db $01,$FF
SPR_T14:             db $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
		            db $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15:             db $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
					db $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1:   LDA #$02                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2:   LDA #$04                ;  | 
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3:   LDA #$06                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4:   LDA #$08                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5:   LDA #$0A                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6:   LDA #$0C                ;  |
                    BRA STORE_03            ;  | OMG YOU FOUND THIS HIDDEN z0mg place!111 you win a cookie!
SUB_OFF_SCREEN_X7:   LDA #$0E                ;  |
STORE_03:			STA $03					;  |            
					BRA START_SUB			;  |
SUB_OFF_SCREEN_X0:   STZ $03					; /

START_SUB:           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_35           ; /
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
                    AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
                    ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
                    STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
                    TAY                     ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
                    LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
                    CLC                     ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
                    ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
                    ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
                    CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
                    PHP                     ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
                    LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
                    LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
                    ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
                    PLP                     ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
                    SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
                    STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
                    LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
                    BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
                    EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
                    STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31:             LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
                    BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE:        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /    
                    LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
                    CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
                    BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
                    LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
                    STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE:         STZ $14C8,x             ; erase sprite
RETURN_35:           RTS                     ; return

VERTICAL_LEVEL:      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ; \
                    LSR A                   ; | 
                    BCS RETURN_35           ; /
                    LDA $E4,x               ; \ 
                    CMP #$00                ;  | if the sprite has gone off the side of the level...
                    LDA $14E0,x             ;  |
                    SBC #$00                ;  |
                    CMP #$02                ;  |
                    BCS ERASE_SPRITE        ; /  ...erase the sprite
                    LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
                    LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
                    AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
                    STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
                    TAY                     ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
                    LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
                    CLC                     ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
                    ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
                    ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
                    CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
                    PHP                     ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
                    LDA $001D             ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
                    LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
                    ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
                    PLP                     ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
                    SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
                    STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
                    LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
                    BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
                    EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
                    STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38:             LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
                    BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
                    BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN:   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / 