;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Pot Sprite
;;	by
;; wiiqwertyuiop
;;
;; This sprite will break if you throw it at a wall or on the ground at a certain speed.
;; 
;; Credit not required, but it is appreciated! :D 
;;
;; Uses Extra-bit? - No
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	!Button	=	$40		; Button to press to pick sprite up
	!PushingRight  = $10		; Speed when your pushing it right
	!PushingLeft   = $F0		; Speed when your pushing it left
	!Sound	=	$07		; Sound effect to play when breaking
	!Bank	=	$1DFC		; Sound effect bank
	!Sprite1 =	$21		; Sprite to spawn
	!CustomSprite = $01		; Custom sprite to spawn

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite INIT
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "INIT ",pc
LDA #$09		;\ sprite = stationary/Carryable
STA $14C8,x		;/
STZ $1504,x
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite MAIN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "MAIN ",pc                                    
PHB                     ; \
PHK                     ;  | The same old
PLB                     ; /
JSR Random		;  Get a "Random" number to use for later
JSR SPRITE_CODE_START   ;  Jump to sprite code
LDA $C2,x		; \
BNE NoSolid		;  | Check if we are carying the sprite
JSL $01B44F		;  | if so don't make it solid
NoSolid:		; /
PLB 			; Yep
RTL                     ; Return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite not being carried
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


SPRITE_CODE_START:

JSR Graphics 	  	; This routine controls graphics.

LDA $1510,x		;\ Keep running the carried code if we have been picked up already
BNE WeAreBeingCarried	;/

LDA $14C8,x		;\
CMP #$0B		; | If we are being carried go to the next part of the code
BEQ WeAreBeingCarried	;/

JSL $01A7DC		;\ Are we touching Mario
BCC Return		;/ If not return

LDA $15        		;\
AND #!Button        	; | Are we pressing X/Y? If not, check if we are pushing it.
BEQ Pushing      	;/

LDA $14C8,x		;\ If the sprite is dead, return
BEQ Return		;/

LDY #$0B		;\
Loop:			; |
LDA $14C8,y		; | loop to see if we're holding anything
CMP #$0B		; | not my code
BEQ Return		; |
DEY			; |
BPL Loop		;/

LDA #$0B        	;\
STA $14C8,x     	; | The sprite is now being carried! :D
STA $C2,x		;/
Return:

LDA $1534,x
CMP #$FF
BNE ThatsAll

LDA $1534,x		;\  Break the sprite if we started in the air
BNE JumpDown		;/

LDA $1588,x		;\
AND #$04		; | If we are not on the ground branch
BEQ BreakAlready	;/
ThatsAll:
RTS

BreakAlready:
LDA #$01		;\ Set a flag
STA $1534,x		;/
RTS

Pushing:
LDA $0E
CMP #$E6
BMI Return
LDA $15
AND #$01
BNE PushingRight
LDA $15
AND #$02
BNE PushingLeft
BRL Return


PushingRight:
LDA #!PushingRight
STA $B6,x
ShareTheX:
JSL $01802A
BRL Return

PushingLeft:
LDA #!PushingLeft
STA $B6,x
BRL ShareTheX

JumpDown:
JMP BreakTheAirBornSprite

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite being carried
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WeAreBeingCarried:

LDA #$0B		;\ Keep this set otherwise the sprite will alsways be solid
STA $C2,x		;/

LDA #$01		;\ This tells us to keep running this code even after we let go of the sprite
STA $1510,x		;/

LDA $1504,x		;\ If we are off the ground and going up branch
BNE WereGoingUP		;/

LDA $1588,x		;\
AND #$04		; | If we are not on the ground branch
BEQ BreakOrNot		;/

LDA #$FF
STA $1534,x

ToRTS:

LDA $15			;\
AND #!Button		; | check if we holding the sprite anymore
BEQ Check		;/

JSL $01A7DC		;\ Are we touching Mario
BCC Check		;/ If not return

Nothing:

RTS

Check:
LDA $AA,x		;\
BNE Nothing		; | Is the sprite moving?
LDA $B6,x		; |
BNE Nothing		;/
LDA #$09		;\
STA $14C8,x		; |
STZ $C2,x		; | if not clear everything
STZ $1510,x		; |
STZ $1528,X		; |
STZ $1504,x		; |
STZ $15			;/
RTS	

BreakOrNot:


LDA $1588,x		;\
AND #$04		; | If we are not on the ground branch
BNE Check		;/

LDA $AA,x		;\ Are we moving up?
CMP #$FA		; |
BCC WereGoingUP		;/ if so branch

LDA $B6,x
BPL Right
BMI Left

NowBack:
LDA $1588,x		;\
AND #$03		; | Are we touching a wall?
BEQ Skip		;/

JMP SmashCode

;LDA $76		;\ See what direction mario is facing
;BEQ Left		;/

;LDA $B6,x		;\
;CMP #!SensitivityR	; | How hard you need to throw it right to break it
;BCS SmashCode		;/
;BRA Skip		; Return

;Left:
;LDA $B6,x		;\
;CMP #!SensitivityL	; | How hard you need to throw it left to break it
;BCC CheckNegative	;/

Skip:
RTS

Right:
LDA #$0A
BCC Skip
BRL NowBack

Left:
LDA #$F5
BCS Skip
BRL NowBack

WereGoingUP:
LDA $AA,x		;\ Are we moving up?
CMP #$FA		; |
BCS ToRTS		;/ if so branch

LDA #$04		;\ Set a flag
STA $1504,x		;/

LDA $1588,x		;\
AND #$04		; | If we are not on the ground branch
BEQ Skip		;/

BRA SmashCode



;CheckNegative:
;LDA $B6,x		;\
;CMP #$7F		; | Do check right speed
;BCC Skip		;/

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite being smashed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



SmashCode:


LDA #!Sound		;\ Sound effect to play
STA !Bank		;/

LDA $E4,x    		;\	         
STA $9A                 ; |
LDA $14E0,x             ; |
STA $9B                 ; |
LDA $D8,x               ; |
STA $98                 ; |
LDA $14D4,x             ; |
STA $99  		; | Shatter code
PHB			; |
LDA #$02		; |
PHA			; |
PLB			; |
LDA #$00		; |
JSL $028663		; |
PLB			;/

LDA $1594,x		;\
BEQ SpawnNothing	; |
CMP #$01		; | Get the random number from before and put it into action
BEQ Sprite		; | 
CMP #$03		; |
BCS CustSprite		;/
RTS

SpawnNothing:
STZ $14C8,x		; Earse the sprite
RTS


Sprite:
LDA #!Sprite1		;\
STA $9E,x		; |
JSL $07F7D2		; | Spawn a normal sprite
LDA #$08		; |
STA $14C8,x		;/
RTS


CustSprite:
LDA #!CustomSprite	;\
STA $7FAB9E,x		; |
LDA #$08		; |
STA $14C8,x		; |
JSL $07F7D2		; | Spawn a custom sprite
JSL $0187A7		; |
LDA #$08		; |
STA $7FAB10,x		;/
RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite GFX code 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



Graphics:
	JSR GET_DRAW_INFO 	; Before actually coding the graphics, we need a routine that will get the current sprite's value 
				; into the OAM.
				; The OAM being a place where the tile data for the current sprite will be stored.
	LDA $00			;\
	STA $0300,y		;/ Draw the X position of the sprite

	LDA $01			;\
	STA $0301,y		;/ Draw the Y position of the sprite

;Those 2 above are always needed to figure out the X/Y position of the sprite

	LDA #$C2		;\
	STA $0302,y		;/ Tile to draw. This is currently tile 24.
				; NOTE: The tile is the upper-left tile of the 16x16 tile you want to draw
	LDA #$F0 
	STA $0309,y

	LDA #$06
	ORA $64
	STA $0303,y		; Write the YXPPCCCT property byte of the sprite
				

	INY			;\
	INY			; | The OAM is 8x8, but our sprite is 16x16 ..
	INY			; | So increment it 4 times.
	INY			;/

	LDY #$02		; Y ends with the tile size .. 02 means it's 16x16
	LDA #$00		; A -> number of tiles drawn - 1.
				; I drew only 1 tile so I put in 1-1 = 00.

	JSL $01B7B3		; Call the routine that draws the sprite.
	RTS			

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;       Y = index to sprite OAM ($300)
;       $00 = sprite x position relative to screen boarder
;       $01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1:             db $0C,$1C
SPR_T2:             db $01,$02

GET_DRAW_INFO:      STZ $186C,x             ; reset sprite offscreen flag, vertical
	STZ $15A0,x             ; reset sprite offscreen flag, horizontal
	LDA $E4,x               ; \
	CMP $1A                 ;  | set horizontal offscreen if necessary
	LDA $14E0,x             ;  |
	SBC $1B                 ;  |
	BEQ ON_SCREEN_X         ;  |
	INC $15A0,x             ; /

ON_SCREEN_X:        LDA $14E0,x             ; \
	XBA	 ;  |
	LDA $E4,x               ;  |
	REP #$20                ;  |
	SEC	 ;  |
	SBC $1A                 ;  | mark sprite invalid if far enough off screen
	CLC	 ;  |
	ADC.w #$0040            ;  |
	CMP.w #$0180            ;  |
	SEP #$20                ;  |
	ROL A                   ;  |
	AND #$01                ;  |
	STA $15C4,x             ; / 
	BNE INVALID             ; 
	
	LDY #$00                ; \ set up loop:
	LDA $1662,x             ;  | 
	AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
	BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
	INY	 ; / 
ON_SCREEN_LOOP:     LDA $D8,x               ; \ 
	CLC	 ;  | set vertical offscreen if necessary
	ADC SPR_T1,y            ;  |
	PHP	 ;  |
	CMP $1C                 ;  | (vert screen boundry)
	ROL $00                 ;  |
	PLP	 ;  |
	LDA $14D4,x             ;  | 
	ADC #$00                ;  |
	LSR $00                 ;  |
	SBC $1D                 ;  |
	BEQ ON_SCREEN_Y         ;  |
	LDA $186C,x             ;  | (vert offscreen)
	ORA SPR_T2,y            ;  |
	STA $186C,x             ;  |
ON_SCREEN_Y:        DEY	 ;  |
	BPL ON_SCREEN_LOOP      ; /

	LDY $15EA,x             ; get offset to sprite OAM
	LDA $E4,x               ; \ 
	SEC	 ;  | 
	SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
	STA $00                 ; / 
	LDA $D8,x               ; \ 
	SEC	 ;  | 
	SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
	STA $01                 ; / 
	RTS	 ; return

INVALID:            PLA	 ; \ return from *main gfx routine* subroutine...
	PLA	 ;  |    ...(not just this subroutine)
	RTS	 ; /        

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB HORZ POS
;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS:        LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16:             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:env

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B829 - vertical mario/sprite position check - shared
; Y = 1 if mario below sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B829 

SUB_VERT_POS:       LDY #$00               ;A:25A1 X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizCHC:0130 VC:085 00 FL:924
                    LDA $96                ;A:25A1 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdiZCHC:0146 VC:085 00 FL:924
                    SEC                    ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0170 VC:085 00 FL:924
                    SBC $D8,x              ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0184 VC:085 00 FL:924
                    STA $0F                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0214 VC:085 00 FL:924
                    LDA $97                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0238 VC:085 00 FL:924
                    SBC $14D4,x            ;A:2501 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizcHC:0262 VC:085 00 FL:924
                    BPL LABEL11            ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0294 VC:085 00 FL:924
                    INY                    ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0310 VC:085 00 FL:924
LABEL11:            RTS                    ;A:25FF X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizcHC:0324 VC:085 00 FL:924


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; my "random" number code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Random:
;LDA $1594,x
;CMP #$03
;BCC BornDone
JSL $01ACF9 
AND #$03
STA $1594,x
BornDone:
RTS

BreakTheAirBornSprite:
LDA $1588,x		;\
AND #$04		; | If we are not on the ground branch
BEQ BornDone		;/
JMP SmashCode
