;@sa1 <-- DO NOT REMOVE THIS LINE!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Real homing bill
; by 33953YoShI
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; This sprite will aim to Mario.
; This version have 16 animation frames instead of 8.
;                                                       Default
; Extra Property Byte 1 : moving speed        [Slow $01 - $18 - $FF Fast]
; Extra Propetry Byte 2 : accuracy of aiming  [Low  $01 - $04 - $FF High]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Uses first extra bit: YES
; This sprite will be exploded when passed a period of time.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		!SE_Tick_SFX =		$23		;\ Choose Tick count SFX
		!SE_Tick_RAM =		$1DFC		;/
		
		!SE_Explode_SFX =	$09		;\ Choose Explode SFX
		!SE_Explode_RAM =	$1DFC		;/
		
		!InitialTickTime =	255		;
		!TickTime =		60		;
		
		!TickCount =		$03		;

TileMap:	db $A6,$67,$A8,$69,$A4,$69,$A8,$67
		db $A6,$42,$A6,$44,$A4,$44,$A6,$42
TileProp:	db $40,$41,$41,$41,$81,$01,$01,$01
		db $00,$41,$41,$41,$01,$01,$01,$01

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
; SA-1 pack - Memory remap
		!BW =		$6000
		
		!9E =		$3200
		!AA =		$9E
		!B6 =		$B6
		!C2 =		$D8
		!D8 =		$3216
		!E4 =		$322C

		!00AA =		$309E
		!00B6 =		$30B6
		!00C2 =		$30D8
		!009E =		$3200
		!00D8 =		$3216
		!00E4 =		$322C
		!14C8 =		$3242
		!14D4 =		$3258
		!14E0 =		$326E
		!151C =		$3284
		!1528 =		$329A
		!1534 =		$32B0
		!1540 =		$32C6
		!154C =		$32DC
		!1558 =		$32F2
		!1564 =		$3308
		!1570 =		$331E
		!157C =		$3334
		!1588 =		$334A
		!1594 =		$3360
		!15A0 =		$3376
		!15AC =		$338C
		!15EA =		$33A2
		!15F6 =		$33B8
		!1602 =		$33CE
		!160E =		$33E4
		!163E =		$33FA
		!187B =		$3410
		
		!14EC =		$74C8
		!14F8 =		$74DE
		!1504 =		$74F4
		!1510 =		$750A
		!15B8 =		$7520
		!15C4 =		$7536
		!15D0 =		$754C
		!15DC =		$7562
		!161A =		$7578
		!1626 =		$758E
		!1632 =		$75A4
		!190F =		$7658
		!1FD6 =		$766E
		!1FE2 =		$7FD6
		!164A =		$75BA
		!1656 =		$75D0
		!1662 =		$75EA
		!166E =		$7600
		!167A =		$7616
		!1686 =		$762C
		!186C =		$7642
		
		!RAM_Tick =		!C2
		!RAM_TickTimer =	!1558
		!RAM_BackwardDistL =	!1534
		!RAM_BackwardDistH =	!1528
		!RAM_AngleDistL =	!1594
		!RAM_AngleDistH =	!1FD6
		!RAM_AngleL =		!1504
		!RAM_AngleH =		!151C
		!RAM_Accuracy =		!1510

		!RAM_ExtraBits =	$6040
		!RAM_ExtraProp1 =	$6057
		!RAM_ExtraProp2 =	$606D
		
		!GetSin =		$07F7DB
		!GetCos =		$07F7DB

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		print "INIT ",pc
InitCode:	LDA #$02
		STA !RAM_AngleDistH,x
		LDA.b #!InitialTickTime
		STA !RAM_TickTimer,x
		LDA !RAM_ExtraProp2,x
		STA !RAM_Accuracy,x
		LDA #$00
		STA !RAM_ExtraProp2,x
		LDA #!TickCount
		STA !RAM_Tick,x
		LDA !RAM_BackwardDistH,x
		ORA !RAM_BackwardDistL,x
		BNE .Return
		LDA $94
		CMP !E4,x
		LDA $95
		SBC !14E0,x
		BPL .Return
		INC !RAM_AngleH,x
.Return		RTL
		
		print "MAIN ",pc
		PHB
		PHK
		PLB
		JSR MainCode
		PLB
		RTL
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MainCode:	JSR SubGFX
		LDY $9D
		BNE .Return
		JSR SubOffScreenSA1
		LDA !14C8,x
		CMP #$08
		BEQ .Normal
.Dying		STZ !RAM_BackwardDistH,x
		STZ !RAM_BackwardDistL,x
		LDY #$00
		LDA !B6,x
		BPL +
		DEY
+		STA $00
		STY $01
		
		LDY #$00
		LDA !AA,x
		BPL +
		DEY
+		STA $02
		STY $03
		ORA !B6,x
		BEQ .Return
		
		JSR GetAngleSA1
		LDA $00
		STA !RAM_AngleL,x
		LDA $01
		STA !RAM_AngleH,x
.Return		RTS
		
.Normal		LDA !RAM_ExtraBits,x
		AND #$04
		BEQ .SkipTick
		LDA !RAM_TickTimer,x
		BNE .SkipTick
		DEC !RAM_Tick,x
		BPL .SetTick
		LDA.b #!SE_Explode_SFX
		STA.w !SE_Explode_RAM|!BW
		JMP GenExplode
		
.SetTick	LDA #!TickTime
		STA !RAM_TickTimer,x
		LDA.b #!SE_Tick_SFX
		STA.w !SE_Tick_RAM|!BW
.SkipTick	LDA !RAM_AngleL,x
		STA $0E
		LDA !RAM_AngleH,x
		STA $0F
		
		LDA !RAM_AngleDistH,x
		ORA !RAM_AngleDistL,x
		BNE .SkipUpdate
		LDA !RAM_Accuracy,x
		BEQ .SkipUpdate
		LDA $D1
		SEC
		SBC !E4,x
		STA $00
		LDA $D2
		SBC !14E0,x
		STA $01
		
		LDA $D3
		SEC
		SBC !D8,x
		XBA
		LDA $D4
		SBC !14D4,x
		XBA
		REP #$21
		ADC.w #$0010
		STA $02
		SEP #$20
		JSR GetAngleSA1
		LDA !RAM_Accuracy,x
		REP #$30
		AND.w #$00FF
		STA $02
		LDA $0E
		SEC
		SBC $00
		BIT.w #$0100
		BEQ .IfPlus
		CLC			;\ CMP -$02 => ADD --$02 => ADD $02
		ADC $02			;/
		BCC +
		LDA $00
		BRA .StoreAngle
+		LDA $0E
		ADC $02
		BRA ++
		
.IfPlus		CMP $02
		BCS +
		LDA $00
		BRA .StoreAngle
+		LDA $0E
		SBC $02
++		AND.w #$01FF
.StoreAngle	STA $0E
		SEP #$20
		STA !RAM_AngleL,x
		XBA
		STA !RAM_AngleH,x
		
.SkipUpdate	STZ $2250
		LDA !RAM_ExtraProp1,x
		STA $0A
		REP #$31
		AND.w #$00FF
		ASL #4
		STA $2251
		LDA $0E
		ADC.w #$0080
		AND.w #$01FF
		TAY
		AND.w #$00FF
		ASL A
		TAX
		LDA.l !GetCos,x
		CPY.w #$0100
		BCC +
		EOR.w #$FFFF
		INC A
		CLC
+		STA $2253
		SEP #$30
		LDX.w $15E9|!BW
		LDA $2307
		ADC !14EC,x
		STA !14EC,x
		LDA $2308
		ADC !E4,x
		STA !E4,x
		LDA $2309
		ADC !14E0,x
		STA !14E0,x
		
		REP #$30
		LDA $0E
		TAY
		AND.w #$00FF
		ASL A
		TAX
		LDA.l !GetSin,x
		CPY.w #$0100
		BCC +
		EOR.w #$FFFF
		INC A
		CLC
+		STA $2253
		SEP #$30
		LDX.w $15E9|!BW
		LDA $2307
		ADC !14F8,x
		STA !14F8,x
		LDA $2308
		ADC !D8,x
		STA !D8,x
		LDA $2309
		ADC !14D4,x
		STA !14D4,x

		SEC
		LDA !RAM_AngleDistL,x
		ORA !RAM_AngleDistH,x
		BEQ ++
		LDA !RAM_AngleDistL,x
		SBC $0A
		BCS +
		SEC
		DEC !RAM_AngleDistH,x
		BPL +
		LDA #$00
		STA !RAM_AngleDistH,x
+		STA !RAM_AngleDistL,x

++		LDA !RAM_BackwardDistL,x
		ORA !RAM_BackwardDistL,x
		BEQ ++
		LDA !RAM_BackwardDistL,x
		SBC $0A
		BCS +
		DEC !RAM_BackwardDistH,x
		BPL +
		LDA #$00
		STA !RAM_BackwardDistH,x
+		STA !RAM_BackwardDistL,x

++		JSL $01A7DC
		RTS
		
GenExplode:	LDA #$0D
		STA !9E,x
		JSL $07F7D2
		LDA #$08
		STA !14C8,x
		LDA #$01
		STA !1534,x
		LDA #$30
		STA !1540,x
		LDA !1656,x
		ORA #$80
		STA !1656,x
		LDA !167A,x
		ORA #$02
		STA !167A,x
		RTS
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubGFX:		JSR GetDrawInfoSA1
		LDA $00
		STA.w $0300|!BW,y
		LDA $01
		STA.w $0301|!BW,y
		LDA !15F6,x
		LDY !RAM_Tick,x
		CPY.b #!TickCount
		BEQ +
		AND #$01
		STA $02
		LDA $14
		AND #$0E
		ORA $02
+		LDY !RAM_BackwardDistH,x
		BNE .Back
		LDY !RAM_BackwardDistL,x
		BEQ .Front
.Back		ORA #$10
		BRA ++
.Front		ORA $64
++		STA $02
		LDA !RAM_AngleH,x
		XBA
		LDA !RAM_AngleL,x
		REP #$21
		ADC.w #$0010
		ASL #3
		XBA
		SEP #$20
		AND #$0F
		LDY !15EA,x
		TAX
		LDA.w TileMap,x
		STA.w $0302|!BW,y
		LDA.w TileProp,x
		EOR $02
		STA.w $0303|!BW,y
		LDX.w $15E9|!BW
		LDA #$00
		LDY #$02
		JSL $01B7B3
		RTS
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GetAngle - Low precision version (x0.5)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetAngleSA1:	REP #$20
		LDY #$00
		LDA $00			;\
		BPL .X_Plus		; |
		LDY #$04		; |
		EOR.w #$FFFF		; | Get absolute value of X
		INC A			; |
		STA $00			;/
.X_Plus		LDA $02			;\
		BPL .Y_Plus		; |
		INY #2			; |
		EOR.w #$FFFF		; | Get absolute value of Y
		INC A			; |
		STA $02			;/
.Y_Plus		CMP $00			;\ If X is smaller than Y...
		BCC +			;/
		STA $04			;\
		LDA $00			; |
		STA $02			; | swap X and Y.
		LDA $04			; |
		STA $00			; |
		INY			;/
+		STY $06			;
		LDA $02			;
		STA $04			;
		STZ $02			;
		ORA $00			;
		AND.w #$FF00		;
		BEQ .Next		;
		XBA			;
-		LSR $00			;
		LSR $04			;
		ROR $02			;
		LSR A			;
		BNE -			;
.Next		LDY #$01		;
		STY $2250		;
		LDA $03			;
		STA $2251		;
		LDA $00			;
		BEQ .DivZero		;
		STA $2253		;
		SEP #$20		;\ wait 5 cycles
		STZ $01			;/
		LDA $2306		;
		LDY $2307		;
		BEQ +			;
		LDA #$FF		;
+		LSR A			;
		TAY			;
		LDA.w AtanTable,y	;
+		LSR $06			;
		BCC +			;
		EOR #$7F		;
		INC A			;
+		LSR $06			;
		BCC +			;
		EOR #$FF		;
		INC A			;
		BEQ +			;
		INC $01			;
+		LSR $06			;
		BCC +			;
		EOR #$FF		;
		INC A			;
		BNE +			;
		INC $01			;
+		STA $00			;
		LDA #$FE		;
		TRB $01			;
		RTS			;
		
.DivZero	SEP #$20		;
		LDY #$00		;
		LDA $06			;
		LSR A			;
		BCS +			;
		LDY #$80		;
		LSR A			;
+		AND #$01		;
		STA $01			;
		STY $00			;
		RTS

AtanTable:
db $00,$01,$01,$02,$03,$03,$04,$04,$05,$06,$06,$07,$08,$08,$09,$0A
db $0A,$0B,$0B,$0C,$0D,$0D,$0E,$0E,$0F,$10,$10,$11,$12,$12,$13,$13
db $14,$15,$15,$16,$16,$17,$18,$18,$19,$19,$1A,$1A,$1B,$1C,$1C,$1D
db $1D,$1E,$1E,$1F,$1F,$20,$21,$21,$22,$22,$23,$23,$24,$24,$25,$25
db $26,$26,$27,$27,$28,$28,$29,$29,$2A,$2A,$2B,$2B,$2C,$2C,$2D,$2D
db $2E,$2E,$2E,$2F,$2F,$30,$30,$31,$31,$32,$32,$32,$33,$33,$34,$34
db $34,$35,$35,$36,$36,$36,$37,$37,$38,$38,$38,$39,$39,$39,$3A,$3A
db $3B,$3B,$3B,$3C,$3C,$3C,$3D,$3D,$3D,$3E,$3E,$3E,$3F,$3F,$3F,$40

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GetDrawInfo - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetDrawInfoSA1:	LDA !14E0,x
		XBA
		LDA !E4,x
		REP #$20
		SEC
		SBC $1A
		STA $00
		CLC
		ADC.w #$0040
		CMP.w #$0180
		SEP #$20
		LDA $01
		BEQ +
		LDA #$01
+		STA !15A0,x
		TDC
		ROL A
		STA !15C4,x
		BNE .Invalid

		LDA !14D4,x
		XBA
		LDA !1662,x
		AND #$20
		BEQ .CheckOnce
.CheckTwice	LDA !D8,x
		REP #$21
		ADC.w #$001C
		SEC
		SBC $1C
		SEP #$20
		LDA !14D4,x
		XBA
		BEQ .CheckOnce
		LDA #$02
.CheckOnce	STA !186C,x
		LDA !D8,x
		REP #$21
		ADC.w #$000C
		SEC
		SBC $1C
		SEP #$21
		SBC #$0C
		STA $01
		XBA
		BEQ .OnScreenY
		INC !186C,x
.OnScreenY	LDY !15EA,x
		RTS
		
.Invalid	PLA
		PLA
		RTS
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SubOffScreen - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
SubOffScreenSA1:
		LDA !15A0,x
		ORA !186C,x
		BEQ .Return2
		LDA !167A,x
		AND #$04
		BNE .Return2
		LDA $5B
		LSR A
		BCS .VerticalLevel
		LDA !D8,x
		ADC #$50
		LDA !14D4,x
		ADC #$00
		CMP #$02
		BCS .EraseSprite
		LDA !14E0,x
		XBA
		LDA !E4,x
		REP #$21
		ADC .AddTable,y
		SEC
		SBC $1A
		CMP .CmpTable,y
.Common		SEP #$20
		BCC .Return2
.EraseSprite	LDA !14C8,x
		CMP #$08
		BCC .KillSprite
		LDY !161A,x
		CPY #$FF
		BEQ .KillSprite
		TYX
		LDA.l $418A00,x
		AND #$FE
		STA.l $418A00,x
		LDX.w $15E9|!BW
.KillSprite	STZ !14C8,x
.Return2	RTS

.VerticalLevel	LDA $13
		LSR A
		BCS .CheckY
		LDA !14E0,x
		XBA
		LDA !E4,x
		REP #$21
		ADC.w #$0040
		CMP.w #$0280
		BRA .Common
.CheckY		LDA !14D4,x
		XBA
		LDA !D8,x
		REP #$20
		SBC $1C
		CLC
		ADC.w #$0070
		CMP.w #$01D0
		BRA .Common

.AddTable	dw $0040,$0040,$0010,$0070
		dw $0090,$0050,$0080,$FFC0
.CmpTable	dw $0170,$01E0,$01B0,$01D0
		dw $0230,$01B0,$0220,$0160
		