;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Real homing bill shooter - Advanced version
; by 33953YoShI
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; This shooter behavior is depend on block number at same positions as it.
;
; Shot directions is depend on 1 digit of block number.
; 0 ~ 7 : Fixing cannon
;
; 5 6 7
; 4 + 0
; 3 2 1
;
; 8,C : left or right, it behavior is same as Standard version.
; 9,D : up or down
; A,E : diagonal, left up or right down
; B,F : diagonal, left down or right up
;
; Generated sprite and interval for generate is depend on 2 digit of block number.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Uses first extra bit: YES
; Generated sprite's extra bit will be set same value as this shooter.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		!SE_Shot_SFX =		$09		;\ Choose Shot SFX
		!SE_Shot_RAM =		$1DFC		;/

; Set to be generated sprite number and interval for generate.
CustSetting:	db $12,$60		; Tile x0x,x8x
		db $12,$60		; Tile x1x,x9x
		db $12,$60		; Tile x2x,xAx
		db $12,$60		; Tile x3x,xBx
		db $12,$60		; Tile x4x,xCx
		db $12,$60		; Tile x5x,xDx
		db $12,$60		; Tile x6x,xEx
		db $12,$60		; Tile x7x,xFx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		!RAM_BackwardDistL =	$1534
		!RAM_BackwardDistH =	$1528
		!RAM_AngleL =		$1504
		!RAM_AngleH =		$151C

		!RAM_ExtraBits =	$7FAB10
		!RAM_NewSpriteNum =	$7FAB9E
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		print "INIT ",pc
		print "MAIN ",pc
		PHB
		PHK
		PLB
		LDA $178B,x
		BIT #$08
		BNE +
		JSR InitCode
+		JSR MainCode
		PLB
		RTL
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

InitCode:	LDA $178B,x
		AND #$F0
		STA $98
		LDA $1793,x
		STA $99
		LDA $179B,x
		AND #$F0
		STA $9A
		LDA $17A3,x
		STA $9B
		STZ $1933
		JSR GetBlock
		STA $00
		LSR #4
		AND #$07
		ORA #$08
		ORA $98
		STA $178B,x
		LDA $00
		AND #$0F
		ORA $9A
		STA $179B,x
Return:		RTS
		
MainCode:	LDA $17AB,x
		BNE Return
		LDA $179B,x
		AND #$0F
		STA $04
		TAY
		LDA.w CheckTable,y
		STA $02
		LDA $178B,x
		AND #$07
		ASL A
		TAY
		LDA.w CustSetting,y
		STA $03
		LDA.w CustSetting+$01,y
		STA $17AB,x
		LDA $179B,x
		AND #$F0
		STA $01
		LDA $178B,x
		AND #$F0
		STA $00
		CMP $1C
		LDA $1793,x
		SBC $1D
		BNE Return
		LDA $17A3,x
		XBA
		LDA $01
		REP #$21
		ADC.w #$0010
		SEC
		SBC $1A
		CMP.w #$0120
		SEP #$20
		BCS Return
		BIT $02
		BMI Generate
		LDA $94
		ADC #$11
		SEC
		SBC $01
		CMP #$22
		BCS Generate
		BIT $02
		BVC Return
		LDA $96
		ADC #$20
		SEC
		SBC $00
		CMP #$40
		BCC Return
		
Generate:	JSL $82A9DE
		BMI Return
		LDA $1783,x
		STA $02
		TYX
		LDA $03
		STA !RAM_NewSpriteNum,x
		JSL $87F7D2
		LDA #$88
		BIT $02
		BVC +
		ORA #$04
+		STA !RAM_ExtraBits,x
		LDA #$01
		STA !RAM_BackwardDistH,x
		LDA #$80
		STA !RAM_BackwardDistL,x
		LDA #$01
		STA $14C8,x
		LDA.b #!SE_Shot_SFX
		STA.w !SE_Shot_RAM
		TXY
		LDX $15E9
		
		LDA $179B,x
		AND #$F0
		STA $9A
		STA $00E4,y
		LDA $17A3,x
		STA $14E0,y
		STA $9B
		LDA $178B,x
		AND #$F0
		STA $98
		SEC
		SBC #$01
		STA $00D8,y
		LDA $1793,x
		SBC #$00
		STA $14D4,y
		STA $99
		LDA $04
		ASL A
		TAX
		CPX #$10
		BCC .Fixing
		REP #$21
		JSR.w (PtrTable-$10,x)
		SEP #$20
		STA !RAM_AngleL,y
		XBA
		BRA +
.Fixing		LDA.w AngleTable,x
		STA !RAM_AngleL,y
		XBA
		LDA.w AngleTable+$01,x
+		STA !RAM_AngleH,y
		XBA
		REP #$20
		ASL #2
		XBA
		SEP #$20
		AND #$07
		TAY
		JMP SubSmoke
		
AngleTable:	dw $0000,$0040,$0080,$00C0,$0100,$0140,$180,$01C0

PtrTable:	dw CheckLR,CheckUD,CheckLU_RD,CheckLD_RU
		dw CheckLR,CheckUD,CheckLU_RD,CheckLD_RU
		
CheckTable:	db $00,$80,$40,$80,$00,$80,$40,$80
		db $00,$40,$80,$80,$00,$40,$80,$80
		
CheckLR:	LDA $94
		CMP $9A
		BPL +
		LDA.w #$0100
		RTS
+		LDA.w #$0000
		RTS
		
CheckUD:	LDA $96
		ADC.w #$0010
		CMP $98
		BPL +
		LDA.w #$0180
		RTS
+		LDA.w #$0080
		RTS
		
CheckLU_RD:	LDA $94
		SEC
		SBC $9A
		STA $00
		LDA $98
		SEC
		SBC.w #$0010
		SEC
		SBC $96
		STA $02
		PHP
		BPL +
		EOR.w #$FFFF
		INC A
		STA $02
		LDA $00
		EOR.w #$FFFF
		INC A
		STA $00
+		LDA $00
		SEC
		SBC $02
		BPL +			;\
		BVS .RD			; | BGE .RD
		BRA .LU			; |
+		BVC .RD			;/
.LU		LDA.w #$0140
		PLP
		BPL +
		LDA.w #$0040
+		RTS

.RD		LDA.w #$0040
		PLP
		BPL +
		LDA.w #$0140
+		RTS


CheckLD_RU:	LDA $94
		SEC
		SBC $9A
		STA $00
		LDA $96
		CLC
		ADC.w #$0010
		SEC
		SBC $98
		STA $02
		PHP
		BPL +
		EOR.w #$FFFF
		INC A
		STA $02
		LDA $00
		EOR.w #$FFFF
		INC A
		STA $00
+		LDA $00
		SEC
		SBC $02
		BPL +			;\
		BVS .RU			; | BGE .RU
		BRA .LD			; |
+		BVC .RU			;/
.LD		LDA.w #$00C0
		PLP
		BPL +
		LDA.w #$01C0
+		RTS

.RU		LDA.w #$01C0
		PLP
		BPL +
		LDA.w #$00C0
+		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubSmoke:	LDA .XofsL,y
		STA $00
		CLC
		ADC $9A
		TAX
		LDA .XofsH,y
		ADC $9B
		CPX $1A
		SBC $1B
		BNE .Return
		LDA .YofsL,y
		STA $01
		CLC
		ADC $98
		TAX
		LDA .YofsH,y
		ADC $99
		CPX $1C
		SBC $1D
		BNE .Return

		LDY #$03
.FindFree	LDA $17C0,y
		BEQ .FoundFree
		DEY
		BPL .FindFree
		BRA .Return

.FoundFree	LDA #$01
		STA $17C0,y
		LDA $98
		CLC
		ADC $01
		STA $17C4,y
		LDA #$1B
		STA $17CC,y
		LDA $9A
		CLC
		ADC $00
		STA $17C8,y
.Return		LDX $15E9
		RTS

.XofsL		db $0C,$08,$00,$F8,$F4,$F8,$00,$08
.XofsH		db $00,$00,$00,$FF,$FF,$FF,$00,$00
.YofsL		db $00,$08,$0C,$08,$00,$F8,$F4,$F8
.YofsH		db $00,$00,$00,$00,$00,$FF,$FF,$FF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GetBlock
; this routine will get Map16 value
; If position is invalid range, will return 0xFFFF.
;
; input:
; $98-$99 block position Y
; $9A-$9B block position X
; $1933   layer
;
; output:
; A Map16 lowbyte
; Y Map16 highbyte
;
; $65-$68 will be destructed.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetBlock:	LDA $5B
		AND #$01
		TAY
		LDA #$20
		CPY #$01
		BCC .Horz0
		LDA #$1C
.Horz0		BIT $5B
		BPL .Layer1_0
		LSR A
.Layer1_0	CPY #$01
		BCC .Horz1
		CMP $99
		BCC .RangeOver
		LDA $9B
		CMP #$02
		BCC .Next
.RangeOver	LDA #$FF
		TAY
		RTS

.Horz1		CMP $9B
		BCC .RangeOver
		LDA $98
		CMP #$B0
		LDA $99
		SBC #$01
		BCS .RangeOver
.Next		LDA $1933
		REP #$21
		BEQ .Layer1_1
		TYA
		BEQ .Horz2
		LDA $98
		ADC.w #$0E00
		AND.w #$FFF0
		STA $67
		BRA +
.Horz2		LDA $98
		AND.w #$FFF0
		STA $67
		LDA $9A
		ADC.w #$1000
		BRA .Common0
.Layer1_1	LDA $98
		AND.w #$FFF0
		STA $67
+		LDA $9A
.Common0	SEP #$20
		LSR #4
		STA $65
		XBA
		CPY #$01
		BCC .Horz3
		STA $66
		ASL $68
		REP #$21
		LDA.w #$0000
		BRA .Common1
.Horz3		ASL A
		STA $4202
		LDA #$D8
		STA $4203
		NOP		;\
		STZ $66		; | wait 8 cycles...
		REP #$21	;/
		LDA $4216
.Common1	ADC $67
		ADC $65
		ADC.w #$C800
		STA $65
		SEP #$20
		LDA #$7F
		STA $67
		LDA [$65]
		TAY
		DEC $67
		LDA [$65]
		RTS
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; TECHNICAL INFORMATION
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; This sprite has used low nibble of positions ram as miscellaneous purposes.
; because shooter haven't miscellaneous memory,
; and low nibble has been cleared in usual case.
;
; also can be used sprite unique ID ($17B3,x) as it.
; because that memory to be written unique ID at sprite loading process,
; but it has not load to anywhere...
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $178B,x 	yyyyittt
;		|||||+++- Generate type
;		||||+---- Initialized flag
;		++++----- Shooter Y position, lowbyte
;
; $179B,x	xxxxdddd
;		||||++++- Generate direction
;		++++----- Shooter X position, lowbyte
;
; $17B3,x	Sprite unique ID (unused in this sprite)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;