;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Real homing bill
; by 33953YoShI
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; This sprite will aim to Mario.
;                                                       Default
; Extra Property Byte 1 : moving speed        [Slow $01 - $18 - $FF Fast]
; Extra Propetry Byte 2 : accuracy of aiming  [Low  $01 - $04 - $FF High]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Uses first extra bit: YES
; This sprite will be exploded when passed a period of time.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		!SE_Tick_SFX =		$23		;\ Choose Tick count SFX
		!SE_Tick_RAM =		$1DFC		;/
		
		!SE_Explode_SFX =	$09		;\ Choose Explode SFX
		!SE_Explode_RAM =	$1DFC		;/
		
		!InitialTickTime =	255		;
		!TickTime =		60		;
		
		!TickCount =		$03		;

TileMap:	db $A6,$A8,$A4,$A8,$A6,$A6,$A4,$A6
TileProp:	db $40,$41,$81,$01,$00,$41,$01,$01

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
		!RAM_Tick =		$C2
		!RAM_TickTimer =	$1558
		!RAM_BackwardDistL =	$1534
		!RAM_BackwardDistH =	$1528
		!RAM_AngleDistL =	$1594
		!RAM_AngleDistH =	$1FD6
		!RAM_AngleL =		$1504
		!RAM_AngleH =		$151C
		!RAM_Accuracy =		$1510

		!RAM_ExtraBits =	$7FAB10
		!RAM_ExtraProp1 =	$7FAB28
		!RAM_ExtraProp2 =	$7FAB34
		
		!GetSin =		$87F7DB
		!GetCos =		$87F7DB

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		print "INIT ",pc
InitCode:	LDA #$02
		STA !RAM_AngleDistH,x
		LDA.b #!InitialTickTime
		STA !RAM_TickTimer,x
		LDA !RAM_ExtraProp2,x
		STA !RAM_Accuracy,x
		LDA #$00
		STA !RAM_ExtraProp2,x
		LDA #!TickCount
		STA !RAM_Tick,x
		LDA !RAM_BackwardDistH,x
		ORA !RAM_BackwardDistL,x
		BNE .Return
		LDA $94
		CMP $E4,x
		LDA $95
		SBC $14E0,x
		BPL .Return
		INC !RAM_AngleH,x
.Return		RTL
		
		print "MAIN ",pc
		PHB
		PHK
		PLB
		JSR MainCode
		PLB
		RTL
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MainCode:	JSR SubGFX
		LDY $9D
		BNE .Return
		JSR SubOffScreen
		LDA $14C8,x
		CMP #$08
		BEQ .Normal
.Dying		STZ !RAM_BackwardDistH,x
		STZ !RAM_BackwardDistL,x
		LDY #$00
		LDA $B6,x
		BPL +
		DEY
+		STA $00
		STY $01
		
		LDY #$00
		LDA $AA,x
		BPL +
		DEY
+		STA $02
		STY $03
		ORA $B6,x
		BEQ .Return
		
		JSR GetAngle
		LDA $00
		STA !RAM_AngleL,x
		LDA $01
		STA !RAM_AngleH,x
.Return		RTS
		
.Normal		LDA !RAM_ExtraBits,x
		AND #$04
		BEQ .SkipTick
		LDA !RAM_TickTimer,x
		BNE .SkipTick
		DEC !RAM_Tick,x
		BPL .SetTick
		LDA.b #!SE_Explode_SFX
		STA.w !SE_Explode_RAM
		JMP GenExplode
		
.SetTick	LDA #!TickTime
		STA !RAM_TickTimer,x
		LDA.b #!SE_Tick_SFX
		STA.w !SE_Tick_RAM
.SkipTick	LDA !RAM_AngleL,x
		STA $0E
		LDA !RAM_AngleH,x
		STA $0F
		
		LDA !RAM_AngleDistH,x
		ORA !RAM_AngleDistL,x
		BNE .SkipUpdate
		LDA !RAM_Accuracy,x
		BEQ .SkipUpdate
		LDA $D1
		SEC
		SBC $E4,x
		STA $00
		LDA $D2
		SBC $14E0,x
		STA $01
		
		LDA $D3
		SEC
		SBC $D8,x
		XBA
		LDA $D4
		SBC $14D4,x
		XBA
		REP #$21
		ADC.w #$0010
		STA $02
		SEP #$20
		JSR GetAngle
		LDA !RAM_Accuracy,x
		REP #$30
		AND.w #$00FF
		STA $02
		LDA $0E
		SEC
		SBC $00
		BIT.w #$0100
		BEQ .IfPlus
		CLC			;\ CMP -$02 => ADD --$02 => ADD $02
		ADC $02			;/
		BCC +
		LDA $00
		BRA .StoreAngle
+		LDA $0E
		ADC $02
		BRA ++
		
.IfPlus		CMP $02
		BCS +
		LDA $00
		BRA .StoreAngle
+		LDA $0E
		SBC $02
++		AND.w #$01FF
.StoreAngle	STA $0E
		SEP #$20
		STA !RAM_AngleL,x
		XBA
		STA !RAM_AngleH,x
		
.SkipUpdate	LDA !RAM_ExtraProp1,x
		STA $4202
		STA $0A
		REP #$31
		AND.w #$00FF
		ASL #4
		STA $08
		LDA $0E
		ADC.w #$0080
		AND.w #$01FF
		TAY
		AND.w #$00FF
		ASL A
		TAX
		LDA.l !GetCos,x
		CMP.w #$0100
		STA $4203
		LDX $15E9
		LDA $08
		BCS .SkipCos
		LDA $4216
		LSR #4
.SkipCos	CPY.w #$0100
		LDY.w #$0000
		BCC .NotNegCos
		EOR.w #$FFFF
		DEY
.NotNegCos	SEP #$30
		ADC $14EC,x
		STA $14EC,x
		XBA
		ADC $E4,x
		STA $E4,x
		TYA
		ADC $14E0,x
		STA $14E0,x
		REP #$30
		
		LDA $0E
		TAY
		AND.w #$00FF
		ASL A
		TAX
		LDA.l !GetSin,x
		CMP.w #$0100
		STA $4203
		LDX $15E9
		LDA $08
		BCS .SkipSin
		LDA $4216
		LSR #4
.SkipSin	CPY.w #$0100
		LDY.w #$0000
		BCC .NotNegSin
		EOR.w #$FFFF
		DEY
.NotNegSin	SEP #$30
		ADC $14F8,x
		STA $14F8,x
		XBA
		ADC $D8,x
		STA $D8,x
		TYA
		ADC $14D4,x
		STA $14D4,x
		
		SEC
		LDA !RAM_AngleDistL,x
		ORA !RAM_AngleDistH,x
		BEQ ++
		LDA !RAM_AngleDistL,x
		SBC $0A
		BCS +
		SEC
		DEC !RAM_AngleDistH,x
		BPL +
		LDA #$00
		STA !RAM_AngleDistH,x
+		STA !RAM_AngleDistL,x

++		LDA !RAM_BackwardDistL,x
		ORA !RAM_BackwardDistL,x
		BEQ ++
		LDA !RAM_BackwardDistL,x
		SBC $0A
		BCS +
		DEC !RAM_BackwardDistH,x
		BPL +
		LDA #$00
		STA !RAM_BackwardDistH,x
+		STA !RAM_BackwardDistL,x

++		JSL $81A7DC
		RTS
		
GenExplode:	LDA #$0D
		STA $9E,x
		JSL $87F7D2
		LDA #$08
		STA $14C8,x
		LDA #$01
		STA $1534,x
		LDA #$30
		STA $1540,x
		LDA $1656,x
		ORA #$80
		STA $1656,x
		LDA $167A,x
		ORA #$02
		STA $167A,x
		RTS
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubGFX:		JSR GetDrawInfo
		LDA $00
		STA $0300,y
		LDA $01
		STA $0301,y
		LDA $15F6,x
		LDY !RAM_Tick,x
		CPY.b #!TickCount
		BEQ +
		AND #$01
		STA $02
		LDA $14
		AND #$0E
		ORA $02
+		LDY !RAM_BackwardDistH,x
		BNE .Back
		LDY !RAM_BackwardDistL,x
		BEQ .Front
.Back		ORA #$10
		BRA ++
.Front		ORA $64
++		STA $02
		LDA !RAM_AngleH,x
		XBA
		LDA !RAM_AngleL,x
		REP #$21
		ADC.w #$0020
		ASL #2
		XBA
		SEP #$20
		AND #$07
		LDY $15EA,x
		TAX
		LDA.w TileMap,x
		STA $0302,y
		LDA.w TileProp,x
		EOR $02
		STA $0303,y
		LDX $15E9
		LDA #$00
		LDY #$02
		JSL $81B7B3
		RTS
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GetAngle - Low precision version (x0.5)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetAngle:	REP #$20
		LDY #$00
		LDA $00			;\
		BPL .X_Plus		; |
		LDY #$04		; |
		EOR.w #$FFFF		; | Get absolute value of X
		INC A			; |
		STA $00			;/
.X_Plus		LDA $02			;\
		BPL .Y_Plus		; |
		INY #2			; |
		EOR.w #$FFFF		; | Get absolute value of Y
		INC A			; |
		STA $02			;/
.Y_Plus		CMP $00			;\ If X is smaller than Y...
		BCC +			;/
		STA $04			;\
		LDA $00			; |
		STA $02			; | swap X and Y.
		LDA $04			; |
		STA $00			; |
		INY			;/
+		STY $06			;
		LDA $02			;
		STA $04			;
		STZ $02			;
		ORA $00			;
		AND.w #$FF00		;
		BEQ .Next		;
		XBA			;
-		LSR $00			;
		LSR $04			;
		ROR $02			;
		LSR A			;
		BNE -			;
.Next		LDY $00			;
		BEQ .DivZero		;
		LDA $03			;
		STA $4204		;
		STY $4206		;
		SEP #$20		;\
		STZ $01			; |
		LDA #$40		; | Wait 16 cycles...
		CPY $03			; |
		BEQ +			; |
		BRA $00			;/
		LDA $4214		;
		LSR A			;
		TAY			;
		LDA.w AtanTable,y	;
+		LSR $06			;
		BCC +			;
		EOR #$7F		;
		INC A			;
+		LSR $06			;
		BCC +			;
		EOR #$FF		;
		INC A			;
		BEQ +			;
		INC $01			;
+		LSR $06			;
		BCC +			;
		EOR #$FF		;
		INC A			;
		BNE +			;
		INC $01			;
+		STA $00			;
		LDA #$FE		;
		TRB $01			;
		RTS			;
		
.DivZero	SEP #$20		;
		LDY #$00		;
		LDA $06			;
		LSR A			;
		BCS +			;
		LDY #$80		;
		LSR A			;
+		AND #$01		;
		STA $01			;
		STY $00			;
		RTS

AtanTable:
db $00,$01,$01,$02,$03,$03,$04,$04,$05,$06,$06,$07,$08,$08,$09,$0A
db $0A,$0B,$0B,$0C,$0D,$0D,$0E,$0E,$0F,$10,$10,$11,$12,$12,$13,$13
db $14,$15,$15,$16,$16,$17,$18,$18,$19,$19,$1A,$1A,$1B,$1C,$1C,$1D
db $1D,$1E,$1E,$1F,$1F,$20,$21,$21,$22,$22,$23,$23,$24,$24,$25,$25
db $26,$26,$27,$27,$28,$28,$29,$29,$2A,$2A,$2B,$2B,$2C,$2C,$2D,$2D
db $2E,$2E,$2E,$2F,$2F,$30,$30,$31,$31,$32,$32,$32,$33,$33,$34,$34
db $34,$35,$35,$36,$36,$36,$37,$37,$38,$38,$38,$39,$39,$39,$3A,$3A
db $3B,$3B,$3B,$3C,$3C,$3C,$3D,$3D,$3D,$3E,$3E,$3E,$3F,$3F,$3F,$40

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GetDrawInfo - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetDrawInfo:	LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$20
		SEC
		SBC $1A
		STA $00
		CLC
		ADC.w #$0040
		CMP.w #$0180
		SEP #$20
		LDA $01
		BEQ +
		LDA #$01
+		STA $15A0,x
		TDC
		ROL A
		STA $15C4,x
		BNE .Invalid

		LDA $14D4,x
		XBA
		LDA $1662,x
		AND #$20
		BEQ .CheckOnce
.CheckTwice	LDA $D8,x
		REP #$21
		ADC.w #$001C
		SEC
		SBC $1C
		SEP #$20
		LDA $14D4,x
		XBA
		BEQ .CheckOnce
		LDA #$02
.CheckOnce	STA $186C,x
		LDA $D8,x
		REP #$21
		ADC.w #$000C
		SEC
		SBC $1C
		SEP #$21
		SBC #$0C
		STA $01
		XBA
		BEQ .OnScreenY
		INC $186C,x
.OnScreenY	LDY $15EA,x
		RTS
		
.Invalid	PLA
		PLA
		RTS
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SubOffScreen - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
SubOffScreen:	LDA $15A0,x
		ORA $186C,x
		BEQ .Return2
		LDA $167A,x
		AND #$04
		BNE .Return2
		LDA $5B
		LSR A
		BCS .VerticalLevel
		LDA $D8,x
		ADC #$50
		LDA $14D4,x
		ADC #$00
		CMP #$02
		BCS .EraseSprite
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$21
		ADC .AddTable,y
		SEC
		SBC $1A
		CMP .CmpTable,y
.Common		SEP #$20
		BCC .Return2
.EraseSprite	LDA $14C8,x
		CMP #$08
		BCC .KillSprite
		LDY $161A,x
		CPY #$FF
		BEQ .KillSprite
		LDA $1938,y
		AND #$FE
		STA $1938,y
.KillSprite	STZ $14C8,x
.Return2	RTS

.VerticalLevel	LDA $13
		LSR A
		BCS .CheckY
		LDA $14E0,x
		XBA
		LDA $E4,x
		REP #$21
		ADC.w #$0040
		CMP.w #$0280
		BRA .Common
.CheckY		LDA $14D4,x
		XBA
		LDA $D8,x
		REP #$20
		SBC $1C
		CLC
		ADC.w #$0070
		CMP.w #$01D0
		BRA .Common

.AddTable	dw $0040,$0040,$0010,$0070
		dw $0090,$0050,$0080,$FFC0
.CmpTable	dw $0170,$01E0,$01B0,$01D0
		dw $0230,$01B0,$0220,$0160
		