;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite 3D - Rip van Fish
; commented by yoshicookiezeus
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


			!RAM_FrameCounter	= $13
			!RAM_FrameCounterB	= $14
			!RAM_MarioSpeedX	= $7B
			!RAM_MarioXPos		= $94
			!RAM_MarioXPosHi	= $95
			!RAM_SpritesLocked	= $9D
			!RAM_SpriteNum		= $9E
			!RAM_SpriteSpeedY	= $AA
			!RAM_SpriteSpeedX	= $B6
			!RAM_SpriteState	= $C2
			!RAM_SpriteYLo		= $D8
			!RAM_SpriteXLo		= $E4
			!OAM_DispX		= $0300
			!OAM_DispY		= $0301
			!OAM_Tile		= $0302
			!OAM_Prop		= $0303
			!OAM_TileSize		= $0460
			!RAM_SpriteYHi		= $14D4
			!RAM_SpriteXHi		= $14E0
			!RAM_SpriteDir		= $157C
			!RAM_SprObjStatus	= $1588
			!RAM_OffscreenHorz	= $15A0
			!RAM_SprOAMIndex	= $15EA
			!RAM_SpritePal		= $15F6
			!RAM_OffscreenVert	= $186C

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			print "INIT ",pc
			INC $164A,x			; Set sprite follower (clouds)?
			RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			print "MAIN ",pc
			PHB
			PHK
			PLB
			JSR RipVanFishMain
			PLB
			RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MaxSpeed:		db $10,$F0
Acceleration:		db $01,$FF

FishTiles:		db $AE,$AC,$8C,$8E		; swimming 1, swimming 2, sleeping 1, sleeping 2

Return02BFCC:		RTS				; Return


RipVanFishMain:		JSR SpriteGraphics
			LDA !RAM_SpritesLocked		;\ If sprites are locked,
			BNE Return02BFCC		;/ return
			JSR SUB_OFF_SCREEN_X0
			JSL $01803A			; Interact with Mario and other sprites
			LDA !RAM_SpriteSpeedX,x		;\ Preserve sprite speeds
			PHA				; |
			LDA !RAM_SpriteSpeedY,x		; |
			PHA				;/
			LDY $1490			;\ If Mario doesn't have a star,
			BEQ CODE_02BFF3			;/ branch
			EOR #$FF			;\ Reverse sprite speeds
			INC A				; | Never actually noticed this feature before...
			STA !RAM_SpriteSpeedY,x		; |
			LDA !RAM_SpriteSpeedX,x		; |
			EOR #$FF			; |
			INC A				; |
			STA !RAM_SpriteSpeedX,x		;/
CODE_02BFF3:		JSR CODE_02C126
			JSL $01801A			;\ Update sprite position, no gravity
			JSL $018022			;/
			JSL $019138			; Interact with objects
			PLA				;\ Restore sprite speeds
			STA !RAM_SpriteSpeedY,x		; |
			PLA				; |
			STA !RAM_SpriteSpeedX,x		;/

			INC $1570,x			; Increase graphics frame timer
			LDA !RAM_SprObjStatus,x		;\ If not touching object horizontally,
			AND #$03			; |
			BEQ CODE_02C012			;/ branch
			STZ !RAM_SpriteSpeedX,x		; Set sprite x speed to zero
CODE_02C012:		LDA !RAM_SprObjStatus,x		;\ If not touching object vertically,
			AND #$0C			; |
			BEQ CODE_02C01B			;/ branch
			STZ !RAM_SpriteSpeedY,x		; Set sprite y speed to zero

CODE_02C01B:		LDA $164A,x			;\ If sprite is followed by clouds (?),
			BNE CODE_02C024			;/ branch
			LDA #$10			;\ Set sprite y speed
			STA !RAM_SpriteSpeedY,x		;/

CODE_02C024:		LDA !RAM_SpriteState,x		;\ Load sprite state
			JSL $0086DF			;/ and use it to determine which code to run

RipVanFishPtrs:		dw CODE_02C02E			; Sleeping
			dw CODE_02C08A			; Chasing Mario

CODE_02C02E:		LDA #$02			;\ Set sprite y speed
			STA !RAM_SpriteSpeedY,x		;/
			LDA !RAM_FrameCounter		;\ If frame counter modulo 4 =/= 0,
			AND #$03			; |
			BNE CODE_02C044			;/ branch
			LDA !RAM_SpriteSpeedX,x		;\ If sprite moving horizontally,
			BEQ CODE_02C044			;/ branch
			BPL CODE_02C042			;\ Else, brake sprite movement
			INC !RAM_SpriteSpeedX,x		; |
			BRA CODE_02C044			; |
CODE_02C042:		DEC !RAM_SpriteSpeedX,x		;/

CODE_02C044:		LDA !RAM_SprObjStatus,X		;\ If not on ground,
			AND #$04			; |
			BEQ CODE_02C053			;/ branch
			STZ !RAM_SpriteSpeedY,x		; Set sprite y speed to zero
			LDA !RAM_SpriteYLo,x		;\ Make sure sprite isn't just above the ground?
			AND #$F0			; |
			STA !RAM_SpriteYLo,x		;/

CODE_02C053:		JSL $02C0D9			; Execute minor extended sprite spawning routine (changing this to JSL ADDR_02C0CF should spawn the unused Rip van Fish Z tile minor extended sprites instead of the normal one)
			LDA $18FD			;\ If awoken by Whistlin' Chuck,
			BNE CODE_02C072			;/ branch

			JSR SUB_HORZ_POS		;\ If Mario not closer than 0x30 pixels horizontally,
			LDA $0F				; |
			ADC #$30			; | 
			CMP #$60			; |
			BCS CODE_02C07B			;/ branch

			JSR SUB_VERT_POS		;\ If Mario not closer than 0x30 pixels vertically,
			LDA $0E				; |
			ADC #$30			; |
			CMP #$60			; |
			BCS CODE_02C07B			;/ branch
           
CODE_02C072:		INC !RAM_SpriteState,x		; Go to chasing state
			LDA #$FF			;\ Set timer for chasing Mario
			STA $151C,x			;/
			BRA CODE_02C08A			; Branch

CODE_02C07B:		LDY #$02			;\ Determine graphics frame to use
			LDA $1570,x			; |
			AND #$30			; |
			BNE CODE_02C085			; |
			INY				; |
CODE_02C085:		TYA				; |
			STA $1602,x			;/
			RTS				; Return 

CODE_02C08A:		LDA !RAM_FrameCounter		;\ If frame counter modulo 2 =/= 0,
			AND #$01			; |
			BNE CODE_02C095			;/ branch
			DEC $151C,x			;\ Decrease time left to chase Mario
			BEQ CODE_02C0CA			;/ If equal to zero, branch

CODE_02C095:		LDA !RAM_FrameCounter		;\ If frame counter modulo 8 =/= 0,
			AND #$07			; |
			BNE CODE_02C0BB			;/ branch

			JSR SUB_HORZ_POS
			LDA !RAM_SpriteSpeedX,x		;\ If horizontal max speed in direction towards Mario achieved,
			CMP MaxSpeed,y			; |
			BEQ CODE_02C0AB			;/ branch
			CLC				;\ Else, accelerate towards Mario
			ADC Acceleration,y		; |
			STA !RAM_SpriteSpeedX,x		;/

CODE_02C0AB:		JSR SUB_VERT_POS
			LDA !RAM_SpriteSpeedY,x		;\ If vertical max speed in direction towards Mario achieved,    
			CMP MaxSpeed,y			; |
			BEQ CODE_02C0BB			;/ branch
			CLC				;\ Else, accelerate towards Mario
			ADC Acceleration,y		; |
			STA !RAM_SpriteSpeedY,x		;/

CODE_02C0BB:		LDY #$00			;\ Determine graphics frame to use
			LDA $1570,x			; |
			AND #$04			; |
			BEQ CODE_02C0C5			; |
			INY				; |
CODE_02C0C5:		TYA				; |
			STA $1602,x			;/
			RTS				; Return

CODE_02C0CA:		STZ !RAM_SpriteState,x		; Go to sleeping state
			JMP CODE_02C02E

ADDR_02C0CF:		LDA #$08			;\ This will never be executed
			LDY !RAM_SpriteDir,x		; | Load #$08 or #$09 into the accumulator depending on direction sprite is facing
			BEQ ADDR_02C0D7			; | Would have been used to spawn different types of Z minor extended sprites depending on direction
			INC A				;/ As it is, minor extended sprites 08 and 09 are unused
ADDR_02C0D7:		BRA CODE_02C0DB

CODE_02C0D9:		LDA #$06			;\ Since the above lines of code aren't ever executed,
CODE_02C0DB:		TAY				;/ LDY #$06 would work just as well here
			LDA !RAM_OffscreenHorz,x	;\ If sprite is offscreen,
			ORA !RAM_OffscreenVert,x	; | 
			BNE Return02C125		;/ return
			TYA
			DEC $1528,x			;\ If not yet time to spawn new Z extended sprite,
			BPL Return02C125		;/ return
			PHA				; Preserve accumulator, since it contains the type of extended sprite to spawn
			LDA #$28			;\ Set time until next spawning
			STA $1528,x			;/
			LDY #$0B			;\ Check minor extended sprite type table for a free slot
CODE_02C0F2:		LDA $17F0,y			; |			
			BEQ CODE_02C107			; |
			DEY				; |
			BPL CODE_02C0F2			;/
			DEC $185D			;\ If no free slots, choose slot of oldest minor extended sprite
			BPL CODE_02C104			; |
			LDA #$0B			; |
			STA $185D			; |
CODE_02C104:		LDY $185D			;/
CODE_02C107:		PLA				;\ Set minor extended sprite type to spawn (06, Rip van Fish Z tile)
			STA $17F0,y			;/
			LDA !RAM_SpriteXLo,x		;\ Set minor extended sprite x position (sprite position + 6)
			CLC				; |
			ADC #$06			; |
			STA $1808,y			;/
			LDA !RAM_SpriteYLo,x		;\ Set minor extended sprite y position (sprite position + 0, originally intended to have a different y offset?)
			CLC				; |
			ADC #$00			; |
			STA $17FC,y			;/
			LDA #$7F			;\ Set minor extended sprite existence timer
			STA $1850,y			;/
			LDA #$FA			;\ Set minor extended sprite x speed
			STA $182C,y			;/
Return02C125:		RTL				; Return 


CODE_02C126:		LDY #$00			;\ Make sprite face the direction it's going
			LDA !RAM_SpriteSpeedX,x		; |
			BPL CODE_02C12D			; |
			INY				; |
CODE_02C12D:		TYA				; |
			STA !RAM_SpriteDir,x		;/
			RTS				; Return


SpriteGraphics:		JSR GET_DRAW_INFO

			PHY
			LDY $1602,x
			LDA FishTiles,y
			PLY
			STA !OAM_Tile,y

			LDA $00
			STA !OAM_DispX,y

			LDA $01
			STA !OAM_DispY,Y

			LDA $15F6,x
			PHY
			LDY !RAM_SpriteDir,X
			BNE NoXFlip
			EOR #$40
NoXFlip:		PLY
			ORA $64
			STA !OAM_Prop,Y

			LDY #$02			;\ The tiles drawn were 16x16
			LDA #$00			; | One tile was drawn
			JSL $01B7B3			;/ Don't draw if offscreen
			RTS				; Return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;org $03B75C

TABLE1:			db $0C,$1C
TABLE2:			db $01,$02

GET_DRAW_INFO:		STZ $186C,x             ; reset sprite offscreen flag, vertical
			STZ $15A0,x             ; reset sprite offscreen flag, horizontal
			LDA $E4,x               ; \
			CMP $1A                 ;  | set horizontal offscreen if necessary
			LDA $14E0,x             ;  |
			SBC $1B                 ;  |
			BEQ ON_SCREEN_X         ;  |
			INC $15A0,x             ; /

ON_SCREEN_X:		LDA $14E0,x             ; \
			XBA			;  |
			LDA $E4,x               ;  |
			REP #$20                ;  |
			SEC			;  |
			SBC $1A                 ;  | mark sprite invalid if far enough off screen
			CLC			;  |
			ADC #$0040            ;  |
			CMP #$0180            ;  |
			SEP #$20                ;  |
			ROL A                   ;  |
			AND #$01                ;  |
			STA $15C4,x             ; / 
			BNE INVALID             ; 
			
			LDY #$00                ; \ set up loop:
			LDA $1662,x             ;  | 
			AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
			BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
			INY			; / 
ON_SCREEN_LOOP:		LDA $D8,x               ; \ 
			CLC			;  | set vertical offscreen if necessary
			ADC TABLE1,y            ;  |
			PHP			;  |
			CMP $1C                 ;  | (vert screen boundry)
			ROL $00                 ;  |
			PLP			;  |
			LDA $14D4,x             ;  | 
			ADC #$00                ;  |
			LSR $00                 ;  |
			SBC $1D                 ;  |
			BEQ ON_SCREEN_Y         ;  |
			LDA $186C,x             ;  | (vert offscreen)
			ORA TABLE2,y            ;  |
			STA $186C,x             ;  |
ON_SCREEN_Y:		DEY			;  |
			BPL ON_SCREEN_LOOP      ; /

			LDY $15EA,x             ; get offset to sprite OAM
			LDA $E4,x               ; \ 
			SEC			;  | 
			SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
			STA $00                 ; / 
			LDA $D8,x               ; \ 
			SEC			;  | 
			SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
			STA $01                 ; / 
			RTS			; return

INVALID:		PLA			; \ return from *main gfx routine* subroutine...
			PLA			;  |    ...(not just this subroutine)
			RTS			; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_OFF_SCREEN
; This subroutine deals with sprites that have moved off screen
; It is adapted from the subroutine at $01AC0D
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			
SPR_T12:		db $40,$B0
SPR_T13:		db $01,$FF
SPR_T14:		db $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
			db $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15:		db $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
			db $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1:	LDA #$02                ; \ entry point of routine determines value of $03
			BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2:	LDA #$04                ;  | 
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3:	LDA #$06                ;  |
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4:	LDA #$08                ;  |
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5:	LDA #$0A                ;  |
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6:	LDA #$0C                ;  |
			BRA STORE_03            ;  |
SUB_OFF_SCREEN_X7:	LDA #$0E                ;  |
STORE_03:		STA $03			;  |            
			BRA START_SUB		;  |
SUB_OFF_SCREEN_X0:	STZ $03			; /

START_SUB:		JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
			BEQ RETURN_35           ; /
			LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
			AND #$01                ; |
			BNE VERTICAL_LEVEL      ; /     
			LDA $D8,x               ; \
			CLC			; | 
			ADC #$50                ; | if the sprite has gone off the bottom of the level...
			LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
			ADC #$00                ; | 
			CMP #$02                ; | 
			BPL ERASE_SPRITE        ; /    ...erase the sprite
			LDA $167A,x             ; \ if "process offscreen" flag is set, return
			AND #$04                ; |
			BNE RETURN_35           ; /
			LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
			AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
			ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
			STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
			TAY			;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
			LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
			CLC			;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
			ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
			ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
			CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
			PHP			;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
			LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
			LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
			ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
			PLP			;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
			SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
			STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
			LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
			BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
			EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
			STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31:		LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
			BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE:		LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
			CMP #$08                ; |
			BCC KILL_SPRITE         ; /    
			LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
			CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
			BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
			LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
			STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE:		STZ $14C8,x             ; erase sprite
RETURN_35:		RTS			 ; return

VERTICAL_LEVEL:		LDA $167A,x             ; \ if "process offscreen" flag is set, return
			AND #$04                ; |
			BNE RETURN_35           ; /
			LDA $13                 ; \
			LSR A                   ; | 
			BCS RETURN_35           ; /
			LDA $E4,x               ; \ 
			CMP #$00                ;  | if the sprite has gone off the side of the level...
			LDA $14E0,x             ;  |
			SBC #$00                ;  |
			CMP #$02                ;  |
			BCS ERASE_SPRITE        ; /  ...erase the sprite
			LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
			LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
			AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
			STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
			TAY			;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
			LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
			CLC			;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
			ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
			ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
			CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
			PHP			;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
			LDA $001D               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
			LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
			ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
			PLP			;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
			SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
			STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
			LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
			BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
			EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
			STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38:		LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
			BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
			BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN:	LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
			ORA $186C,x             ; |  
			RTS			; / return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS:       LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16:            RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642




                    ;org $03B829        

SUB_VERT_POS:       LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $96                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $D8,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $97                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14D4,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL17             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL17:            RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642