;;;;;;;;;;;;;;;;;;;;;;;;;
;; Display VWF Message ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Based on a disassembly of "Display Level Message 1" by Iceguy ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; This sprite only works in conjunction with Level ASM.
;; To make it work properly, place the following code under the appropriate level in levelinit.asm:
;;
;; 	LDA #$xx	; last two digits of VWF message to be displayed
;;	STA $13E6
;;	JSR PrefixVWF00
;;
;; Then, place this code at the end of levelinit.asm, somewhere after all of the level code:
;;
;; PrefixVWF00:
;;	LDA #$00	; set prefix 00 for message to be displayed
;;	STA $13E7
;;	LDA #$00	; clear DisplayedRAM so that message can be redisplayed upon level reload
;;	STA $60
;;	RTS
;;
;; The PrefixVWF00 label makes the sprite load message 00xx, so it will only load messages 0000-00FF.
;; To load messages 0100-01FF and above, simply make a new label called PrefixVWF01 and copy and paste
;; everything from PrefixVFW00, changing the first LDA to 01 instead of 00.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


!VWFState = $702000		; VWF State register address
!MessageRAM = $13E6		; message number to load, two bytes stored at $13E6 and $13E7 in reverse order
				; (e.g. message 00C0 would be stored as C0 at $13E6 and 00 at $13E7)
!DisplayedRAM = $60		; prevents message from redisplaying

print "INIT ",pc

print "MAIN ",pc
	LDA !DisplayedRAM
	BEQ Begin
	RTL
Begin:
	REP #$20
	LDA !MessageRAM
	STA.l !VWFState+1
	SEP #$20
	LDA.l !VWFState
	BNE Return
	LDA #$01
	STA.l !VWFState
	STA !DisplayedRAM
Return:
	RTL