;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Teleport Generator, by Shinnok, based on Mikeyk's Level Ender and smkdan's custom
;; level teleport block.
;;
;; Description: This sprite will teleport Mario somewhere when all of the sprites
;; on screen are killed.
;;
;; Uses first extra bit: YES
;; When the first extra bit is clear, the sprite will teleport to the current screen exit.
;; If it's Set, it'll teleport to a custom level you choose here (By default, it's set to
;; teleport to Yoshi's House (Level 104).
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                            
                    EXTRA_BITS = $7FAB10
                    NEW_SPRITE_NUM = $7FAB9E            
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
                    RTL                 


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"  
                    LDA $1493
                    BNE RETURN
                    
                    STX $00
                    LDA NEW_SPRITE_NUM,x
                    STA $01

                    LDY #$0B    
LOOP_START          CPY $00
                    BEQ DONT_CHECK
                    LDA $190F,y
                    AND #$40
                    BNE DONT_CHECK                  
                    LDA $14C8,y
                    BNE RETURN
DONT_CHECK          DEY
                    BPL LOOP_START                  

                    LDA EXTRA_BITS,x
                    AND #$04
                    BNE HOLE
                    JSR NORMAL_TELE
                    BRA RETURN
HOLE                JSR SPECIAL_TELE

RETURN              RTL                    


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Teleport to the screen destination
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

NORMAL_TELE	    LDA #$06
		    STA $71
		    STZ $89
		    STZ $88
		    RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Teleport to the level it's set here
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPECIAL_TELE	    LDA $5B
		    BEQ HORZ

		    LDX $97
		    BRA SETUP

HORZ		    LDX $95		;mario X pos high
	
SETUP		    PEA $104	;push level destination, you may want to change it.
	 	    PLA		;low byte
		    STA $19B8,x	;write exit table
		    PLA		;high byte
		    ORA #$04	;exit present
		    ORA #$00	
		    STA $19D8,x	;write high bit and properties
		    LDA #$06	;teleport
		    STA $71
		    STZ $89
		    STZ $88
		    RTS