;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Bandit - by wiiqwertyuiop
;;
;; Give Credit
;;
;; Use Extra Bit? - No
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Stuff:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!Range = $60	; Proximity distance.
!Coin = $21	; Coin
!Subtract = $02 	; Number of Coins to subtract

!Sound	= $20	; Sound to play when he steals someting
!Bank	= $1DF9	; Bank the sound is in

SpeedTable:	db $10,$F0	;    X speeds (right, left)
RunSpeedTable:	db $F0,$10	;    X speeds Running away (left, right)

!MushroomItem = $74	; Mushroom
!CapeItem = $77		; Cape
!StarItem = $76		; Star
!FlowerItem = $75	; Flower

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Code Below
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


print "INIT ",pc
STZ $1534,x
STZ $1528,x
STZ $C2,x 
JSR SUB_HORZ_POS
TYA
STA $157C,x
RTL

print "MAIN ",pc

PHB		;\
PHK		; | Change the data bank to the one our code is running from.
PLB		; | This is a good practice.
JSR SpriteCode	; | Jump to the sprite's function.
PLB		; | Restore old data bank.
RTL		;/ And return.

;===================================
;Sprite Function
;===================================



BoxClear:
LDA $0DBF
CMP #!Subtract
BCC Clear
BRL KeepGoin
CoinClear:
LDA $19
BEQ Clear
BRL KeepGoin
Clear:
STZ $C2,x 
LDA $1534,x
CMP #$01
BCS RunAway
LDA $1528,x
CMP #$01
BCS RunAway
RTS
RunAway:
LDA $1588,x
AND #$03
BNE TouchingWallSPC


PHY			; \
JSR SUB_HORZ_POS	;  | Go right or left
LDA RunSpeedTable,y	;  | depending on which side
PLY			;  | of the sprite Mario stands
STA $B6,x		; /


DontMindMeSPC:
JSL $01802A		; Update position + add gravity
GameFreeze:
RTS

TouchingWallSPC:
STZ $AA,x
STZ $B6,x
STZ $C2,x
BRL DontMindMeSPC



TouchingWall:
STZ $AA,x
STZ $B6,x
STZ $C2,x
BRL DontMindMe



Stay:
STZ $AA,x
STZ $B6,x
RTS

BoxClear2:
BRL BoxClear

CoinClear2:
BRL CoinClear

RunAway2:
BRL RunAway

SpriteCode:
JSR Graphics 	  ; This routine controls graphics.
LDA $9D
BNE GameFreeze
JSR ContactCheck

LDA $1534,x
BNE Clear
LDA $0DC2
BNE KeepGoin
LDA $0DBF
CMP #!Subtract
BCC CoinClear2
LDA $1528,x
BNE RunAway2


LDA $19
BEQ BoxClear2

KeepGoin:
LDA $1528,x
BNE RunAway2

JSR Proximity 	; Determine if Mario is close..
LDA $C2,x
BEQ Stay 	; If not, remain hidden.

LDA $1588,x
AND #$03
BNE TouchingWall

LDA $94                 ; \ 
SBC $E4,x               ;  |
CLC                     ;  | If mario is near and above him freeze
ADC #$11                ;  |
CMP #$22                ;  |
BCS JustSkip            ; /

LDA $D8,x
CMP $96
BCS ZeroOut

LDA $14D4,x
CMP $97
BNE ZeroOut
BRA JustSkip

NoooGiveB:
JMP NoooGive

ZeroOut:
STZ $C2,x
BRA DontMindMe

JustSkip:
PHY			; \
JSR SUB_HORZ_POS	;  | Go right or left
LDA SpeedTable,y	;  | depending on which side
PLY			;  | of the sprite Mario stands
STA $B6,x		; /


DontMindMe:
JSL $01802A		; Update position + add gravity

LDA $14C8,x	;\
CMP #$04	; | If the sprite is dead or not it it's normal state, return.
BEQ NoooGiveB	;/

JSL $01A7DC	;\ Check for Mario Contact
BCC NoContact	;/

LDA $0E				;\
CMP #$E6			; | Determine if Mario touches sprite from sides.
BPL SpriteWins			;/ If he does, branch.
RTS

HasStarBranch:
JSR HasStar			; Branch to has star
RTS

SpriteWins:
LDA $1490			;\ IF Mario has star power ..
BNE HasStarBranch		;/ Kill sprite.

LDA $1534,x		; \
BNE NahImFull		; / If we already have a mushroom or what ever just steal coins

LDA $19
BEQ ItemBox

LDA $19		; \
CMP #$01	; |
BEQ Mushroom	; |
CMP #$03	; |
BEQ Flower	; | Check what item we have if nothing continue
;CMP #$03	; |
;BEQ Star	; |
CMP #$02	; |
BEQ Cape	; /

NahImFull:
LDA $0DBF	 ; \ See if we have coins
BNE SubractCoins ; /

;LDA #$2A	; \ If we have no coins OR powerups
;STA $1DFC	; / make a noise and end


NoContact:
RTS

ItemBox:
LDA $0DC2	; \
CMP #$01	; |
BEQ MushroomBox	; |
CMP #$02	; |
BEQ FlowerBox	; | Check what item we have if nothing continue
CMP #$03	; |
BEQ StarBox	; |
CMP #$04	; |
BEQ CapeBox	; /
CMP #$00
BEQ NahImFull
RTS

Cape:
LDA #$04
BRA NoItemToday

Star:
LDA #$03
BRA NoItemToday

Flower:
LDA #$02
BRA NoItemToday

Mushroom:
LDA #$01
NoItemToday:
STA $1534,x
LDA #!Sound
STA !Bank
STZ $19
RTS

CapeBox:
LDA #$04
BRA NoItemTodayBox

StarBox:
LDA #$03
BRA NoItemTodayBox

FlowerBox:
LDA #$02
BRA NoItemTodayBox

MushroomBox:
LDA #$01
NoItemTodayBox:
STA $1534,x
LDA #!Sound
STA !Bank
STZ $0DC2
RTS

SubractCoins:
LDA $1528,x
;CMP #!Subtract
;BCC Return
BNE Return
LDA $0DBF
SEC
SBC #!Subtract
STA $0DBF
LDA #!Subtract
STA $1528,x
LDA #!Sound
STA !Bank
Return:
RTS

NoooGive:
LDA $1528,x
BEQ ThinAgain


JustOneCoin:
LDA $0DBF
CLC
ADC #!Subtract
STA $0DBF

LDA #$01
STA $1DFC

STZ $1528,x

ThinAgain:
LDA $1534,x
CMP #$01
BEQ TakeAmushroomGiveAMushroom
CMP #$02
BEQ TakeAFlowerGiveAFlower
CMP #$03
BEQ TakeAStarGiveAStar
CMP #$04
BEQ TakeACapeGiveACape2
EndSpawn:
LDA $1534,x
BNE ThinAgain
LDA #$04
STA $14C8,x
EndSpawn2:
RTS
TakeACapeGiveACape2:
JSR TakeACapeGiveACape
RTS

TakeAmushroomGiveAMushroom:
LDA $15A0,x
ORA $186C,x
BNE EndSpawn2
JSL $02A9DE
BMI EndSpawn2
LDA #$01
STA $14C8,y
LDA #!MushroomItem
STA $009E,y
AllPowerupsComeHere:
LDA $E4,x
STA $00E4,y
LDA $14E0,x
STA $14E0,y
LDA $D8,x
STA $00D8,y
LDA $14D4,x
STA $14D4,y
PHX
TYX
JSL $07F7D2
PLX
STZ $1534,x
BRA ThinAgain

TakeAFlowerGiveAFlower:
LDA $15A0,x
ORA $186C,x
BNE EndSpawn
JSL $02A9DE
BMI EndSpawn
LDA #$01
STA $14C8,y
LDA #!FlowerItem
STA $009E,y
STZ $1534,x
BRA AllPowerupsComeHere

AllPowerupsComeHere2:
BRA AllPowerupsComeHere

TakeAStarGiveAStar:
LDA $15A0,x
ORA $186C,x
BNE EndSpawn
JSL $02A9DE
BMI EndSpawn
LDA #$01
STA $14C8,y
LDA #!StarItem
STA $009E,y
STZ $1534,x
BRA AllPowerupsComeHere2

TakeACapeGiveACape:
LDA $15A0,x
ORA $186C,x
BNE EndSpawn22
JSL $02A9DE
BMI EndSpawn22
LDA #$01
STA $14C8,y
LDA #!CapeItem
STA $009E,y
STZ $1534,x
BRA AllPowerupsComeHere2
EndSpawn22:
RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Taken From Iceguy's Vertical Bomb Sprite
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Invert: db $FF,$00

Proximity:
	LDA $14E0,x	;\
	XBA		; |
	LDA $E4,x	; | Get Sprite X position.
	REP #$20	;/
	SEC		;\
	SBC $94		; | Subtract from Mario's and push for later.
	SEP #$20	; | 
	PHA		;/
	JSR SUB_HORZ_POS;\ Determine which side of the sprite Mario is on.
	PLA		; | Pull range.
	EOR Invert,y	;/ Apply inversion.
	CMP #!Range	;\ If out of range..
	BCS OutOfRange	;/ Branch off.
	LDA #$01	;\ State = falling.
	STA $C2,x	;/
	RTS
OutOfRange:
	LDA $E4,x	;\
	CMP $94		;/ If IN Mario's range..
	BNE RangeOut	;\
	LDA #$01	;/
	STA $C2,x	;\ Consider sprite in range.
RangeOut:		;/
	RTS



ContactCheck:

	JSL $01A7DC
	BCC NoContact2
	JSR SUB_VERT_POS        ; 
                    LDA $0E                 ; \ if mario isn't above sprite, and there's vertical contact...
                    CMP #$E6                ;  |     ... sprite wins
                    BPL NoContact2         ; /

;===========================================
;Mario Hurts Sprite
;===========================================

	JSL $01AA33             ;\ Set mario speed.
	JSL $01AB99             ;/ Display contact graphic.

	LDA $140D		; IF spin-jumping ..
	BNE SpinKill		; Go to spin kill.
	
	;LDA #$10		;\
	;STA $AA,x		; | Make sprite fall.
	;JSL $01802A		; |
				; |
	JSR NoooGive		;/
	LDA #$13		;\
	STA $1DF9		;/ Play sound.
NoContact2:
	RTS

SpinKill:
	JSR NoooGive			;\
			;/ Sprite status = killed by a spin-jump.
	LDA #$13		;\
	STA $1DF9		;/ Sound to play.
	;JSL $07FC3B		; Show star animation effect.
	RTS




XSPEED: db $08,$F8

;===========================================
;Killed by Star Routine
;===========================================

HasStar:
	
	LDA $167A,x		;\ Don't disable clipping when killed by a star. 
	ORA #$01		; | NOTE: We do this to not make glitched graphics show up ..
	STA $167A,x		; | when the sprite is killed by a star.
				;/  You can also check this option in the .cfg editor.

	LDA #$04		;\ Set the sprite status to ..
	STA $14C8,x		;/ Killed by a star.
	LDA #$D0		;\
	STA $AA,x		;/ Set Y speed so sprite falls down.
	INC $18D2		; Increase number of consective enemies stomped/ killed by star.
	LDA $18D2		; IF consecutive # of enemies killed by star/stomped ..
	CMP #$08		; IS 8 ..
	BCC NotEight
	LDA #$08		;\ Keep it static at 8, because you get 1-ups all the time afterwards.
	STA $18D2		;/
NotEight:
	JSL $02ACE5		; This code calls the "give points" routine.
	LDY $18D2		; Get consecutive # of enemies stomped in Y.
	CPY #$08		; If it's less than 8 once again, return.
	BCC NoSound
	LDA StarSFX,y		;\
	STA $1DF9		;/ Play sounds depending on how many enemies were stomped/killed by star.
NoSound:
	RTS			; Return.

StarSFX:         db $00,$13,$14,$15,$16,$17,$18,$19
;===================================
;Graphics Code
;===================================

PROPERTIES: db $47,$07

TILEMAP:
db $D6,$F6		;TILEMAP

TILEMAP3:
db $DA,$FA		;TILEMAP3
db $DC,$FC		;TILEMAP4

TILEMAP33:
db $AE,$CE		;TILEMAP3
db $DE,$FE		;TILEMAP4

YDISP: db $09,$F9

FlipX:
STZ $157C,x
BRL SkipXFlip

FlipXR:
LDA #$01
STA $157C,x
BRL SkipXFlip


Graphics:


LDA $14
LSR
LSR
LSR
AND #$01
ASL
STA $03

LDA $B6,x
BEQ AnimatedNorun

LDA $B6,x
BPL FlipX
BMI FlipXR

AnimatedNorun:
LDA $AA,x
BNE SkipXFlip
LDA $14
AND #$3F
BNE SkipXFlip


LDA $157C,x
EOR #$01
STA $157C,x

SkipXFlip:

JSR GET_DRAW_INFO ; Before actually coding the graphics, we need a routine that will get the current sprite's value
; into the OAM.
; The OAM being a place where the tile data for the current sprite will be stored.
LDA $157C,x
STA $02 ; Store direction to $02 for use with property routine later.

PHX ;\ Push the sprite index, since we're using it for a loop.
LDX #$01 ;/ X = number of times to loop through. Since we only draw one MORE tile, loop one more time.
Loop:
LDA $00 ;\
STA $0300,y ;/ Draw the X position of the sprite

LDA $01 ;\
SEC ; | Y displacement is added for the Y position, so one tile is higher than the other.
SBC YDISP,x ; | Otherwise, both tiles would have been drawn to the same position!
STA $0301,y ; | If X is 00, i.e. first tile, then load the first value from the table and apply that
;/ as the displacement. For the second tile, F0 is added to make it higher than the first.

PHX
LDX $15E9
LDA $B6,x
BEQ NoAnimate
PLX
TXA
CLC
ADC $03
PHX
TAX
LDA TILEMAP3,x
PLX
STA $0302,y
BRA SkipC



NoAnimate:
PLX
LDA TILEMAP,x
STA $0302,y

SkipC:
PHX ; Push number of times to go through loop (01), because we're using it for a table here.
LDX $02 ;\
LDA PROPERTIES,x ; | Set properties based on direction.
ORA $64
STA $0303,y ;/
PLX ; Pull number of times to go through loop.

INY ;\
INY ; | The OAM is 8x8, but our sprite is 16x16 ..
INY ; | So increment it 4 times.
INY ;/

DEX ; After drawing this tile, decrease number of tiles to go through loop. If the second tile
; is drawn, then loop again to draw the first tile.

BPL Loop ; Loop until X becomes negative (FF).

PLX ; Pull back the sprite index! We pushed it at the beginning of the routine.

LDY #$02 ; Y ends with the tile size .. 02 means it's 16x16
LDA #$01 ; A -> number of tiles drawn - 1.
; I drew 2 tiles, so 2-1 = 1. A = 01.

JSL $01B7B3 ; Call the routine that draws the sprite.
RTS ; Never forget this!


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;       Y = index to sprite OAM ($300)
;       $00 = sprite x position relative to screen boarder
;       $01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1:              db $0C,$1C
SPR_T2:              db $01,$02

GET_DRAW_INFO:       STZ $186C,x             ; reset sprite offscreen flag, vertical
	STZ $15A0,x             ; reset sprite offscreen flag, horizontal
	LDA $E4,x               ; \
	CMP $1A                 ;  | set horizontal offscreen if necessary
	LDA $14E0,x             ;  |
	SBC $1B                 ;  |
	BEQ ON_SCREEN_X         ;  |
	INC $15A0,x             ; /

ON_SCREEN_X:         LDA $14E0,x             ; \
	XBA	 ;  |
	LDA $E4,x               ;  |
	REP #$20                ;  |
	SEC	 ;  |
	SBC $1A                 ;  | mark sprite invalid if far enough off screen
	CLC	 ;  |
	ADC.w #$0040            ;  |
	CMP.w #$0180            ;  |
	SEP #$20                ;  |
	ROL A                   ;  |
	AND #$01                ;  |
	STA $15C4,x             ; / 
	BNE INVALID             ; 
	
	LDY #$00                ; \ set up loop:
	LDA $1662,x             ;  | 
	AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
	BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
	INY	 ; / 
ON_SCREEN_LOOP:      LDA $D8,x               ; \ 
	CLC	 ;  | set vertical offscreen if necessary
	ADC SPR_T1,y            ;  |
	PHP	 ;  |
	CMP $1C                 ;  | (vert screen boundry)
	ROL $00                 ;  |
	PLP	 ;  |
	LDA $14D4,x             ;  | 
	ADC #$00                ;  |
	LSR $00                 ;  |
	SBC $1D                 ;  |
	BEQ ON_SCREEN_Y         ;  |
	LDA $186C,x             ;  | (vert offscreen)
	ORA SPR_T2,y            ;  |
	STA $186C,x             ;  |
ON_SCREEN_Y:         DEY	 ;  |
	BPL ON_SCREEN_LOOP      ; /

	LDY $15EA,x             ; get offset to sprite OAM
	LDA $E4,x               ; \ 
	SEC	 ;  | 
	SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
	STA $00                 ; / 
	LDA $D8,x               ; \ 
	SEC	 ;  | 
	SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
	STA $01                 ; / 
	RTS	 ; return

INVALID:             PLA	 ; \ return from *main gfx routine* subroutine...
	PLA	 ;  |    ...(not just this subroutine)
	RTS	 ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB HORZ POS
;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS:        LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16:             RTS                     ;A:25FF X:0006 Y:0001 D

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B829 - vertical mario/sprite position check - shared
; Y = 1 if mario below sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B829 

SUB_VERT_POS:        LDY #$00               ;A:25A1 X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizCHC:0130 VC:085 00 FL:924
                    LDA $96                ;A:25A1 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdiZCHC:0146 VC:085 00 FL:924
                    SEC                    ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0170 VC:085 00 FL:924
                    SBC $D8,x              ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0184 VC:085 00 FL:924
                    STA $0F                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0214 VC:085 00 FL:924
                    LDA $97                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0238 VC:085 00 FL:924
                    SBC $14D4,x            ;A:2501 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizcHC:0262 VC:085 00 FL:924
                    BPL LABEL11            ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0294 VC:085 00 FL:924
                    INY                    ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0310 VC:085 00 FL:924
LABEL11:             RTS                    ;A:25FF X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizcHC:0324 VC:085 00 FL:924

