;32x32 YI platforms
;by smkdan

;Tilemap has been made for SP4
;subtract 40h from all TILEMAPx entries to make it work with SP3

;=====

TILEMAP	dcb $80,$82	;1 unpressed
	dcb $A0,$A2
	dcb $A4		;'1'

	dcb $80,$82	;2 unpressed
	dcb $A0,$A2
	dcb $A6		;'2'

	dcb $80,$82	;3 unpressed
	dcb $A0,$A2
	dcb $88		;'3'

	dcb $80,$82	;4 unpressed
	dcb $A0,$A2
	dcb $8A		;'4'

	dcb $84,$86	;1 pressed
	dcb $A0,$A2
	dcb $A4

	dcb $84,$86	;2 pressed
	dcb $A0,$A2
	dcb $A6

	dcb $84,$86	;3 pressed
	dcb $A0,$A2
	dcb $88

	dcb $84,$86	;4 pressed
	dcb $A0,$A2
	dcb $8A

XDISP 	dcb $00,$10
	dcb $00,$10
	dcb $08

YDISP 	dcb $00,$00
	dcb $10,$10
	dcb $08

;=====

TILEMAPBLOW	dcb $8C		;single tile, flipped accordingly

PROPERTIESBLOW	dcb $00,$40,$80,$C0	;flip accordingly

XDISPBLOW	dcb $00,$10
		dcb $00,$10

YDISPBLOW	dcb $00,$00
		dcb $10,$10

;=====

TILEMAPSMOKE	dcb $A8,$A8,$AA,$AC

XDISPSMOKE	dcb $07,$07,$07,$07
		dcb $06,$06,$08,$08
		dcb $05,$05,$09,$09
		dcb $04,$04,$0A,$0A
		dcb $03,$03,$0B,$0B
		dcb $02,$02,$0C,$0C
		dcb $01,$01,$0D,$0D
		dcb $00,$00,$0E,$0E
		dcb $FF,$FF,$0F,$0F
		dcb $FE,$FE,$10,$10
		dcb $FD,$FD,$11,$11
		dcb $FC,$FC,$12,$12
		dcb $FB,$FB,$13,$13
		dcb $FA,$FA,$14,$14
		dcb $F9,$F9,$15,$15
		dcb $F8,$F8,$16,$16

YDISPSMOKE	dcb $07,$07,$07,$07
		dcb $06,$08,$06,$08
		dcb $05,$09,$05,$09
		dcb $04,$0A,$04,$0A
		dcb $03,$0B,$03,$0B
		dcb $02,$0C,$02,$0C
		dcb $01,$0D,$01,$0D
		dcb $00,$0E,$00,$0E
		dcb $FF,$0F,$FF,$0F
		dcb $FE,$10,$FE,$10
		dcb $FD,$11,$FD,$11
		dcb $FC,$12,$FC,$12
		dcb $FB,$13,$FB,$13
		dcb $FA,$14,$FA,$14
		dcb $F9,$15,$F9,$15
		dcb $F8,$16,$F8,$16

dcb "INIT"
	LDA $7FAB28,x	;copy count byte to misc properties
	STA $C2,x
	STZ $1528,x	;reset general counter until the time comes
	RTL

dcb "MAIN"
	PHB
	PHK
	PLB	
	JSR Run
	PLB

	RTL

Run	
	JSR SUB_OFF_SCREEN_X0	;offscreen processing	
	JSR GET_DRAW_INFO

	LDA $C2,x	;check status to figure out GFX and whether to interact or not
	AND #$08
	BEQ Norm	;bit 3 clr = not exploding, continue as normal
	LDA $C2,x	;so bit 3 is set, if bit 4 is also set, go to smoke routine
	AND #$10
	BNE Smoke	;if bit 4 set, smoke otherwise...

	LDA $1528,x		;enter explode routine
	INC A			;increment and...
	STA $1528,x		;store counter
	CMP #$06		;8 frames?
	BNE Still_Exploding	;continue exploding unless 8 frames passed

	STZ $1528,x		;done exploding, reset counter
	LDA #$18		;set both bit 3 and 4
	STA $C2,x		;and enter smoke portion

Smoke
	JSR GFX_Smoke		;smoke and exit
	LDA $1528,x
	INC A
	STA $1528,x
	CMP #$10		;if frames elapsed not reached 16, return without erase
	BNE Still_Smoking
	
	STZ $14C8,x		;otherwise erase sprite

Still_Smoking
	BRA Return_l
	
Still_Exploding			;the blast frames haven't passed yet	
	JSR GFX_Explode		;show blast GFX and return
	BRA Return_l

Norm
	JSR GFX_Norm
	LDA $9D
	BNE Return_l		;locked sprites?

	BRA Continue

Return_l
	RTS			;because the other is out of range

Continue
	JSL $01A7DC		;Contact?
	BCC No_Interaction	;return on no contact
	LDA $7D			;return if mario is rising
	BMI No_Interaction	
	JSR SUB_VERT_POS	;under / over
	BEQ No_Interaction


	BRA Skip1

ClipTbl	dcw $0018,$0028,$0028
 
Skip1
	LDA $187A		;yoshi flag
	CLC
	ASL A
	TAY			;into Y

;To control how high mario has to actually be to be 'on it'

	LDA $14D4,x		;sprite high Y
	XBA
	LDA $D8,x		;sprite low Y
	REP #$20		;16bit math
	SEC
	SBC $96			;sub mario Y pos.  Mario is OVER the sprite.  Mario Y < sprite Y
	CMP ClipTbl,y		;compare depending on mario or yoshi mario
	SEP #$20
	BCC Return		;return if he's too low (underflows)

	LDA #$01
	STA $1471		;'riding sprite'
	STZ $7D			;no Y speed
	BRA Skip2

HeightTbl dcw $FFE2,$FFD2,$FFD2

Skip2
	LDA $187A		;yoshi flag
	CLC
	ASL A			;2 bytes
	TAY			;into Y reg

	LDA $14D4,x		;sprite high Y
	XBA
	LDA $D8,x		;sprite low Y
	REP #$20
	CLC
	ADC HeightTbl,y		;stepped on height
	STA $96			;new mario Y position
	SEP #$20

	LDA $C2,x
	AND #$04		;Was it previously set?
	BEQ Prev_Clr
	BRA Return

Prev_Clr
	LDA $7FAB34,x
	BNE Mute1

	LDA #$02
	STA $1DF9		;Play the stepping on sound

Mute1
	LDA $C2,x		;bit 2 set = mario is on
	ORA #$04
	STA $C2,x

	BRA Return

No_Interaction
	LDA $C2,x
	AND #$04		;mario standing on it bit
	BEQ Return		;if it was set previously, decrement its counter

	LDA $7FAB34,x		;non-zero = don't play sounds
	BNE Mute2

	LDA #$13
	STA $1DF9		;Play kicking shell sound,  can't think of anything better.

Mute2
	LDA $C2,x		;bit 2 clr = mario is off it
	AND #$FB
	DEC A
	STA $C2,x		;store properties for next frame
	BPL Return		;if not underflowing from zero, return

	LDA $7FAB34,x		;no sounds?
	BNE Mute3

	STZ $1DF9		;cancel that kicking shell sound.
	LDA #$09		;Exploding sound on kill
	STA $1DFC
	
Mute3 
	LDA #$08		;bit 3 set = exploding
	STA $C2,x
        
Return
	RTS

;Currently NOT updating sprites

;GRAPHICS ROUTINES
;=================

GFX_Norm
	PHX		;preserve sprite index
	LDA $15F6,x
	PHA		;push properties too
	LDX #$00	;reset loop index

Norm_OAM_Loop
	LDA $00
	CLC
	ADC XDISP,x
	STA $0300,y	;store X position

	LDA $01
	CLC
	ADC YDISP,x
	STA $0301,y	;store Y position

	PHX		;preserve loop index
	LDX $15E9	;reload sprite index...
	LDA $C2,x	;properties pointing to the tilemap.  effectively 2 number bits, and a high pressed bit.
	CLC
	ASL A		;x4, 4 entries per entry
	ASL A
	CLC
	ADC $C2,x	;x5
	STA $02		;scratch RAM
	PLA		;loop index into A
	PHA		;but still needs to be preserved, no stack relative in TRASM
	ADC $02		;add entry address bits with loop index
	TAX		;into X
	LDA TILEMAP,x
	STA $0302,y	;store character
	PLX		;restore loop index

	PLA		;pull sprite properties
	ORA $64		;level settings
	STA $0303,y
	PHA		;push again.  no stack relative.

	INY		;advance OAM index
	INY
	INY
	INY
	INX
	CPX #$05	;5 loops
	BNE Norm_OAM_Loop

	PLA		;pull sprite properties
	PLX		;restore sprite index

	LDY #$02	;16x16 tiles
	LDA #$04	;5 tiles
	JSL $01B7B3	;bookkeeping

	STZ $B6,x		;Platform isn't moving at all
	STZ $AA,x
	RTS

;========

GFX_Explode
	PHX		;preserve sprite index
	LDA $15F6,x
	PHA		;push properties
	LDX #$00	;reset loop index

Blow_OAM_Loop
	LDA $00		;X pos of blast GFX
	CLC
	ADC XDISPBLOW,x
	STA $0300,y

	LDA $01
	CLC
	ADC YDISPBLOW,x
	STA $0301,y	;Y pos

	LDA TILEMAPBLOW
	STA $0302,y	;and the single character

	PLA		;grab sprite properties
	PHA
	ORA PROPERTIESBLOW,x
	ORA $64		;level bits
	STA $0303,y	;store appropriate flip/mirror

	INY
	INY
	INY
	INY
	INX
	CPX #$04	;4 loops
	BNE Blow_OAM_Loop

	PLA		;pull sprite properties
	PLX		;restore sprite index
	
	LDY #$02	;16x16 tiles
	LDA #$03	;4 tiles
	JSL $01B7B3	;bookkeeping
		
	RTS

;==========

GFX_Smoke
	PHX		;preserve sprite index

	LDA $1528,x	;load count
	CLC
	ASL A
	ASL A		;4 entries for 4 clouds of smoke, but low bit is clipped
	STA $02		;scratch, base address

	LDA #$00	;reset index

Smoke_OAM_Loop
	PHA		;we're going to change X reg

	CLC
	ADC $02		;add base address
	TAX		;into X
	LDA $00
	CLC
	ADC XDISPSMOKE,x
	STA $0300,y	;X pos

	PLA		;restore loop index
	PHA		;no stack relative

	CLC
	ADC $02
	TAX
	LDA $01
	CLC
	ADC YDISPSMOKE,x
	STA $0301,y	;Y pos

	LDX $15E9	;sprite index
	LDA $1528,x	;load count
	CLC
	LSR A
	LSR A		;F / 4 = 3
	TAX
	LDA TILEMAPSMOKE,x
	STA $0302,y	;load one of 3 smoke tiles

	LDA #$00
	LDX $15E9	;reload sprite index
	LDA $15F6,x	;sprite properties
	ORA $64		;level bits
	STA $0303,y	;store properties

	INY		;advance index
	INY
	INY
	INY
	PLA		;pull loop index
	INC A
	CMP #$04
	BNE Smoke_OAM_Loop

	PLX		;restore sprite index

	LDY #$02	;16x16 tiles
	LDA #$03	;4 tiles
	JSL $01B7B3	;bookkeeping
		
	RTS

;=================
;BORROWED ROUTINES
;=================

;GET_DRAW_INFO
;==============

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1              dcb $0C,$1C
SPR_T2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;SUB_VERT_POS
;============

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B829 - vertical mario/sprite position check - shared
; Y = 1 if mario below sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B829 

SUB_VERT_POS        LDY #$00               ;A:25A1 X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizCHC:0130 VC:085 00 FL:924
                    LDA $96                ;A:25A1 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdiZCHC:0146 VC:085 00 FL:924
                    SEC                    ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0170 VC:085 00 FL:924
                    SBC $D8,x              ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0184 VC:085 00 FL:924
                    STA $0F                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0214 VC:085 00 FL:924
                    LDA $97                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0238 VC:085 00 FL:924
                    SBC $14D4,x            ;A:2501 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizcHC:0262 VC:085 00 FL:924
                    BPL LABEL11            ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0294 VC:085 00 FL:924
                    INY                    ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0310 VC:085 00 FL:924
LABEL11             RTS                    ;A:25FF X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizcHC:0324 VC:085 00 FL:924

;SUB_HORZ_POS
;============

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS        LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642



TABLE3              dcb $40,$B0
TABLE6              dcb $01,$FF 
TABLE4              dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0 
TABLE5              dcb $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X0 LDA #$06                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | 
SUB_OFF_SCREEN_X1   LDA #$04                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X2   LDA #$02                ;  |
STORE_03            STA $03                 ;  |
                    BRA START_SUB           ;  |
SUB_OFF_SCREEN_HB   STZ $03                 ; /

START_SUB           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_2            ; /    
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ;  |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ;  | 
                    ADC #$50                ;  | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ;  | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ;  | 
                    CMP #$02                ;  | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ;  |
                    BNE RETURN_2            ; /
                    LDA $13                 ; \ 
                    AND #$01                ;  | 
                    ORA $03                 ;  | 
                    STA $01                 ;  |
                    TAY                     ; /
                    LDA $1A                 ;x boundry ;A:0101 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0256 VC:090 00 FL:16953
                    CLC                     ;A:0100 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZcHC:0280 VC:090 00 FL:16953
                    ADC TABLE4,y            ;A:0100 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZcHC:0294 VC:090 00 FL:16953
                    ROL $00                 ;A:01C0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0326 VC:090 00 FL:16953
                    CMP $E4,x               ;x pos ;A:01C0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0364 VC:090 00 FL:16953
                    PHP                     ;A:01C0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0394 VC:090 00 FL:16953
                    LDA $1B                 ;x boundry hi ;A:01C0 X:0006 Y:0001 D:0000 DB:03 S:01EC P:eNvMXdizCHC:0416 VC:090 00 FL:16953
                    LSR $00                 ;A:0100 X:0006 Y:0001 D:0000 DB:03 S:01EC P:envMXdiZCHC:0440 VC:090 00 FL:16953
                    ADC TABLE5,y            ;A:0100 X:0006 Y:0001 D:0000 DB:03 S:01EC P:envMXdizcHC:0478 VC:090 00 FL:16953
                    PLP                     ;A:01FF X:0006 Y:0001 D:0000 DB:03 S:01EC P:eNvMXdizcHC:0510 VC:090 00 FL:16953
                    SBC $14E0,x             ;x pos high ;A:01FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0538 VC:090 00 FL:16953
                    STA $00                 ;A:01FE X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0570 VC:090 00 FL:16953
                    LSR $01                 ;A:01FE X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0594 VC:090 00 FL:16953
                    BCC LABEL20             ;A:01FE X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZCHC:0632 VC:090 00 FL:16953
                    EOR #$80                ;A:01FE X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZCHC:0648 VC:090 00 FL:16953
                    STA $00                 ;A:017E X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizCHC:0664 VC:090 00 FL:16953
LABEL20             LDA $00                 ;A:017E X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizCHC:0688 VC:090 00 FL:16953
                    BPL RETURN_2            ;A:017E X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizCHC:0712 VC:090 00 FL:16953
ERASE_SPRITE        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ;  |
                    BCC KILL_SPRITE         ; /
                    LDY $161A,x             ;A:FF08 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZCHC:0140 VC:071 00 FL:21152
                    CPY #$FF                ;A:FF08 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizCHC:0172 VC:071 00 FL:21152
                    BEQ KILL_SPRITE         ;A:FF08 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0188 VC:071 00 FL:21152
                    LDA #$00                ; \ mark sprite to come back    A:FF08 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0204 VC:071 00 FL:21152
                    STA $1938,y             ; /                             A:FF00 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdiZcHC:0220 VC:071 00 FL:21152
KILL_SPRITE         STZ $14C8,x             ; erase sprite
RETURN_2            RTS                     ; return

VERTICAL_LEVEL      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ;  |
                    BNE RETURN_2            ; /
                    LDA $13                 ; \ only handle every other frame??
                    LSR A                   ;  | 
                    BCS RETURN_2            ; /
                    AND #$01                ;A:0227 X:0006 Y:00EC D:0000 DB:03 S:01ED P:envMXdizcHC:0228 VC:112 00 FL:1142
                    STA $01                 ;A:0201 X:0006 Y:00EC D:0000 DB:03 S:01ED P:envMXdizcHC:0244 VC:112 00 FL:1142
                    TAY                     ;A:0201 X:0006 Y:00EC D:0000 DB:03 S:01ED P:envMXdizcHC:0268 VC:112 00 FL:1142
                    LDA $1C                 ;A:0201 X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0282 VC:112 00 FL:1142
                    CLC                     ;A:02BD X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0306 VC:112 00 FL:1142
                    ADC TABLE3,y            ;A:02BD X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0320 VC:112 00 FL:1142
                    ROL $00                 ;A:026D X:0006 Y:0001 D:0000 DB:03 S:01ED P:enVMXdizCHC:0352 VC:112 00 FL:1142
                    CMP $D8,x               ;A:026D X:0006 Y:0001 D:0000 DB:03 S:01ED P:enVMXdizCHC:0390 VC:112 00 FL:1142
                    PHP                     ;A:026D X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNVMXdizcHC:0420 VC:112 00 FL:1142
                    LDA.W $001D             ;A:026D X:0006 Y:0001 D:0000 DB:03 S:01EC P:eNVMXdizcHC:0442 VC:112 00 FL:1142
                    LSR $00                 ;A:0200 X:0006 Y:0001 D:0000 DB:03 S:01EC P:enVMXdiZcHC:0474 VC:112 00 FL:1142
                    ADC TABLE6,y            ;A:0200 X:0006 Y:0001 D:0000 DB:03 S:01EC P:enVMXdizCHC:0512 VC:112 00 FL:1142
                    PLP                     ;A:0200 X:0006 Y:0001 D:0000 DB:03 S:01EC P:envMXdiZCHC:0544 VC:112 00 FL:1142
                    SBC $14D4,x             ;A:0200 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNVMXdizcHC:0572 VC:112 00 FL:1142
                    STA $00                 ;A:02FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0604 VC:112 00 FL:1142
                    LDY $01                 ;A:02FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizcHC:0628 VC:112 00 FL:1142
                    BEQ LABEL22             ;A:02FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0652 VC:112 00 FL:1142
                    EOR #$80                ;A:02FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0668 VC:112 00 FL:1142
                    STA $00                 ;A:027F X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0684 VC:112 00 FL:1142
LABEL22             LDA $00                 ;A:027F X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0708 VC:112 00 FL:1142
                    BPL RETURN_2            ;A:027F X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:0732 VC:112 00 FL:1142
                    BMI ERASE_SPRITE        ;A:0280 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:0170 VC:064 00 FL:1195

SUB_IS_OFF_SCREEN   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ;  |  
                    RTS                     ; / return
