;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Aimed Eerie Generator, by yoshicookiezeus
;; based on mikeyk's generic.asm
;;
;; Continuously generates Eeries at Mario's height from the direction
;; he is facing.
;;
;; Uses first extra bit: NO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			!RAM_FrameCounterB	= $14
			!RAM_ScreenBndryXLo	= $1A
			!RAM_ScreenBndryXHi	= $1B
			!RAM_ScreenBndryYLo	= $1C
			!RAM_ScreenBndryYHi	= $1D
			!RAM_MarioDirection	= $76
			!RAM_MarioYPos		= $96
			!RAM_MarioYPosHi	= $97
			!RAM_SpritesLocked	= $9D
			!RAM_SpriteNum		= $9E
			!RAM_SpriteSpeedX	= $B6
			!RAM_SpriteState	= $C2
			!RAM_SpriteYLo		= $D8
			!RAM_SpriteXLo		= $E4
			!RAM_RandomByte2	= $148E
			!RAM_SpriteYHi		= $14D4
			!RAM_SpriteXHi		= $14E0

			!SpriteToGen		= $38
			!TimeBetweenSpawns	= $3F	; needs to be one less than a power of 2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
		
		print "INIT ",pc
		print "MAIN ",pc
		PHB		 
		PHK		 
		PLB		 
		JSR Main
		PLB		 
		RTL      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

OffsetXLo:	db $F0,$FF
OffsetXHi:	db $FF,$00
SpeedX:		db $10,$F0

Main:		LDA !RAM_FrameCounterB		;\  if not time to spawn sprite
		AND #!TimeBetweenSpawns		; |
		ORA !RAM_SpritesLocked		; | or if sprites locked,
		BNE Return			;/  branch
		JSL $02A9DE			;\  find empty sprite slot
		BMI Return			;/  if no slot found, return
		TYX        
		
		LDA #$08			;\  set new sprite status
		STA $14C8,x			;/
		
		LDA #!SpriteToGen		;\  set new sprite number
		STA !RAM_SpriteNum,x		;/
		JSL $07F7D2			; reset sprite properties

		LDA !RAM_MarioYPos		;\ set new sprite y position to Mario y position
		CLC				; |
		ADC #$08			; |
		STA !RAM_SpriteYLo,x		; |
		LDA !RAM_MarioYPosHi		; |
		ADC #$00			; |
		STA !RAM_SpriteYHi,x		;/

		LDA !RAM_MarioDirection		;\ use the direction Mario is facing
		TAY				;/ to determine sprite direction
		LDA OffsetXLo,y			;\  use direction to determine x offset
		CLC				; |
		ADC !RAM_ScreenBndryXLo		; | add screen position
		STA !RAM_SpriteXLo,x		; | and set as sprite x position
		LDA !RAM_ScreenBndryXHi		; |
		ADC OffsetXHi,y			; |
		STA !RAM_SpriteXHi,x		;/
		LDA SpeedX,y			;\ set sprite speed
		STA !RAM_SpriteSpeedX,x		;/

Return:		RTS