;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Air bubble shooter.
;;   by TheBiob
;; Description: This shoots air bubbles. The shooter will generate the bubbles on a "randomly" generated timer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!timeMax	= $80 ; How long the shooter waits maximal
!timeMin	= $30 ; How long the shooter waits minimal

;;;;;;;;;;;;;;;
; Sprite Code ;
;;;;;;;;;;;;;;;

	print "INIT ",pc
	print "MAIN ",pc
		LDA $17AB,x	; \ Wait until it's time to shoot
		BNE .return	; /

		JSL $01ACF9		; > RNG routine
		EOR $94
		LDY.b #!timeMax-!timeMin
		BEQ .ValueOne	; > timeMax-timeMin == $00 Use timeMin
		INY				; \ timeMax-timeMin == $FF Use RNG result directly
		BEQ .ValueAll	; /
		STA $4202		;\
		STY $4203		; |
		NOP #2			; | calculate (Max-Min+1)*RNG/256+Min, it answer is between from Min to Max.
		LDA.b #!timeMin	; |
		CLC				; |
		ADC $4217		;/
		BRA .ValueAll	;
.ValueOne	LDA.b #!timeMin		;
.ValueAll	STA $17AB,x			;
		LDA $178B,x             ; \ don't generate if off screen vertically
		CMP $1C                 ;  |
		LDA $1793,x             ;  |
		SBC $1D                 ;  |
		BNE .return             ; /
		LDA $179B,x             ; \ don't generate if off screen horizontally
		CMP $1A                 ;  |
		LDA $17A3,x             ;  |
		SBC $1B                 ;  |
		BNE .return             ; / 
		
		LDY #$08;?
.loop	LDA $170B,y
		BEQ .slotfound
		DEY : BPL .loop
.return
	RTL
.slotfound
		LDA #$12	; \ Set ex sprite type to Water bubble
		STA $170B,y	; /
		
		LDA $179B,x	; \ set x position for new sprite
		STA $171F,y	;  |
		LDA $17A3,x	;  |
		STA $1733,y	; /
		LDA $178B,x	; \ set y position for new sprite
		STA $1715,y	;  |
		LDA $1793,x	;  |
		STA $1729,y	; /
		
		RTL	; > Return