;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite 61 - Floating skulls
; adapted for Romi's Spritetool and commented by yoshicookiezeus
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


!RAM_FrameCounter	= $13
!RAM_FrameCounterB	= $14
!RAM_IsFlying		= $72
!RAM_MarioObjStatus	= $77
!RAM_MarioSpeedX	= $7B
!RAM_MarioSpeedY	= $7D
!RAM_MarioXPos		= $94
!RAM_MarioXPosHi	= $95
!RAM_MarioYPos		= $96
!RAM_MarioYPosHi	= $97
!RAM_SpritesLocked	= $9D
!RAM_SpriteNum		= $9E
!RAM_SpriteSpeedY	= $AA
!RAM_SpriteSpeedX	= $B6
!RAM_SpriteState	= $C2
!RAM_SpriteYLo		= $D8
!RAM_SpriteXLo		= $E4
!SelfX = $151C
!OAM_DispX		= $0300
!OAM_DispY		= $0301
!OAM_Tile		= $0302
!OAM_Prop		= $0303
!OAM_TileSize		= $0460
!RAM_SpriteYHi		= $14D4
!RAM_SpriteXHi		= $14E0
!RAM_SpriteDir		= $157C
!RAM_SprObjStatus	= $1588
!RAM_OffscreenHorz	= $15A0
!RAM_SprOAMIndex	= $15EA
!RAM_SpritePal		= $15F6
!RAM_OffscreenVert	= $186C
!RAM_OnYoshi		= $187A


Tilemap:		db $E0,$E2
!Number_Of_Skulls	= $04		; Don't set this to higher than 08


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_Offset:		db $10,$20,$30,$40,$50,$60,$70

print "INIT ",pc
PHB
PHK
PLB
STZ $18BC	; clear sprite trigger
LDA #$0C
STA !SelfX,x
INC !RAM_SpriteState,x
LDA #!Number_Of_Skulls;\ setup loop
DEC A		; |
DEC A		; |
BMI No_Spawn	; |
STA $00		;/
CODE_02ED93:		JSL $02A9E4	;\ search for a free sprite slot
BMI CODE_02EDCB	;/ if no free sprite slots, branch
LDA #$08	;\ set sprite status
STA $14C8,y	;/
LDA $7FAB9E,x	;\ set sprite number
PHX       	; |
TYX		; |
STA $7FAB9E,x	; |
PLX		;/
LDA !RAM_SpriteYLo,x;\ set sprite y position
STA $00D8,y	; |
LDA !RAM_SpriteYHi,x; |
STA !RAM_SpriteYHi,y;/
LDX $00		;\ use loop counter to determine x offset
LDA X_Offset,x	;/
LDX $15E9	; load sprite index
CLC		;\ set sprite x position
ADC !RAM_SpriteXLo,x; |
STA $00E4,y	; |
LDA !RAM_SpriteXHi,x; |
ADC #$00	; |
STA !RAM_SpriteXHi,y;/
LDA $00
PHA
PHX
TYX
JSL $07F7D2	; clear out old sprite table values
JSL $0187A7	; get table values for custom sprite
LDA #$88	;\ set extra bit
STA $7FAB10,x	;/
LDA #$0C
STA !SelfX,x
PLX
PLA
STA $00
CODE_02EDCB:		DEC $00		; decrease loop counter
BPL CODE_02ED93	; if still skulls left to spawn, go to start of loop
No_Spawn:		PLB
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

print "MAIN ",pc
PHB
PHK
PLB
JSR Sprite_Code_Start
PLB
RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Sprite_Code_Start:	LDA !RAM_SpriteState,x;\ if sprite wasn't INITed and thus isn't the main sprite,
BEQ CODE_02EDF6	;/ branch
JSR SUB_OFF_SCREEN_X0
LDA $14C8,x	;\ if sprite not inexistant,
BNE CODE_02EDF6	;/ branch
LDY #$09	; setup loop
CODE_02EDE6:		PHX
TYX
LDA $7FAB9E,x	;\ if sprite being checked isn't skull,
PLX		; |
CMP $7FAB9E,x	; |
BNE CODE_02EDF2	;/ branch
LDA #$00	;\ else, erase sprite
STA $14C8,y	;/
CODE_02EDF2:		DEY		; decrease loop counter
BPL CODE_02EDE6	; if still sprites left to check, go to start of loop
Return02EDF5:		RTS		; return

CODE_02EDF6:		JSR Sprite_Graphics
LDA !RAM_SpritesLocked;\ if sprites locked,
BNE Return02EDF5;/ return
STZ $00
LDY #$09	; setup loop
CODE_02EE21:		LDA $14C8,y	;\ if sprite being checked is inexistant,
BEQ CODE_02EE36	;/ branch
PHX
TYX
LDA $7FAB9E,x	;\ if sprite being checked isn't skull,
PLX		; |
CMP $7FAB9E,x	; |
BNE CODE_02EE36	;/ branch
CODE_02EE36:		DEY		; decrease loop counter
BPL CODE_02EE21	; if still sprites left to check, go to start of loop

LDA $18BC	; use sprite trigger to determin x speed
BNE .Move

STZ !RAM_SpriteSpeedX,x
BRA .NoMove

  .Move
LDA !SelfX,x
STA !RAM_SpriteSpeedX,x;

  .NoMove
LDA !RAM_SpriteSpeedY,x;\ if sprite y speed is less than 0x20,
CMP #$20	; |
BMI CODE_02EE48	;/ branch
LDA #$20	;\ else, set sprite y speed to 0x20
STA !RAM_SpriteSpeedY,x;/ to prevent sprite from falling too fast





CODE_02EE48:
JSL $01802A	; update sprite position

LDA !RAM_SprObjStatus,x;\ if sprite touches a wall, revert x speed
AND #$03
BEQ .NoBounceX

LDA !SelfX,x
EOR #$FF
INC
STA !SelfX,x

  .NoBounceX
LDA !RAM_SprObjStatus,x;\ if sprite not on ground,
AND #$04	; | 
BEQ CODE_02EE57	;/ branch
LDA #$10	;\ else, set sprite y speed to 0x10
STA !RAM_SpriteSpeedY,x;/

  CODE_02EE57:
JSL $01A7DC	;\ if Mario not touching sprite,
BCC Return02EEA8;/ return
LDA !RAM_MarioSpeedY;\ if Mario moving upwards,
BMI Return02EEA8;/ return
LDA #$0C	;\ set sprite trigger
STA $18BC	;/
LDA !RAM_SprOAMIndex,x;\ make sprite graphics sink slightly
TAX		; |
INC !OAM_DispY,x;/
LDX $15E9	; load sprite index
LDA #$01	;\ set platform type 
STA $1471	;/
STZ !RAM_IsFlying; clear flying flag
LDA #$1C	;\ set Mario y position according to Yoshi status
LDY !RAM_OnYoshi; |
BEQ CODE_02EE80	; |
LDA #$2C	; |
CODE_02EE80:		STA $01		; |
LDA !RAM_SpriteYLo,x; |
SEC		; |
SBC $01		; |
STA !RAM_MarioYPos; |
LDA !RAM_SpriteYHi,x; |
SBC #$00	; |
STA !RAM_MarioYPosHi;/
LDA !RAM_MarioObjStatus;\ if Mario blocked to the right,
AND #$01	; |
BNE Return02EEA8;/ return
LDY #$00	;\ make Mario match the sprite's horizontal movement
LDA $1491	; |
BPL CODE_02EE9E	; |
DEY		; |
CODE_02EE9E:		CLC		; |
ADC !RAM_MarioXPos; |
STA !RAM_MarioXPos; |
TYA		; |
ADC !RAM_MarioXPosHi; |
STA !RAM_MarioXPosHi;/
Return02EEA8:		RTS		; return


Sprite_Graphics:	JSR GET_DRAW_INFO

PHX
LDA !RAM_FrameCounterB
LSR
LSR
LSR
AND #$01
TAX
LDA Tilemap,x
PLX
STA !OAM_Tile,y
LDA $00
STA !OAM_DispX,y
LDA $01
CMP #$F0
BCS No_Move_Y
CLC
ADC #$03
No_Move_Y:		STA !OAM_DispY,y
LDA $15F6,x
ORA $64
STA !OAM_Prop,y

LDY #$02		; \ 460 = 2 (all 16x16 tiles)
LDA #$00		;  | A = (number of tiles drawn - 1)
JSL $01B7B3		; / don't draw if offscreen
RTS; return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;org $03B75C

TABLE1: db $0C,$1C
TABLE2: db $01,$02

GET_DRAW_INFO:		STZ $186C,x             ; reset sprite offscreen flag, vertical
STZ $15A0,x             ; reset sprite offscreen flag, horizontal
LDA $E4,x               ; \
CMP $1A                 ;  | set horizontal offscreen if necessary
LDA $14E0,x             ;  |
SBC $1B                 ;  |
BEQ ON_SCREEN_X         ;  |
INC $15A0,x             ; /

ON_SCREEN_X:		LDA $14E0,x             ; \
XBA;  |
LDA $E4,x               ;  |
REP #$20                ;  |
SEC;  |
SBC $1A                 ;  | mark sprite invalid if far enough off screen
CLC;  |
ADC #$0040            ;  |
CMP #$0180            ;  |
SEP #$20                ;  |
ROL A                   ;  |
AND #$01                ;  |
STA $15C4,x             ; / 
BNE INVALID             ; 

LDY #$00                ; \ set up loop:
LDA $1662,x             ;  | 
AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
INY; / 
ON_SCREEN_LOOP:		LDA $D8,x               ; \ 
CLC;  | set vertical offscreen if necessary
ADC TABLE1,y            ;  |
PHP;  |
CMP $1C                 ;  | (vert screen boundry)
ROL $00                 ;  |
PLP;  |
LDA $14D4,x             ;  | 
ADC #$00                ;  |
LSR $00                 ;  |
SBC $1D                 ;  |
BEQ ON_SCREEN_Y         ;  |
LDA $186C,x             ;  | (vert offscreen)
ORA TABLE2,y            ;  |
STA $186C,x             ;  |
ON_SCREEN_Y:		DEY;  |
BPL ON_SCREEN_LOOP      ; /

LDY $15EA,x             ; get offset to sprite OAM
LDA $E4,x               ; \ 
SEC;  | 
SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
STA $00                 ; / 
LDA $D8,x               ; \ 
SEC;  | 
SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
STA $01                 ; / 
RTS; return

INVALID:		PLA; \ return from *main gfx routine* subroutine...
PLA;  |    ...(not just this subroutine)
RTS; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_OFF_SCREEN
; This subroutine deals with sprites that have moved off screen
; It is adapted from the subroutine at $01AC0D
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T12:		db $40,$B0
SPR_T13:		db $01,$FF
SPR_T14:		db $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
db $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15:		db $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
db $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1:	LDA #$02                ; \ entry point of routine determines value of $03
BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2:	LDA #$04                ;  | 
BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3:	LDA #$06                ;  |
BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4:	LDA #$08                ;  |
BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5:	LDA #$0A                ;  |
BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6:	LDA #$0C                ;  |
BRA STORE_03            ;  |
SUB_OFF_SCREEN_X7:	LDA #$0E                ;  |
STORE_03:		STA $03;  |            
BRA START_SUB		;  |
SUB_OFF_SCREEN_X0:	STZ $03; /

START_SUB:		JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
BEQ RETURN_35           ; /
LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
AND #$01                ; |
BNE VERTICAL_LEVEL      ; /     
LDA $D8,x               ; \
CLC; | 
ADC #$50                ; | if the sprite has gone off the bottom of the level...
LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
ADC #$00                ; | 
CMP #$02                ; | 
BPL ERASE_SPRITE        ; /    ...erase the sprite
LDA $167A,x             ; \ if "process offscreen" flag is set, return
AND #$04                ; |
BNE RETURN_35           ; /
LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
TAY;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
CLC;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
PHP;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
PLP;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31:		LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE:		LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
CMP #$08                ; |
BCC KILL_SPRITE         ; /    
LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE:		STZ $14C8,x             ; erase sprite
RETURN_35:		RTS ; return

VERTICAL_LEVEL:		LDA $167A,x             ; \ if "process offscreen" flag is set, return
AND #$04                ; |
BNE RETURN_35           ; /
LDA $13                 ; \
LSR A                   ; | 
BCS RETURN_35           ; /
LDA $E4,x               ; \ 
CMP #$00                ;  | if the sprite has gone off the side of the level...
LDA $14E0,x             ;  |
SBC #$00                ;  |
CMP #$02                ;  |
BCS ERASE_SPRITE        ; /  ...erase the sprite
LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
TAY;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
CLC;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
PHP;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
LDA $001D               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
PLP;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38:		LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN:	LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
ORA $186C,x             ; |  
RTS; / return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS:       LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16:            RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642