;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Play Cutscene when No Sprites on Scree, By ICB, Based on code by mikeyk
;;
;; Description: This sprite will cause a cutscene to play when all sprites
;; on screen are killed.
;;
;; Uses first extra bit: NO
;;
;; Change CUTSCENE value below to select a different cutscene
;; They go in order from #$01 to #$08,
;; #$00 and anything above #$08 Crash the game!
;; #$01 - Iggy's Castle
;; #$02 - Morton's Castle
;; Etc.
;; #$08 - ending credits
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                            
                    EXTRA_BITS = $7FAB10
                    CUTSCENE = $01          
                    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
                    RTL                 


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"  
                    LDA $1493
                    BNE RETURN
                   

                    LDY #$0B    
LOOP_START          CPY $00
                    BEQ DONT_CHECK
                    LDA $190F,y
                    AND #$40
                    BNE DONT_CHECK                  
                    LDA $14C8,y
                    BNE RETURN
DONT_CHECK          DEY
                    BPL LOOP_START                  

JSR CUTSCENE_PLAY

RETURN              RTL                    


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Cutscene Plays
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

CUTSCENE_PLAY
LDA #CUTSCENE                ;  | 
STA $13C6               ;  | 
LDA #$18                ;  | 
STA $0100        ;  | 

RETURN67            RTS                     ; return



                    