;dynamic wild ptooie piranha
;by smkdan

;this reqiures dsx.asm in the patch directory to be applied to your ROM

;GRAPHICS ARE IN THE BIN
;IT MUST BE IN THE SAME DIRECTORY AS THIS ASM FILE

XDISP		dcb $E8,$E8,$E8,$E9,$E9,$EA,$EB,$EC	;32 frames
		dcb $ED,$EE,$EF,$F0,$F1,$F2,$F4,$F6
		dcb $F8,$FA,$FB,$FD,$FE,$00,$01,$02
		dcb $03,$04,$05,$06,$07,$07,$08,$08
YDISP		dcb $EC,$EB,$EA,$EA,$E9,$E8,$E8,$E7	;""
		dcb $E6,$E6,$E5,$E5,$E5,$E4,$E4,$E4
		dcb $E4,$E4,$E4,$E5,$E5,$E5,$E6,$E6
		dcb $E7,$E8,$E8,$E9,$EA,$EA,$EB,$EC

;Launch speeds
SPDTBLX		dcb $0C,$0C,$0C,$0B,$0B,$0B,$0A,$09	;one for each angle 00-0F.  They are shared between flips.
		dcb $08,$08,$07,$06,$05,$03,$02,$01

SPDTBLY		dcb $00,$02,$04,$06,$08,$09,$0B,$0D
		dcb $0E,$0F,$11,$12,$12,$13,$14,$14

;Firing angles for the (default of) three shots.  values from 00h-0Fh.  They will index the two speed tables you see above
;The first Fire in the command table uses the first byte, the second fire uses the second byte etc.  It loops when it's done with the command list.
;since it can fire up to 16 times, a max of 16 bytes can be here.
;for reference, these are the frame numbers it aims to before it fires off a needlenose bomb.
FIREANGLE	dcb $06,$09,$0D

;Set this to sprite needlenose bomb is inserted as
SPRITE_NUM = $08

;HITPOINTS.  when it's been hit X times, it blows up
;can't be greater than 0Fh
HITPOINTS = $03

;palette sequence for hits. the xyppcct portion of it. green,yellow,red,blue.  it's indexed by how many hits it's taken.
;there must be HITPOINTS +1 entries here, since the first is shown when no hits have been taken.  glitches otherwise
PALSEQ	dcb $0A,$04,$08,$06

;other variables
STARE_INTERVAL = $60	;stare for 96 frames
FLASH_INTERVAL = $30	;flash when stunned for however long
VINE_TILE = $80		;tile #
VINE_PROP = $07		;xyppccct
SHOOT_SOUND = $3A	;firing sound to 1DFC
POP_SOUND = $4A		;dieing pop sound to 1DFC

;C2: frame index. 00-2F, 16 frames per flip.
;	00-1F Flipped page 1 frames
;	20-3F Flipped page 2 (mouth) frames
;	40-4C Shrinking mouth frames
;1504: hit counter / shot index
;1528: target frame for hurt
;1570: action
;1602: action counter

PROPRAM = $04
TEMP = $09

dcb "INIT"	
	RTL

dcb "MAIN"
	PHB
	PHK
	PLB
	JSR Run
	PLB
	RTL

;a series of commands that run in the order you see here.  You can stick commands anywhere aslong as EndFire stays at the end
;if you want it to fire 5 times for example, there'd be 5 Aim + Fires.  An Aim MUST precede a Fire.
;it can't fire more than 16 times in a loop
ACTIONTABLE		;a jump table.  not sure how you can just write data without instructions. TRASM blows, BTW. It's older than alot of the board members.
	JMP LocateMario	;00 locate mario...
	JMP Stare	;01 and stare for a bit
	JMP Aim		;02 aim head for the first shot
	JMP Fire	;03 fire first shot
	JMP Wait	;04 wait until next shot
	JMP Aim		;05 aim for second shot
	JMP Fire	;06 fire second shot
	JMP Wait	;07 wait some more
	JMP Aim		;08 aim for third shot
	JMP Fire	;09 fire last shot
	JMP Wait	;0A final wait
	JMP Wait	;0B is longer than normal
	JMP EndFire	;0C loop back to 00

;hurt
	JMP GetHurt	;0D rear head and flash
	JMP CheckDeath	;0E die if hit counter has expired
	JMP ShrinkPop	;0F entered if checkdeath reveals that it should die

;must point to GetHurt
HURT_INDEX = $0D	

;todo: hurt behaviour

Run
	JSR SUB_OFF_SCREEN_X0
	JSR GET_DRAW_INFO
	JSR GFX			;draw sprite

	LDA $14C8,x
	CMP #$08          	 
	BNE Return           
	LDA $9D			;locked sprites?
	BNE Return

;run subroutine according to action
	LDA $1570,x		;load action
	ASL A			;x2...
	CLC
	ADC $1570,x		;x3
	INC A			;+1
	TXY			;TXY = sprite index in Y
	TAX			;X = routine index
	JSR (ACTIONTABLE,x)	;jump to appropriate routine, easier to manage than a if-then-else

	JSR INTERACTMARIO	;interact with mario based on offsets
	JSR CHECKHURT		;check for projectile interaction
	BEQ Nothurt		;if there's contact, change the action index to getting hurt
;hurt
	LDA #HURT_INDEX		;switch index to getting hurt.  IT MUST MATCH THE INDEX IN THE ACTIONTABLE
	STA $1570,x
	STZ $1602,x		;and reset counter

	LDY #$18		;target frame with no flip
	LDA $C2,x		;test frame index...
	BIT #$10		;...for the flip
	BEQ Noflip
	LDY #$08		;target frame with flip
Noflip
	TYA
	STA $1528,x		;store target frame for getting hurt subroutine

Nothurt
	JSL $01802A		;update the speed
Return
	RTS			
;=====
ACTIONSUBROUTINES
;=====
;these run until a counter expires or some other condition is met

Wait
	TYX
	INC $1602,x		;just do nothing until counter expires
	LDA $1602,x
	CMP #$28		;40 frame delay
	BNE ReturnWT

	INC $1570,x		;next behaviour
	STZ $1602,x		;zero counter
ReturnWT
	RTS

;===

LocateMario
	TYX			;x = sprite index now
	LDA $C2,x		;preserve frame index since it's only calculating the target frame
	AND #$1F		;mask page bit
	STA TEMP
	JSR TRACKMARIO		;grab target frame
	LDA $C2,x		;load target frame
	CMP TEMP		;compare with current
	BEQ FinishLM		;if equal, then jump right into staring

	LDA $14			;only process every 4th frame
	AND #$01
	BNE ReturnLM

	BCC DecLM 		;target frame smaller = dec current
;IncLM
	INC TEMP		;++
	BRA ReturnLM		;keep returning until it's equal
DecLM
	DEC TEMP		;--
	BRA ReturnLM		;return
FinishLM
	INC $1570,x		;next action
	STZ $1602,x		;zero counter
ReturnLM
	LDA TEMP		;new frame index
	STA $C2,x
	RTS

;==

Stare
	TYX
	JSR TRACKMARIO		;lock onto mario for a bit
	INC $1602,x		;for X frames
	LDA $1602,x
	CMP #STARE_INTERVAL
	BNE ReturnST

	INC $1570,x		;next behaviour behaviour
	STZ $1602,x		;zero counter
ReturnST
	RTS

;==

Aim
	TYX
	LDA $1504,x		;grab shot index
	LSR A
	LSR A
	LSR A
	LSR A			;high 4 bits
	TAY			;into Y index
	LDA FIREANGLE,y		;load 
	STA TEMP

	LDA $C2,x		;load current frame
	BIT #$10		;testflip
	BEQ A1Noinv		;don't invert if not set
	LDA TEMP
	EOR #$1F		;invert all bits
	STA TEMP	
A1Noinv
	LDA TEMP		;load current
	CMP $C2,x		;compare to target
	BEQ FinishA1		;if equal, then jump to firing

	LDA $14			;only process every 2nd frame
	AND #$01
	BNE ReturnA1

	BCC DecA1 		;target frame smaller = dec current
;IncA1
	INC $C2,x		;++
	BRA ReturnA1		;keep returning until it's equal
DecA1
	DEC $C2,x		;--
	BRA ReturnA1		;return
FinishA1
	INC $1570,x		;next action, NOT YET
	STZ $1602,x		;zero counter
ReturnA1		
	RTS

;==

Fire
	TYX
	LDA $1602,x		;if first time, fire the sprite
	BNE FiredF1
	JSR FIRESPRITE		;fire the sprite according to the current frame

	LDA $1504,x		;advance shot index
	CLC
	ADC #$10
	STA $1504,x		;new index

FiredF1
	INC $1602,x		;advance counter
	LDA $1602,x		;and test for termination
	CMP #$10		;open mouth for 16 frames
	BEQ FinishF1

	LDA $C2,x		;set mouth page
	ORA #$20
	STA $C2,x
	BRA ReturnF1
FinishF1
	LDA $C2,x		;mask page bit
	AND #$DF
	STA $C2,x		;..to close mouth

	INC $1570,x		;next behaviour
	STZ $1602,x		;zero counter
ReturnF1
	RTS

;==
EndFire
	TYX
	LDA $1504,x		;reset shooting index
	AND #$0F		;(preserving hit points)
	STA $1504,x

	STZ $1570,x		;zero behaviour
	STZ $1602,x		;and zero counter
	RTS

;=====
GetHurt				;it won't clip the page bit since YI keeps the mouth open if it's hit like that
	TYX
	LDA $C2,x
	AND #$1F		;mask page bit from current frame
	STA TEMP

	LDA $1528,x		;target
	CMP TEMP		;compare to current
	BEQ PreFlashGH		;if equal, then jump to firing
	BCC DecGH 		;target frame smaller = dec current
;IncGH
	INC $C2,x		;++
	LDA $C2,x		;test...
	AND #$1F		;while masking the page bit
	CMP $1528,x		;...against target frame
	BEQ PreFlashGH

	INC $C2,x		;increment one more if not reached, since it's pretty fast in YI
	BRA PreFlashGH		;now flash
DecGH
	DEC $C2,x		;--
	LDA $C2,x		;also test
	AND #$1F		;while masking the page bit
	CMP $1528,x
	BEQ PreFlashGH

	DEC $C2,x		;""
PreFlashGH			;flashing palette
	LDA $1504,x		;test hit points
	INC A			;verge of death?
	CMP #HITPOINTS		;it doesn't flash on the last hit, only when shrinking
	BNE FlashGH

	INC $1602,x		;advance counter minus flashing
	LDA $1602,x
	CMP #FLASH_INTERVAL	;stay still for flashing
	BNE ReturnGH		;nothing
	BRA FinishGH		;move onto hurt (and die)

FlashGH
	INC $1602,x		;advance counter
	LDA $1602,x		;and test
	CMP #FLASH_INTERVAL
	BEQ FinishGH		;move onto checking death status if time is up

	LDA $1504,x		;first, clear shot index to start at zero again, so it also simplifies below calculation
	AND #$0F
	STA $1504,x

	LDA $14			;flash based on frame counter
	LSR A
	LSR A			;every 4th frame
	AND #$01		;two variables
	CLC
	ADC $1504,x		;add hit counter
	TAY			;new index

	LDA $15F6,x		;load palette etc.
	AND #$F1		;mask palette
	ORA PALSEQ,y		;new palette
	STA $15F6,x
	
	BRA ReturnGH		;skip past exit
	
FinishGH
	INC $1570,x		;next action
	STZ $1602,x		;zero counter
ReturnGH		
	RTS

;==
CheckDeath
	TYX
	INC $1504,x		;increment hit counter
	LDA $1504,x		;and test
	CMP #HITPOINTS
	BNE DontDieCD
;DIE
	LDY #$50		;frame with no flipping
	LDA $C2,x		;test current frame direction
	BIT #$10		;flip bit
	BNE NoFlipCD
	LDY #$40		;flipping with the shrink pop

NoFlipCD
	STY $C2,x		;store to frame
	INC $1570,x		;shrinkpop action
	STZ $1602,x		;zero counter
	RTS			;return here
	
DontDieCD
	LDY $1504,x		;reconfigure palette
	LDA $15F6,x
	AND #$F1		;mask palette
	ORA PALSEQ,y		;and insert new
	STA $15F6,x

	STZ $1570,x		;reset action
	STZ $1602,x		;and counter
	RTS

;==
ShrinkPop
	TYX
	LDA $14			;only shrink twice a frame
	AND #$01
	BEQ DontDieSP		;skip shrinking if not set

FlashSP
	LDA $1504,x		;hitpoint based palette
	AND #$0F
	STA $1504,x

	LDA $14			;flash based on frame counter
	LSR A
	LSR A			;every 4th frame
	AND #$01		;two variables
	CLC
	ADC $1504,x		;add hit counter
	TAY			;new index

	LDA $15F6,x		;load palette etc.
	AND #$F1		;mask palette
	ORA PALSEQ,y		;new palette
	STA $15F6,x

	INC $C2,x		;advance frame counter
	LDA $C2,x		;and test
	AND #$0F		;only frames to test
	CMP #$0C		;last frame?
	BNE DontDieSP

	JSR SUB_SMOKE		;smoke

	LDA $D8,x		;sub y to make stars go higher
	SEC
	SBC #$10		;16px higher
	STA $D8,x
	LDA $14D4,x		;y high
	SBC #$00		;carry
	STA $14D4,x

	JSL $07FC3B		;stars
	JSR SUB_SMOKE		;some more smoke

	STZ $14C8,x		;erase sprite

	LDA #POP_SOUND		;load popping sound
	STA $1DFC		;to $214X

DontDieSP
	RTS			;return


;GFX ROUTINE
;===========

FRAMES	dcb $00,$01,$02,$03	;16 frames each
	dcb $10,$11,$12,$13
	dcb $20,$21,$22,$23
	dcb $30,$31,$32,$33

	dcb $40,$41,$42,$43	;16 open mouth frames
	dcb $50,$51,$52,$53
	dcb $60,$61,$62,$63
	dcb $70,$71,$72,$73

	dcb $80,$81,$82,$83	;12 shrink pop frames
	dcb $90,$91,$92,$93
	dcb $A0,$A1,$A2,$A3

XDISPG	dcb $00,$10,$00,$10
YDISPG	dcb $00,$00,$10,$10
TILEMAP	dcb $00,$02,$20,$22	;test map

ReturnGl
	RTS

GFX
	dcb $D4,$00;[PEI ($00)]

	LDA $15F6,x		;store palettes as one of the first things
	STA PROPRAM

	PHY			;adjust according to offsets, since the plants don't rotate on the same spot
	LDA $C2,x		;see if it's shrinking
	BIT #$40
	BEQ NoShrinkGFX		;non shrinking code

;shrinkinggfx
	AND #$0F		;only regard low nybble
	CLC
	ADC #$20		;past 20 normal frames
	STA TEMP		;frame index

	LDY #$16		;index for positions untouched
	LDA $C2,x		;test flip
	BIT #$10
	BNE NoFlipSPGA
	LDY #$07		;modified position index

NoFlipSPGA	
	LDA $00
	CLC
	ADC XDISP,y		;shrink xpos
	STA $00
	LDA $01
	CLC
	ADC YDISP,y		;shrink ypos
	STA $01
	PLY

	LDA $C2,x		;test flip
	BIT #$10
	BEQ NoFlipSPG

	LDA #$40		;set flip bit
	TSB PROPRAM

NoFlipSPG	
	BRA ShrinkReEntry	;skip past normal shrink

NoShrinkGFX
	LDA $C2,x
	AND #$1F		;mask page bit
	TAY
	LDA $00
	CLC
	ADC XDISP,y		;x displacement...
	STA $00
	LDA $01
	CLC
	ADC YDISP,y		;y displacement...
	STA $01
	PLY

	LDA $C2,x		;load frame index
	AND #$2F		;only low 4 bits + page select, not including the flip bit
	STA TEMP		;to potentially be operated on

	LDA $C2,x		;invert frame select if flipped
	BIT #$10		;flip bit
	BEQ NoX

	LDA TEMP		;load operated index...
	EOR #$0F		;reflip bits
	STA TEMP		;new index

	LDA #$40		;set flip bit in properties if flip bit in frame index is set
	TSB PROPRAM

NoX
	LDA TEMP		;need to shift page bit one to the right
	AND #$20		;page bit
	LSR A			;into #$10
	ORA TEMP		;OR with existing bits
	AND #$1F		;now mask page bit
	STA TEMP

ShrinkReEntry
	PHY
	LDY TEMP
	LDA FRAMES,y
	PLY
	JSR GETSLOT
	BEQ ReturnGl
	STA TEMP

	LDX #$00	;zero index

OAM_LOOP
	LDA PROPRAM
	AND #$40
	BEQ NoXFM
	LDA $00
	SEC
	SBC XDISPG,x
	CLC
	ADC #$10
	STA $0300,y
	BRA N1
NoXFM
	LDA $00
	CLC
	ADC XDISPG,x
	STA $0300,y

N1
	LDA PROPRAM
	AND #$80
	BEQ NoYFM
	LDA $01
	SEC
	SBC YDISPG,x
	CLC
	ADC #$10
	STA $0301,y
	BRA N2

NoYFM
	LDA $01
	CLC
	ADC YDISPG,x
	STA $0301,y

N2
	LDA TILEMAP,x
	CLC
	ADC TEMP	;add calculated tile
	STA $0302,y

	LDA PROPRAM
	ORA $64
	STA $0303,y

	INY
	INY
	INY
	INY
	INX
	CPX #$04
	BNE OAM_LOOP

	LDX $15E9	;restore sprite index 

	LDA #VINE_PROP	;load properties
	ORA $64		;other properties
	STA PROPRAM

	LDA $C2,x
	BIT #$10
	BNE Vineleft	;no flip if facing left

	LDA #$40	;set xflip
	TSB PROPRAM

Vineleft
	PLA		;pull previously pushed xcoord
	BIT PROPRAM	;test for flip
	BVC NoflipV
	INC A		;adjust one pixel
NoflipV
	STA $0300,y	;to next entry in OAM
	PLA		;pushed ycoord
	STA $0301,y
	LDA #VINE_TILE	;same as the piranha plant
	STA $0302,y
	LDA PROPRAM
	STA $0303,y
	
        LDY #$02
        LDA #$04               ;5 tiles
        JSL $01B7B3

	RTS
ReturnG
	LDX $15E9	;restore sprite index 
	RTS

;2kb buffer is at 7F:0B44.  It is copied in one chunk to VRAM on NMI.
;variables for following routine
;based off smwedit's code
SLOTPTR = $0660		;16bit pointer for source GFX
SLOTBANK = $0662	;bank
SLOTDEST = $0663	;VRAM address
SLOTSUSED = $06FE	;how many slots have been used

MAXSLOTS = $04		;maximum selected slots

SLOTS dcb $CC,$C8,$C4,$C0	;avaliable slots.  Any more transfers and it's overflowing by a dangerous amount.

GETSLOT
	PHY		;preserve OAM index
	PHA		;preserve frame
	LDA SLOTSUSED	;test if slotsused == maximum allowed
	CMP #MAXSLOTS
	BEQ NoneFree

	PLA		;pop frame
	REP #$20	;16bit A
	AND.w #$00FF	;wipe high
	XBA		;<< 8
	LSR A		;>> 1 = << 7
	STA TEMP	;back to scratch
	PEA SPRITEGFX	;push 16bit address, since i'm not sure how else i'm going to get the address of the label itself in TRASM
	PLA		;pull 16bit address
	CLC
	ADC TEMP	;add frame offset	
	STA SLOTPTR	;store to pointer to be used at transfer time
	SEP #$20	;8bit store
	PHB		;push db...
	PLA		;pull to A...
	STA SLOTBANK	;store bank to 24bit pointer

	LDY SLOTSUSED	;calculate VRAM address + tile number
	LDA SLOTS,y	;get tile# in VRAM
	PHA		;preserve for eventual pull
	SEC
	SBC #$C0	;starts at C0h, they start at C0 in tilemap
	REP #$20	;16bit math
	AND.w #$00FF	;wipe high byte
	ASL A		;multiply by 32, since 32 bytes/16 words equates to 1 32bytes tile
	ASL A
	ASL A
	ASL A
	ASL A
	CLC
	ADC #$0B44	;add 0B44, base address of buffer	
	STA SLOTDEST	;destination address in the buffer

	JSR DMABUFFER	;ROM -> RAM copy

	SEP #$20	;8bit A	
	INC SLOTSUSED	;one extra slot has been used

	PLA		;return starting tile number
	PLY
	RTS
		
NoneFree
	PLA
	PLY
	LDA #$00	;zero on no free slots
	RTS

;;;;;;;;;;;;;;;;
;Tansfer routine
;;;;;;;;;;;;;;;;

;DMA ROM -> RAM ROUTINE

DMABUFFER
;set destination RAM address
	REP #$20
	LDA SLOTDEST
	STA $2181	;16bit RAM dest
	LDY #$7F
	STY $2183	;set 7F as bank

;common DMA settings
	STZ $4300	;1 reg only
	LDY #$80	;to 2180, RAM write/read
	STY $4301

;first line
	LDA SLOTPTR
	STA $4302	;low 16bits
	LDY SLOTBANK
	STY $4304	;bank
	LDY #$80	;128 bytes
	STY $4305
	LDY #$01
	STY $420B	;transfer

;second line
	LDA SLOTDEST	;update buffer dest
	CLC
	ADC #$0200	;512 byte rule for sprites
	STA SLOTDEST	;updated base
	STA $2181	;updated RAM address

	LDA SLOTPTR	;update source address
	CLC
	ADC #$0200	;512 bytes, next row
	STA SLOTPTR
	STA $4302	;low 16bits
	LDY SLOTBANK
	STY $4304	;bank
	LDY #$80
	STY $4305
	LDY #$01
	STY $420B	;transfer

;third line
	LDA SLOTDEST	;update buffer dest
	CLC
	ADC #$0200	;512 byte rule for sprites
	STA SLOTDEST	;updated base
	STA $2181	;updated RAM address

	LDA SLOTPTR	;update
	CLC
	ADC #$0200
	STA SLOTPTR
	STA $4302
	LDY SLOTBANK
	STY $4304
	LDY #$80
	STY $4305
	LDY #$01
	STY $420B	;transfer

;fourth line
	LDA SLOTDEST	;update buffer dest
	CLC
	ADC #$0200	;512 byte rule for sprites
	STA SLOTDEST	;updated base
	STA $2181	;updated RAM address

	LDA SLOTPTR
	CLC
	ADC #$0200
	STA SLOTPTR
	STA $4302
	LDY SLOTBANK
	STY $4304
	LDY #$80
	STY $4305
	LDY #$01
	STY $420B

	SEP #$20	;8bit A
	RTS		;all done, return

;interact with mario based on offsets
INTERACTMARIO
	LDA $C2,x		;load frame index, but disregard page bit
	AND #$1F
	TAY			;as index

	LDA $E4,x		;sprite xlow
	PHA			;we're going to preserve positions so that the interaction routine is done according to the offsets
	LDA $14E0,x		;sprite xhigh
	PHA

	LDA $E4,x		;add xdisp to x positions
	CLC
	ADC XDISP,y
	STA $E4,x
	LDA $14E0,x		;carry to xhigh
	ADC #$00
	STA $14E0,x

	LDA XDISP,y		;test high bit
	BPL Nosignx
	DEC $14E0,x		;"ADC #$FF" instead of ADC #$00

Nosignx
	LDA $D8,x		;sprite ylow
	PHA
	LDA $14D4,x		;sprite yhigh
	PHA

	LDA YDISP,y		;add 4px to ydisp since it's a bit high otherwise
	CLC
	ADC #$04
	STA TEMP		;scratch...
	LDA $D8,x		;add ydisp to y positions
	CLC
	ADC TEMP		;use operated upon value
	STA $D8,x
	LDA $14D4,x
	ADC #$00
	STA $14D4,x

	LDA YDISP,y		;test high bit
	BPL Nosigny
	DEC $14D4,x		;"ADC #$FF" instead of ADC #$00

Nosigny
	JSL $01A7DC		;mario interact

	PLA			;now restore positions
	STA $14D4,x
	PLA
	STA $D8,x
	PLA
	STA $14E0,x
	PLA
	STA $E4,x

	RTS

;display frame relative to mario.  (totalframes * ydistance) / (xdist + ydist)
;first, total frames * ydistance
;if C2 is preserved before entering the routine, it can just get the target frame
TRACKMARIO
	STZ $C2,x		;reset frame index

	JSR SUB_VERT_POS	;00 if mario below
	CPY #$00
	BNE Above		;if not above, set flip towards mario

	JSR SUB_HORZ_POS	;face mario in what direction?
	CPY #$00
	BNE Faceleft

	LDA #$1F		;flip to face right, frame 0F
	STA $C2,x	
Faceleft
	BRA ReturnTM		;just return

Above
	LDA $0F			;ydistance multiplicand 1
	EOR #$FF		;invert because mario - sprite produces negative if mario is above sprite
	INC A
	STA $0F			;new ydist
	STA $4202
	LDA #$10		;16 total frames multiplicand 2
	STA $4203

	LDA #$10		;set flip bit, may be changed...
	STA $C2,x
	JSR SUB_HORZ_POS	;place xdif in $0E
	CPY #$00		;00 if mario right to sprite
	BEQ Right

	LDA $0E			;fix xpos
	EOR #$FF		;two's complement
	INC A
	STA $0E

	STZ $C2,x		;reset flip bit if on left
Right
	LDA $0E			;if difference is <=8 px, set frame to 0F
	CMP #$08
	BCS Farenough

	LDA $C2,x		;test flip bit which was determined above...
	BIT #$10
	BNE Closeright
	ORA #$0F		;frame 0F if on left
Closeright
	STA $C2,x		;but 10 if on right
	BRA ReturnTM		;just return

Farenough
	LDA #$00		;wipe high
	XBA
	LDA $0E			;xdif
	CLC
	ADC $0F			;ydif
	XBA
	ADC #$00		;carry into high byte
	XBA

	REP #$30		;16bit divide coming up
	LDX $4216		;dividend into X (total frames * ydistance)
	TAY			;divisor into Y (xdist + ydist)
	JSR DIVIDE		;quotient in $00
	SEP #$30		;all 8bit
	LDX $15E9		;restore sprite index

	LDA $C2,x		;add frame index bits
	BIT #$10		;test flip bit, make it simpler to work with
	BEQ Leaveindex
	PHA
	LDA $00
	EOR #$0F		;flip bits of result
	STA $00
	PLA
Leaveindex
	ORA $00
	STA $C2,x
	
ReturnTM
	RTS

;checks whether there's sprite contact and damage should be registered
CHECKHURT
	LDA $C2,x		;get disp index
	AND #$1F		;mask page bit
	TAY			;into Y

	LDA $E4,x		;xpositions
	PHA
	CLC
	ADC XDISP,y
	STA $E4,x
	LDA $14E0,x
	PHA
	ADC #$00
	STA $14E0,x

	LDA XDISP,y		;sign fix
	BPL NosignxCH
	DEC $14E0,x
NosignxCH
	LDA $D8,x		;ypositions
	PHA
	CLC
	ADC YDISP,y
	STA $D8,x
	LDA $14D4,x
	PHA
	ADC #$00
	STA $14D4,x

	LDA YDISP,y		;sign fix
	BPL NosignyCH
	DEC $14D4,x
NosignyCH
	LDY #$0B		;loop count

CheckLoop
	LDA $14C8,y		;sprite status
	CMP #$09
	BNE CheckKick
	BRA ClipTest		;jump to cliptest
	
CheckKick
	CMP #$0A		;sprites are kicked
	BNE CheckCarried
	BRA ClipTest

CheckCarried
	CMP #$0B		;sprites that are being carried
	BNE NextSprite

ClipTest
	LDA $1686,Y		;skip sprites that don't interact with others
	AND #$08
	BNE NextSprite

	JSL $03B69F	;clipA
	PHX
	TYX
	JSL $03B6E5	;clipB
	PLX
	JSL $03B72B	;check contact between A and B
	BCC NextSprite	;no contact = don't set

	LDA $9E,y	;test sprite type to see if it's a throw block
	CMP #$53
	BNE Notthrowblock

;throwblock
	LDA $E4,y	;load position into block area
	STA $9A		;block xlow
	LDA $14E0,y
	STA $9B		;block xhigh
	LDA $D8,y
	STA $98		;block ylow
	LDA $14D4,y
	STA $99		;block yhigh
	LDA #$00
	PHY
	PHB		;the DB has to be 02 for the routine to work, despite being able to be called from any bank
	LDA #$02
	PHA
	PLB
	JSL $028663	;shatter block routine
	PLB		;restore bank
	PLY
	BRA Throwblockskip

Notthrowblock
	STY $15E9	;temporarily store hurting sprite as sprite index for stars effect
	PHY
	JSL $07FC3B	;create stars
	PLY
	STX $15E9	;restore sprite index

	LDA #$47	;enemy hit sound
	STA $1DFC

Throwblockskip
	PHX		;x = index since no STZ $add,y
	TYX
	STZ $14C8,x	;erase sprite
	PLX		;restore...

	LDA #$01
	STA TEMP	;contact return 01
	BRA ReturnCH	

NextSprite	
        DEY
	BPL CheckLoop
	
	STZ TEMP	;no contact return 00
ReturnCH
	PLA		;restore positions
	STA $14D4,x
	PLA
	STA $D8,x
	PLA
	STA $14E0,x
	PLA
	STA $E4,x

	LDA TEMP	;load return value
	RTS		;last return

;generates the projectile
FIRESPRITE
GenCust
	JSL $02A9E4		;grab free sprite slot
	BMI ReturnFS		;return if none left before anything else...

	JSR SetupCust

ReturnFS
	RTS			;return custom

SetupCust
	PHX			;preserve sprite index

	LDA #$01
	STA $14C8,y		;normal status, run init routine?

	LDA #SPRITE_NUM		;load sprite number to generate

	PHX			;preserve data in X register
	TYX
	STA $7FAB9E,x		;into sprite type table for custom sprites
	PLX			;restore data in X register

	LDA $C2,x		;set positions according to offsets
	AND #$1F
	STA TEMP		;store index to temp
	
	LDA $E4,x		;store xpositions to scratch to operate on
	CLC
	ADC #$08		;displace by intial 8 pixels
	STA $00
	LDA $14E0,x
	ADC #$00
	STA $01

	PHY
	LDY TEMP		;load displacements
	LDA XDISP,y
	CLC
	ADC $00
	STA $00
	LDA $01
	ADC #$00		;transfer carry
	STA $01

	LDA XDISP,y		;adjust for signed addition
	BPL NosignxGC
	DEC $01			;"ADC #$FF" instead of ADC #$00
NosignxGC
	PLY

	LDA $00			;now copy to generated sprite x
	STA $E4,y
	LDA $01
	STA $14E0,y

	LDA $D8,x		;same deal for Y
	CLC
	ADC #$08		;initial adjustment
	STA $00
	LDA $14D4,x
	ADC #$00
	STA $01

	PHY
	LDY TEMP
	LDA YDISP,y
	CLC
	ADC $00
	STA $00
	LDA $01
	ADC #$00
	STA $01

	LDA YDISP,y	;adjust for signed addition
	BPL NosignyGC
	DEC $01		;"ADC #$FF" instead of ADC #$00
NosignyGC
	PLY

	LDA $00			;set generated sprite y
	STA $D8,y
	LDA $01
	STA $14D4,y

	PHX
	TYX			;new sprite slot into X
	JSL $07F7D2		;create sprite
	JSL $0187A7
        LDA #$88		;set as custom sprite
        STA $7FAB10,x
	PLX

;speed must be set after initialisation
	LDA $C2,x		;set xpsd according to current frame
	BIT #$10		;test flip
	BEQ GCLeft		;need index inversion if going right
	EOR #$0F		;...and invert

GCLeft
	AND #$0F		;mask flip
	STA TEMP		;preserve the index

	PHY
	TAY			;...as Y index
	LDA SPDTBLX,y
	ASL A			;mult by 4
	ASL A
	PLY
	STA $B6,y		;set xspd

	PHY
	LDY TEMP		;reload index
	LDA SPDTBLY,y		;load speed entry
	ASL A			;mult by 4
	ASL A
	EOR #$FF		;rising
	INC A
	PLY
	STA $AA,y		;set Yspeed

	LDA $C2,x		;need to invert xspd according to direction
	BIT #$10
	BNE GCRightA

	LDA $B6,y
	EOR #$FF		;two's complement
	INC A
	STA $B6,y		;adjusted xspeed
GCRightA

	LDA #SHOOT_SOUND	;play shooting sound
	STA $1DFC

	PLX			;restore sprite index

	RTS			;return

;=================
;BORROWED ROUTINES
;=================

;GET_DRAW_INFO
;==============

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1              dcb $0C,$1C
SPR_T2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /
	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_OFF_SCREEN
; This subroutine deals with sprites that have moved off screen
; It is adapted from the subroutine at $01AC0D
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
SPR_T12             dcb $40,$B0
SPR_T13             dcb $01,$FF
SPR_T14             dcb $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
		            dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15             dcb $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
					dcb $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1   LDA #$02                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2   LDA #$04                ;  | 
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3   LDA #$06                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4   LDA #$08                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5   LDA #$0A                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6   LDA #$0C                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X7   LDA #$0E                ;  |
STORE_03			STA $03					;  |            
					BRA START_SUB			;  |
SUB_OFF_SCREEN_X0   STZ $03					; /

START_SUB           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_35           ; /
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
                    AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
                    ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
                    STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
                    TAY                     ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
                    LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
                    CLC                     ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
                    ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
                    ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
                    CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
                    PHP                     ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
                    LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
                    LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
                    ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
                    PLP                     ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
                    SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
                    STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
                    LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
                    BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
                    EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
                    STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31             LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
                    BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /    
                    LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
                    CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
                    BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
                    LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
                    STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE         STZ $14C8,x             ; erase sprite
RETURN_35           RTS                     ; return

VERTICAL_LEVEL      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ; \
                    LSR A                   ; | 
                    BCS RETURN_35           ; /
                    LDA $E4,x               ; \ 
                    CMP #$00                ;  | if the sprite has gone off the side of the level...
                    LDA $14E0,x             ;  |
                    SBC #$00                ;  |
                    CMP #$02                ;  |
                    BCS ERASE_SPRITE        ; /  ...erase the sprite
                    LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
                    LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
                    AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
                    STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
                    TAY                     ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
                    LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
                    CLC                     ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
                    ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
                    ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
                    CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
                    PHP                     ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
                    LDA.W $001D             ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
                    LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
                    ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
                    PLP                     ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
                    SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
                    STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
                    LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
                    BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
                    EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
                    STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38             LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
                    BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
                    BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / return

;SUBHORZPOS
;==========

SUB_HORZ_POS        LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    SEP #$20
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0E                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642

;SUBVERTPPOS, 24px bias
;======================

SUB_VERT_POS        LDY #$00               ;A:25A1 X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizCHC:0130 VC:085 00 FL:924
                    REP #$20
                    LDA $96		   ;16px adjustment
		    PHA
                    CLC
                    ADC.w #$0018
                    STA $96
                    SEP #$20
                    LDA $96
                    SEC                    ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0170 VC:085 00 FL:924
                    SBC $D8,x              ;A:2546 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizCHC:0184 VC:085 00 FL:924
                    STA $0F                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0214 VC:085 00 FL:924
                    LDA $97                ;A:25D6 X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0238 VC:085 00 FL:924
                    SBC $14D4,x            ;A:2501 X:0007 Y:0000 D:0000 DB:03 S:01EA P:envMXdizcHC:0262 VC:085 00 FL:924
                    BPL LABEL11            ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0294 VC:085 00 FL:924
                    INY                    ;A:25FF X:0007 Y:0000 D:0000 DB:03 S:01EA P:eNvMXdizcHC:0310 VC:085 00 FL:924
LABEL11             REP #$20
                    PLA			   ;restore
                    STA $96
		    SEP #$20
                    RTS                    ;A:25FF X:0007 Y:0001 D:0000 DB:03 S:01EA P:envMXdizcHC:0324 VC:085 00 FL:924

;16bit divide.  result in $00.  X/Y.  I found it on a 6502 site.
;===============================================================

DIVIDE  STY $02
        STX $00
        LDX.w #$0010		;16bits to run through
        LDA.w #$0000		;initialise A
        ASL $00
DIV1    ROL A
        CMP $02
        BCC DIV2
        SBC $02
DIV2    ROL $00
        DEX
        BNE DIV1
        RTS

SPRITEGFX
INCBIN sprites\ptooiegfxb.bin	;included graphics file

;A smoke routine
;===============

SUB_SMOKE           LDY #$03                ; \ find a free slot to display effect
FINDFREE            LDA $17C0,y             ;  |
                    BEQ FOUNDONE            ;  |
                    DEY                     ;  |
                    BPL FINDFREE            ;  |
                    RTS                     ; / return if no slots open

FOUNDONE            LDA #$01                ; \ set effect graphic to smoke graphic
                    STA $17C0,y             ; /
                    LDA $D8,x               ; \ smoke y position = generator y position
                    STA $17C4,y             ; /
                    LDA #$18                ; \ set time to show smoke
                    STA $17CC,y             ; /
                    LDA $E4,x               ; \ load generator x position and store it for later
                    STA $17C8,y             ; /
                    LDX $15E9
             
                    RTS


