;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;foo.asm smog cloud
;blatantly based on marine pop's torpedo by LX5 (and other sprites by the same author)
;
!yxppccct = $0C
!cluster_x_lo  = $1E16
!cluster_x_hi  = $1E3E
!cluster_y_lo  = $1E02
!cluster_y_hi  = $1E2A
!cluster_x_speed = $1E66
!cluster_y_speed = $1E52
!cluster_x_fraction = $1E7A
!cluster_y_fraction = $1E8E
!cluster_offscreen = $0F9A

;;;;;;;;;;;;;;;;;;;;
; main code
;;;;;;;;;;;;;;;;;;;;

Main:
JSR GetDrawInfo
LDA !cluster_offscreen,y
BNE .notdraw
LDA #$40
JSR GetOAMSlot
LDA $00
STA $0200,x
LDA $01
STA $0201,x
LDA #$60
STA $0202,x
LDA #!yxppccct
PHX 
LDX !cluster_x_speed,y
BPL +
ORA #$40
+   
ORA $64
PLX 
STA $0203,x
TXA 
LSR #2
TAX 
LDA #$02 
ORA $02
STA $0420,x
.notdraw
LDA $9D
BNE .thing
JSR ClusterUpdateXPos
JSR ClusterUpdateYPos
LDA $1E79,y
SEC
SBC #$01
STA $1E79,y
BNE .ret
JSR smoke_cluster
LDA #$00
STA $1892,y
RTS
.thing   
JMP .no_move 
RTS
.no_move
LDA !cluster_offscreen,y
BEQ .ret
LDA #$00
STA $1892,y
.ret
RTS

;;;;;;;;;;;;;;;;
; shared
;;;;;;;;;;;;;;;;

GetOAMSlot:  
  TXA 
  CMP #$FC
  BEQ .break
.loop   
  LDA $0201,x
  CMP #$F0
  BEQ .break
  INX #4
  CPX #$FC
  BNE .loop
.break   
  RTS

GetDrawInfo:  
  TYX   
  LDA $82FF50,x
  TAX 
GetDrawInfoNoOAM: 
  LDA #$00
  STA !cluster_offscreen,y
  STA $02
  LDA !cluster_x_hi,y
  XBA 
  LDA !cluster_x_lo,y
  REP #$20
  SEC 
  SBC $1A
  CLC 
  ADC #$0040 
  CMP #$0180
  SEP #$20
  BCS .is_offscreen
  LDA !cluster_x_hi,y
  XBA 
  LDA !cluster_x_lo,y
  REP #$20
  SEC 
  SBC $1A
  CMP #$FFC0
  SEP #$20
  BCC .NopeX
.is_offscreen  
  LDA #$01
  STA !cluster_offscreen,y
.NopeX   
  LDA !cluster_y_hi,y
  XBA 
  LDA !cluster_y_lo,y
  REP #$20
  SEC 
  SBC $1C
  SBC #$0100
  CMP #$0020
  SEP #$20
  BCS .NopeY
  LDA #$01
  STA !cluster_offscreen,y
.NopeY   
  LDA !cluster_x_lo,y
  SEC 
  SBC $1A
  STA $00
  LDA !cluster_x_hi,y
  SBC $1B ;#$00
  BEQ .no_high_bit
  LDA #$01 ;$01
  STA $02
.no_high_bit  
  LDA !cluster_y_lo,y
  SEC 
  SBC $1C
  STA $01
  RTS 

smoke_cluster:
  LDX #$03
-   
  LDA $17C0,x
  BEQ +
  DEX 
  BPL -
  RTS 
+   
  LDA #$01
  STA $17C0,x
  LDA #$1B
  STA $17CC,x
  LDA !cluster_x_lo,y
  STA $17C8,x
  LDA !cluster_y_lo,y
  STA $17C4,x
  RTS


ClusterUpdateXPos:
  LDA !cluster_x_speed,y
  BEQ .Finish
  ASL #4
  CLC 
  ADC !cluster_x_fraction,y
  STA !cluster_x_fraction,y
  PHP 
  LDX #$00
  LDA !cluster_x_speed,y
  LSR #4
  CMP #$08
  BCC $03
  ORA #$F0
  DEX 
  PLP 
  ADC !cluster_x_lo,y
  STA !cluster_x_lo,y
  TXA 
  ADC !cluster_x_hi,y
  STA !cluster_x_hi,y
.Finish
  RTS 

ClusterUpdateYPos:
  LDA !cluster_y_speed,y
  BEQ .Finish
  ASL #4
  CLC 
  ADC !cluster_y_fraction,y
  STA !cluster_y_fraction,y
  PHP 
  LDX #$00
  LDA !cluster_y_speed,y
  LSR #4
  CMP #$08
  BCC $03
  ORA #$F0
  DEX 
  PLP 
  ADC !cluster_y_lo,y
  STA !cluster_y_lo,y
  TXA 
  ADC !cluster_y_hi,y
  STA !cluster_y_hi,y
.Finish 
 RTS 