
;=============;
; Gas Bubble  ;
;=============;

print "INIT ",pc
	JSR SUB_HORZ_POS	;\
	TYA			; |
	STA $157C,x		;/ Initially face Mario.
	RTL

print "MAIN ",pc
	PHB
	PHK
	PLB
	JSR Spr ; Call local subroutine.
	PLB
	RTL

;=========
;Main
;=========           
DATA_02E30B:                      db $10,$F0

DATA_02E30D:                      db $01,$FF

DATA_02E30F:                      db $10,$F0

Spr:
CODE_02E311:                      JSR.w GasBubbleGfx ; Always draw graphics.       
CODE_02E314:                      LDA $9D     		;\
CODE_02E316:                      BNE Return02E351      ;/ Return if sprites locked.  
CODE_02E318:                      LDA.w $14C8,X             
CODE_02E31B:                      CMP.b #$08   		;\             
CODE_02E31D:                      BNE Return02E351      ;/ Return if sprite dead.  
CODE_02E31F:                      LDY.w $157C,X     
CODE_02E322:                      LDA.w DATA_02E30B,Y   ; Based on direction, load speed values.      
CODE_02E325:                      STA $B6,X 		; Store them to $B6,x.   
CODE_02E327:                      JSR.w UpdateXPosNoGrvty  ; And update position, without affecting gravity. 
CODE_02E32A:                      LDA $13  		;\    
CODE_02E32C:                      AND.b #$03            ; |  
CODE_02E32E:                      BNE CODE_02E344       ;/ Only executes the below code every 3 frames. 
CODE_02E330:                      LDA $C2,X     
CODE_02E332:                      AND.b #$01 ; Get one bit of $C2,x into Y.              
CODE_02E334:                      TAY                       
CODE_02E335:                      LDA $AA,X  			;\  
CODE_02E337:                      CLC                       	; |
CODE_02E338:                      ADC.w DATA_02E30D,Y       	; | Makes it move in a wavy motion.
CODE_02E33B:                      STA $AA,X    			;/
CODE_02E33D:                      CMP.w DATA_02E30F,Y		;\ Don't let it go beyond the maximum speed ..       	
CODE_02E340:                      BNE CODE_02E344		;/
CODE_02E342:                      INC $C2,X     		; Otherwise, $C2 = 01.
CODE_02E344:                      JSR.w UpdateYPosNoGrvty	; Update Y position, without gravity.   
CODE_02E347:                      INC.w $1570,X			; Increase # of frames sprite has been onscreen.             
CODE_02E34A:                      JSR.w SUB_OFF_SCREEN_X0	; Handle off-screen stuff.   
CODE_02E34D:                      JSL.l $01A7DC			; Interact with Mario.    
Return02E351:                     RTS                       ; Return 
;===============
;X/Y Update Codes
;================
UpdateXPosNoGrvty:                TXA                       ; \ Adjust index so we use X values rather than Y 
CODE_02D289:                      CLC                       ;  | 
CODE_02D28A:                      ADC.b #$0C                ;  | 
CODE_02D28C:                      TAX                       ; / 
CODE_02D28D:                      JSR.w UpdateYPosNoGrvty   
CODE_02D290:                      LDX.w $15E9               ; X = sprite index 
Return02D293:                     RTS                       ; Return 

UpdateYPosNoGrvty:                LDA $AA,X    ; \ $14EC or $14F8 += 16 * speed 
CODE_02D296:                      ASL                       ;  | 
CODE_02D297:                      ASL                       ;  | 
CODE_02D298:                      ASL                       ;  | 
CODE_02D299:                      ASL                       ;  | 
CODE_02D29A:                      CLC                       ;  | 
CODE_02D29B:                      ADC.w $14EC,X             ;  | 
CODE_02D29E:                      STA.w $14EC,X             ; / 
CODE_02D2A1:                      PHP                       
CODE_02D2A2:                      PHP                       
CODE_02D2A3:                      LDY.b #$00                
CODE_02D2A5:                      LDA $AA,X    ; \ Amount to move sprite = speed / 16 
CODE_02D2A7:                      LSR                       ;  | 
CODE_02D2A8:                      LSR                       ;  | 
CODE_02D2A9:                      LSR                       ;  | 
CODE_02D2AA:                      LSR                       ; / 
CODE_02D2AB:                      CMP.b #$08                ; \ If speed was negative... 
CODE_02D2AD:                      BCC CODE_02D2B2           ;  | 
CODE_02D2AF:                      ORA.b #$F0                ;  | ...set high bits 
CODE_02D2B1:                      DEY                       ; / 
CODE_02D2B2:                      PLP                       
CODE_02D2B3:                      PHA                       ; \ Add to position 
CODE_02D2B4:                      ADC $D8,X       ;  | 
CODE_02D2B6:                      STA $D8,X       ;  | 
CODE_02D2B8:                      TYA                       ;  | 
CODE_02D2B9:                      ADC.w $14D4,X   	  	;  | 
CODE_02D2BC:                      STA.w $14D4,X   	  	;  | 
CODE_02D2BF:                      PLA                       ; / 
CODE_02D2C0:                      PLP                       
CODE_02D2C1:                      ADC.b #$00                
CODE_02D2C3:                      STA.w $1491               ; $1491 = amount sprite was moved 
Return02D2C6:                     RTS                       ; Return

;===============
;Graphics Routine
;=============== 

DATA_02E352:                      db $00,$10,$20,$30,$00,$10,$20,$30
                                  db $00,$10,$20,$30,$00,$10,$20,$30
DATA_02E362:                      db $00,$00,$00,$00,$10,$10,$10,$10
                                  db $20,$20,$20,$20,$30,$30,$30,$30
DATA_02E372:                      db $80,$82,$84,$86,$A0,$A2,$A4,$A6
                                  db $A0,$A2,$A4,$A6,$80,$82,$84,$86
DATA_02E382:                      db $3B,$3B,$3B,$3B,$3B,$3B,$3B,$3B
                                  db $BB,$BB,$BB,$BB,$BB,$BB,$BB,$BB
DATA_02E392:                      db $00,$00,$02,$02,$00,$00,$02,$02
                                  db $01,$01,$03,$03,$01,$01,$03,$03
DATA_02E3A2:                      db $00,$01,$02,$01

DATA_02E3A6:                      db $02,$01,$00,$01

GasBubbleGfx:                     JSR.w GET_DRAW_INFO        
CODE_02E3AD:                      LDA.w $1570,X  		;\           
CODE_02E3B0:                      LSR                       	; |
CODE_02E3B1:                      LSR                           ; |
CODE_02E3B2:                      LSR                       	; | This changes the X and Y offset displacement ..
CODE_02E3B3:                      AND.b #$03                    ; | Every now and then.
CODE_02E3B5:                      TAY                       	; | More LSRs for slower animation.
CODE_02E3B6:                      LDA.w DATA_02E3A2,Y       	; |
CODE_02E3B9:                      STA $02                   	;/ Because the bubble changes it's X/Y offset all the time.
CODE_02E3BB:                      LDA.w DATA_02E3A6,Y       	; 
CODE_02E3BE:                      STA $03     			;              
CODE_02E3C0:                      LDY.w $15EA,X
CODE_02E3C3:                      PHX   			; Y = Index into sprite OAM                       
CODE_02E3C4:                      LDX.b #$0F                
CODE_02E3C6:                      LDA $00                   
CODE_02E3C8:                      CLC                       
CODE_02E3C9:                      ADC.w DATA_02E352,X 		; Apply X displacement to sprite X position.      
CODE_02E3CC:                      PHA                		; And push it for later.       
CODE_02E3CD:                      LDA.w DATA_02E392,X       
CODE_02E3D0:                      AND.b #$02    		            
CODE_02E3D2:                      BNE CODE_02E3DA           
CODE_02E3D4:                      PLA                       
CODE_02E3D5:                      CLC                       
CODE_02E3D6:                      ADC $02			; Add animation change offsets to $00 and branch to store..                   
CODE_02E3D8:                      BRA CODE_02E3DE           

CODE_02E3DA:                      PLA                       
CODE_02E3DB:                      SEC                       
CODE_02E3DC:                      SBC $02                   
CODE_02E3DE:                      STA.w $0300,Y ; Store X displacement to $0300,y, X position of sprite.         
CODE_02E3E1:                      LDA $01   ; Get Y position of sprite.                
CODE_02E3E3:                      CLC                       
CODE_02E3E4:                      ADC.w DATA_02E362,X ; Add "normal" displacement again.       
CODE_02E3E7:                      PHA                 ; Push for later.
CODE_02E3E8:                      LDA.w DATA_02E392,X       
CODE_02E3EB:                      AND.b #$01                
CODE_02E3ED:                      BNE CODE_02E3F5           
CODE_02E3EF:                      PLA                       
CODE_02E3F0:                      CLC   		;\                    
CODE_02E3F1:                      ADC $03               ;/ Add to Y displacement.  
CODE_02E3F3:                      BRA CODE_02E3F9           

CODE_02E3F5:                      PLA                       
CODE_02E3F6:                      SEC                       
CODE_02E3F7:                      SBC $03                   
CODE_02E3F9:                      STA.w $0301,Y ; Store Y displacement ..         
CODE_02E3FC:                      LDA.w DATA_02E372,X  	;\     
CODE_02E3FF:                      STA.w $0302,Y         ;/ Store tile data.
CODE_02E402:                      LDA.w DATA_02E382,X       
CODE_02E405:                      STA.w $0303,Y 	; Store property info.         
CODE_02E408:                      INY                       
CODE_02E409:                      INY  ; OAM is 8x8, so for each 16x16, increase 4 times INY #4.                     
CODE_02E40A:                      INY                       
CODE_02E40B:                      INY                       
CODE_02E40C:                      DEX ; Decrease # of times to go through loop ..                       
CODE_02E40D:                      BPL CODE_02E3C6 ; Until all tiles are drawn.           
CODE_02E40F:                      PLX                       
CODE_02E410:                      LDY.b #$02                
CODE_02E412:                      LDA.b #$0F ; Gas bubble = 16 16x16 tiles.                
CODE_02E414:                      JSL $01B7B3 ; Call OAM write routine and end.
				RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B817 - horizontal mario/sprite check - shared
; Y = 1 if mario left of sprite??
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B817        

SUB_HORZ_POS:        LDY #$00                ;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
                    LDA $94                 ;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
                    SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
                    SBC $E4,x               ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
                    STA $0F                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
                    LDA $95                 ;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
                    SBC $14E0,x             ;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
                    BPL LABEL16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
                    INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
LABEL16:             RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642
                    



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;       Y = index to sprite OAM ($300)
;       $00 = sprite x position relative to screen boarder
;       $01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1:              db $0C,$1C
SPR_T2:             db $01,$02

GET_DRAW_INFO:       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X:         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC #$0040            ;  |
                    CMP #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP:      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y:         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID:             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_OFF_SCREEN
; This subroutine deals with sprites that have moved off screen
; It is adapted from the subroutine at $01AC0D
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
SPR_T12:             db $40,$B0
SPR_T13:             db $01,$FF
SPR_T14:             db $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
		            db $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15:             db $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
					db $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1:   LDA #$02                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2:   LDA #$04                ;  | 
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3:   LDA #$06                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4:   LDA #$08                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5:   LDA #$0A                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6:   LDA #$0C                ;  |
                    BRA STORE_03            ;  | OMG YOU FOUND THIS HIDDEN z0mg place!111 you win a cookie!
SUB_OFF_SCREEN_X7:   LDA #$0E                ;  |
STORE_03:			STA $03					;  |            
					BRA START_SUB			;  |
SUB_OFF_SCREEN_X0:   STZ $03					; /

START_SUB:           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_35           ; /
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
                    AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
                    ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
                    STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
                    TAY                     ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
                    LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
                    CLC                     ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
                    ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
                    ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
                    CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
                    PHP                     ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
                    LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
                    LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
                    ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
                    PLP                     ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
                    SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
                    STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
                    LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
                    BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
                    EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
                    STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31:             LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
                    BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE:        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /    
                    LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
                    CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
                    BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
                    LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
                    STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE:         STZ $14C8,x             ; erase sprite
RETURN_35:           RTS                     ; return

VERTICAL_LEVEL:      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ; \
                    LSR A                   ; | 
                    BCS RETURN_35           ; /
                    LDA $E4,x               ; \ 
                    CMP #$00                ;  | if the sprite has gone off the side of the level...
                    LDA $14E0,x             ;  |
                    SBC #$00                ;  |
                    CMP #$02                ;  |
                    BCS ERASE_SPRITE        ; /  ...erase the sprite
                    LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
                    LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
                    AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
                    STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
                    TAY                     ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
                    LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
                    CLC                     ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
                    ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
                    ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
                    CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
                    PHP                     ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
                    LDA $001D             ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
                    LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
                    ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
                    PLP                     ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
                    SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
                    STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
                    LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
                    BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
                    EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
                    STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38:             LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
                    BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
                    BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN:   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / return