;==================;
;Gulpit, FROM PM   ;
;Coded by Iceguy   ;
;==================;

;It's better to leave these as they are.
!TimeToStop	= $28
!TimeInMouth	= $3E
!SwallowSFX = $21

!Rock = $08			; SPRITE NUMBER OF THE ROCK DO CHANGE THIS!

print "INIT ", pc
	JSR SUB_HORZ_POS
	TYA
	;EOR #$01
	STA $157C,x
	STZ $C2,x
	LDA #$01
	STA $1504,x
	RTL

Return:
	RTS

print "MAIN ", pc
	PHB
	PHK
	PLB
	LDA $1594,x
	BEQ +
	DEC $1594,x
+	JSR Run
	PLB
	RTL

Run:
	JSR SubOffScreen
	JSR Graphics
	LDA $14C8,x		;If the sprite is dead..
	CMP #$08
	BNE Return		;..return
	
	LDA $C2,x
	CMP #$03
	BEQ +
	CMP #$04			; if swallowing, skip sprite locking
	BEQ +
	LDA $9D
	BNE Return
+
	JSL $01A7DC
	BCC +
	JSR CheckContact
+	
	LDA $C2,x
	ASL A
	PHX
	TAX
	JMP (Ptr,x)
	
Ptr:
	dw Walking	; 00
	dw Stop		; 01
	dw StopA		; 02
	dw Swallow	; 03
	dw SwallowA	; 04
	dw Gulp		; 05
	dw Spit		; 06
	dw DoneSpit	; 07
	dw Jumped	; 08
	dw Rec		; 09
	
DoneSpit:
	PLX
	STZ $C2,x
	STZ $1626,x
	STZ $1534,x
	RTS
	
Spit:
	PLX
	LDA $1534,x
	BEQ spitit
	INC $1626,x
	LDA $1626,x
	CMP #$10
	BCC +
	INC $C2,x
+	RTS
spitit:
	LDA #$20
	STA $1DF9
	LDA $186C,x
	BNE EndSpawn
	JSL $02A9DE
	BMI EndSpawn
	LDA #$01			; Sprite state ($14C8,x).
	STA $14C8,y
	PHX
	TYX
	LDA #!Rock			; This the sprite number to spawn.
	STA $7FAB9E,x
	PLX
	
	PHY
	LDY $157C,x
	LDA $E4,x
	CLC
	ADC val,y
	PLY
	STA $00E4,y
	
	PHY
	LDY $157C,x
	LDA $14E0,x
	CLC
	ADC val2,y
	PLY
	STA $14E0,y
	
	LDA $D8,x
	SEC
	SBC #$09
	STA $00D8,y	
	LDA $14D4,x
	SBC #$00
	STA $14D4,y	
	LDA #$01
	STA $1504,y
	PHX
	TYX
	JSL $07F7D2
	JSL $0187A7
	LDA #$0C
	STA $7FAB10,x
	PLX
	LDA #$01
	STA $1534,x
EndSpawn:
	RTS

val: db $0C,$00
val2: db $00,$00

Gulp:
	PLX
	JSR SUB_HORZ_POS
	TYA
	STA $157C,x
	INC $1626,x
	LDA $1626,x
	CMP #!TimeInMouth
	BCC +
	INC $C2,x
	STZ $1626,x
+	RTS
	
SwallowA:
	PLX
	INC $1626,x
	LDA $1626,x
	CMP #$0C
	BCC +
	INC $C2,x
	STZ $1626,x
+	
	RTS	
	
Swallow:
	PLX
	LDA #!SwallowSFX
	STA $1DFC
	INC $1626,x
	LDA $1626,x
	CMP #$06
	BCC +
	INC $C2,x
+	
	RTS
	
StopA:
	PLX
	LDA $1594,x
	BNE +
	INC $C2,x
+	RTS

Stop:
	PLX
	LDA.b #!TimeToStop
	STA $1594,x
	INC $C2,x
	RTS
	
WalkSp: 	db $0A,$FA			; Walking speed.
Timer: 	db $76,$52,$A2,$66	; Random walking timers before turning.	

Walking:
	PLX
	LDA $1588,x
	AND #$03
	BEQ +
	LDA $157C,x
	EOR #$01
	STA $157C,x		; Flip if touching wall.
+
	LDY $157C,x
	LDA WalkSp,y
	STA $B6,x
	JSL $01802A

	LDA $1510,x
	BNE +
	JSR FindContact	; Check to see if it touches the rock sprite.
+	RTS
	
FindContact:
	JSL $03B6E5		;Get clipping for self
	PHX				;Preserve sprite #
	LDX #$0C			;Load # of sprites
INTRLOOP:
	DEX				;next sprite
	BMI ABORTINTR		;If done, end
	LDA $14C8,x
	BEQ INTRLOOP
	TXA
	CMP $01,s
	BEQ INTRLOOP
	JSL $03B69F		;get clipping for client sprite
	JSL $03B72B		;Check for contact
	BCC INTRLOOP		;if no contact, continue loop
	LDA $14C8,x
	CMP #$08
	BCC INTRLOOP
	TXY				;client sprite index to Y
	PLX				;own sprite index to X
	PHX
	TYX
	LDA $7FAB9E,x
	PLX
	CMP #!Rock                ;mushroom sprite number
	BNE Endprocess

	;LDA #$00
	;STA $14C8,y
	LDA #$FF
	STA $1626,y			; disp. after a while
	
	INC $C2,x			; state = pick up rock.
	
Endprocess:
	PHX			;preserve self index
	TYX			;client back to X
	BRA INTRLOOP		;continue loop
ABORTINTR:
	PLX			;Finished. Get self sprite index back
INTREND:
	RTS
	
CheckContact:
	LDA $1490
	BEQ +
	JMP Gone
+	
	LDA $0E
	CMP #$E6
	BPL HurtHurt	; sprite wins
	LDA #$02
	STA $1DF9
	JSL $01AA33
	JSL $01AB99
	JSR SUB_HORZ_POS
	TYA
	EOR #$01
	TAY
	LDA BounceMarioX,y
	STA $7B
	LDA #$BC
	STA $7D
	INC $1528,x
	LDA $1528,x
	CMP #$03
	BCS Gone
	LDA $C2,x
	CMP #$01
	BEQ ret
	CMP #$02
	BEQ ret
	CMP #$03
	BEQ ret
	CMP #$04
	BEQ ret
	LDA #$08
	STA $C2,x
ret:
	LDA #$28
	STA $1DFC		
	RTS
HurtHurt:
	JSL $00F5B7
	RTS
	
Jumped:
	PLX
	LDA $1510,x
	INC $1510,x
	CMP #$15
	BCC NoRec
	INC $C2,x
	;STZ $1510,x
NoRec:
	RTS

Rec:
	PLX
	INC $1510,x
	LDA $1510,x
	CMP.b #$15+#$12
	BCC NoRec2
	STZ $C2,x
	STZ $1510,x
NoRec2:
	RTS
	
Gone:
	LDA #$02
	STA $14C8,x
	LDA #$13
	STA $1DF9
	LDA #$F0
	STA $AA,x
	JSL $01802A
	RTS

BounceMarioX:
db $E0,-$E0
	
;==================;
;GRAPHICS ROUTINE ;
;==================;

PROPERTIES: 
	db $6D,$2D
	
TILEMAP6:
	db $CC,$CE,$EC,$EE		; FRAME 1 JUMPED ON
	db $CC,$CE,$EC,$EE
			
TILEMAP5: 
	db $C8,$CA,$E8,$EA		; FRAME 1 JUMPED ON
	db $C8,$CA,$E8,$EA
	
TILEMAP4: 
	db $C4,$C6,$A0,$E6		; FRAME 1 IN MOUTH
	db $C4,$C6,$A0,$E6
	
TILEMAP3: 
	db $C0,$C2,$E0,$E2		; FRAME 2 SWALLOW
	db $C0,$C2,$E0,$E2
	
TILEMAP2: 
	db $8C,$8E,$AC,$AE		; FRAME 1 SWALLOW
	db $8C,$8E,$AC,$AE
	
XDISP2:
	db $00,$10,$00,$10 	
	db $10,$00,$10,$00	
YDISP2:
	db $F0,$F0,$00,$00
	db $F0,$F0,$00,$00 
	
TILEMAP: 
	db $80,$82,$A0,$A2		; FRAME 1 RIGHT WALKING 1
	db $84,$86,$A4,$A6		; FRAME 2 RIGHT WALKING 2
	db $80,$82,$A0,$A2		; FRAME 3 RIGHT WALKING 1
	db $88,$8A,$A8,$AA		; FRAME 4 RIGHT WALKING 3
	
	db $80,$82,$A0,$A2		; FRAME 1 
	db $84,$86,$A4,$A6		; FRAME 2
	db $80,$82,$A0,$A2		; FRAME 3
	db $88,$8A,$A8,$AA		; FRAME 4

YDISP:  
	db $F0,$F0,$00,$00 
	db $F0,$F0,$00,$00 
	db $F0,$F0,$00,$00 
	db $F0,$F0,$00,$00

	db $F0,$F0,$00,$00 
	db $F0,$F0,$00,$00 
	db $F0,$F0,$00,$00 
	db $F0,$F0,$00,$00 

XDISP:
	db $00,$10,$00,$10 
	db $00,$10,$00,$10 
	db $00,$10,$00,$10 
	db $00,$10,$00,$10  

	db $10,$00,$10,$00
	db $10,$00,$10,$00 
	db $10,$00,$10,$00 
	db $10,$00,$10,$00 
Graphics:
	JSR GET_DRAW_INFO
	
	LDA $C2,x
	STA $04			;$04 = sprite state.

	LDA $14C8,x
	CMP #$02
	BEQ +
	LDA $04			; no animation at all unless walking
	BNE +
	LDA $14
	LSR #3
	AND #$03	
	ASL A 			
	ASL A
	STA $03			
+
	LDA $157C,x
	STA $02			
	BNE NoAdd
	
	LDA $04			; for modes 3 and above, only add 4
	CMP #$03
	BCS AddFour
	LDA $03			
	CLC			
	ADC #$10
	BRA Store
AddFour:
	LDA $03
	CLC
	ADC #$04
Store:
	STA $03			
NoAdd:
	PHX			
	LDX #$03		
Loop:
	PHX			
	TXA			
	ORA $03	
	TAX

	LDA $04
	CMP #$03
	BCS nexdisp
	LDA $00			
	CLC			
	ADC XDISP,x		
	BRA ydisp
nexdisp:
	LDA $00
	CLC
	ADC XDISP2,x
ydisp:
	STA $0300,y

	LDA $01			
	CLC			
	ADC YDISP,x		
	STA $0301,y		
	
	LDA $04
	CMP #$03
	BEQ TilemapA
	CMP #$04
	BEQ TilemapB
	CMP #$05
	BEQ TilemapC
	CMP #$06
	BEQ TilemapD
	CMP #$08
	BEQ TilemapE
	
	LDA TILEMAP,x
	BRA StoreToMap
TilemapA:
	LDA TILEMAP2,x
	BRA StoreToMap
TilemapB:
	LDA TILEMAP3,x
	BRA StoreToMap
TilemapC:
	LDA TILEMAP4,x
	BRA StoreToMap
TilemapD:
	LDA TILEMAP5,x
	BRA StoreToMap	
TilemapE:
	LDA TILEMAP6,x
StoreToMap:
	STA $0302,y	
	
	PHX			
	LDX $02			
	LDA PROPERTIES,x
	STA $0303,y		
	PLX			

	INY			
	INY			
	INY			
	INY
					
	PLX			
	DEX							
	BPL Loop		
	PLX			

	LDY #$02		
	LDA #$03						
	JSL $01B7B3		
	RTS			

;Sprite Routines

;=================;
;SUB_HORZ_POS
;=================;

SUB_HORZ_POS:
	LDY #$00
	LDA $D1
	SEC
	SBC $E4,x
	STA $0F
	LDA $D2
	SBC $14E0,x
	BPL SPR_L16
	INY
SPR_L16:
	RTS

;=================;
;SUB_VERT_POS
;=================;

SUB_VERT_POS:
	LDY #$00
	LDA $D3
	SEC
	SBC $D8,x
	STA $0F
	LDA $D4
	SBC $14D4,x
	BPL SPR_L11
	INY
SPR_L11:
	RTS

;=================;
;SUB_OFF_SCREEN
;=================;

SPR_T12:
	db $40,$B0
SPR_T13:
	db $01,$FF
SPR_T14:
	db $30,$C0,$A0,$C0,$A0,$F0,$60,$90
	db $30,$C0,$A0,$80,$A0,$40,$60,$B0
SPR_T15:
	db $01,$FF,$01,$FF,$01,$FF,$01,$FF
	db $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X1:
	LDA #$02
	BRA STORE_03
SUB_OFF_SCREEN_X2:
	LDA #$04
	BRA STORE_03
SUB_OFF_SCREEN_X3:
	LDA #$06
	BRA STORE_03
SUB_OFF_SCREEN_X4:
	LDA #$08
	BRA STORE_03
SUB_OFF_SCREEN_X5:
	LDA #$0A
	BRA STORE_03
SUB_OFF_SCREEN_X6:
	LDA #$0C
	BRA STORE_03
SUB_OFF_SCREEN_X7:
	LDA #$0E
STORE_03:
	STA $03
	BRA START_SUB
SubOffScreen:
	STZ $03

START_SUB:
	JSR SUB_IS_OFF_SCREEN
	BEQ RETURN_35
	LDA $5B
	AND #$01
	BNE VERTICAL_LEVEL
	LDA $D8,x
	CLC
	ADC #$50
	LDA $14D4,x
	ADC #$00
	CMP #$02
	BPL ERASE_SPRITE
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	AND #$01
	ORA $03
	STA $01
	TAY
	LDA $1A
	CLC
	ADC SPR_T14,y
	ROL $00
	CMP $E4,x
	PHP
	LDA $1B
	LSR $00
	ADC SPR_T15,y
	PLP
	SBC $14E0,x
	STA $00
	LSR $01
	BCC SPR_L31
	EOR #$80
	STA $00
SPR_L31:
	LDA $00
	BPL RETURN_35
	ERASE_SPRITE:
	LDA $14C8,x
	CMP #$08
	BCC KILL_SPRITE
	LDY $161A,x
	CPY #$FF
	BEQ KILL_SPRITE
	LDA #$00
	STA $1938,y
KILL_SPRITE:
	STZ $14C8,x
RETURN_35:
	RTS

VERTICAL_LEVEL:
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	LSR A
	BCS RETURN_35
	LDA $E4,x
	CMP #$00
	LDA $14E0,x
	SBC #$00
	CMP #$02
	BCS ERASE_SPRITE
	LDA $13
	LSR A
	AND #$01
	STA $01
	TAY
	LDA $1C
	CLC
	ADC SPR_T12,y
	ROL $00
	CMP $D8,x
	PHP
	LDA $001D
	LSR $00
	ADC SPR_T13,y
	PLP
	SBC $14D4,x
	STA $00
	LDY $01
	BEQ SPR_L38
	EOR #$80
	STA $00
SPR_L38:
	LDA $00
	BPL RETURN_35
	BMI ERASE_SPRITE

SUB_IS_OFF_SCREEN:
	LDA $15A0,x
	ORA $186C,x
	RTS

;================;
;GET_DRAW_INFO
;================;

SPR_T1:
	db $0C,$1C
SPR_T2:
	db $01,$02

GET_DRAW_INFO:
	STZ $186C,x
	STZ $15A0,x
	LDA $E4,x
	CMP $1A
	LDA $14E0,x
	SBC $1B
	BEQ ON_SCREEN_X
	INC $15A0,x

ON_SCREEN_X:
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
	SEC
	SBC $1A
	CLC
	ADC.w #$0040
	CMP.w #$0180
	SEP #$20
	ROL A
	AND #$01
	STA $15C4,x
	BNE INVALID

	LDY #$00
	LDA $1662,x
	AND #$20
	BEQ ON_SCREEN_LOOP
	INY
ON_SCREEN_LOOP:
	LDA $D8,x
	CLC
	ADC SPR_T1,y
	PHP
	CMP $1C
	ROL $00
	PLP
	LDA $14D4,x
	ADC #$00
	LSR $00
	SBC $1D
	BEQ ON_SCREEN_Y
	LDA $186C,x
	ORA SPR_T2,y
	STA $186C,x
ON_SCREEN_Y:
	DEY
	BPL ON_SCREEN_LOOP
	LDY $15EA,x
	LDA $E4,x
	SEC
	SBC $1A
	STA $00
	LDA $D8,x
	SEC
	SBC $1C
	STA $01
	RTS

INVALID:
	PLA
	PLA
	RTS

;==============;
;RANDOM (1024) ;
;==============;

RANDOM:
	PHX
	PHP
	SEP #$30
	PHA
	JSL $01ACF9
	PLX
	CPX #$FF
	BNE NORMALRT
	LDA $148B
	BRA ENDRANDOM
NORMALRT:
	INX
	LDA $148B
	STA $4202
	STX $4203
	NOP #4
	LDA $4217	
ENDRANDOM:
	PLP
	PLX
	RTL

;============;
;PROXIMITY   ;
;============;

DirTbl: db $F0,$10
DirFix: db $FF,$00

Proximity:
	LDA $E4,x		;\
	SEC				; |
	SBC $94			; |
	PHA				; |
	JSR SUB_HORZ_POS	; | Check sprite range ..
	PLA				; |
	EOR DirFix,y		; |
	CMP $00			; | If Range > !Temp return.
	BCC Ranged		; | If in RANGE.. branch.
Zero:				; |
	LDA #$00			; |
	RTS				; |
Ranged:				; |
	LDA $76			; | Now it is in range, but we have to check if it's facing Mario, like > <.
	EOR #$01			; |
	CMP $157C,x		; |
	BEQ Zero			; |
	LDA #$01			; | In range!
	RTS				;/
