;==========
;The rock which Gulpit spits out.
;==========

!Tile = $E4

print "INIT ", pc
	JSR SUB_HORZ_POS
	TYA
	STA $157C,x
	RTL

Return:
	RTS

print "MAIN ", pc
	PHB
	PHK
	PLB
	LDA $1626,x
	BEQ +
	DEC $1626,x
	+
	JSR Run
	PLB
	RTL

Run:

	LDA $1626,x
	CMP #$42
	BCC Skip
	CMP #$D0
	BCS Skip
	STZ $14C8,x

Skip:
	JSR SubOffScreen
	JSR GFX

	LDA $7FAB10,x
	AND #$04
	STA $1504,x
	
	LDA $14C8,x		;If the sprite is dead..
	CMP #$08
	BNE Return		;..return
	LDA $9D
	BNE Return		;Also return if sprites are locked.

	JSL $01A7DC	
	
	LDA $1588,x
	AND #$03
	BEQ +
	JSR DrawSmoke		; It disappears when it touches a wall.
	STZ $14C8,x
+	
	STZ $AA,x
	LDA $1504,x
	BEQ DontMove
	LDY $157C,x
	LDA Speeds,y
	STA $B6,x
	JSL $01802A
DontMove:	
	RTS                     
	
STAR_SOUNDS:         
	db $00,$13,$14,$15,$16,$17,$18,$19
	
StarA:            
	LDA #$02                
	STA $14C8,x             
	INC $18D2               
	LDA $18D2               
	CMP #$08                
	BCC NO_RESET          
	LDA #$08                
	STA $18D2               
NO_RESET:           
	JSL $02ACE5             
	LDY $18D2               
	CPY #$08                
	BCS NO_SOUND           
	LDA STAR_SOUNDS,y       
	STA $1DF9               
NO_SOUND:           
	RTS   
	
NoTouch:	
	RTS

Speeds: db $30,$D0
	
;Sprite Routines
;Graphics

Props: db $7D,$3D

GFX:
	JSR GetDrawInfo
	LDA $157C,x
	STA $02
	LDA $00
	STA $0300,y
	LDA $01
	STA $0301,y
	LDA.b #!Tile
	STA $0302,y
	PHX
	LDX $02
	LDA Props,x
	ORA $64
	STA $0303,y
	PLX
	INY #4
	LDY #$02
	LDA #$00
	JSL $01B7B3
	RTS

DrawSmoke:
	LDY #$03
-
	LDA $17C0,y
	BEQ +
	DEY
	BPL -
	RTS
+
	LDA #$01
	STA $17C0,y
	LDA #$1C     
	STA $17CC,y
	LDA $D8,x
	STA $17C4,y
	LDA $E4,x
	STA $17C8,y
	RTS

;=================;
;SUB_HORZ_POS
;=================;

SUB_HORZ_POS:
	LDY #$00
	LDA $D1
	SEC
	SBC $E4,x
	STA $0F
	LDA $D2
	SBC $14E0,x
	BPL SPR_L16
	INY
SPR_L16:
	RTS

;=================;
;SUB_VERT_POS
;=================;

SUB_VERT_POS:
	LDY #$00
	LDA $D3
	SEC
	SBC $D8,x
	STA $0F
	LDA $D4
	SBC $14D4,x
	BPL SPR_L11
	INY
SPR_L11:
	RTS

;=================;
;SUB_OFF_SCREEN
;=================;

SPR_T12:
	db $40,$B0
SPR_T13:
	db $01,$FF
SPR_T14:
	db $30,$C0,$A0,$C0,$A0,$F0,$60,$90
	db $30,$C0,$A0,$80,$A0,$40,$60,$B0
SPR_T15:
	db $01,$FF,$01,$FF,$01,$FF,$01,$FF
	db $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X1:
	LDA #$02
	BRA STORE_03
SUB_OFF_SCREEN_X2:
	LDA #$04
	BRA STORE_03
SUB_OFF_SCREEN_X3:
	LDA #$06
	BRA STORE_03
SUB_OFF_SCREEN_X4:
	LDA #$08
	BRA STORE_03
SUB_OFF_SCREEN_X5:
	LDA #$0A
	BRA STORE_03
SUB_OFF_SCREEN_X6:
	LDA #$0C
	BRA STORE_03
SUB_OFF_SCREEN_X7:
	LDA #$0E
STORE_03:
	STA $03
	BRA START_SUB
SubOffScreen:
	STZ $03

START_SUB:
	JSR SUB_IS_OFF_SCREEN
	BEQ RETURN_35
	LDA $5B
	AND #$01
	BNE VERTICAL_LEVEL
	LDA $D8,x
	CLC
	ADC #$50
	LDA $14D4,x
	ADC #$00
	CMP #$02
	BPL ERASE_SPRITE
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	AND #$01
	ORA $03
	STA $01
	TAY
	LDA $1A
	CLC
	ADC SPR_T14,y
	ROL $00
	CMP $E4,x
	PHP
	LDA $1B
	LSR $00
	ADC SPR_T15,y
	PLP
	SBC $14E0,x
	STA $00
	LSR $01
	BCC SPR_L31
	EOR #$80
	STA $00
SPR_L31:
	LDA $00
	BPL RETURN_35
	ERASE_SPRITE:
	LDA $14C8,x
	CMP #$08
	BCC KILL_SPRITE
	LDY $161A,x
	CPY #$FF
	BEQ KILL_SPRITE
	LDA #$00
	STA $1938,y
KILL_SPRITE:
	STZ $14C8,x
RETURN_35:
	RTS

VERTICAL_LEVEL:
	LDA $167A,x
	AND #$04
	BNE RETURN_35
	LDA $13
	LSR A
	BCS RETURN_35
	LDA $E4,x
	CMP #$00
	LDA $14E0,x
	SBC #$00
	CMP #$02
	BCS ERASE_SPRITE
	LDA $13
	LSR A
	AND #$01
	STA $01
	TAY
	LDA $1C
	CLC
	ADC SPR_T12,y
	ROL $00
	CMP $D8,x
	PHP
	LDA $001D
	LSR $00
	ADC SPR_T13,y
	PLP
	SBC $14D4,x
	STA $00
	LDY $01
	BEQ SPR_L38
	EOR #$80
	STA $00
SPR_L38:
	LDA $00
	BPL RETURN_35
	BMI ERASE_SPRITE

SUB_IS_OFF_SCREEN:
	LDA $15A0,x
	ORA $186C,x
	RTS

;================;
;GET_DRAW_INFO
;================;

SPR_T1:
	db $0C,$1C
SPR_T2:
	db $01,$02

GetDrawInfo:
	STZ $186C,x
	STZ $15A0,x
	LDA $E4,x
	CMP $1A
	LDA $14E0,x
	SBC $1B
	BEQ ON_SCREEN_X
	INC $15A0,x

ON_SCREEN_X:
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
	SEC
	SBC $1A
	CLC
	ADC.w #$0040
	CMP.w #$0180
	SEP #$20
	ROL A
	AND #$01
	STA $15C4,x
	BNE INVALID

	LDY #$00
	LDA $1662,x
	AND #$20
	BEQ ON_SCREEN_LOOP
	INY
ON_SCREEN_LOOP:
	LDA $D8,x
	CLC
	ADC SPR_T1,y
	PHP
	CMP $1C
	ROL $00
	PLP
	LDA $14D4,x
	ADC #$00
	LSR $00
	SBC $1D
	BEQ ON_SCREEN_Y
	LDA $186C,x
	ORA SPR_T2,y
	STA $186C,x
ON_SCREEN_Y:
	DEY
	BPL ON_SCREEN_LOOP
	LDY $15EA,x
	LDA $E4,x
	SEC
	SBC $1A
	STA $00
	LDA $D8,x
	SEC
	SBC $1C
	STA $01
	RTS

INVALID:
	PLA
	PLA
	RTS