;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Lose coins if stunned by ground pound quake, by ICB. Based on Ice Power by mikeyk
;;
;; Description: This is a generator that makes Mario lose coins if the ground shakes
;; from any sprite that stuns mario when the ground shakes, such as a Power Thwomp
;; MUST be placed at the entrance to the level with sprites who shake the ground, 
;; and also at each secondary entrance in that level.
;;
;; MUST BE INSERTED AS A GENERATOR!!!
;; Uses first extra bit: NO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

        coin = $21  	;Sprite number of moving coin sprite
	
	RAM_IsDucking 	= $73 
	RAM_OnYoshi	= $187A

	RAM_MarioXPos	= $94 
	RAM_MarioXPosHi	= $95 
	RAM_MarioYPos	= $96 
	RAM_MarioYPosHi	= $97

	RAM_SpriteYHi	= $14D4
	RAM_SpriteXHi	= $14E0
	RAM_SpriteYLo	= $D8
	RAM_SpriteXLo	= $E4

	RAM_MarioDir 	= $76 
	RAM_SpriteDir	= $157C 
	


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
                    dcb "INIT"              ;generators don't have an init routine
                    dcb "MAIN"                                    
                    PHB                     
                    PHK                     
                    PLB          
         
                    JSR SPRITE_CODE_START   
                    PLB                     
                    RTL      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


                    NEW_SPRITE_NUM = $9E

SPRITE_CODE_START
	LDA $7F8820		
	CMP #$0D
	BCC NoAdjust
	LDA #$00		; Initialize RAM the first time
	STA $7F8820
NoAdjust:	
	BEQ CanShoot
	DEC
	STA $7F8820
	BRA Return
CanShoot:
	LDA $77			;\If Mario isn't
	CMP #$04		;|on the ground
	BNE RETURN		;/then return
	LDA $1887		;\if Mario isn't frozen from ground shake
	CMP #$01		;|then
	BMI Return		;/return
	LDA $0DBF		;\If Mario has no coins
	CMP #$00		;|in his overalls pockets
	BEQ RETURN		;/return
	LDA RAM_OnYoshi	;if he's on yoshi
	ORA $14AD		;\Or pow
	ORA $14AE		;/Or silver pow, return
	BNE Return


BRA COIN_GEN
RETURN 
RTS
XGEN    dcb $B2,$F8,$Ba	;|X speed to make coins pop out

COIN_GEN

STZ $09				;|This code limits the number of coins that pop out
LDY #$0B			;| It is advisde that you not change it due to lag
LOOP				;|and sprite slot limitations.
LDA $14C8,y
BEQ NEXT
PHX
TYX
LDA $9E,x
PLX
CMP #Coin
BNE NEXT

INC $09				;\Right now 
LDA $09				;|it is set
CMP #$03			;|to knock out three coins
BEQ NOCOIN


NEXT
DEY
BPL LOOP

                   JSL $02A9DE             ; \ get an index to an unused sprite slot, return if all slots full
                    BMI RETURN2          ; / after: Y has index of sprite being generated
	LDA $14		; \knock out one coin
	AND #$0A	;  |every few frames

BNE RETURN2
PHX
TYX

     	LDA $09		;\however many coins pop out
	DEC $0DBF	;/dec that many from coin counter
LDA #$01
STA $1DFC
	LDA #COIN 	;|Store sprite number
        STA $9E,x
        JSL $07F7D2               ;|Reset sprite properties
	LDA #$08             ; |store sprite status
        STA $14C8,x
   
        LDA Xgen,y              
        STA $AA,x         
	LDA RAM_MarioXPos
	STA RAM_SpriteXLo,x
	LDA RAM_MarioXPosHi
	STA RAM_SpriteXHi,x

	LDA RAM_MarioYPos
	CLC
	ADC #$00
	STA RAM_SpriteYLo,x
	LDA RAM_MarioYPosHi
	ADC #$00
	STA RAM_SpriteYHi,x


	LDA RAM_MarioXPos
	ADC #$0D
	STA RAM_SpriteXLo,x
 
	PLX
                    
NOCOIN
RETURN2
	
	RTS