#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#define PI 3.141592653589793238462643383279502884197169399375105820974944592307816406286

int main(int argc, char *argv[])
{
	char * filename;
	float angle;
	if (argc==2 || argc>3)
	{
		printf("usage: circletool [ball-n-chain-pendulum.asm angle]\n");
		return 1;
	}
	if (argc==1)
	{
		printf(
      "             180\n"
      "     135 _.-\"\"\"\"-._ 135\n"
      "       .          `.\n"
      "      /              \\\n"
      "     |                |\n"
			"  90 |                |90\n"
			"     |                |\n"
			"      \\              /\n"
			"    45 `._        _.'45\n"
			"          `-....-'\n"
			"             0\n"
			"Enter the angle you want (higher than 180 is valid, but not logical): ");
		scanf("%f", &angle);
		filename=(char*)malloc(1024);
		printf("Enter the filename (extension is required, but spaces are allowed): ");
		scanf(" ");//drop the newline
		gets(filename);
	}
	else
	{
		filename=argv[1];
		sscanf(argv[2], "%f", &angle);
	}
	if (angle<0) angle=90-angle;
	angle/=90;
	unsigned int offX[256];
	unsigned int offY[5256];
	for (int i=0;i<256;i++)
	{
		offX[i]=(int)(256*sin(angle*PI/2*sin(i*PI/256.0)));
		offY[i]=(int)(256*cos(angle*PI/2*sin(i*PI/256.0)));
	}
	FILE * file2=fopen(filename, "rt");
	if (!file2)
	{
		printf("invalid filename");
		return 1;
	}
	FILE * file=fopen("tmpasm.asm", "wt");
	char line[1024]="lard will rule over all!";
	while (strcmp(line, "HorzSineTable:\n"))
	{
		fgets(line, 1000, file2);
		fputs(line, file);
		if (feof(file2))
		{
			fclose(file);
			fclose(file2);
			remove("tmpasm.asm");
			printf("didn't find HorzSineTable: in the asm file");
			return 1;
		}
	}
	fclose(file2);
	for (int x=0;x<32;x++)
	{
		fprintf(file, "db ");
		for (int y=0;y<8;y++)
		{
			if (y) fprintf(file, ",");
			fprintf(file, "$%.2X,$%.2X", offX[x*8+y]%256, (offX[x*8+y]/256)%256);
		}
		fprintf(file, "\n");
	}
	fprintf(file, "VertSineTable:\n");
	for (int x=0;x<32;x++)
	{
		fprintf(file, "db ");
		for (int y=0;y<8;y++)
		{
			if (y) fprintf(file, ",");
			fprintf(file, "$%.2X,$%.2X", offY[x*8+y]%256, (offY[x*8+y]/256)%256);
		}
		fprintf(file, "\n");
	}
	fclose(file);
	remove(filename);
	rename("tmpasm.asm", filename);
	return 0;
}
