;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Pipe Dwelling Pitchin Chuck ;;
;;         by TheBiob          ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!Speed = $0C		; Speed of pipe chuck when coming out/going inside the pipe
!ProjectileSpeed = $18	; Speed of projectile the chuck throws
!TimeThrow = $70	; When to throw the baseball
!TimeDefault = $50	; When to stop throwing the baseball
!TimeLook = $20		; When he starts to look around
!TimeStunned = $80	; How long the chuck is stunned for.
!SprDistance = $20	; Distance the player has to be away from the sprite for it to come out of the pipe
!HitPoints = $02	; How often you need to stomp on the chuck for it to die minus 1

!HitSnd = $28		; Sound when stomped on. \ See https://www.smwcentral.net/?p=viewthread&t=6665 for values
!HitBnk = $1DFC		; Sound when stomped on. /

StateTime:
    db $18,$80,$18,$40
;       M   O   m   I
; How long the sprite is in each state
; States:
; M - Moving out of pipe
; m - Moving into pipe
; O - Out of pipe
; I - Inside pipe

TblBalls:
	db $01,$03,$05,$04

main:
	PHB : PHK : PLB
		JSR SprMain
	PLB : RTL

init:
	LDA #$03
	STA $1534,x
	LDA $E4,x
	CLC : ADC #$08
	STA $E4,x
	LDA $14E0,x
	ADC #$00
	STA $14E0,x
	LDA #$01
	STA $1504,x
	RTL

SprStates:
	dw -1			; Non-existent
	dw init			; Init
	dw Falling		; killed, falling offscreen
	dw Falling		; jumped on
	dw Falling_kill	; killed, spinjump
	dw SprMain_skip	; killed, lava
	dw Falling_kill	; killed, coin at level end
	dw SprMain_skip	; inside yoshis mouth
	dw SprMain_main	; main routine


Falling:
	JSL $01802A
	LDA $14D4,x
	XBA
	LDA $D8,x
	REP #$20
		STA $00
		LDA $1464
		CLC : ADC #$00E0
		CMP $00
		BCS +
	SEP #$20
.kill
	STZ $14C8,x
	RTS
+	SEP #$20
	JMP Graphics

SprMain:
	LDA $9D
	BNE .skip
	LDA $14C8,x
	ASL : TAY
	REP #$20
		LDA SprStates,y
		STA $0A
	SEP #$20
	JMP ($000A)
.main
	LDA $C2,x
	CMP #$03
	BNE +
	LDA $1540,x
	BNE +
	STZ $C2,x
+	LDY #$00
	JSR SubOffScreen
	JSR RunState
	;JSL $01803A
	LDA #$02
	STA $1570,x
	PHB : PHA : PLB
		PHK
		PEA.w .return-1
		PEA.w $B888
		JML $02C79D
.return
	PLB
	LDA $1570,x
	BNE .skip
	LDA #!TimeStunned
	STA $1540,x
	STZ $160E,x
	LDA $1534,x
	CMP #$02
	BNE .skip
	LDA #$01
	STA $1504,x
.skip
	JSR Graphics
	RTS

RunState:
	LDA $1534,x
	ASL : TAY
	REP #$20
		LDA .statepntr,y
		STA $0A
	SEP #$20
	JMP ($000A)

.statepntr
	dw InPipe
	dw Moving
	dw OutOfPipe
	dw Moving
	dw Reset

Reset:
	STZ $1534,x
InPipe:
	JSR CheckPlayerDist
	BCC .notnext
	DEC $1504,x
	BNE .notnext
	LDA #!Speed^$FF+1
	STA $AA,x
	LDA #$01
	STA $1602,x
	BRA NextState
.notnext
	RTS

Moving:
	DEC $1504,x
	BEQ NextState
	JSL $01801A
	RTS

OutOfPipe:
	DEC $1504,x
	BNE .notnext
	LDA #!Speed
	STA $AA,x
	STZ $1602,x
	BRA NextState
.notnext
	LDA $1504,x
	CMP #!TimeThrow
	BNE +
	JSR ThrowBall
	INC $1602,x
	RTS
+	CMP #!TimeDefault
	BNE +
	DEC $160E,x
	BMI ++
	LDY $1534,x
	LDA StateTime-1,y
	STA $1504,x
	LDA #$01
	STA $1602,x
	RTS
++	STZ $1602,x
	RTS
+	CMP #!TimeLook
	BNE .return
	JSL $01ACF9
	AND #$01
	BEQ .return
	LDA #$03
	STA $1602,x
.return
	RTS

NextState:
	INC $1534,x
	LDY $1534,x
	LDA StateTime-1,y
	STA $1504,x
	LDA $E4,x
	LSR #4
	AND #$03
	TAY
	LDA TblBalls,y
	STA $160E,x
	RTS

CheckPlayerDist:
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
		SEC : SBC $94
		BPL +
		EOR #$FFFF
		INC
+		CMP.w #!SprDistance
	SEP #$20
	RTS

CheckPlayerPos:
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
		SEC : SBC $94
	SEP #$20
	RTS

ThrowBall:
	LDY #$07
-	LDA $170B,y
	BEQ .empty
	DEY : BPL -
	RTS
.empty
	LDA #$0D
	STA $170B,y
	LDA $D8,x
	CLC : ADC #$08
	STA $1715,y
	LDA $14D4,x
	ADC #$00
	STA $1729,y
	LDA $E4,x
	CLC : ADC #$04
	STA $171F,y
	LDA $14E0,x
	ADC #$00
	STA $1733,y
	JSR CheckPlayerPos
	BCS +
	LDA #!ProjectileSpeed
	BRA ++
+	LDA #!ProjectileSpeed^$FF+1
++	STA $1747,y
	RTS

Frames:
	dw idle
	dw grab
	dw throw
	dw look

idle:
; XX = X offset
; YY = Y offset
; TT = Tile
; PP = YXPPCCCT properties
;       XX  YY  TT  PP
	db $0A,$10,$0D,$4B
	db $0A,$10,$0D,$4B
	db $FA,$09,$4E,$4B
	db $01,$00,$06,$4B

	db $FE,$10,$0D,$0B
	db $FE,$10,$0D,$0B
	db $06,$09,$4E,$0B
	db $FF,$00,$06,$0B
grab:
	db $00,$01,$5D,$4B
	db $00,$FF,$AD,$49
	db $FA,$09,$AE,$4B
	db $01,$00,$06,$4B

	db $07,$01,$5D,$0B
	db $07,$FF,$AD,$09
	db $06,$09,$AE,$0B
	db $FF,$00,$06,$0B
throw:
	db $0A,$09,$BD,$4B
	db $0A,$09,$BD,$4B
	db $FA,$09,$A4,$4B
	db $01,$00,$06,$4B

	db $FF,$09,$BD,$0B
	db $FF,$09,$BD,$0B
	db $06,$09,$A4,$0B
	db $FF,$00,$06,$0B
look:
	db $0A,$10,$0D,$4B
	db $0A,$10,$0D,$4B
	db $FA,$09,$4E,$4B
	db $01,$00,$0A,$4B

	db $FE,$10,$0D,$0B
	db $FE,$10,$0D,$0B
	db $06,$09,$4E,$0B
	db $FF,$00,$0A,$0B

Graphics:
	JSR GetDrawInfo
	JSR CheckPlayerPos
	PHP
	LDA $1602,x
	ASL : TAX : PLP
	REP #$20
		LDA Frames,x
		BCC .store
		CLC : ADC #$0010
.store	STA $0A
	SEP #$20
	PHY : TYA : LSR : LSR : TAY
	LDA #$00
	STA $0460,y
	STA $0461,y
	LDA #$02
	STA $0462,y
	STA $0463,y
	PLY
	LDX #$03
-	LDA ($0A)
	CLC : ADC $00
	STA $0300,y
	JSR next
	LDA ($0A)
	CLC : ADC $01
	STA $0301,y
	JSR next
	LDA ($0A)
	STA $0302,y
	JSR next
	LDA ($0A)
	STA $0303,y
	JSR next
	INY #4
	DEX : BPL -

	LDX $15E9
	LDA #$03
	LDY #$FF
	JSL $01B7B3
	RTS

next:
	INC $0A
	BNE +
	INC $0B
+	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GetDrawInfo - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetDrawInfo:
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$20
	SEC
	SBC $1A
	STA $00
	CLC
	ADC.w #$0040
	CMP.w #$0180
	SEP #$20
	LDA $01
	BEQ +
	LDA #$01
+	STA $15A0,x
	TDC
	ROL A
	STA $15C4,x
	BNE .Invalid

	LDA $14D4,x
	XBA
	LDA $1662,x
	AND #$20
	BEQ .CheckOnce
.CheckTwice
	LDA $D8,x
	REP #$21
	ADC.w #$001C
	SEC
	SBC $1C
	SEP #$20
	LDA $14D4,x
	XBA
	BEQ .CheckOnce
	LDA #$02
.CheckOnce
	STA $186C,x
	LDA $D8,x
	REP #$21
	ADC.w #$000C
	SEC
	SBC $1C
	SEP #$21
	SBC #$0C
	STA $01
	XBA
	BEQ .OnScreenY
	INC $186C,x
.OnScreenY
	LDY $15EA,x
	RTS
.Invalid
	PLA
	PLA
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SubOffScreen - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
SubOffScreen:
	LDA $15A0,x
	ORA $186C,x
	BEQ .Return2
	LDA $167A,x
	AND #$04
	BNE .Return2
	LDA $5B
	LSR A
	BCS .VerticalLevel
	LDA $D8,x
	ADC #$50
	LDA $14D4,x
	ADC #$00
	CMP #$02
	BCS .EraseSprite
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$21
	ADC .AddTable,y
	SEC
	SBC $1A
	CMP .CmpTable,y
.Common
	SEP #$20
	BCC .Return2
.EraseSprite
	LDA $14C8,x
	CMP #$08
	BCC .KillSprite
	LDY $161A,x
	CPY #$FF
	BEQ .KillSprite
	LDA $1938,y
	AND #$FE
	STA $1938,y
.KillSprite
	STZ $14C8,x
.Return2
	RTS
.VerticalLevel
	LDA $13
	LSR A
	BCS .CheckY
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$21
	ADC.w #$0040
	CMP.w #$0280
	BRA .Common
.CheckY
	LDA $14D4,x
	XBA
	LDA $D8,x
	REP #$20
	SBC $1C
	CLC
	ADC.w #$0070
	CMP.w #$01D0
	BRA .Common

.AddTable
	dw $0040,$0040,$0010,$0070
	dw $0090,$0050,$0080,$FFC0
.CmpTable
	dw $0170,$01E0,$01B0,$01D0
	dw $0230,$01B0,$0220,$0160


print "MAIN ",hex(main)
print "INIT ",hex(init)