;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Sparkling block effect
;  by TheBiob
; Description:
;  This invisible sprite will make a sparkle effect appear at it's location.
;  It will destroy itself once the block changes
;   If the extra bit is set you can place the sprite on air (25) as well
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!freeram_block = $7FC700 ; 24 bytes freeram

print "MAIN ",hex(main)
print "INIT ",hex(init)

main:
	PHB : PHK : PLB
		LDY #$00
		JSR SubOffScreen
	PLB
	JSR SpriteToBlock
	TXA : ASL : TAX
	JSR GetBlock
	CMP !freeram_block,x
	SEP #$30
	BNE .kill
	LDX $15E9
	LDA $13
	AND #$0F
	BNE .return
	PEA.w $0180CA-1
	JML $01B14E
.kill2
	SEP #$30
	LDA #$01
	STA $0EF9
.kill
	LDX $15E9
	STZ $14C8,x
.return
	RTL

init:
	JSR SpriteToBlock
	TXA : ASL : TAX
	JSR GetBlock
	CMP #$0025
	BNE .store
	TAY : PHX
	LDA $15E9
	AND #$00FF
	TAX
	LDA $7FAB10,x
	PLX
	AND #$0004
	BEQ main_kill2
	TYA
.store
	STA !freeram_block,x
	SEP #$30
	LDX $15E9
	RTL

SpriteToBlock:
	LDA $D8,x
	STA $98
	LDA $14D4,x
	STA $99
	LDA $E4,x
	STA $9A
	LDA $14E0,x
	STA $9B
	RTS

GetBlock:
	LDA $5B
	AND #$01
	TAY
	LDA #$20
	CPY #$01
	BCC .Horz0
	LDA #$1C
.Horz0		BIT $5B
	BPL .Layer1_0
	LSR A
.Layer1_0	CPY #$01
	BCC .Horz1
	CMP $99
	BCC .RangeOver
	LDA $9B
	CMP #$02
	BCC .Next
.RangeOver	REP #$30
	LDA #$FFFF
	RTS
.Horz1		CMP $9B
	BCC .RangeOver
	LDA $98
	CMP #$B0
	LDA $99
	SBC #$01
	BCS .RangeOver
.Next		LDA $1933
	REP #$21
	BEQ .Layer1_1
	TYA
	BEQ .Horz2
	LDA $98
	ADC.w #$0E00
	AND.w #$FFF0
	STA $67
	BRA +
.Horz2		LDA $98
	AND.w #$FFF0
	STA $67
	LDA $9A
	ADC.w #$1000
	BRA .Common0
.Layer1_1	LDA $98
	AND.w #$FFF0
	STA $67
+	LDA $9A
.Common0	SEP #$20
	LSR #4
	STA $65
	XBA
	CPY #$01
	BCC .Horz3
	STA $66
	ASL $68
	REP #$21
	LDA.w #$0000
	BRA .Common1
.Horz3		ASL A
	STA $4202
	LDA #$D8
	STA $4203
	NOP
	STZ $66
	REP #$21
	LDA $4216
.Common1	ADC $67
	ADC $65
	ADC.w #$C800
	STA $65
	SEP #$20
	LDA #$7F
	STA $67
	LDA [$65]
	XBA
	DEC $67
	LDA [$65]
	REP #$30
	RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SubOffScreen - Optimized version
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Argument
; Y : type (#$00=X0, #$02=X1 ... #$0E=X7)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
SubOffScreen:
	LDA $15A0,x
	ORA $186C,x
	BEQ .Return2
	LDA $167A,x
	AND #$04
	BNE .Return2
	LDA $5B
	LSR A
	BCS .VerticalLevel
	LDA $D8,x
	ADC #$50
	LDA $14D4,x
	ADC #$00
	CMP #$02
	BCS .EraseSprite
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$21
	ADC .AddTable,y
	SEC
	SBC $1A
	CMP .CmpTable,y
.Common
	SEP #$20
	BCC .Return2
.EraseSprite
	LDA $14C8,x
	CMP #$08
	BCC .KillSprite
	LDY $161A,x
	CPY #$FF
	BEQ .KillSprite
	LDA $1938,y
	AND #$FE
	STA $1938,y
.KillSprite
	STZ $14C8,x
.Return2
	RTS
.VerticalLevel
	LDA $13
	LSR A
	BCS .CheckY
	LDA $14E0,x
	XBA
	LDA $E4,x
	REP #$21
	ADC.w #$0040
	CMP.w #$0280
	BRA .Common
.CheckY
	LDA $14D4,x
	XBA
	LDA $D8,x
	REP #$20
	SBC $1C
	CLC
	ADC.w #$0070
	CMP.w #$01D0
	BRA .Common

.AddTable
	dw $0040,$0040,$0010,$0070
	dw $0090,$0050,$0080,$FFC0
.CmpTable
	dw $0170,$01E0,$01B0,$01D0
	dw $0230,$01B0,$0220,$0160