;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Kirby's Dreamland 3 Tick
; Programmed by SMWEdit
;
; Uses first extra bit: NO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		NO_SEEK_TIME_SPIKE = $60	; time after extending spike to not face mario or extend spike
		NO_SEEK_TIME_WALL = $40		; time after hitting wall to not face mario or extend spike
		SPIKERANGE = $04		; how close it needs to be to extend spike

;;RAM addresses, don't change these:

		FRAMENUM = $1602
		SPIKETMR = $163E
		NOSEEKTMR = $1540
		HOLDSPIKETMR = $1558

		TMP1 = $00

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; INIT and MAIN JSL targets
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		dcb "INIT"
		JSR SUB_HORZ_POS	; \
		TYA			;  | face mario
		STA $157C,x		; /
		RTL		

		dcb "MAIN"			
		PHB
		PHK				
		PLB				
		JSR SPRITE_ROUTINE	
		PLB
		RTL     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPRITE_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPEED_TABLE	dcb $08,$F8

INTERACTHEIGHT	dcb $01,$01,$01,$01

		dcb $01,$01,$01,$01
		dcb $01,$01,$01,$01
		dcb $01,$01,$01,$01
		dcb $01,$01,$01,$01

		dcb $01,$01,$01,$01
		dcb $01,$01,$01,$01
		dcb $01,$02,$02,$02
		dcb $04,$04,$04,$04
		dcb $04,$04,$04,$04
		dcb $04,$04,$04,$04
		dcb $04,$04,$04,$04
		dcb $04,$04,$04,$04
		dcb $04,$04,$04,$04
		dcb $02,$02,$02,$01
		dcb $01,$01,$01,$01
		dcb $01,$01,$01,$01

RETURN1		RTS

SPRITE_ROUTINE	JSR SUB_GFX		; \  return if
		LDA $14C8,x		;  | sprite status
		CMP #$08		; /  is not 8
		BNE RETURN1		; \  return if
		LDA $9D			;  | sprites
		BNE RETURN1		; /  are locked
		LDA $15D0,x		; \ return if
		BNE RETURN1		; / being eaten
		JSR SUB_OFF_SCREEN_X0	; only process sprite while on screen

		LDA $187A		; \ don't shift
		BEQ NOYOSHI1		; / if not on Yoshi
		LDA $96			; \
		PHA			;  | offset Y
		CLC			;  | position by
		ADC #$10		;  | #$10 and
		STA $96			;  | back it up
		LDA $97			;  | in the
		PHA			;  | process
		ADC #$00		;  |
		STA $97			; /
NOYOSHI1
		STZ $B6,x		; X speed is zero, unless it's set later in the code

		LDA SPIKETMR,x		; \  jump to spike
		BEQ NOTHAVESPIKE	;  | code if spike is
		JMP HASSPIKE		; /  extended
NOTHAVESPIKE

		LDA $D8,x		; \
		SEC			;  | walking or
		SBC $96			;  | standing
		STA TMP1		;  | still
		LDA $14D4,x		;  | depending
		SBC $97			;  | on relative
		BMI STANDINGSTILL	;  | Y position
		BNE WALKING		;  |
		LDA TMP1		;  |
		CMP #$18		;  |
		BCS WALKING		; /

STANDINGSTILL
		LDA $1588,x		; \
		AND #$03		;  | if the sprite
		BEQ DONT_CHANGE_DIR	;  | is hitting a
		LDA $157C,x		;  | wall, then flip
		EOR #$01		;  | its direction
		STA $157C,x		; /		 
DONT_CHANGE_DIR
		JSR SUB_HORZ_POS	; \
		TYA			;  | face mario
		STA $157C,x		; /
		LDA FRAMENUM,x		; \
		CMP #STILLFRAMES-1	;  | cycle through
		BCS RESETSTILL		;  | indexes to
		INC FRAMENUM,x		;  | frame data
		BRA NORESETSTILL	;  |
RESETSTILL	STZ FRAMENUM,x		; /
NORESETSTILL
		STZ NOSEEKTMR,x		; end seek-disable timer
		BRA AFTERMAINCODE	; don't execute code for other modes

WALKING
		LDA $1588,x			; \  don't update
		AND #%00000100			;  | frame number
		BEQ AFTERWALK			; /  if in air
		LDA FRAMENUM,x			; \
		CMP #WALKFRAMES+STILLFRAMES-1	;  | cycle through
		BCS RESETWALK			;  | indexes to
		INC FRAMENUM,x			;  | frame data
		BRA NORESETWALK			;  |
RESETWALK	LDA #STILLFRAMES		;  |
		STA FRAMENUM,x			; /
NORESETWALK
AFTERWALK
		LDA $1588,x		; \  check if sprite
		AND #%00000011		;  | is touching
 		BEQ DONT_CHANGE_DIR_2	; /  object side
		LDA $157C,x		; \  flip
		EOR #%00000001		;  | sprite
		STA $157C,x		; / direction
NO_FLIP
		LDA #NO_SEEK_TIME_WALL	; \ set timer to pause
		STA NOSEEKTMR,x		; / following/spiking
DONT_CHANGE_DIR_2
		LDY $157C,x		; \  set X
		LDA SPEED_TABLE,y	;  | speed
		STA $B6,x		; /
		LDA NOSEEKTMR,x		; \ don't execute following code
		BNE NO_SPIKE_OR_FLIP	; / if timer still going
		JSR SUB_HORZ_POS	; \
		TYA			;  | face mario
		STA $157C,x		; /
		LDA $14E0,x		; \
		CMP $95			;  | if sprite
		BNE NOSPIKE		;  | is close
		LDA $E4,x		;  | enough to
		SEC			;  | mario, then
		SBC $94			;  | start
		BPL CHECKX		;  | extending
		EOR #%11111111		;  | its spike
		INC A			;  |
CHECKX		CMP #SPIKERANGE		;  |
		BCS NOSPIKE		;  |
		LDA #SPIKEFRAMES	;  |
		STA SPIKETMR,x		; /
NOSPIKE
NO_SPIKE_OR_FLIP
		BRA AFTERMAINCODE	; don't execute code for other modes

HASSPIKE	LDA #SPIKEFRAMES		; \
		SEC				;  | set frame
		SBC SPIKETMR,x			;  | according
		CLC				;  | to how
		ADC #STILLFRAMES+WALKFRAMES	;  | much time
		STA FRAMENUM,x			;  | is left
		LDA #NO_SEEK_TIME_SPIKE		;  |
		STA NOSEEKTMR,x			; /

AFTERMAINCODE

		LDA $187A		; \ don't load backup
		BEQ NOYOSHI2		; / if not on Yoshi
		PLA			; \
		STA $97			;  | load backed
		PLA			;  | up Y position
		STA $96			; /
NOYOSHI2
		JSL $01802A		; update position based on speed values
		JSL $018032		; interact with other sprites
		;;JSL $01A7DC		; check for mario/sprite contact
		LDA $E4,x		; \
		PHA			;  | back up sprite's
		LDA $14E0,x		;  | position so I
		PHA			;  | can shift it
		LDA $D8,x		;  | around temporarily
		PHA			;  |
		LDA $14D4,x		;  |
		PHA			; /
		LDY FRAMENUM,x		; \  load interaction
		LDA INTERACTHEIGHT,y	;  | height into Y in
		TAY			; /  preparation for loop
INTERACTLOOP	CPY #$00		; \
		BEQ ENDINTERACT		;  | create
		PHY			;  | interaction
		JSL $01A7DC		;  | fields
		PLY			;  |
		LDA $D8,x		;  |
		SEC			;  |
		SBC #$10		;  |
		STA $D8,x		;  |
		LDA $14D4,x		;  |
		SBC #$00		;  |
		STA $14D4,x		;  |
		DEY			;  |
		BRA INTERACTLOOP	; /
ENDINTERACT	PLA			; \
		STA $14D4,x		;  | load backed up
		PLA			;  | sprite position
		STA $D8,x		;  |
		PLA			;  |
		STA $14E0,x		;  |
		PLA			;  |
		STA $E4,x		; /
RETURN		RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GRAPHICS ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		STILLFRAMES = $04		; amount of still frames
		WALKFRAMES = $10		; amount of walking frames
		SPIKEFRAMES = $30		; amount of spiking frames

		ADDRTEMP = $04
		FRAMETMP = $06
		PROP_TMP = $07
		COUNT_TMP = $08
		TILESDRAWN = $09

INDEXES		dcb $00,$00,$02,$02

		dcb $04,$04,$04,$04
		dcb $06,$06,$06,$06
		dcb $04,$04,$04,$04
		dcb $08,$08,$08,$08

		dcb $06,$06,$06,$04
		dcb $04,$04,$08,$08
		dcb $08,$0A,$0A,$0A
		dcb $0C,$0C,$0C,$0C
		dcb $0C,$0C,$0C,$0C
		dcb $0C,$0C,$0C,$0C
		dcb $0C,$0C,$0C,$0C
		dcb $0C,$0C,$0C,$0C
		dcb $0C,$0C,$0C,$0C
		dcb $0A,$0A,$0A,$08
		dcb $08,$08,$04,$04
		dcb $04,$06,$06,$06

COUNT		dcb $03,$04,$03,$02,$03,$03,$04
TILES		dcw TILES1&$FFFF,TILES2&$FFFF,TILES3&$FFFF,TILES4&$FFFF
		dcw TILES5&$FFFF,TILES6&$FFFF,TILES7&$FFFF
XDISP		dcw XDISP1&$FFFF,XDISP2&$FFFF,XDISP3&$FFFF,XDISP4&$FFFF
		dcw XDISP5&$FFFF,XDISP6&$FFFF,XDISP7&$FFFF
YDISP		dcw YDISP1&$FFFF,YDISP2&$FFFF,YDISP3&$FFFF,YDISP4&$FFFF
		dcw YDISP5&$FFFF,YDISP6&$FFFF,YDISP7&$FFFF
SIZES		dcw SIZES1&$FFFF,SIZES2&$FFFF,SIZES3&$FFFF,SIZES4&$FFFF
		dcw SIZES5&$FFFF,SIZES6&$FFFF,SIZES7&$FFFF
PROPS		dcw PROPS1&$FFFF,PROPS2&$FFFF,PROPS3&$FFFF,PROPS4&$FFFF
		dcw PROPS5&$FFFF,PROPS6&$FFFF,PROPS7&$FFFF

TILES1		dcb $89,$8A,$AA
XDISP1		dcb $FC,$04,$04
YDISP1		dcb $00,$00,$F8
SIZES1		dcb $02,$02,$00
PROPS1		dcb $00,$00,$00

TILES2		dcb $8C,$82,$92,$AA
XDISP2		dcb $FC,$0C,$0C,$04
YDISP2		dcb $00,$00,$08,$F8
SIZES2		dcb $02,$00,$00,$00
PROPS2		dcb $00,$00,$00,$00

TILES3		dcb $80,$81,$AA
XDISP3		dcb $FC,$04,$04
YDISP3		dcb $00,$00,$F8
SIZES3		dcb $02,$02,$00
PROPS3		dcb $00,$00,$00

TILES4		dcb $83,$84
XDISP4		dcb $FC,$04
YDISP4		dcb $00,$00
SIZES4		dcb $02,$02
PROPS4		dcb $00,$00

TILES5		dcb $86,$87,$BA
XDISP5		dcb $FC,$04,$04
YDISP5		dcb $00,$00,$F8
SIZES5		dcb $02,$02,$00
PROPS5		dcb $00,$00,$00

TILES6		dcb $8E,$8E,$A0
XDISP6		dcb $F9,$08,$00
YDISP6		dcb $00,$00,$F0
SIZES6		dcb $02,$02,$02
PROPS6		dcb $00,$40,$00

TILES7		dcb $A2,$A4,$A6,$A8
XDISP7		dcb $00,$00,$00,$00
YDISP7		dcb $00,$F0,$E0,$D0
SIZES7		dcb $02,$02,$02,$02
PROPS7		dcb $00,$00,$00,$00

SUB_GFX		JSR GET_DRAW_INFO
		STZ TILESDRAWN		; zero tiles drawn
		PHY			; \
		LDY FRAMENUM,x		;  | store index for
		LDA INDEXES,y		;  | frame data to
		STA FRAMETMP		;  | scratch RAM
		LSR A			;  |
		TAY			;  | ... then set
		LDA COUNT,y		;  | number of tiles
		STA COUNT_TMP		;  | for this wing
		PLY			; /

		PHX			; back up X
		LDX #$00		; load X with zero
TILELP		CPX COUNT_TMP		; end of loop?
		BNE NORETFRML		; if so, then end
		JMP RETFRML
NORETFRML
		PHY			; \
		LDY FRAMETMP		;  | get X
		LDA XDISP,y		;  | offset
		STA ADDRTEMP		;  | for this
		LDA XDISP+1,y		;  | tile and
		STA ADDRTEMP+1		;  | flip it
		TXY			;  | if the
		LDA (ADDRTEMP),y	;  | sprite is
		PHX			;  | flipped
		LDX $15E9		;  |
		LDY $157C,x		;  |
		BNE NO_FLIP_X		;  |
		EOR #%11111111		;  |
		INC A			;  |
		INC A			;  | ... and add one more than normal
NO_FLIP_X	PLX			;  | because sprite has odd # width
		PLY			; /
		CLC			; \ add it to sprite's
		ADC $00			; / screen X offset
		STA $0300,y		; set tile's X position
		PHY			; \
		LDY FRAMETMP		;  | get Y
		LDA YDISP,y		;  | offset
		STA ADDRTEMP		;  | for this
		LDA YDISP+1,y		;  | tile
		STA ADDRTEMP+1		;  |
		TXY			;  |
		LDA (ADDRTEMP),y	;  |
		PLY			; /
		CLC			; \ add it to sprite's
		ADC $01			; / screen Y offset
		STA $0301,y		; set tile's Y position
		PHY			; \
		LDY FRAMETMP		;  | get
		LDA TILES,y		;  | tile
		STA ADDRTEMP		;  | number
		LDA TILES+1,y		;  |
		STA ADDRTEMP+1		;  |
		TXY			;  |
		LDA (ADDRTEMP),y	;  |
		PLY			; /
		STA $0302,y		; set tile #
		PHY			; \
		LDY FRAMETMP		;  | get
		LDA SIZES,y		;  | tile
		STA ADDRTEMP		;  | size
		LDA SIZES+1,y		;  |
		STA ADDRTEMP+1		;  |
		TXY			;  |
		LDA (ADDRTEMP),y	;  |
		PLY			; /
		PHX			; back up X
		PHA			; \
		TYA			;  | get index to
		LSR A			;  | extra tile
		LSR A			;  | properties
		TAX			;  |
		PLA			; /
		STA $0460,x		; set tile size
		PLX			; load backed up X
		CMP #$02		; \
		BEQ NO_ADD_8		;  | if the
		PHX			;  | tile is
		LDX $15E9		;  | flipped
		LDA $157C,x		;  | and it
		PLX			;  | is an 8x8
		CMP #$00		;  | then add
		BNE NO_ADD_8		;  | 8 to its
		LDA $0300,y		;  | X position
		CLC			;  | to fix a
		ADC #$08		;  | glitch
		STA $0300,y		; /
NO_ADD_8	PHY			; \
		LDY FRAMETMP		;  | get Y
		LDA PROPS,y		;  | offset
		STA ADDRTEMP		;  | for this
		LDA PROPS+1,y		;  | tile
		STA ADDRTEMP+1		;  |
		TXY			;  |
		LDA (ADDRTEMP),y	;  |
		PLY			; /
		STA PROP_TMP
		PHX			; back up X (index to tile data)
		LDX $15E9		; load X with index to sprite
		LDA $15F6,x		; load palette info
		PHY			; \
		LDY $157C,x		;  | flip the tile
		BNE NO_FLIP_X_2		;  | if the sprite
		ORA #%01000000		;  | is flipped
NO_FLIP_X_2	PLY			; /
		PLX			; load backed up X
		EOR PROP_TMP
		ORA $64			; add in priority bits
		STA $0303,y		; set extra info
		INY			; \
		INY			;  | index to next slot
		INY			;  |
		INY			; /
		INX			; next tile to draw
		INC TILESDRAWN		; another tile drawn
		JMP TILELP		; loop
RETFRML		PLX			; load backed up X

		LDY #$FF		; #$FF means don't define sizes here
		LDA TILESDRAWN		; \ number of tiles
		DEC A			; / minus one
		JSL $01B7B3		; don't draw if offscreen
		RTS



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; ROUTINES FROM THE LIBRARY ARE PASTED BELOW
; You should never have to modify this code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GET_DRAW_INFO
; This is a helper for the graphics routine.  It sets off screen flags, and sets up
; variables.  It will return with the following:
;
;       Y = index to sprite OAM ($300)
;       $00 = sprite x position relative to screen boarder
;       $01 = sprite y position relative to screen boarder  
;
; It is adapted from the subroutine at $03B760
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPR_T1              dcb $0C,$1C
SPR_T2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC SPR_T1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA SPR_T2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_OFF_SCREEN
; This subroutine deals with sprites that have moved off screen
; It is adapted from the subroutine at $01AC0D
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    
SPR_T12             dcb $40,$B0
SPR_T13             dcb $01,$FF
SPR_T14             dcb $30,$C0,$A0,$C0,$A0,$F0,$60,$90		;bank 1 sizes
		            dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0		;bank 3 sizes
SPR_T15             dcb $01,$FF,$01,$FF,$01,$FF,$01,$FF		;bank 1 sizes
					dcb $01,$FF,$01,$FF,$01,$00,$01,$FF		;bank 3 sizes

SUB_OFF_SCREEN_X1   LDA #$02                ; \ entry point of routine determines value of $03
                    BRA STORE_03            ;  | (table entry to use on horizontal levels)
SUB_OFF_SCREEN_X2   LDA #$04                ;  | 
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X3   LDA #$06                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X4   LDA #$08                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X5   LDA #$0A                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X6   LDA #$0C                ;  |
                    BRA STORE_03            ;  |
SUB_OFF_SCREEN_X7   LDA #$0E                ;  |
STORE_03			STA $03					;  |            
					BRA START_SUB			;  |
SUB_OFF_SCREEN_X0   STZ $03					; /

START_SUB           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_35           ; /
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0756 VC:176 00 FL:205
                    AND #$01                ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0780 VC:176 00 FL:205
                    ORA $03                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0796 VC:176 00 FL:205
                    STA $01                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0820 VC:176 00 FL:205
                    TAY                     ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0844 VC:176 00 FL:205
                    LDA $1A                 ;A:8A01 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizcHC:0858 VC:176 00 FL:205
                    CLC                     ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0882 VC:176 00 FL:205
                    ADC SPR_T14,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZcHC:0896 VC:176 00 FL:205
                    ROL $00                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizcHC:0928 VC:176 00 FL:205
                    CMP $E4,x               ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:0966 VC:176 00 FL:205
                    PHP                     ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:0996 VC:176 00 FL:205
                    LDA $1B                 ;A:8AC0 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizCHC:1018 VC:176 00 FL:205
                    LSR $00                 ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdiZCHC:1042 VC:176 00 FL:205
                    ADC SPR_T15,y           ;A:8A00 X:0009 Y:0001 D:0000 DB:01 S:01F0 P:envMXdizcHC:1080 VC:176 00 FL:205
                    PLP                     ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F0 P:eNvMXdizcHC:1112 VC:176 00 FL:205
                    SBC $14E0,x             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1140 VC:176 00 FL:205
                    STA $00                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1172 VC:176 00 FL:205
                    LSR $01                 ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:eNvMXdizCHC:1196 VC:176 00 FL:205
                    BCC SPR_L31             ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1234 VC:176 00 FL:205
                    EOR #$80                ;A:8AFF X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdiZCHC:1250 VC:176 00 FL:205
                    STA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1266 VC:176 00 FL:205
SPR_L31             LDA $00                 ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1290 VC:176 00 FL:205
                    BPL RETURN_35           ;A:8A7F X:0009 Y:0001 D:0000 DB:01 S:01F1 P:envMXdizCHC:1314 VC:176 00 FL:205
ERASE_SPRITE        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /    
                    LDY $161A,x             ;A:FF08 X:0007 Y:0001 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1108 VC:059 00 FL:2878
                    CPY #$FF                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZCHC:1140 VC:059 00 FL:2878
                    BEQ KILL_SPRITE         ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1156 VC:059 00 FL:2878
                    LDA #$00                ;A:FF08 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdizcHC:1172 VC:059 00 FL:2878
                    STA $1938,y             ;A:FF00 X:0007 Y:0000 D:0000 DB:01 S:01F3 P:envMXdiZcHC:1188 VC:059 00 FL:2878
KILL_SPRITE         STZ $14C8,x             ; erase sprite
RETURN_35           RTS                     ; return

VERTICAL_LEVEL      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_35           ; /
                    LDA $13                 ; \
                    LSR A                   ; | 
                    BCS RETURN_35           ; /
                    LDA $E4,x               ; \ 
                    CMP #$00                ;  | if the sprite has gone off the side of the level...
                    LDA $14E0,x             ;  |
                    SBC #$00                ;  |
                    CMP #$02                ;  |
                    BCS ERASE_SPRITE        ; /  ...erase the sprite
                    LDA $13                 ;A:0000 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:1218 VC:250 00 FL:5379
                    LSR A                   ;A:0016 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1242 VC:250 00 FL:5379
                    AND #$01                ;A:000B X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1256 VC:250 00 FL:5379
                    STA $01                 ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1272 VC:250 00 FL:5379
                    TAY                     ;A:0001 X:0009 Y:00E4 D:0000 DB:01 S:01F3 P:envMXdizcHC:1296 VC:250 00 FL:5379
                    LDA $1C                 ;A:001A X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0052 VC:251 00 FL:5379
                    CLC                     ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0076 VC:251 00 FL:5379
                    ADC SPR_T12,y           ;A:00BD X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0090 VC:251 00 FL:5379
                    ROL $00                 ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:enVMXdizCHC:0122 VC:251 00 FL:5379
                    CMP $D8,x               ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0160 VC:251 00 FL:5379
                    PHP                     ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0190 VC:251 00 FL:5379
                    LDA.W $001D             ;A:006D X:0009 Y:0001 D:0000 DB:01 S:01F2 P:eNVMXdizcHC:0212 VC:251 00 FL:5379
                    LSR $00                 ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdiZcHC:0244 VC:251 00 FL:5379
                    ADC SPR_T13,y           ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:enVMXdizCHC:0282 VC:251 00 FL:5379
                    PLP                     ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F2 P:envMXdiZCHC:0314 VC:251 00 FL:5379
                    SBC $14D4,x             ;A:0000 X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNVMXdizcHC:0342 VC:251 00 FL:5379
                    STA $00                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0374 VC:251 00 FL:5379
                    LDY $01                 ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0398 VC:251 00 FL:5379
                    BEQ SPR_L38             ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0422 VC:251 00 FL:5379
                    EOR #$80                ;A:00FF X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0438 VC:251 00 FL:5379
                    STA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0454 VC:251 00 FL:5379
SPR_L38             LDA $00                 ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0478 VC:251 00 FL:5379
                    BPL RETURN_35           ;A:007F X:0009 Y:0001 D:0000 DB:01 S:01F3 P:envMXdizcHC:0502 VC:251 00 FL:5379
                    BMI ERASE_SPRITE        ;A:8AFF X:0002 Y:0000 D:0000 DB:01 S:01F3 P:eNvMXdizcHC:0704 VC:184 00 FL:5490

SUB_IS_OFF_SCREEN   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / return


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SUB_HORZ_POS
; This routine determines which side of the sprite Mario is on.  It sets the Y register
; to the direction such that the sprite would face Mario
; It is ripped from $03B817
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_HORZ_POS		LDY #$00				;A:25D0 X:0006 Y:0001 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1020 VC:097 00 FL:31642
					LDA $94					;A:25D0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZCHC:1036 VC:097 00 FL:31642
					SEC                     ;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1060 VC:097 00 FL:31642
					SBC $E4,x				;A:25F0 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizCHC:1074 VC:097 00 FL:31642
					STA $0F					;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1104 VC:097 00 FL:31642
					LDA $95					;A:25F4 X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1128 VC:097 00 FL:31642
					SBC $14E0,x				;A:2500 X:0006 Y:0000 D:0000 DB:03 S:01ED P:envMXdiZcHC:1152 VC:097 00 FL:31642
					BPL SPR_L16             ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1184 VC:097 00 FL:31642
					INY                     ;A:25FF X:0006 Y:0000 D:0000 DB:03 S:01ED P:eNvMXdizcHC:1200 VC:097 00 FL:31642
SPR_L16				RTS                     ;A:25FF X:0006 Y:0001 D:0000 DB:03 S:01ED P:envMXdizcHC:1214 VC:097 00 FL:31642


