;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Uses first extra bit: NO
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	RAM_IsDucking 	= $73 
	RAM_OnYoshi	= $187A

	RAM_MarioXPos	= $94 
	RAM_MarioXPosHi	= $95 
	RAM_MarioYPos	= $96 
	RAM_MarioYPosHi	= $97

	RAM_SpriteYHi	= $14D4
	RAM_SpriteXHi	= $14E0
	RAM_SpriteYLo	= $D8
	RAM_SpriteXLo	= $E4

	RAM_MarioDir 	= $76 
	RAM_SpriteDir	= $157C 


	LASER = $05		; custom sprite # for laser_projectile.cfg
	BOMB = $04		; custom sprite # for mbomb.cfg
	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

t_PROPFLASH:
	dcb $00,$02,$04,$06,$08,$0A,$0C,$0E
                    
dcb "INIT"              ;generators don't have an init routine
		
dcb "MAIN"                                    
	PHB                     
	PHK                     
	PLB 
      
	LDA $19			;if Mario isn't big, return		
	CMP #$01		
	BEQ PowerUpCheck	;check for powerups		
	LDA #$00		
	STA $0DC6		;reset powerup RAM if not big
		
PowerUpCheck          
        JSR SPRITE_CODE_START   
        PLB                     
        RTL      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                 EXTRA_BITS = $7FAB10

Return_A	RTS

SPRITE_CODE_START
	LDA $187A
	BNE Return_A
	LDA $73
	BNE Return_A
	LDA $75
	BNE Return_A	
	LDA $0DC6
	CMP #$0A
	BEQ Haste
	RTS
Haste
	;JSR Palette
	LDA $77
	AND #$03
	BNE Return
	LDA $15
	AND #$40
	BEQ Return
	LDA $15		
	AND #$03	
	BEQ Return	
	LDA $77		
	AND #$04	
	BEQ Return	;doesnt work on yoshi
	LDA $187A
	BNE Return	;
	LDA $76			;if mario's going left..
	BEQ DashLeft
	BRA DashRight		;or right..
	RTS

DashLeft:
	LDA #$03
	STA $1490
	LDA #$0D
	STA $13E0
	LDA #$C7
	STA $7B
	LDA $14		; \
	AND #$03	;  | play sound effect every 4 frames
	BNE Return	;  |
	LDA #$4D	;  |
	STA $1DFC	; /
	JSL $01AB99
	BRA Return
	RTS
DashRight:
	LDA #$03
	STA $1490
	LDA #$0D
	STA $13E0
	LDA #$2F
	STA $7B
	LDA $14		; \
	AND #$03	;  | play sound effect every 4 frames
	BNE Return	;  |
	LDA #$4D	;  |
	STA $1DFC	; /
	JSL $01AB99
	BRA Return
	RTS
Return
	RTS

Palette
	LDY #$87	
	STY $2121 	
	LDA #$1D	
	STA $2122 	
	LDA #$58
	STA $2122

	LDY #$88	
	STY $2121 	
	LDA #$88	
	STA $2122 	
	LDA #$00
	STA $2122

	LDY #$89	
	STY $2121 	
	LDA #$FF	
	STA $2122 	
	LDA #$03
	STA $2122

	LDY #$8A	
	STY $2121 	
	LDA #$AB	
	STA $2122 	
	LDA #$24
	STA $2122

	LDY #$8B	
	STY $2121 	
	LDA #$34	
	STA $2122 	
	LDA #$45
	STA $2122

	LDY #$8C	
	STY $2121 	
	LDA #$D8	
	STA $2122 	
	LDA #$59
	STA $2122

	LDY #$8D	
	STY $2121 	
	LDA #$39	
	STA $2122 	
	LDA #$1A
	STA $2122

	LDY #$8E	
	STY $2121 	
	LDA #$DF
	STA $2122 	
	LDA #$35
	STA $2122

	LDY #$8F	
	STY $2121 	
	LDA #$FF	
	STA $2122 	
	LDA #$03
	STA $2122
	RTS

