;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Bully from SM64
;
;Uses first extra bit: YES
;Clear	; Small Bully
;Set	; Big Bully
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			incsrc definition.asm

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite data		;
;;;;;;;;;;;;;;;;;;;;;;;;;

TILE_MAP		dcb $88,$A8				;small
			dcb $80,$82,$A0,$A2,$84,$86,$A4,$A6	;big
TILE_PROP		dcb $43,$03
HORZ_DISP		dcb $00,$10,$00,$10

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Don't change these.

VERT_DISP		dcb $F0,$F0,$00,$00,$03
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_SPEED			dcb $18,$E8
X_SPEED_2		dcb $28,$D8
MARIO_SPEED		dcb $B8,$48
MARIO_SPEED_2		dcb $E0,$20
SPEED_TABLE		dcb $FF,$01

MARIO_POS_CHECK		dcw $FFE8,$FFD8

;;;;;;;;;;;;;;;;;;;;;;;;;
;INIT & MAIN		;
;;;;;;;;;;;;;;;;;;;;;;;;;

			dcb "INIT"
			JSR SUB_HORZ_POS
			SEP #$20
			TYA
			STA $157C,x
			LDA $7FAB10,x
			AND #$04
			BEQ INIT_END
			LDA #$02
			STA $1602,x
			LDA #$0E
			STA $1656,x
			LDA #$30
			STA $1662,x
INIT_END		RTL

			dcb "MAIN"
			PHB
			PHK
			PLB
			JSR SPRITE_ROUTINE
			JSR SPRITE_GFX
			PLB
			RTL

;;;;;;;;;;;;;;;;;;;;;;;;;
;Main sprite routine	;
;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN			RTS
SPRITE_ROUTINE		LDA $14C8,x
			CMP #$08
			BNE RETURN
			LDA $9D
			BNE RETURN
			JSR SubOffScreen
			INC $1570,x

			JSR SUB_HORZ_POS
			SEP #$20
			TYA
			CMP $157C,x
			BEQ NOT_CHANGE_DIR
			LDA $151C,x
			AND #$02
			BNE NOT_CHANGE_DIR
			LDA $157C,x
			ORA #$02
			STA $151C,x

NOT_CHANGE_DIR		LDA $151C,x
			AND #$02
			BEQ WALKING
			LDA $151C,x
			AND #$01
			TAY
			LDA $B6,x
			BEQ SPEED_ZERO
			CLC
			ADC SPEED_TABLE,y
			STA $B6,x
			BRA UPDATE
SPEED_ZERO		LDA $1588,x
			AND #$04
			BEQ UPDATE
			LDA $154C,x
			BNE UPDATE
			STZ $151C,x
			JSR SUB_HORZ_POS
			SEP #$20
			TYA
			STA $157C,x

WALKING			LDY $157C,x
			LDA X_SPEED,y
			STA $B6,x

UPDATE			LDA $1602,x
			BNE BIG_BULLY
			JSL $01802A
			BRA ON_GROUND
BIG_BULLY		LDA $1588,x
			AND #$04
			PHA
			JSL $01802A
			LDA $1588,x
			AND #$04
			BEQ IN_AIR
			STZ $AA,x
			PLA
			BRA ON_GROUND
IN_AIR			PLA
			BEQ WAS_IN_AIR
			LDA #$08
			STA $1540,x
WAS_IN_AIR		LDA $1540,x
			BEQ ON_GROUND
			STZ $AA,x

ON_GROUND		LDA $1588,x
			AND #$03
			BEQ CONTACT_CHECK
			AND #$01
			ORA #$02
			STA $151C,x
			LDA $B6,x
			EOR #$FF
			INC A
			STA $B6,x
			LDA #$02
CONTACT_CHECK		LDA $154C,x
			BNE NOT_CONTACT
			JSL $01A7DC
			BCC NOT_CONTACT
			LDA #$28
			STA $1DFC
			LDA #$18
			STA $154C,x
			JSR SUB_HORZ_POS
			SEP #$20
			TYA
			EOR #$01
			TAY
			ORA #$02
			STA $151C,x
			STY $0D
			JSR SUB_VERT_POS
			LDY $187A,x
			BEQ NOT_RIDING_ON_YOSHI
			CLC
			ADC.w #$0010
NOT_RIDING_ON_YOSHI	LDY $1602,x
			CMP MARIO_POS_CHECK,y
			SEP #$20
			BPL SPRITE_WINS
			LDA $7D
			BMI SPRITE_WINS
MARIO_WINS		INC $0D
			INC $0D
SPRITE_WINS		LDY $0D
			LDA MARIO_SPEED,y
			STA $7B
			LDA X_SPEED,y
			STA $B6,x
NOT_CONTACT		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite GFX		;
;;;;;;;;;;;;;;;;;;;;;;;;;

SPRITE_GFX		STZ $0F

			LDA $1602,x
			STA $0E

			LDA $1570,x
			LSR A
			LSR A
			AND #$01
			LDY $151C,x
			BEQ ANIME_1
			LDA #$00
ANIME_1			LDY $0E
			BEQ ANIME_2
			ASL A
			ASL A
ANIME_2			STA $03
			LDA $157C,x
			STA $02

			JSR GetDrawInfo

			PHX
			PHY
			LDY $0E
			LDX $02+VERT_DISP,y
			PLY

GFX_LOOP		PHX
			LDA HORZ_DISP,x
			LDX $0E
			BEQ NO_FLIP_HORZ
			LDX $02
			BNE NO_FLIP_HORZ
			EOR #$10
NO_FLIP_HORZ		CLC
			ADC $00
			STA $0300,y
			PLX

			PHY
			LDA $01
			LDY $0E
			BEQ SMALL_BULLY
			CLC
			ADC VERT_DISP,x
SMALL_BULLY		PLY
			STA $0301,y

			PHX
			TXA
			CLC
			ADC $03
			ADC $0E
			TAX
			LDA TILE_MAP,x
			STA $0302,y
			PLX

			PHX
			LDX $02
			LDA TILE_PROP,x
			ORA $64
			STA $0303,y
			PLX

			INC $0F
			INY
			INY
			INY
			INY
			DEX
			BPL GFX_LOOP

			PLX
			LDA $0F
			DEC A
			LDY #$02
			JSL $01B7B3
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sub horz pos		;
;;;;;;;;;;;;;;;;;;;;;;;;;

POS_PLUS		dcb $00,$00,$08

SUB_HORZ_POS		LDY $1602,x
			LDA $E4,x
			CLC
			ADC POS_PLUS,y
			STA $00
			LDA $14E0,x
			ADC #$00
			STA $01
			REP #$20
			LDY #$00
			LDA $94
			SEC
			SBC $00
			STA $0E
			BPL SUB_HORZ_RETURN
			INY
SUB_HORZ_RETURN		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;
;Sub horz pos		;
;;;;;;;;;;;;;;;;;;;;;;;;;

SUB_VERT_POS		LDY #$00
			LDA $D8,x
			STA $00
			LDA $14D4,x
			STA $01
			REP #$20
			LDA $96
			SEC
			SBC $00
			STA $0E
			BPL SUB_VERT_RETURN
			INY
SUB_VERT_RETURN		RTS