;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Piranha plant, from SMB3
;
;
;Uses extra bits : YES
;Clear	: normal
;Set	: upside down
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


			incsrc xkas_def.asm


			print "INIT ",pc
			LDA $E4,x
			ORA #$08
			STA $E4,x
			LDA $D8,x
			BNE Init000
			DEC $14D4,x
Init000:		DEC $D8,x
			DEC A
			STA $1504,x	;original Y pos low
			LDA $7FAB10,x
			AND #$04
			STA $151C,x	;extra bit, false or true
			BEQ InitReturn
			LDA $D8,x
			CLC
			ADC #$10
			STA $1504,x
InitReturn:		RTL

			print "MAIN ",pc
			PHB
			PHK
			PLB
			JSR SpriteMain
			PLB
			RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


Yspeed:			db $00,$F0,$00,$10
MovingTimer:		db $20,$30,$20,$30


SpriteMain:		LDA $1594,x
			BNE DontDrawGFX
			JSR SpriteGraphic
DontDrawGFX:		JSR !SubOffScreen
			LDA $9D
			BNE Return
			INC $1570,x
			LDA $1594,x
			BNE DontInteract
			JSL $81803A
DontInteract:		LDA $C2,x
			AND #$03
			TAY
			LDA $1540,x
			BEQ NewState
			LDA Yspeed,y
			LDY $151C,x
			BEQ StoreToAA
			EOR #$FF
			INC A
StoreToAA:		STA $AA,x
			JSL $81801A		;update Y position
Return:			RTS

NewState:		LDA $C2,x
			AND #$03
			STA $00
			BNE MoveAlways
			JSR SubHorzPos
			LDA $0E
			CLC
			ADC #$1B
			CMP #$37
			LDA #$01
			STA $1594,x
			BCC Return
MoveAlways:		STZ $1594,x
			LDY $00
			LDA MovingTimer,y
			STA $1540,x
			INC $C2,x
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

!SquareTile		= $C0

Tilemap:		db $AC,$CE,$AE,$CE
VertDisp:		db $00,$10,$10,$00
TileProp:		db $28,$2A,$A8,$AA

SpriteGraphic:		JSR !GetDrawInfo

			LDA $1570,x		; Animation frame
			LSR A
			LSR A
			AND #$02
			STA $03
			LDA $151C,x		; Extra bit
			LSR A
			STA $04

			STZ $02			; Loop count
			STZ $0F			; The number of tile drawn

			LDA $15D0,x
			BEQ .NotBeingEaten
			INC $02
			BRA DrawPiranha

.NotBeingEaten		PHY
			LDA $00
			STA $0300,y
			LDA $1504,x
			PHA
			SEC
			SBC $1C
			STA $0301,y
			LDA #!SquareTile
			STA $0302,y
			LDA #$00
			STA $0303,y


			INC $0F

			LDY $04

			PLA
			SEC
			SBC $D8,x
			DEY
			BMI NotUpsideDown
			CMP #$00
			BMI Draw2Tiles
			BRA OnlyOneTile
NotUpsideDown:		CMP #$10
			BMI OnlyOneTile
Draw2Tiles:		INC $02


OnlyOneTile:		PLY
			INY #$04

DrawPiranha:		PHX
			LDX $02
GFXLoop:		PHX
			LDA $00
			STA $0300,y
			PHX
			TXA
			ORA $04
			TAX
			LDA $01
			CLC
			ADC VertDisp,x
			STA $0301,y
			LDA TileProp,x
			STA $0303,y
			PLA		;loads X as A from stack
			ORA $03
			TAX
			LDA Tilemap,x
			STA $0302,y
			PLX
			INY #$04
			INC $0F
			DEX
			BPL GFXLoop
			PLX

			LDY #$02
			LDA $0F
			DEC A
			JSL $81B7B3
			RTS


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Sub Horz Pos
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                     
SubHorzPos:		LDY #$00
			LDA $D1
			SEC
			SBC $E4,x
			STA $0E
			LDA $D2
			SBC $14E0,x
			STA $0F
			BPL SubHorzPosR
			INY
SubHorzPosR:		RTS
